<?php
/**
* @title		   Responsive Slider for Articles
* @version   	   3.x
* @copyright   	   Copyright (C) 2011-2014 Minitek, All rights reserved.
* @license   	   GNU General Public License version 3 or later.
* @author url      http://www.minitek.gr/
* @author email    info@minitek.gr
* @developers      Minitek.gr
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

if(!defined('DS')){
	define('DS',DIRECTORY_SEPARATOR);
}

// Load PHP Thumb Factory Library
if ($params->get('load_phpthumb')) {
	if( !defined('PhpThumbFactoryLoaded') ) {
		require_once dirname(__FILE__).DS.'admin'.DS.'phpthumb/ThumbLib.inc.php';
		define('PhpThumbFactoryLoaded',1);
	}
}

// Get Helper function
require_once JPATH_SITE.DS.'modules'.DS.'mod_minitek_slider'.DS.'helper.php';

// Define parameters
$module_id = $module->id;

// Define parameters
if ($params->get('auto_module_id')) {
	$sliderid = 'mnslider'.$module_id;
} else {
  	$sliderid = ''.$params->get('custom_module_id'); 
}

// Add stylesheets
$document = JFactory::getDocument();
$document->addStyleSheet(JURI::base().'modules/mod_minitek_slider/assets/css/camera.css');

// Add scripts
if ($params->get('load_jquery')) {
  	JHtml::_('jquery.framework');
}
$document->addScript(JURI::base().'modules/mod_minitek_slider/assets/js/jquery.mobile.customized.min.js');
$document->addScript(JURI::base().'modules/mod_minitek_slider/assets/js/camera.js');
 
if ($params->get('load_easing')) {
  	$document->addScript(JURI::base().'modules/mod_minitek_slider/assets/js/jquery.easing.1.3.js');
}

// Basic slider params
$sliderHeight = (int)$params->get('image_height');
$height = (int)$params->get('image_height') / (int)$params->get('image_width');
$percHeight = $height * 100;
$minHeight = (int)$params->get('minimum_height');
$showThumbs = $params->get('show_thumbs');
if ($showThumbs) {
  	$thumbs = 'true';
} else {
  	$thumbs = 'false';
}

// Slider effects params
$sliderEffect = $params->get('slider_effect');
$mobilesliderEffect = $params->get('mobile_slider_effect');
$sliderEasing = $params->get('easing');
$mobilesliderEasing = $params->get('mobile_easing');
$autoplay = $params->get('autoplay');
if ($autoplay) {
  	$sliderAutoplay = 'true';
} else {
  	$sliderAutoplay = 'false';
}
$mobileAutoplay = $params->get('mobile_autoplay');
if ($mobileAutoplay) {
  	$mobilesliderAutoplay = 'true';
} else {
  	$mobilesliderAutoplay = 'false';
}
$autoplaySpeed = (int)$params->get('autoplay_speed');
$transitionSpeed = (int)$params->get('transition_speed');
$playPause = $params->get('play_pause_buttons');
if ($playPause) {
  	$playPauseButtons = 'true';
} else {
  	$playPauseButtons = 'false';
}
$pauseClick = $params->get('pause_on_click');
if ($pauseClick) {
  	$pauseOnClick = 'true';
} else {
  	$pauseOnClick = 'false';
}
$pauseHover = $params->get('pause_on_hover');
if ($pauseHover) {
  	$pauseOnHover = 'true';
} else {
  	$pauseOnHover = 'false';
}
$showArrows = $params->get('show_arrows');
if ($showArrows) {
  	$showNavArrows = 'true';
} else {
  	$showNavArrows = 'false';
}
$autohideArrows = $params->get('autohide_arrows');
if ($autohideArrows) {
  	$autohideNavArrows = 'true';
} else {
  	$autohideNavArrows = 'false';
}
$mobileautohideArrows = $params->get('mobile_autohide_arrows');
if ($mobileautohideArrows) {
  	$mobileautohideNavArrows = 'true';
} else {
  	$mobileautohideNavArrows = 'false';
}
$opacityGrid = $params->get('opacity_on_grid');
if ($opacityGrid) {
  	$opacityOnGrid = 'true';
} else {
  	$opacityOnGrid = 'false';
}
$loader = $params->get('loader');
$loader_color = $params->get('loader_color');
$loader_bg_color = $params->get('loader_bg_color');
$loader_opacity = $params->get('loader_opacity');
$loader_padding = $params->get('loader_padding');
$loader_stroke = $params->get('loader_stroke');
$pie_diameter = $params->get('pie_diameter');
$pie_position = $params->get('pie_position');
$bar_position = $params->get('bar_position');
$bar_direction = $params->get('bar_direction');

// Hide Navigation Bullets
if ($params->get('show_bullets')) {
  	$document->addScriptDeclaration( 
    	'jQuery.noConflict();
  			jQuery(window).load(function(){	
  	    	jQuery(".camera_pag").css("display", "block");
  	  	});
  	');
} else {
 	$no_margin = $sliderid.' {
		margin-bottom: 0 !important;}
  	';		 
  	$document->addStyleDeclaration( $no_margin );
}

// Add Carousel script
$document->addScriptDeclaration( 
  	'jQuery.noConflict();
		
	  	jQuery(document).ready(function(){	
			
			jQuery("#'.$sliderid.'").camera({
			
				/* General */
			  	height: "'.$percHeight.'%",
			  	minHeight: "'.$minHeight.'px",
	     	  	thumbnails: '.$thumbs.',
				
			  	/* Effects*/		
				fx: "'.$sliderEffect.'",
				mobileFx: "'.$mobilesliderEffect.'",			
				easing: "'.$sliderEasing.'",
				mobileEasing: "'.$mobilesliderEasing.'",	
				autoAdvance: '.$sliderAutoplay.',
				mobileAutoAdvance: '.$mobilesliderAutoplay.',
				time: '.$autoplaySpeed.',
				transPeriod: '.$transitionSpeed.',
				playPause: '.$playPauseButtons.',
				pauseOnClick: '.$pauseOnClick.',
				hover: '.$pauseOnHover.',			
				navigation: '.$showNavArrows.',
				navigationHover: '.$autohideNavArrows.',
				mobileNavHover: '.$mobileautohideNavArrows.',
				opacityOnGrid: '.$opacityOnGrid.',		
				  
				/* Loader */
  				loader: "'.$loader.'",
  				loaderColor: "'.$loader_color.'",
  				loaderBgColor: "'.$loader_bg_color.'",
  				loaderOpacity: '.$loader_opacity.',
  				loaderPadding: '.$loader_padding.',
  				loaderStroke: '.$loader_stroke.',	
				pieDiameter: '.$pie_diameter.',
  				piePosition: "'.$pie_position.'",  				
  				barPosition: "'.$bar_position.'",	
  				barDirection: "'.$bar_direction.'"
					
      		});
		
		});
  	'
);

$input = JFactory::getApplication()->input;

$idbase = $params->get('catid');
$cacheid = md5(serialize(array ($idbase, $module->module)));

$cacheparams = new stdClass;
$cacheparams->cachemode = 'id';
$cacheparams->class = 'MinitekSliderHelper';
$cacheparams->method = 'getList';
$cacheparams->methodparams = $params;
$cacheparams->modeparams = $cacheid;

$items = JModuleHelper::moduleCache($module, $params, $cacheparams);
require JModuleHelper::getLayoutPath('mod_minitek_slider', $params->get('layout', 'default'));
