<?php
/**
* @title		   Minitek Contact Module
* @version   	   3.x
* @copyright   	   Copyright (C) 2011-2015 Minitek, All rights reserved.
* @license   	   GNU General Public License version 3 or later.
* @author url      http://www.minitek.gr/
* @developers      Minitek.gr
*/
defined('_JEXEC') or die;

JHtml::_('behavior.keepalive');
JHtml::_('behavior.formvalidation');

$uri = JFactory::getURI(); 
$pageURL = $uri->toString(); 
?>

<div id="<?php echo $modmncontact; ?>" class="contact-form">
	
	<form id="contact-form" action="<?php echo JRoute::_('index.php'); ?>" method="post" class="form-validate form-horizontal">
		
		<fieldset>
			
			<legend><?php echo JText::_('MOD_MINITEK_CONTACT_FORM_LABEL'); ?></legend>
			
			<div class="control-group">
				<div class="control-label">
					<?php echo JText::_('MOD_MINITEK_CONTACT_FORM_NAME'); ?>
				</div>
				<div class="controls">
					<input 
						type="text" 
						placeholder="<?php echo JText::_('MOD_MINITEK_CONTACT_FORM_NAME'); ?>" 
						aria-required="true" 
						required="" 
						size="30" 
						value="" 
						id="jform_contact_name" 
						name="jform[contact_name]"
					>
				</div>
			</div>
			
			<div class="control-group">
				<div class="control-label">
					<?php echo JText::_('MOD_MINITEK_CONTACT_FORM_EMAIL'); ?>
				</div>
				<div class="controls">
					<input 
						type="email" 
						aria-required="true" 
						required="" 
						size="30" 
						value="" 
						id="jform_contact_email" 
						placeholder="<?php echo JText::_('MOD_MINITEK_CONTACT_FORM_EMAIL'); ?>" 
						name="jform[contact_email]"
					>
				</div>
			</div>
			
			<div class="control-group">
				<div class="control-label">
					<?php echo JText::_('MOD_MINITEK_CONTACT_FORM_SUBJECT'); ?>
				</div>
				<div class="controls">
					<input 
						type="text" 
						placeholder="<?php echo JText::_('MOD_MINITEK_CONTACT_FORM_SUBJECT'); ?>" 
						aria-required="true" 
						required="" 
						size="60" 
						value="" 
						id="jform_contact_emailmsg" 
						name="jform[contact_subject]"
					>
				</div>
			</div>
			
			<div class="control-group">
				<div class="control-label">
					<?php echo JText::_('MOD_MINITEK_CONTACT_FORM_MESSAGE'); ?>
				</div>
				<div class="controls">
					<textarea 
						placeholder="<?php echo JText::_('MOD_MINITEK_CONTACT_FORM_MESSAGE'); ?>" 
						aria-required="true" 
						required="true" 
						rows="12" 
						cols="50" 
						id="jform_contact_message" 
						name="jform[contact_message]">
					</textarea>
				</div>
			</div>
			
			<div class="control-group">
				<div class="controls">
					<div class="checkbox">
						<input 
							type="checkbox" 
							value="1" 
							id="jform_contact_email_copy" 
							name="jform[contact_email_copy]"
						>							
						<label 
							title="" 
							class="hasTooltip" 
							for="jform_contact_email_copy" 
							id="jform_contact_email_copy-lbl" 
							data-original-title="<?php echo JText::_('MOD_MINITEK_CONTACT_FORM_EMAIL_COPY_TOOLTIP'); ?>"
						>
							<?php echo JText::_('MOD_MINITEK_CONTACT_FORM_EMAIL_COPY'); ?>
						</label>						
					</div>
				</div>
			</div>
			
			<div class="form-actions">
				<button class="btn btn-primary validate" type="submit"><?php echo JText::_('MOD_MINITEK_CONTACT_FORM_SEND_BUTTON'); ?></button>
				<input type="hidden" name="option" value="com_contact" />
				<input type="hidden" name="task" value="contact.submit" />
				<input type="hidden" name="return" value="<?php echo base64_encode($pageURL); ?>" />
				<input type="hidden" name="id" value="<?php echo $contactId; ?>" />
				<?php echo JHtml::_('form.token'); ?>
			</div>
			
		</fieldset>
		
	</form>
	
</div>

