<?php
/**
 * @package   T3 Blank
 * @copyright Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.
 * @license   GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

// get params
$sitename  = $this->params->get('sitename');
$slogan    = $this->params->get('slogan', '');
$logotype  = $this->params->get('logotype', 'text');
$logoimage = $logotype == 'image' ? $this->params->get('logoimage', T3Path::getUrl('images/logo.png', '', true)) : '';
$logoimgsm = ($logotype == 'image' && $this->params->get('enable_logoimage_sm', 0)) ? $this->params->get('logoimage_sm', T3Path::getUrl('images/logo-sm.png', '', true)) : false;

if (!$sitename) {
	$sitename = JFactory::getConfig()->get('sitename');
}


$t3action = JRequest::getVar('t3action');
$headerslider_param = $this->params->get('header-slider');


if ($this->countModules('mn-slider') && $headerslider_param) {
	$headerslider = "header-slider";
} else{
	$headerslider ="";
}
	

?>

<!-- HEADER -->
<header id="t3-header" class="t3-header <?php echo $headerslider ?>">
    <div class="container">
        <div class="row">
            <!-- LOGO -->
            <div class="col-xs-12 col-sm-3 col-md-2 col-lg-3 logo">
                <div class="logo-<?php echo $logotype, ($logoimgsm ? ' logo-control' : '') ?>">
                    <a href="<?php echo JURI::base(true) ?>" title="<?php echo strip_tags($sitename) ?>">
                        <?php if($logotype == 'image'): ?>
                            <img class="logo-img" src="<?php echo JURI::base(true) . '/' . $logoimage ?>" alt="<?php echo strip_tags($sitename) ?>" />
                        <?php endif ?>
                        <?php if($logoimgsm) : ?>
                            <img class="logo-img-sm" src="<?php echo JURI::base(true) . '/' . $logoimgsm ?>" alt="<?php echo strip_tags($sitename) ?>" />
                        <?php endif ?>
                        <span><?php echo $sitename ?></span>
                    </a>
                    <small class="site-slogan"><?php echo $slogan ?></small>
                </div>
            </div>
            <!-- //LOGO -->
            
            <!-- Mainnav -->
            <nav id="t3-mainnav" class="navbar navbar-default t3-mainnav col-xs-12 col-sm-1 col-md-8 col-lg-7">
                <div class="t3-navbar navbar-collapse collapse">
                    <jdoc:include type="<?php echo $this->getParam('navigation_type', 'megamenu') ?>" name="<?php echo $this->getParam('mm_type', 'mainmenu') ?>" />
                </div>
            </nav>
            <!-- //Mainnav -->
            
            <!-- Top Login Icon -->
            <?php if ($t3action != 'layout') { ?>
                <?php if ($this->countModules('login-popup')) : ?>
                <div class="col-mn-login">
                    <?php $user = JFactory::getUser();
                        if ($user->get('guest')) { ?>
                    <a class="mn-login"><i class="fa fa-user"></i></a>
                    <?php } else { ?>
                    <a class="mn-login"><i class="fa fa-unlock"></i></a>
                    <?php } ?>
                </div>
                <?php endif ?>
            <?php } ?>
            <!-- //Top Login Icon -->
             
            <!-- Top Search Icon -->
            <?php if ($t3action != 'layout') { ?>
                <?php if ($this->countModules('search-popup')) : ?>
                <!-- Top-Right Login -->
                <div class="col-mn-search">
                    <a class="mn-search"><i class="fa fa-search"></i></a>
                </div>
                <?php endif ?> 
            <?php } ?>
            <!-- //Top Search Icon --> 
            <?php if ($t3action != 'layout') { ?>
                <?php if ($this->countModules('top-popup')) : ?>
                <!-- Top-Right Login -->
                <div class="col-top-popup">
                    <a class="top-popup"><i class="fa mn-ficons-pencil"></i></a>
                </div>
                <?php endif ?> 
            <?php } ?>
            
            <!-- Brand and toggle get grouped for better mobile display -->
            
			<?php if ($this->getParam('navigation_collapse_enable', 1) && $this->getParam('responsive', 1)) : ?>
                <?php $this->addScript(T3_URL.'/js/nav-collapse.js'); ?>
                <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".t3-navbar-collapse">
                    <i class="fa fa-bars"></i>
                </button>
            <?php endif ?>

            <?php if ($this->getParam('addon_offcanvas_enable')) : ?>
                <?php $this->loadBlock ('off-canvas') ?>
            <?php endif ?>
                
        </div>
    </div>    
</header>
<!-- //HEADER -->




