SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;


DROP TABLE IF EXISTS `#__assets`;
CREATE TABLE IF NOT EXISTS `#__assets` (
`id` int(10) unsigned NOT NULL COMMENT 'Primary Key',
  `parent_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set parent.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `level` int(10) unsigned NOT NULL COMMENT 'The cached level in the nested tree.',
  `name` varchar(50) NOT NULL COMMENT 'The unique name for the asset.\n',
  `title` varchar(100) NOT NULL COMMENT 'The descriptive title for the asset.',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.'
) ENGINE=InnoDB AUTO_INCREMENT=528 DEFAULT CHARSET=utf8;

INSERT INTO `#__assets` (`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`) VALUES
(1, 0, 0, 325, 0, 'root.1', 'Root Asset', '{"core.login.site":{"6":1,"2":1},"core.login.admin":{"6":1},"core.login.offline":{"6":1},"core.admin":{"8":1},"core.manage":{"7":1},"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
(2, 1, 1, 2, 1, 'com_admin', 'com_admin', '{}'),
(3, 1, 3, 4, 1, 'com_banners', 'com_banners', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(4, 1, 5, 6, 1, 'com_cache', 'com_cache', '{"core.admin":{"7":1},"core.manage":{"7":1}}'),
(5, 1, 7, 8, 1, 'com_checkin', 'com_checkin', '{"core.admin":{"7":1},"core.manage":{"7":1}}'),
(6, 1, 9, 10, 1, 'com_config', 'com_config', '{}'),
(7, 1, 11, 16, 1, 'com_contact', 'com_contact', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(8, 1, 17, 78, 1, 'com_content', 'com_content', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1},"core.delete":[],"core.edit":{"4":1},"core.edit.state":{"5":1},"core.edit.own":[]}'),
(9, 1, 79, 80, 1, 'com_cpanel', 'com_cpanel', '{}'),
(10, 1, 81, 82, 1, 'com_installer', 'com_installer', '{"core.admin":[],"core.manage":{"7":0},"core.delete":{"7":0},"core.edit.state":{"7":0}}'),
(11, 1, 83, 84, 1, 'com_languages', 'com_languages', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(12, 1, 85, 86, 1, 'com_login', 'com_login', '{}'),
(13, 1, 87, 88, 1, 'com_mailto', 'com_mailto', '{}'),
(14, 1, 89, 90, 1, 'com_massmail', 'com_massmail', '{}'),
(15, 1, 91, 92, 1, 'com_media', 'com_media', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1},"core.delete":{"5":1}}'),
(16, 1, 93, 94, 1, 'com_menus', 'com_menus', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(17, 1, 95, 96, 1, 'com_messages', 'com_messages', '{"core.admin":{"7":1},"core.manage":{"7":1}}'),
(18, 1, 97, 250, 1, 'com_modules', 'com_modules', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(19, 1, 251, 254, 1, 'com_newsfeeds', 'com_newsfeeds', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(20, 1, 255, 256, 1, 'com_plugins', 'com_plugins', '{"core.admin":{"7":1},"core.manage":[],"core.edit":[],"core.edit.state":[]}'),
(21, 1, 257, 258, 1, 'com_redirect', 'com_redirect', '{"core.admin":{"7":1},"core.manage":[]}'),
(22, 1, 259, 260, 1, 'com_search', 'com_search', '{"core.admin":{"7":1},"core.manage":{"6":1}}'),
(23, 1, 261, 262, 1, 'com_templates', 'com_templates', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(24, 1, 263, 266, 1, 'com_users', 'com_users', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(25, 1, 267, 270, 1, 'com_weblinks', 'com_weblinks', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1},"core.delete":[],"core.edit":{"4":1},"core.edit.state":{"5":1},"core.edit.own":[]}'),
(26, 1, 271, 272, 1, 'com_wrapper', 'com_wrapper', '{}'),
(27, 8, 18, 33, 2, 'com_content.category.2', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(29, 7, 12, 13, 2, 'com_contact.category.4', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(30, 19, 252, 253, 2, 'com_newsfeeds.category.5', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(31, 25, 268, 269, 2, 'com_weblinks.category.6', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(32, 24, 264, 265, 1, 'com_users.category.7', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(33, 1, 273, 274, 1, 'com_finder', 'com_finder', '{"core.admin":{"7":1},"core.manage":{"6":1}}'),
(34, 1, 275, 276, 1, 'com_joomlaupdate', 'com_joomlaupdate', '{"core.admin":[],"core.manage":[],"core.delete":[],"core.edit.state":[]}'),
(35, 1, 277, 278, 1, 'com_tags', 'com_tags', '{"core.admin":[],"core.manage":[],"core.manage":[],"core.delete":[],"core.edit.state":[]}'),
(36, 1, 279, 280, 1, 'com_contenthistory', 'com_contenthistory', '{}'),
(37, 1, 281, 282, 1, 'com_ajax', 'com_ajax', '{}'),
(38, 1, 283, 284, 1, 'com_postinstall', 'com_postinstall', '{}'),
(40, 18, 98, 99, 2, 'com_modules.module.2', 'Login', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(41, 18, 100, 101, 2, 'com_modules.module.3', 'Popular Articles', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(42, 18, 102, 103, 2, 'com_modules.module.4', 'Recently Added Articles', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(43, 18, 104, 105, 2, 'com_modules.module.8', 'Toolbar', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(44, 18, 106, 107, 2, 'com_modules.module.9', 'Quick Icons', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(45, 18, 108, 109, 2, 'com_modules.module.10', 'Logged-in Users', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(46, 18, 110, 111, 2, 'com_modules.module.12', 'Admin Menu', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(47, 18, 112, 113, 2, 'com_modules.module.13', 'Admin Submenu', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(48, 18, 114, 115, 2, 'com_modules.module.14', 'User Status', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(49, 18, 116, 117, 2, 'com_modules.module.15', 'Title', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(52, 18, 118, 119, 2, 'com_modules.module.79', 'Multilanguage status', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(53, 18, 120, 121, 2, 'com_modules.module.86', 'Joomla Version', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(54, 1, 285, 286, 1, 'com_k2', 'com_k2', '{"core.admin":[],"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(60, 18, 122, 123, 2, 'com_modules.module.92', 'K2 Quick Icons (admin)', ''),
(61, 18, 124, 125, 2, 'com_modules.module.93', 'K2 Stats (admin)', ''),
(62, 8, 34, 55, 2, 'com_content.category.8', 'Articles', '{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
(63, 62, 35, 44, 3, 'com_content.category.9', 'Architecture', '{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
(64, 62, 45, 54, 3, 'com_content.category.10', 'Interior Design', '{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
(65, 8, 56, 59, 2, 'com_content.category.11', 'FAQ', '{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
(70, 65, 57, 58, 3, 'com_content.article.5', 'FAQ', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(71, 27, 19, 20, 3, 'com_content.article.6', 'About us 2', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(72, 27, 21, 22, 3, 'com_content.article.7', 'Page Breaks', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(73, 75, 63, 64, 3, 'com_content.article.8', 'Typography', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(74, 75, 65, 66, 3, 'com_content.article.9', 'Module variations', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(75, 8, 60, 69, 2, 'com_content.category.12', 'Explore', '{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
(76, 75, 61, 62, 3, 'com_content.category.13', 'Template themes', '{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
(77, 75, 67, 68, 3, 'com_content.article.10', 'Module positions', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(78, 7, 14, 15, 2, 'com_contact.category.14', 'Contacts category I', '{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
(79, 27, 23, 24, 3, 'com_content.article.11', 'Archived Article I', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(80, 27, 25, 26, 3, 'com_content.article.12', 'Archived Article II', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(81, 27, 27, 28, 3, 'com_content.article.13', 'Archived Article III', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(82, 18, 126, 127, 2, 'com_modules.module.94', 'Off Canvas Menu', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(91, 18, 128, 129, 2, 'com_modules.module.95', 'Latest Articles', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(92, 18, 130, 131, 2, 'com_modules.module.96', 'Copyright', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(93, 18, 132, 133, 2, 'com_modules.module.97', 'OUR SERVICES', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(95, 18, 134, 135, 2, 'com_modules.module.99', 'Cameras', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(96, 18, 136, 137, 2, 'com_modules.module.100', 'Interviews', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(99, 18, 138, 139, 2, 'com_modules.module.103', 'Responsive Scroller position-1', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(100, 18, 140, 141, 2, 'com_modules.module.104', 'Responsive Scroller position-8', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(101, 18, 142, 143, 2, 'com_modules.module.105', 'Computing position-14', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(102, 18, 144, 145, 2, 'com_modules.module.106', 'Responsive Scroller position-13 2', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(115, 18, 146, 147, 2, 'com_modules.module.119', 'Login', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(116, 18, 148, 149, 2, 'com_modules.module.120', 'Search', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(118, 18, 150, 151, 2, 'com_modules.module.122', 'Tags', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(119, 18, 152, 153, 2, 'com_modules.module.123', 'Latest Comments', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(121, 18, 154, 155, 2, 'com_modules.module.124', 'Minitek Wall', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(128, 18, 156, 157, 2, 'com_modules.module.125', 'Computing', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(129, 18, 158, 159, 2, 'com_modules.module.126', 'MOBILE', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(132, 18, 160, 161, 2, 'com_modules.module.127', 'Tech Trends', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(134, 18, 162, 163, 2, 'com_modules.module.129', 'Cameras', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(137, 18, 164, 165, 2, 'com_modules.module.132', 'INTERVIEWS', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(138, 18, 166, 167, 2, 'com_modules.module.133', 'Off-canvas Social', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(147, 18, 168, 169, 2, 'com_modules.module.134', 'Blog Categories', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(148, 18, 170, 171, 2, 'com_modules.module.135', 'Category Articles', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(149, 18, 172, 173, 2, 'com_modules.module.136', 'mod_dark', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(150, 18, 174, 175, 2, 'com_modules.module.137', 'mod_yellow', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(151, 18, 176, 177, 2, 'com_modules.module.138', 'mod_orange', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(152, 18, 178, 179, 2, 'com_modules.module.139', 'mod_blue', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(156, 18, 180, 181, 2, 'com_modules.module.142', 'mod_green', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(157, 18, 182, 183, 2, 'com_modules.module.143', 'mod_purple', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(213, 18, 184, 185, 2, 'com_modules.module.169', 'Tags', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(214, 18, 186, 187, 2, 'com_modules.module.170', 'Categories', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(215, 18, 188, 189, 2, 'com_modules.module.171', 'Latest Comments', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(217, 18, 190, 191, 2, 'com_modules.module.173', 'Login', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(219, 18, 192, 193, 2, 'com_modules.module.175', 'Article Categories', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(220, 18, 194, 195, 2, 'com_modules.module.176', 'Article Categories', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(221, 18, 196, 197, 2, 'com_modules.module.177', 'Login', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(223, 18, 198, 199, 2, 'com_modules.module.179', 'Scroll Button', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(235, 63, 36, 37, 4, 'com_content.article.46', 'Improving visualization by using a new software', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(238, 1, 287, 288, 1, '#___minitek_wall_modules.6', '#___minitek_wall_modules.6', ''),
(241, 18, 200, 201, 2, 'com_modules.module.181', 'Breadcrumbs', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(278, 18, 202, 203, 2, 'com_modules.module.211', 'Parallax1', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(281, 18, 204, 205, 2, 'com_modules.module.213', 'Latest Reviews', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(302, 63, 38, 39, 4, 'com_content.article.49', 'Experience and inspirational ideas', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(303, 63, 40, 41, 4, 'com_content.article.50', 'The design of a luxury condominium tower', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(304, 63, 42, 43, 4, 'com_content.article.51', 'Buildings examples of Art Deco architecture', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(307, 64, 46, 47, 4, 'com_content.article.54', 'Reading magazines helps our inspiration', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(308, 64, 48, 49, 4, 'com_content.article.55', 'Our latest and favourite city''s apartment interior', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(309, 64, 50, 51, 4, 'com_content.article.56', 'Living room project outside the city limits', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(310, 64, 52, 53, 4, 'com_content.article.57', 'Interior design in a famous city diner', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(318, 18, 206, 207, 2, 'com_modules.module.229', 'Minitek Slider', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(322, 18, 208, 209, 2, 'com_modules.module.233', 'Top-menu', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(325, 1, 289, 290, 1, '#___minitek_wall_modules.19', '#___minitek_wall_modules.19', ''),
(332, 18, 210, 211, 2, 'com_modules.module.241', 'Minitek Slider for Articles', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(338, 18, 212, 213, 2, 'com_modules.module.242', 'Contact us title', '{"core.delete":[],"core.edit":[],"core.edit.state":[],"module.edit.frontend":[]}'),
(371, 18, 214, 215, 2, 'com_modules.module.272', 'Most Popular', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(373, 1, 291, 292, 1, '#___minitek_wall_modules.20', '#___minitek_wall_modules.20', ''),
(376, 1, 293, 294, 1, '#___minitek_wall_modules.21', '#___minitek_wall_modules.21', ''),
(379, 1, 295, 296, 1, '#___minitek_wall_modules.22', '#___minitek_wall_modules.22', ''),
(382, 1, 297, 298, 1, '#___minitek_wall_modules.23', '#___minitek_wall_modules.23', ''),
(385, 1, 299, 300, 1, '#___minitek_wall_modules.24', '#___minitek_wall_modules.24', ''),
(388, 1, 301, 302, 1, '#___minitek_wall_modules.25', '#___minitek_wall_modules.25', ''),
(393, 1, 303, 304, 1, '#___minitek_wall_modules.26', '#___minitek_wall_modules.26', ''),
(399, 1, 305, 306, 1, '#___minitek_wall_modules.27', '#___minitek_wall_modules.27', ''),
(400, 1, 307, 308, 1, '#___minitek_wall_modules.28', '#___minitek_wall_modules.28', ''),
(452, 18, 216, 217, 2, 'com_modules.module.314', 'Browse by Category', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(454, 18, 218, 219, 2, 'com_modules.module.316', 'K2 Category Title', '{"core.delete":[],"core.edit":[],"core.edit.state":[],"module.edit.frontend":[]}'),
(478, 1, 309, 310, 1, 'com_minitekwall.instance.46', 'Development', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(479, 1, 311, 312, 1, '#__minitek_wall_modules.52', '#__minitek_wall_modules.52', ''),
(486, 18, 220, 221, 2, 'com_modules.module.334', 'Home Slider', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(487, 8, 70, 77, 2, 'com_content.category.15', 'Frontpage Slider', '{"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
(488, 487, 71, 72, 3, 'com_content.article.58', 'We build the next level of construction design', '{"core.delete":[],"core.edit":{"4":1},"core.edit.state":{"5":1}}'),
(489, 487, 73, 74, 3, 'com_content.article.59', 'Our ideas are driven by imagination & quality', '{"core.delete":[],"core.edit":{"4":1},"core.edit.state":{"5":1}}'),
(490, 487, 75, 76, 3, 'com_content.article.60', 'Our projects are a result of your own vision & our experience', '{"core.delete":[],"core.edit":{"4":1},"core.edit.state":{"5":1}}'),
(495, 18, 222, 223, 2, 'com_modules.module.338', 'Footer Social', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(499, 18, 224, 225, 2, 'com_modules.module.341', 'CONTACT', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(500, 18, 226, 227, 2, 'com_modules.module.342', 'VISIT US', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(501, 1, 313, 314, 1, 'com_minitekwall.instance.47', 'Porfolio', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(502, 1, 315, 316, 1, '#__minitek_wall_modules.53', '#__minitek_wall_modules.53', ''),
(506, 18, 228, 229, 2, 'com_modules.module.346', 'Minitek Wall Title', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(507, 27, 29, 30, 3, 'com_content.article.61', 'About us', '{"core.delete":[],"core.edit":{"4":1},"core.edit.state":{"5":1}}'),
(510, 1, 317, 318, 1, 'com_minitekwall.instance.1', 'Home Wall', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(511, 1, 319, 320, 1, '#__minitek_wall_modules.1', '#__minitek_wall_modules.1', ''),
(512, 1, 321, 322, 1, 'com_minitekwall', 'Minitek Wall', '{"core.admin":[],"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(514, 18, 230, 231, 2, 'com_modules.module.349', 'Home Creators', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(515, 18, 232, 233, 2, 'com_modules.module.350', 'Home Wall', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(516, 18, 234, 235, 2, 'com_modules.module.351', 'Home our principles', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(517, 18, 236, 237, 2, 'com_modules.module.352', 'Home Contact', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(518, 18, 238, 239, 2, 'com_modules.module.353', 'Home Features', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(519, 18, 240, 241, 2, 'com_modules.module.354', 'Footer Menu', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(520, 18, 242, 243, 2, 'com_modules.module.355', 'Home Contact Title', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(522, 18, 244, 245, 2, 'com_modules.module.356', 'Home The Creators Title', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(523, 18, 246, 247, 2, 'com_modules.module.357', 'Home Latest Projects Title', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(524, 18, 248, 249, 2, 'com_modules.module.358', 'Off Canvas Search', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"module.edit.frontend":[]}'),
(525, 27, 31, 32, 3, 'com_content.article.62', 'Home', '{"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(527, 1, 323, 324, 1, '#__minitek_wall_modules.2', '#__minitek_wall_modules.2', '');

DROP TABLE IF EXISTS `#__associations`;
CREATE TABLE IF NOT EXISTS `#__associations` (
  `id` int(11) NOT NULL COMMENT 'A reference to the associated item.',
  `context` varchar(50) NOT NULL COMMENT 'The context of the associated item.',
  `key` char(32) NOT NULL COMMENT 'The key for the association computed from an md5 on associated ids.'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__banners`;
CREATE TABLE IF NOT EXISTS `#__banners` (
`id` int(11) NOT NULL,
  `cid` int(11) NOT NULL DEFAULT '0',
  `type` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `imptotal` int(11) NOT NULL DEFAULT '0',
  `impmade` int(11) NOT NULL DEFAULT '0',
  `clicks` int(11) NOT NULL DEFAULT '0',
  `clickurl` varchar(200) NOT NULL DEFAULT '',
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `description` text NOT NULL,
  `custombannercode` varchar(2048) NOT NULL,
  `sticky` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `params` text NOT NULL,
  `own_prefix` tinyint(1) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `reset` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `language` char(7) NOT NULL DEFAULT '',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `version` int(10) unsigned NOT NULL DEFAULT '1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__banner_clients`;
CREATE TABLE IF NOT EXISTS `#__banner_clients` (
`id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL DEFAULT '',
  `contact` varchar(255) NOT NULL DEFAULT '',
  `email` varchar(255) NOT NULL DEFAULT '',
  `extrainfo` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `metakey` text NOT NULL,
  `own_prefix` tinyint(4) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__banner_tracks`;
CREATE TABLE IF NOT EXISTS `#__banner_tracks` (
  `track_date` datetime NOT NULL,
  `track_type` int(10) unsigned NOT NULL,
  `banner_id` int(10) unsigned NOT NULL,
  `count` int(10) unsigned NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__categories`;
CREATE TABLE IF NOT EXISTS `#__categories` (
`id` int(11) NOT NULL,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #___assets table.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) unsigned NOT NULL DEFAULT '0',
  `path` varchar(255) NOT NULL DEFAULT '',
  `extension` varchar(50) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` mediumtext NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `metadesc` varchar(1024) NOT NULL COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) NOT NULL COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1'
) ENGINE=InnoDB AUTO_INCREMENT=16 DEFAULT CHARSET=utf8;

INSERT INTO `#__categories` (`id`, `asset_id`, `parent_id`, `lft`, `rgt`, `level`, `path`, `extension`, `title`, `alias`, `note`, `description`, `published`, `checked_out`, `checked_out_time`, `access`, `params`, `metadesc`, `metakey`, `metadata`, `created_user_id`, `created_time`, `modified_user_id`, `modified_time`, `hits`, `language`, `version`) VALUES
(1, 0, 0, 0, 27, 0, '', 'system', 'ROOT', 'root', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{}', '', '', '{}', 651, '2011-01-01 00:00:01', 0, '0000-00-00 00:00:00', 0, '*', 1),
(2, 27, 1, 1, 2, 1, 'uncategorised', 'com_content', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 651, '2011-01-01 00:00:01', 0, '0000-00-00 00:00:00', 0, '*', 1),
(4, 29, 1, 3, 4, 1, 'uncategorised', 'com_contact', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 651, '2011-01-01 00:00:01', 0, '0000-00-00 00:00:00', 0, '*', 1),
(5, 30, 1, 5, 6, 1, 'uncategorised', 'com_newsfeeds', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 651, '2011-01-01 00:00:01', 0, '0000-00-00 00:00:00', 0, '*', 1),
(6, 31, 1, 7, 8, 1, 'uncategorised', 'com_weblinks', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 651, '2011-01-01 00:00:01', 0, '0000-00-00 00:00:00', 0, '*', 1),
(7, 32, 1, 9, 10, 1, 'uncategorised', 'com_users', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 651, '2011-01-01 00:00:01', 0, '0000-00-00 00:00:00', 0, '*', 1),
(8, 62, 1, 11, 16, 1, 'articles', 'com_content', 'Articles', 'articles', '', '<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":"","image_alt":""}', '', '', '{"author":"","robots":""}', 651, '2014-07-28 13:17:41', 781, '2015-03-29 21:10:58', 0, '*', 1),
(9, 63, 8, 12, 13, 2, 'articles/architecture', 'com_content', 'Architecture', 'architecture', '', '<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":"images\\/echo\\/articles\\/categories\\/categories.jpg","image_alt":""}', '', '', '{"author":"","robots":""}', 651, '2014-07-28 13:18:52', 429, '2015-07-19 15:05:07', 0, '*', 1),
(10, 64, 8, 14, 15, 2, 'articles/interior-design', 'com_content', 'Interior Design', 'interior-design', '', '<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":"images\\/echo\\/articles\\/categories\\/categories.jpg","image_alt":""}', '', '', '{"author":"","robots":""}', 651, '2014-07-28 13:19:24', 429, '2015-07-19 15:09:01', 0, '*', 1),
(11, 65, 1, 17, 18, 1, 'faq', 'com_content', 'FAQ', 'faq', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 651, '2014-07-28 13:19:40', 444, '2014-07-28 13:19:44', 0, '*', 1),
(12, 75, 1, 19, 22, 1, 'explore', 'com_content', 'Explore', 'explore', '', '<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 651, '2014-07-28 13:25:19', 0, '0000-00-00 00:00:00', 0, '*', 1),
(13, 76, 12, 20, 21, 2, 'explore/template-themes', 'com_content', 'Template themes', 'template-themes', '', '<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 651, '2014-07-28 13:25:40', 0, '0000-00-00 00:00:00', 0, '*', 1),
(14, 78, 1, 23, 24, 1, 'contacts-category-i', 'com_contact', 'Contacts category I', 'contacts-category-i', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 651, '2014-07-28 13:29:17', 444, '2014-07-28 13:29:21', 0, '*', 1),
(15, 487, 1, 25, 26, 1, 'frontpage-slider', 'com_content', 'Frontpage Slider', 'frontpage-slider', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":"","image_alt":""}', '', '', '{"author":"","robots":""}', 651, '2015-05-18 21:33:45', 0, '2015-05-18 21:33:45', 0, '*', 1);

DROP TABLE IF EXISTS `#__contact_details`;
CREATE TABLE IF NOT EXISTS `#__contact_details` (
`id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `con_position` varchar(255) DEFAULT NULL,
  `address` text,
  `suburb` varchar(100) DEFAULT NULL,
  `state` varchar(100) DEFAULT NULL,
  `country` varchar(100) DEFAULT NULL,
  `postcode` varchar(100) DEFAULT NULL,
  `telephone` varchar(255) DEFAULT NULL,
  `fax` varchar(255) DEFAULT NULL,
  `misc` mediumtext,
  `image` varchar(255) DEFAULT NULL,
  `email_to` varchar(255) DEFAULT NULL,
  `default_con` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `catid` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `mobile` varchar(255) NOT NULL DEFAULT '',
  `webpage` varchar(255) NOT NULL DEFAULT '',
  `sortname1` varchar(255) NOT NULL,
  `sortname2` varchar(255) NOT NULL,
  `sortname3` varchar(255) NOT NULL,
  `language` char(7) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `hits` int(10) unsigned NOT NULL DEFAULT '0'
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

INSERT INTO `#__contact_details` (`id`, `name`, `alias`, `con_position`, `address`, `suburb`, `state`, `country`, `postcode`, `telephone`, `fax`, `misc`, `image`, `email_to`, `default_con`, `published`, `checked_out`, `checked_out_time`, `ordering`, `params`, `user_id`, `catid`, `access`, `mobile`, `webpage`, `sortname1`, `sortname2`, `sortname3`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`, `version`, `hits`) VALUES
(1, 'John Doe', 'john-doe', '', '2411 Any Street', 'Any Town', '', 'United Kingdom', '', 'Q+123 456 7890', 'fax', '', '', 'info@youremail.you', 0, 1, 0, '0000-00-00 00:00:00', 1, '{"show_contact_category":"","show_contact_list":"","presentation_style":"","show_tags":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"","linka_name":"","linka":false,"linkb_name":"","linkb":false,"linkc_name":"","linkc":false,"linkd_name":"","linkd":false,"linke_name":"","linke":false,"contact_layout":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":""}', 445, 14, 1, 'Q+999 456 7890', '', '', '', '', '*', '2014-07-28 13:30:42', 651, '', '2015-03-11 14:19:07', 737, '', '', '{"robots":"","rights":""}', 1, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 20, 655);

DROP TABLE IF EXISTS `#__content`;
CREATE TABLE IF NOT EXISTS `#__content` (
`id` int(10) unsigned NOT NULL,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #___assets table.',
  `title` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` text NOT NULL,
  `urls` text NOT NULL,
  `attribs` varchar(5120) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `language` char(7) NOT NULL COMMENT 'The language code for the article.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.'
) ENGINE=InnoDB AUTO_INCREMENT=63 DEFAULT CHARSET=utf8;

INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(5, 70, 'FAQ', 'faq', '  <div class="mn-mod-header">\r\n    <div class="mn-title">\r\n      <h2>Frequently Asked Questions</h2>\r\n    </div>\r\n    <div class="mn-description">\r\n      <h4>Welcome to our FAQ section. Below you will find a selection<br>of the questions we get asked most. Simply click the question to reveal the answer.</h4>\r\n    </div>\r\n  </div>\r\n\r\n\r\n<div class="panel-group" id="accordion">\r\n  <div class="panel panel-default">\r\n    <div class="panel-heading">\r\n      <h4 class="panel-title">\r\n        <a data-toggle="collapse" data-parent="#accordion" href="#collapse1">\r\n            Lorem ipsum dolor sit amet consectetur adipiscing elit?\r\n        </a>\r\n      </h4>\r\n    </div>\r\n    <div id="collapse1" class="panel-collapse collapse in">\r\n      <div class="panel-body">\r\nLorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam id ultricies nibh, vitae hendrerit odio. Nulla non hendrerit velit, eu ullamcorper diam. Duis viverra id libero ut consequat. Vivamus convallis lorem urna, ut ullamcorper est euismod vel. Lorem ipsum dolor sit amet, consectetur adipiscing elit. \r\n      </div>\r\n    </div>\r\n  </div>\r\n  <div class="panel panel-default">\r\n    <div class="panel-heading">\r\n      <h4 class="panel-title">\r\n        <a data-toggle="collapse" data-parent="#accordion" href="#collapse2">\r\n          Lorem ipsum dolor sit amet consectetur adipiscing elit?\r\n        </a>\r\n      </h4>\r\n    </div>\r\n    <div id="collapse2" class="panel-collapse collapse">\r\n      <div class="panel-body">\r\nLorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam id ultricies nibh, vitae hendrerit odio. Nulla non hendrerit velit, eu ullamcorper diam. Duis viverra id libero ut consequat. Vivamus convallis lorem urna, ut ullamcorper est euismod vel. Lorem ipsum dolor sit amet, consectetur adipiscing elit. \r\n      </div>\r\n    </div>\r\n  </div>\r\n  <div class="panel panel-default">\r\n    <div class="panel-heading">\r\n      <h4 class="panel-title">\r\n        <a data-toggle="collapse" data-parent="#accordion" href="#collapse3">\r\n          Lorem ipsum dolor sit amet consectetur adipiscing elit?\r\n        </a>\r\n      </h4>\r\n    </div>\r\n    <div id="collapse3" class="panel-collapse collapse">\r\n      <div class="panel-body">\r\nLorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam id ultricies nibh, vitae hendrerit odio. Nulla non hendrerit velit, eu ullamcorper diam. Duis viverra id libero ut consequat. Vivamus convallis lorem urna, ut ullamcorper est euismod vel. Lorem ipsum dolor sit amet, consectetur adipiscing elit. \r\n      </div>\r\n    </div>\r\n  </div>\r\n    <div class="panel panel-default">\r\n    <div class="panel-heading">\r\n      <h4 class="panel-title">\r\n        <a data-toggle="collapse" data-parent="#accordion" href="#collapse4">\r\n          Lorem ipsum dolor sit amet consectetur adipiscing elit?\r\n        </a>\r\n      </h4>\r\n    </div>\r\n    <div id="collapse4" class="panel-collapse collapse">\r\n      <div class="panel-body">\r\nLorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam id ultricies nibh, vitae hendrerit odio. Nulla non hendrerit velit, eu ullamcorper diam. Duis viverra id libero ut consequat. Vivamus convallis lorem urna, ut ullamcorper est euismod vel. Lorem ipsum dolor sit amet, consectetur adipiscing elit. \r\n      </div>\r\n    </div>\r\n  </div>\r\n  <div class="panel panel-default">\r\n    <div class="panel-heading">\r\n      <h4 class="panel-title">\r\n        <a data-toggle="collapse" data-parent="#accordion" href="#collapse5">\r\n          Lorem ipsum dolor sit amet consectetur adipiscing elit?\r\n        </a>\r\n      </h4>\r\n    </div>\r\n    <div id="collapse5" class="panel-collapse collapse">\r\n      <div class="panel-body">\r\nLorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam id ultricies nibh, vitae hendrerit odio. Nulla non hendrerit velit, eu ullamcorper diam. Duis viverra id libero ut consequat. Vivamus convallis lorem urna, ut ullamcorper est euismod vel. Lorem ipsum dolor sit amet, consectetur adipiscing elit. \r\n      </div>\r\n    </div>\r\n  </div>\r\n  <div class="panel panel-default">\r\n    <div class="panel-heading">\r\n      <h4 class="panel-title">\r\n        <a data-toggle="collapse" data-parent="#accordion" href="#collapse6">\r\n          Lorem ipsum dolor sit amet consectetur adipiscing elit?\r\n        </a>\r\n      </h4>\r\n    </div>\r\n    <div id="collapse6" class="panel-collapse collapse">\r\n      <div class="panel-body">\r\nLorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam id ultricies nibh, vitae hendrerit odio. Nulla non hendrerit velit, eu ullamcorper diam. Duis viverra id libero ut consequat. Vivamus convallis lorem urna, ut ullamcorper est euismod vel. Lorem ipsum dolor sit amet, consectetur adipiscing elit. \r\n      </div>\r\n    </div>\r\n  </div>\r\n  <div class="panel panel-default">\r\n    <div class="panel-heading">\r\n      <h4 class="panel-title">\r\n        <a data-toggle="collapse" data-parent="#accordion" href="#collapse7">\r\n          Lorem ipsum dolor sit amet consectetur adipiscing elit?\r\n        </a>\r\n      </h4>\r\n    </div>\r\n    <div id="collapse7" class="panel-collapse collapse">\r\n      <div class="panel-body">\r\nLorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam id ultricies nibh, vitae hendrerit odio. Nulla non hendrerit velit, eu ullamcorper diam. Duis viverra id libero ut consequat. Vivamus convallis lorem urna, ut ullamcorper est euismod vel. Lorem ipsum dolor sit amet, consectetur adipiscing elit. \r\n      </div>\r\n    </div>\r\n  </div>\r\n  <div class="panel panel-default">\r\n    <div class="panel-heading">\r\n      <h4 class="panel-title">\r\n        <a data-toggle="collapse" data-parent="#accordion" href="#collapse8">\r\n          Lorem ipsum dolor sit amet consectetur adipiscing elit?\r\n        </a>\r\n      </h4>\r\n    </div>\r\n    <div id="collapse8" class="panel-collapse collapse">\r\n      <div class="panel-body">\r\nLorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam id ultricies nibh, vitae hendrerit odio. Nulla non hendrerit velit, eu ullamcorper diam. Duis viverra id libero ut consequat. Vivamus convallis lorem urna, ut ullamcorper est euismod vel. Lorem ipsum dolor sit amet, consectetur adipiscing elit. \r\n      </div>\r\n    </div>\r\n  </div>\r\n  <div class="panel panel-default">\r\n    <div class="panel-heading">\r\n      <h4 class="panel-title">\r\n        <a data-toggle="collapse" data-parent="#accordion" href="#collapse9">\r\n          Lorem ipsum dolor sit amet consectetur adipiscing elit?\r\n        </a>\r\n      </h4>\r\n    </div>\r\n    <div id="collapse9" class="panel-collapse collapse">\r\n      <div class="panel-body">\r\nLorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam id ultricies nibh, vitae hendrerit odio. Nulla non hendrerit velit, eu ullamcorper diam. Duis viverra id libero ut consequat. Vivamus convallis lorem urna, ut ullamcorper est euismod vel. Lorem ipsum dolor sit amet, consectetur adipiscing elit. \r\n      </div>\r\n    </div>\r\n  </div>\r\n  <div class="panel panel-default">\r\n    <div class="panel-heading">\r\n      <h4 class="panel-title">\r\n        <a data-toggle="collapse" data-parent="#accordion" href="#collapse10">\r\n          Lorem ipsum dolor sit amet consectetur adipiscing elit?\r\n        </a>\r\n      </h4>\r\n    </div>\r\n    <div id="collapse10" class="panel-collapse collapse">\r\n      <div class="panel-body">\r\nLorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam id ultricies nibh, vitae hendrerit odio. Nulla non hendrerit velit, eu ullamcorper diam. Duis viverra id libero ut consequat. Vivamus convallis lorem urna, ut ullamcorper est euismod vel. Lorem ipsum dolor sit amet, consectetur adipiscing elit. \r\n      </div>\r\n    </div>\r\n  </div>\r\n  <div class="panel panel-default">\r\n    <div class="panel-heading">\r\n      <h4 class="panel-title">\r\n        <a data-toggle="collapse" data-parent="#accordion" href="#collapse11">\r\n          Lorem ipsum dolor sit amet consectetur adipiscing elit?\r\n        </a>\r\n      </h4>\r\n    </div>\r\n    <div id="collapse11" class="panel-collapse collapse">\r\n      <div class="panel-body">\r\nLorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam id ultricies nibh, vitae hendrerit odio. Nulla non hendrerit velit, eu ullamcorper diam. Duis viverra id libero ut consequat. Vivamus convallis lorem urna, ut ullamcorper est euismod vel. Lorem ipsum dolor sit amet, consectetur adipiscing elit. \r\n      </div>\r\n    </div>\r\n  </div>\r\n  <div class="panel panel-default">\r\n    <div class="panel-heading">\r\n      <h4 class="panel-title">\r\n        <a data-toggle="collapse" data-parent="#accordion" href="#collapse12">\r\n          Lorem ipsum dolor sit amet consectetur adipiscing elit?\r\n        </a>\r\n      </h4>\r\n    </div>\r\n    <div id="collapse12" class="panel-collapse collapse">\r\n      <div class="panel-body">\r\nLorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam id ultricies nibh, vitae hendrerit odio. Nulla non hendrerit velit, eu ullamcorper diam. Duis viverra id libero ut consequat. Vivamus convallis lorem urna, ut ullamcorper est euismod vel. Lorem ipsum dolor sit amet, consectetur adipiscing elit. \r\n      </div>\r\n    </div>\r\n  </div>\r\n    <div class="panel panel-default">\r\n    <div class="panel-heading">\r\n      <h4 class="panel-title">\r\n        <a data-toggle="collapse" data-parent="#accordion" href="#collapse13">\r\n          Lorem ipsum dolor sit amet consectetur adipiscing elit?\r\n        </a>\r\n      </h4>\r\n    </div>\r\n    <div id="collapse13" class="panel-collapse collapse">\r\n      <div class="panel-body">\r\nLorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam id ultricies nibh, vitae hendrerit odio. Nulla non hendrerit velit, eu ullamcorper diam. Duis viverra id libero ut consequat. Vivamus convallis lorem urna, ut ullamcorper est euismod vel. Lorem ipsum dolor sit amet, consectetur adipiscing elit. \r\n      </div>\r\n    </div>\r\n  </div>\r\n\r\n\r\n</div>\r\n', '', 1, 11, '2014-07-28 13:22:20', 651, '', '2014-07-28 13:22:24', 444, 0, '0000-00-00 00:00:00', '2014-07-28 13:22:20', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 2, 0, '', '', 1, 96, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(6, 71, 'About us 2', 'about-us-2', '<div class="dark-bg col-xs-12 mn-about big-typo">\r\n	<div class="mn-about-inner">\r\n        <div class="mn-about-img col-md-6">\r\n            <img src="images/oxygen/about/about1.jpg" border="0" alt="about1">\r\n        </div>\r\n        <div class="mn-about-content col-md-6">\r\n        	<div class="mn-about-content-inner-right">\r\n                <h3 class="text-justify"><span>Who We are</span></h3>\r\n                <h5 class="text-justify">Lorem Ipsum dolor sit amet, consectetur adipisicing.</h5>\r\n                <p class="text-justify">Dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Donec aliquam commodo justo. Aenean leo ligula, porttitor eu, consequat vitae seasne eleifend ac enim.</p>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</div>\r\n\r\n<div class="dark-bg col-xs-12 mn-about big-typo">\r\n	<div class="mn-about-inner">\r\n        <div class="mn-about-content col-md-6">\r\n        	<div class="mn-about-content-inner-left">\r\n                <h3 class="text-justify"><span>What We Do</span></h3>\r\n                <h5 class="text-justify">Lorem Ipsum dolor sit amet, consectetur adipisicing.</h5>\r\n                <p class="text-justify">Dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Donec aliquam commodo justo. Aenean leo ligula, porttitor eu, consequat vitae seasne eleifend ac enim.</p>\r\n            </div>\r\n        </div>\r\n        <div class="mn-about-img col-md-6">\r\n            <img src="images/oxygen/about/about2.jpg" border="0" alt="about2">\r\n        </div>\r\n    </div>\r\n</div>\r\n\r\n<div class="dark-bg col-xs-12 mn-about big-typo">\r\n	<div class="mn-about-inner">\r\n        <div class="mn-about-img col-md-6">\r\n            <img src="images/oxygen/about/about3.jpg" border="0" alt="about3">\r\n        </div>\r\n        <div class="mn-about-content col-md-6">\r\n        	<div class="mn-about-content-inner-right">\r\n                <h3 class="text-justify"><span>Our Story is  Quite Old</span></h3>\r\n                <h5 class="text-justify">Lorem Ipsum dolor sit amet, consectetur adipisicing.</h5>\r\n                <p class="text-justify">Dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Donec aliquam commodo justo. Aenean leo ligula, porttitor eu, consequat vitae seasne eleifend ac enim.</p>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</div>\r\n\r\n', '', 1, 2, '2014-07-28 13:23:15', 651, '', '2015-05-28 16:26:10', 266, 0, '0000-00-00 00:00:00', '2014-07-28 13:23:15', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 68, 6, '', '', 1, 529, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(7, 72, 'Page Breaks', 'page-breaks', '', '\r\n<p>Ut dignissim aliquet nibh tristique hendrerit. Donec ullamcorper nulla quis metus vulputate id placerat augue eleifend. Aenean venenatis consectetur orci, sit amet ultricies magna sagittis vel. Nulla non diam nisi, ut ultrices massa. Pellentesque sed nisl metus. Praesent a mi vel ante molestie venenatis.</p>\r\n<p>Donec sed odio dui. Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Donec id elit non mi porta gravida at eget metus. Etiam porta sem malesuada magna mollis euismod. Cras justo odio, dapibus ac facilisis in, egestas eget quam.</p>\r\n<p>Mauris justo metus, ultrices id lobortis et, euismod sit amet metus. Maecenas sed nisl a arcu ultricies consectetur. Integer ut mollis elit. Nulla ultrices scelerisque mauris id commodo. Integer congue lectus et justo pellentesque sed semper lacus facilisis. Nunc tristique placerat odio eget rutrum.</p>\r\n<p>Ut viverra erat id augue bibendum rutrum. Nam aliquet feugiat molestie. Maecenas tempus scelerisque tellus eu mattis. Aliquam dignissim aliquam posuere. Sed dignissim, ipsum sed sodales aliquam, erat dolor varius eros, in semper sem metus vel metus. Nullam est mauris, laoreet condimentum hendrerit et, euismod quis dolor. Nunc eleifend lacinia libero eget scelerisque. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae.</p>\r\n<p>Nulla vitae elit libero, a pharetra augue. Donec ullamcorper nulla non metus auctor fringilla. Nulla vitae elit libero, a pharetra augue. Aenean lacinia bibendum nulla sed consectetur. Donec id elit non mi porta gravida at eget metus.</p>\r\n<p>Vivamus eget est urna. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Vivamus mauris justo, fermentum quis mattis vel, auctor vitae metus. Maecenas non dolor ac risus faucibus luctus non id turpis. Morbi ante nibh, suscipit non adipiscing in, ornare in ipsum.</p>\r\n<hr title="Second page" alt="second-page" class="system-pagebreak" />\r\n<p>Nullam ac odio orci, sed pretium velit. Integer sit amet justo faucibus lorem imperdiet sagittis. Proin egestas, risus in faucibus sodales, tortor turpis feugiat risus, varius laoreet dui turpis ac dolor. Nullam suscipit fringilla augue non rhoncus. Nullam ac nibh eu ipsum tristique ullamcorper. Nunc porttitor lorem id orci dapibus lacinia. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas.</p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed posuere consectetur est at lobortis. Vestibulum id ligula porta felis euismod semper. Donec id elit non mi porta gravida at eget metus. Integer posuere erat a ante venenatis dapibus posuere velit aliquet.</p>\r\n<p>Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Maecenas sed diam eget risus varius blandit sit amet non magna. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus.</p>\r\n<hr title="Third page" alt="third-page" class="system-pagebreak" />\r\n<p> </p>\r\n<p>Donec sed odio dui. Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Donec id elit non mi porta gravida at eget metus. Etiam porta sem malesuada magna mollis euismod. Cras justo odio, dapibus ac facilisis in, egestas eget quam.</p>\r\n<p>Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Maecenas sed diam eget risus varius blandit sit amet non magna. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus.</p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed posuere consectetur est at lobortis. Vestibulum id ligula porta felis euismod semper. Donec id elit non mi porta gravida at eget metus. Integer posuere erat a ante venenatis dapibus posuere velit aliquet.</p>\r\n<p>Nulla vitae elit libero, a pharetra augue. Donec ullamcorper nulla non metus auctor fringilla. Nulla vitae elit libero, a pharetra augue. Aenean lacinia bibendum nulla sed consectetur. Donec id elit non mi porta gravida at eget metus.</p>\r\n<hr title="Fourth page" alt="fourth-page" class="system-pagebreak" />\r\n<p>Maecenas faucibus mollis interdum. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Donec id elit non mi porta gravida at eget metus. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Praesent commodo cursus magna, vel scelerisque nisl consectetur et.</p>\r\n<p>Fusce id enim id erat sodales auctor. Duis tortor nisl, condimentum vel feugiat vel, venenatis ut dolor. Donec interdum ornare ligula, vitae adipiscing diam imperdiet at. Donec facilisis, nunc sit amet ultricies adipiscing, ligula justo congue lectus, sit amet vehicula enim lorem in neque. In ultrices bibendum justo ac vehicula. Nam tincidunt blandit consequat.</p>\r\n<p>Vestibulum id ligula porta felis euismod semper. Cras justo odio, dapibus ac facilisis in, egestas eget quam. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Donec id elit non mi porta gravida at eget metus.</p>\r\n<hr title="Fifth page" alt="fifth-page" class="system-pagebreak" />\r\n<p>Nullam quis risus eget urna mollis ornare vel eu leo. Sed posuere consectetur est at lobortis. Aenean lacinia bibendum nulla sed consectetur. Maecenas sed diam eget risus varius blandit sit amet non magna. Etiam porta sem malesuada magna mollis euismod.</p>\r\n<p>Nullam quis risus eget urna mollis ornare vel eu leo. Donec id elit non mi porta gravida at eget metus. Aenean lacinia bibendum nulla sed consectetur.</p>\r\n<p>Vestibulum id ligula porta felis euismod semper. Donec ullamcorper nulla non metus auctor fringilla. Curabitur blandit tempus porttitor. Donec id elit non mi porta gravida at eget metus. Cras justo odio, dapibus ac facilisis in, egestas eget quam.</p>\r\n<p> </p>', 1, 2, '2014-07-28 13:23:49', 651, '', '2014-07-28 13:23:53', 444, 0, '0000-00-00 00:00:00', '2014-07-28 13:23:49', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 2, 5, '', '', 1, 30, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(8, 73, 'Typography', 'typography', '\r\n<div class="page-header col-xs-12">\r\n  <h2 id="headings">ALERTS</h2>\r\n</div>\r\n<div class="col-xs-12 col-sm-6">\r\n  <div class="alert alert-success"> <strong>Success!</strong> You successfully read this important alert message.\r\n    <button class="close" type="button" data-dismiss="alert">?</button>\r\n  </div>\r\n  <div class="alert alert-info"> <strong>Info!</strong> This alert needs your attention, but it''s not super important.\r\n    <button class="close" type="button" data-dismiss="alert">?</button>\r\n  </div>\r\n</div>\r\n<div class="col-xs-12 col-sm-6">\r\n  <div class="alert alert-warning"> <strong>Warning!</strong> Best check yo self, you''re not looking too good.\r\n    <button class="close" type="button" data-dismiss="alert">?</button>\r\n  </div>\r\n  <div class="alert alert-error fade in">\r\n    <button class="close" type="button" data-dismiss="alert">?</button>\r\n    <strong>Error!</strong> Empty password not allowed </div>\r\n</div>\r\n<div class="col-xs-12 col-sm-12">\r\n  <div class="page-header">\r\n    <h2 id="headings">HEADINGS</h2>\r\n  </div>\r\n  <div class="bs-example bs-example-type">\r\n    <table class="table">\r\n      <tbody>\r\n        <tr>\r\n          <td><h1>h1. Heading <small>Secondary text</small></h1></td>\r\n        </tr>\r\n        <tr>\r\n          <td><h2>h2. Heading <small>Secondary text</small></h2></td>\r\n        </tr>\r\n        <tr>\r\n          <td><h3>h3. Heading <small>Secondary text</small></h3></td>\r\n        </tr>\r\n        <tr>\r\n          <td><h4>h4. Heading <small>Secondary text</small></h4></td>\r\n        </tr>\r\n        <tr>\r\n          <td><h5>h5. Heading <small>Secondary text</small></h5></td>\r\n        </tr>\r\n        <tr>\r\n          <td><h6>h6. Heading <small>Secondary text</small></h6></td>\r\n        </tr>\r\n      </tbody>\r\n    </table>\r\n  </div>\r\n  <div class="highlight">\r\n    <pre><code class="html"><span class="nt">&lt;h1&gt;</span>h1. Bootstrap heading <span class="nt">&lt;small&gt;</span>Secondary text<span class="nt">&lt;/small&gt;&lt;/h1&gt;</span>\r\n<span class="nt">&lt;h2&gt;</span>h2. heading <span class="nt">&lt;small&gt;</span>Secondary text<span class="nt">&lt;/small&gt;&lt;/h2&gt;</span>\r\n<span class="nt">&lt;h3&gt;</span>h3. heading <span class="nt">&lt;small&gt;</span>Secondary text<span class="nt">&lt;/small&gt;&lt;/h3&gt;</span>\r\n<span class="nt">&lt;h4&gt;</span>h4. heading <span class="nt">&lt;small&gt;</span>Secondary text<span class="nt">&lt;/small&gt;&lt;/h4&gt;</span>\r\n<span class="nt">&lt;h5&gt;</span>h5. heading <span class="nt">&lt;small&gt;</span>Secondary text<span class="nt">&lt;/small&gt;&lt;/h5&gt;</span>\r\n<span class="nt">&lt;h6&gt;</span>h6. heading <span class="nt">&lt;small&gt;</span>Secondary text<span class="nt">&lt;/small&gt;&lt;/h6&gt;</span>\r\n</code></pre>\r\n  </div>\r\n</div>\r\n<div class="col-xs-12 col-md-6">\r\n  <div class="page-header">\r\n    <h2 id="headings">Body Text</h2>\r\n  </div>\r\n  <div class="bs-example">\r\n    <p>Nullam quis risus eget urna mollis ornare vel eu leo. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Nullam id dolor id nibh ultricies vehicula.</p>\r\n  </div>\r\n  <div class="highlight">\r\n    <pre><code class="html"><span class="nt">&lt;p&gt;</span>...<span class="nt">&lt;/p&gt;</span>\r\n</code></pre>\r\n  </div>\r\n</div>\r\n<div class="col-xs-12 col-md-6">\r\n  <div class="page-header">\r\n    <h2 id="headings">Lead Body Text</h2>\r\n  </div>\r\n  <div class="bs-example">\r\n    <p class="lead">Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Duis mollis, est non commodo luctus.</p>\r\n  </div>\r\n  <div class="highlight">\r\n    <pre><code class="html"><span class="nt">&lt;p</span> <span class="na">class=</span><span class="s">"lead"</span><span class="nt">&gt;</span>...<span class="nt">&lt;/p&gt;</span>\r\n</code></pre>\r\n  </div>\r\n</div>\r\n<div class="clearfix"></div>\r\n<div class="col-xs-12 col-md-6">\r\n  <div class="page-header">\r\n    <h2 id="headings">Abbreviations</h2>\r\n  </div>\r\n  <div class="bs-example">\r\n    <p>An abbreviation of the word attribute is <abbr title="attribute">attr</abbr>.</p>\r\n  </div>\r\n  <div class="highlight">\r\n    <pre><code class="html"><span class="nt">&lt;abbr</span> <span class="na">title=</span><span class="s">"attribute"</span><span class="nt">&gt;</span>attr<span class="nt">&lt;/abbr&gt;</span>\r\n</code></pre>\r\n  </div>\r\n</div>\r\n<div class="col-xs-12 col-md-6">\r\n  <div class="page-header">\r\n    <h2 id="headings">Initialism</h2>\r\n  </div>\r\n  <div class="bs-example">\r\n    <p><abbr title="HyperText Markup Language" class="initialism">HTML</abbr> is the best thing since sliced bread.</p>\r\n  </div>\r\n  <div class="highlight">\r\n    <pre><code class="html"><span class="nt">&lt;abbr</span> <span class="na">title=</span><span class="s">"HyperText Markup Language"</span> <span class="na">class=</span><span class="s">"initialism"</span><span class="nt">&gt;</span>HTML<span class="nt">&lt;/abbr&gt;</span>\r\n</code></pre>\r\n  </div>\r\n</div>\r\n<div class="clearfix"></div>\r\n<div class="col-xs-12 col-md-6">\r\n  <div class="page-header">\r\n    <h2 id="headings">Labels</h2>\r\n  </div>\r\n  <div class="bs-example"> <span class="label label-default">Default</span> <span class="label label-primary">Primary</span> <span class="label label-success">Success</span> <span class="label label-info">Info</span> <span class="label label-warning">Warning</span> <span class="label label-danger">Danger</span> </div>\r\n  <div class="highlight">\r\n    <pre><code class="html"><span class="nt">&lt;span</span> <span class="na">class=</span><span class="s">"label label-default"</span><span class="nt">&gt;</span>Default<span class="nt">&lt;/span&gt;</span>\r\n<span class="nt">&lt;span</span> <span class="na">class=</span><span class="s">"label label-primary"</span><span class="nt">&gt;</span>Primary<span class="nt">&lt;/span&gt;</span>\r\n<span class="nt">&lt;span</span> <span class="na">class=</span><span class="s">"label label-success"</span><span class="nt">&gt;</span>Success<span class="nt">&lt;/span&gt;</span>\r\n<span class="nt">&lt;span</span> <span class="na">class=</span><span class="s">"label label-info"</span><span class="nt">&gt;</span>Info<span class="nt">&lt;/span&gt;</span>\r\n<span class="nt">&lt;span</span> <span class="na">class=</span><span class="s">"label label-warning"</span><span class="nt">&gt;</span>Warning<span class="nt">&lt;/span&gt;</span>\r\n<span class="nt">&lt;span</span> <span class="na">class=</span><span class="s">"label label-danger"</span><span class="nt">&gt;</span>Danger<span class="nt">&lt;/span&gt;</span>\r\n</code></pre>\r\n  </div>\r\n</div>\r\n<div class="col-xs-12 col-md-6">\r\n  <div class="page-header">\r\n    <h2 id="headings">Badges</h2>\r\n  </div>\r\n  <div class="bs-example"> <a href="#">Inbox <span class="badge">42</span></a> </div>\r\n  <div class="highlight">\r\n    <pre><code class="html"><span class="nt">&lt;a</span> <span class="na">href=</span><span class="s">"#"</span><span class="nt">&gt;</span>Inbox <span class="nt">&lt;span</span> <span class="na">class=</span><span class="s">"badge"</span><span class="nt">&gt;</span>42<span class="nt">&lt;/span&gt;&lt;/a&gt;</span>\r\n</code></pre>\r\n  </div>\r\n</div>\r\n<div class="clearfix"></div>\r\n<div class="page-header col-xs-12">\r\n  <h2 id="headings">BLOCKQUOTES</h2>\r\n</div>\r\n<div class="col-xs-12 col-md-6">\r\n  <div class="page-header">\r\n    <h2 id="headings">Default blockquote</h2>\r\n  </div>\r\n  <div class="bs-example">\r\n    <blockquote>\r\n      <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.</p>\r\n    </blockquote>\r\n  </div>\r\n  <div class="highlight">\r\n    <pre><code class="html"><span class="nt">&lt;blockquote&gt;</span>\r\n  <span class="nt">&lt;p&gt;</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.<span class="nt">&lt;/p&gt;</span>\r\n<span class="nt">&lt;/blockquote&gt;</span>\r\n</code></pre>\r\n  </div>\r\n</div>\r\n<div class="col-xs-12 col-md-6">\r\n  <div class="page-header">\r\n    <h2 id="headings">Blockquote options</h2>\r\n  </div>\r\n  <div class="bs-example">\r\n    <blockquote>\r\n      <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.</p>\r\n      <small>Someone famous in <cite title="Source Title">Source Title</cite></small> </blockquote>\r\n  </div>\r\n  <div class="highlight">\r\n    <pre><code class="html"><span class="nt">&lt;blockquote&gt;</span>\r\n  <span class="nt">&lt;p&gt;</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.<span class="nt">&lt;/p&gt;</span>\r\n  <span class="nt">&lt;small&gt;</span>Someone famous in <span class="nt">&lt;cite</span> <span class="na">title=</span><span class="s">"Source Title"</span><span class="nt">&gt;</span>Source Title<span class="nt">&lt;/cite&gt;&lt;/small&gt;</span>\r\n<span class="nt">&lt;/blockquote&gt;</span>\r\n</code></pre>\r\n  </div>\r\n</div>\r\n<div class="clearfix"></div>\r\n<div class="col-xs-12">\r\n  <div class="page-header">\r\n    <h2 id="headings">Alternate blockquote display</h2>\r\n  </div>\r\n  <div class="bs-example" style="overflow: hidden;">\r\n    <blockquote class="pull-right">\r\n      <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.</p>\r\n      <small>Someone famous in <cite title="Source Title">Source Title</cite></small> </blockquote>\r\n  </div>\r\n  <div class="highlight">\r\n    <pre><code class="html"><span class="nt">&lt;blockquote</span> <span class="na">class=</span><span class="s">"pull-right"</span><span class="nt">&gt;</span>\r\n  ...\r\n<span class="nt">&lt;/blockquote&gt;</span>\r\n</code></pre>\r\n  </div>\r\n</div>\r\n<div class="page-header col-xs-12">\r\n  <h2 id="headings">LISTS</h2>\r\n</div>\r\n<div class="col-xs-12 col-md-6">\r\n  <div class="page-header">\r\n    <h2 id="headings">Unordered</h2>\r\n  </div>\r\n  <div class="bs-example">\r\n    <ul>\r\n      <li>Lorem ipsum dolor sit amet</li>\r\n      <li>Consectetur adipiscing elit</li>\r\n      <li>Nulla volutpat aliquam velit\r\n        <ul>\r\n          <li>Phasellus iaculis neque</li>\r\n          <li>Purus sodales ultricies</li>\r\n          <li>Vestibulum laoreet porttitor sem</li>\r\n          <li>Ac tristique libero volutpat at</li>\r\n        </ul>\r\n      </li>\r\n      <li>Faucibus porta lacus fringilla vel</li>\r\n    </ul>\r\n  </div>\r\n  <div class="highlight">\r\n    <pre><code class="html"><span class="nt">&lt;ul&gt;</span>\r\n  <span class="nt">&lt;li&gt;</span>...<span class="nt">&lt;/li&gt;</span>\r\n<span class="nt">&lt;/ul&gt;</span>\r\n</code></pre>\r\n  </div>\r\n</div>\r\n<div class="col-xs-12 col-md-6">\r\n  <div class="page-header">\r\n    <h2 id="headings">Ordered</h2>\r\n  </div>\r\n  <div class="bs-example">\r\n    <ol>\r\n      <li>Lorem ipsum dolor sit amet</li>\r\n      <li>Consectetur adipiscing elit</li>\r\n      <li>Integer molestie lorem at massa</li>\r\n      <li>Facilisis in pretium nisl aliquet</li>\r\n      <li>Nulla volutpat aliquam velit</li>\r\n      <li>Faucibus porta lacus fringilla vel</li>\r\n      <li>Aenean sit amet erat nunc</li>\r\n      <li>Eget porttitor lorem</li>\r\n    </ol>\r\n  </div>\r\n  <div class="highlight">\r\n    <pre><code class="html"><span class="nt">&lt;ol&gt;</span>\r\n  <span class="nt">&lt;li&gt;</span>...<span class="nt">&lt;/li&gt;</span>\r\n<span class="nt">&lt;/ol&gt;</span>\r\n</code></pre>\r\n  </div>\r\n</div>\r\n<div class="clearfix"></div>\r\n<div class="col-xs-12 col-md-6">\r\n  <div class="page-header">\r\n    <h2 id="headings">Unstyled</h2>\r\n  </div>\r\n  <div class="bs-example">\r\n    <ul class="list-unstyled">\r\n      <li>Lorem ipsum dolor sit amet</li>\r\n      <li>Nulla volutpat aliquam velit\r\n        <ul>\r\n          <li>Phasellus iaculis neque</li>\r\n          <li>Purus sodales ultricies</li>\r\n          <li>Vestibulum laoreet porttitor sem</li>\r\n          <li>Ac tristique libero volutpat at</li>\r\n        </ul>\r\n      </li>\r\n      <li>Faucibus porta lacus fringilla vel</li>\r\n    </ul>\r\n  </div>\r\n  <div class="highlight">\r\n    <pre><code class="html"><span class="nt">&lt;ul</span> <span class="na">class=</span><span class="s">"list-unstyled"</span><span class="nt">&gt;</span>\r\n  <span class="nt">&lt;li&gt;</span>...<span class="nt">&lt;/li&gt;</span>\r\n<span class="nt">&lt;/ul&gt;</span>\r\n</code></pre>\r\n  </div>\r\n</div>\r\n<div class="col-xs-12 col-md-6">\r\n  <div class="page-header">\r\n    <h2 id="headings">Inline</h2>\r\n  </div>\r\n  <div class="bs-example">\r\n    <ul class="list-inline">\r\n      <li>Lorem ipsum</li>\r\n      <li>Phasellus iaculis</li>\r\n      <li>Nulla volutpat</li>\r\n    </ul>\r\n  </div>\r\n  <div class="highlight">\r\n    <pre><code class="html"><span class="nt">&lt;ul</span> <span class="na">class=</span><span class="s">"list-inline"</span><span class="nt">&gt;</span>\r\n  <span class="nt">&lt;li&gt;</span>...<span class="nt">&lt;/li&gt;</span>\r\n<span class="nt">&lt;/ul&gt;</span>\r\n</code></pre>\r\n  </div>\r\n</div>\r\n<div class="clearfix"></div>\r\n<div class="col-xs-12 col-md-6">\r\n  <div class="page-header">\r\n    <h2 id="headings">Description</h2>\r\n  </div>\r\n  <div class="bs-example">\r\n    <dl>\r\n      <dt>Description lists</dt>\r\n      <dd>A description list is perfect for defining terms.</dd>\r\n      <dt>Euismod</dt>\r\n      <dd>Vestibulum id ligula porta felis euismod semper eget lacinia odio sem nec elit.</dd>\r\n      <dd>Donec id elit non mi porta gravida at eget metus.</dd>\r\n      <dt>Malesuada porta</dt>\r\n      <dd>Etiam porta sem malesuada magna mollis euismod.</dd>\r\n    </dl>\r\n  </div>\r\n  <div class="highlight">\r\n    <pre><code class="html"><span class="nt">&lt;dl&gt;</span>\r\n  <span class="nt">&lt;dt&gt;</span>...<span class="nt">&lt;/dt&gt;</span>\r\n  <span class="nt">&lt;dd&gt;</span>...<span class="nt">&lt;/dd&gt;</span>\r\n<span class="nt">&lt;/dl&gt;</span>\r\n</code></pre>\r\n  </div>\r\n</div>\r\n<div class="col-xs-12 col-md-6">\r\n  <div class="page-header">\r\n    <h2 id="headings">Horizontal description</h2>\r\n  </div>\r\n  <div class="bs-example">\r\n    <dl class="dl-horizontal">\r\n      <dt>Description lists</dt>\r\n      <dd>A description list is perfect for defining terms.</dd>\r\n      <dt>Euismod</dt>\r\n      <dd>Vestibulum id ligula porta felis euismod semper eget lacinia odio sem nec elit.</dd>\r\n      <dt>Malesuada porta</dt>\r\n      <dd>Etiam porta sem malesuada magna mollis euismod.</dd>\r\n      <dt>Felis euismod semper eget lacinia</dt>\r\n      <dd>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus.</dd>\r\n    </dl>\r\n  </div>\r\n  <div class="highlight">\r\n    <pre><code class="html"><span class="nt">&lt;dl</span> <span class="na">class=</span><span class="s">"dl-horizontal"</span><span class="nt">&gt;</span>\r\n  <span class="nt">&lt;dt&gt;</span>...<span class="nt">&lt;/dt&gt;</span>\r\n  <span class="nt">&lt;dd&gt;</span>...<span class="nt">&lt;/dd&gt;</span>\r\n<span class="nt">&lt;/dl&gt;</span>\r\n</code></pre>\r\n  </div>\r\n</div>\r\n<div class="clearfix"></div>\r\n<div class="col-xs-12">\r\n  <div class="page-header">\r\n    <h2 id="headings">BUTTONS</h2>\r\n  </div>\r\n  <div class="bs-example">\r\n    <button type="button" class="btn btn-default">Default</button>\r\n    <button type="button" class="btn btn-primary">Primary</button>\r\n    <button type="button" class="btn btn-success">Success</button>\r\n    <button type="button" class="btn btn-info">Info</button>\r\n    <button type="button" class="btn btn-warning">Warning</button>\r\n    <button type="button" class="btn btn-danger">Danger</button>\r\n    <button type="button" class="btn btn-link">Link</button>\r\n  </div>\r\n  <div class="highlight">\r\n    <pre><code class="html"><span class="c">&lt;!-- Standard button --&gt;</span>\r\n<span class="nt">&lt;button</span> <span class="na">type=</span><span class="s">"button"</span> <span class="na">class=</span><span class="s">"btn btn-default"</span><span class="nt">&gt;</span>Default<span class="nt">&lt;/button&gt;</span>\r\n\r\n<span class="c">&lt;!-- Provides extra visual weight and identifies the primary action in a set of buttons --&gt;</span>\r\n<span class="nt">&lt;button</span> <span class="na">type=</span><span class="s">"button"</span> <span class="na">class=</span><span class="s">"btn btn-primary"</span><span class="nt">&gt;</span>Primary<span class="nt">&lt;/button&gt;</span>\r\n\r\n<span class="c">&lt;!-- Indicates a successful or positive action --&gt;</span>\r\n<span class="nt">&lt;button</span> <span class="na">type=</span><span class="s">"button"</span> <span class="na">class=</span><span class="s">"btn btn-success"</span><span class="nt">&gt;</span>Success<span class="nt">&lt;/button&gt;</span>\r\n\r\n<span class="c">&lt;!-- Contextual button for informational alert messages --&gt;</span>\r\n<span class="nt">&lt;button</span> <span class="na">type=</span><span class="s">"button"</span> <span class="na">class=</span><span class="s">"btn btn-info"</span><span class="nt">&gt;</span>Info<span class="nt">&lt;/button&gt;</span>\r\n\r\n<span class="c">&lt;!-- Indicates caution should be taken with this action --&gt;</span>\r\n<span class="nt">&lt;button</span> <span class="na">type=</span><span class="s">"button"</span> <span class="na">class=</span><span class="s">"btn btn-warning"</span><span class="nt">&gt;</span>Warning<span class="nt">&lt;/button&gt;</span>\r\n\r\n<span class="c">&lt;!-- Indicates a dangerous or potentially negative action --&gt;</span>\r\n<span class="nt">&lt;button</span> <span class="na">type=</span><span class="s">"button"</span> <span class="na">class=</span><span class="s">"btn btn-danger"</span><span class="nt">&gt;</span>Danger<span class="nt">&lt;/button&gt;</span>\r\n\r\n<span class="c">&lt;!-- Deemphasize a button by making it look like a link while maintaining button behavior --&gt;</span>\r\n<span class="nt">&lt;button</span> <span class="na">type=</span><span class="s">"button"</span> <span class="na">class=</span><span class="s">"btn btn-link"</span><span class="nt">&gt;</span>Link<span class="nt">&lt;/button&gt;</span>\r\n</code></pre>\r\n  </div>\r\n</div>\r\n<div class="clearfix"></div>\r\n<div class="col-xs-12">\r\n  <div class="page-header">\r\n    <h2 id="headings">Sizes</h2>\r\n  </div>\r\n  <div class="bs-example">\r\n    <p>\r\n      <button type="button" class="btn btn-primary btn-lg">Large button</button>\r\n      <button type="button" class="btn btn-default btn-lg">Large button</button>\r\n    </p>\r\n    <p>\r\n      <button type="button" class="btn btn-primary">Default button</button>\r\n      <button type="button" class="btn btn-default">Default button</button>\r\n    </p>\r\n    <p>\r\n      <button type="button" class="btn btn-primary btn-sm">Small button</button>\r\n      <button type="button" class="btn btn-default btn-sm">Small button</button>\r\n    </p>\r\n    <p>\r\n      <button type="button" class="btn btn-primary btn-xs">Extra small button</button>\r\n      <button type="button" class="btn btn-default btn-xs">Extra small button</button>\r\n    </p>\r\n  </div>\r\n  <div class="highlight">\r\n    <pre><code class="html"><span class="nt">&lt;p&gt;</span>\r\n  <span class="nt">&lt;button</span> <span class="na">type=</span><span class="s">"button"</span> <span class="na">class=</span><span class="s">"btn btn-primary btn-lg"</span><span class="nt">&gt;</span>Large button<span class="nt">&lt;/button&gt;</span>\r\n  <span class="nt">&lt;button</span> <span class="na">type=</span><span class="s">"button"</span> <span class="na">class=</span><span class="s">"btn btn-default btn-lg"</span><span class="nt">&gt;</span>Large button<span class="nt">&lt;/button&gt;</span>\r\n<span class="nt">&lt;/p&gt;</span>\r\n<span class="nt">&lt;p&gt;</span>\r\n  <span class="nt">&lt;button</span> <span class="na">type=</span><span class="s">"button"</span> <span class="na">class=</span><span class="s">"btn btn-primary"</span><span class="nt">&gt;</span>Default button<span class="nt">&lt;/button&gt;</span>\r\n  <span class="nt">&lt;button</span> <span class="na">type=</span><span class="s">"button"</span> <span class="na">class=</span><span class="s">"btn btn-default"</span><span class="nt">&gt;</span>Default button<span class="nt">&lt;/button&gt;</span>\r\n<span class="nt">&lt;/p&gt;</span>\r\n<span class="nt">&lt;p&gt;</span>\r\n  <span class="nt">&lt;button</span> <span class="na">type=</span><span class="s">"button"</span> <span class="na">class=</span><span class="s">"btn btn-primary btn-sm"</span><span class="nt">&gt;</span>Small button<span class="nt">&lt;/button&gt;</span>\r\n  <span class="nt">&lt;button</span> <span class="na">type=</span><span class="s">"button"</span> <span class="na">class=</span><span class="s">"btn btn-default btn-sm"</span><span class="nt">&gt;</span>Small button<span class="nt">&lt;/button&gt;</span>\r\n<span class="nt">&lt;/p&gt;</span>\r\n<span class="nt">&lt;p&gt;</span>\r\n  <span class="nt">&lt;button</span> <span class="na">type=</span><span class="s">"button"</span> <span class="na">class=</span><span class="s">"btn btn-primary btn-xs"</span><span class="nt">&gt;</span>Extra small button<span class="nt">&lt;/button&gt;</span>\r\n  <span class="nt">&lt;button</span> <span class="na">type=</span><span class="s">"button"</span> <span class="na">class=</span><span class="s">"btn btn-default btn-xs"</span><span class="nt">&gt;</span>Extra small button<span class="nt">&lt;/button&gt;</span>\r\n<span class="nt">&lt;/p&gt;</span>\r\n</code></pre>\r\n  </div>\r\n</div>\r\n<div class="clearfix"></div>\r\n<div class="col-xs-12">\r\n  <div class="page-header">\r\n    <h2 id="headings">JUMBOTRON</h2>\r\n  </div>\r\n  <div class="bs-example">\r\n    <div class="jumbotron">\r\n      <h1>Hello, world!</h1>\r\n      <p>This is a simple hero unit, a simple jumbotron-style component for calling extra attention to featured content or information.</p>\r\n      <p><a class="btn btn-primary btn-lg" role="button">Learn more</a></p>\r\n    </div>\r\n  </div>\r\n  <div class="highlight">\r\n    <pre><code class="html"><span class="nt">&lt;div</span> <span class="na">class=</span><span class="s">"jumbotron"</span><span class="nt">&gt;</span>\r\n  <span class="nt">&lt;h1&gt;</span>Hello, world!<span class="nt">&lt;/h1&gt;</span>\r\n  <span class="nt">&lt;p&gt;</span>...<span class="nt">&lt;/p&gt;</span>\r\n  <span class="nt">&lt;p&gt;&lt;a</span> <span class="na">class=</span><span class="s">"btn btn-primary btn-lg"</span> <span class="na">role=</span><span class="s">"button"</span><span class="nt">&gt;</span>Learn more<span class="nt">&lt;/a&gt;&lt;/p&gt;</span>\r\n<span class="nt">&lt;/div&gt;</span>\r\n</code></pre>\r\n  </div>\r\n</div>\r\n<div class="page-header col-xs-12">\r\n  <h2 id="headings">ICONS</h2>\r\n</div>\r\n<section id="new">\r\n  <h2 class="page-header">40 New Icons in 4.3</h2>\r\n  <div class="row fontawesome-icon-list">\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bed"></i> bed</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-buysellads"></i> buysellads</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cart-arrow-down"></i> cart-arrow-down</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cart-plus"></i> cart-plus</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-connectdevelop"></i> connectdevelop</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-dashcube"></i> dashcube</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-diamond"></i> diamond</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-facebook-official"></i> facebook-official</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-forumbee"></i> forumbee</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-heartbeat"></i> heartbeat</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-hotel"></i> hotel <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-leanpub"></i> leanpub</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-mars"></i> mars</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-mars-double"></i> mars-double</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-mars-stroke"></i> mars-stroke</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-mars-stroke-h"></i> mars-stroke-h</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-mars-stroke-v"></i> mars-stroke-v</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-medium"></i> medium</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-mercury"></i> mercury</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-motorcycle"></i> motorcycle</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-neuter"></i> neuter</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-pinterest-p"></i> pinterest-p</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-sellsy"></i> sellsy</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-server"></i> server</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-ship"></i> ship</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-shirtsinbulk"></i> shirtsinbulk</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-simplybuilt"></i> simplybuilt</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-skyatlas"></i> skyatlas</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-street-view"></i> street-view</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-subway"></i> subway</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-train"></i> train</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-transgender"></i> transgender</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-transgender-alt"></i> transgender-alt</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-user-plus"></i> user-plus</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-user-secret"></i> user-secret</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-user-times"></i> user-times</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-venus"></i> venus</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-venus-double"></i> venus-double</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-venus-mars"></i> venus-mars</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-viacoin"></i> viacoin</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-whatsapp"></i> whatsapp</div>\r\n  </div>\r\n</section>\r\n<section id="web-application">\r\n  <h2 class="page-header">Web Application Icons</h2>\r\n  <div class="row fontawesome-icon-list">\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-adjust"></i> adjust</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-anchor"></i> anchor</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-archive"></i> archive</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-area-chart"></i> area-chart</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-arrows"></i> arrows</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-arrows-h"></i> arrows-h</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-arrows-v"></i> arrows-v</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-asterisk"></i> asterisk</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-at"></i> at</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-automobile"></i> automobile <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-ban"></i> ban</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bank"></i> bank <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bar-chart"></i> bar-chart</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bar-chart-o"></i> bar-chart-o <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-barcode"></i> barcode</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bars"></i> bars</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bed"></i> bed</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-beer"></i> beer</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bell"></i> bell</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bell-o"></i> bell-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bell-slash"></i> bell-slash</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bell-slash-o"></i> bell-slash-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bicycle"></i> bicycle</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-binoculars"></i> binoculars</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-birthday-cake"></i> birthday-cake</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bolt"></i> bolt</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bomb"></i> bomb</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-book"></i> book</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bookmark"></i> bookmark</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bookmark-o"></i> bookmark-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-briefcase"></i> briefcase</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bug"></i> bug</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-building"></i> building</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-building-o"></i> building-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bullhorn"></i> bullhorn</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bullseye"></i> bullseye</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bus"></i> bus</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cab"></i> cab <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-calculator"></i> calculator</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-calendar"></i> calendar</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-calendar-o"></i> calendar-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-camera"></i> camera</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-camera-retro"></i> camera-retro</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-car"></i> car</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-caret-square-o-down"></i> caret-square-o-down</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-caret-square-o-left"></i> caret-square-o-left</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-caret-square-o-right"></i> caret-square-o-right</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-caret-square-o-up"></i> caret-square-o-up</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cart-arrow-down"></i> cart-arrow-down</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cart-plus"></i> cart-plus</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cc"></i> cc</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-certificate"></i> certificate</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-check"></i> check</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-check-circle"></i> check-circle</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-check-circle-o"></i> check-circle-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-check-square"></i> check-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-check-square-o"></i> check-square-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-child"></i> child</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-circle"></i> circle</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-circle-o"></i> circle-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-circle-o-notch"></i> circle-o-notch</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-circle-thin"></i> circle-thin</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-clock-o"></i> clock-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-close"></i> close <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cloud"></i> cloud</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cloud-download"></i> cloud-download</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cloud-upload"></i> cloud-upload</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-code"></i> code</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-code-fork"></i> code-fork</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-coffee"></i> coffee</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cog"></i> cog</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cogs"></i> cogs</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-comment"></i> comment</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-comment-o"></i> comment-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-comments"></i> comments</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-comments-o"></i> comments-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-compass"></i> compass</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-copyright"></i> copyright</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-credit-card"></i> credit-card</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-crop"></i> crop</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-crosshairs"></i> crosshairs</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cube"></i> cube</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cubes"></i> cubes</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cutlery"></i> cutlery</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-dashboard"></i> dashboard <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-database"></i> database</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-desktop"></i> desktop</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-diamond"></i> diamond</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-dot-circle-o"></i> dot-circle-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-download"></i> download</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-edit"></i> edit <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-ellipsis-h"></i> ellipsis-h</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-ellipsis-v"></i> ellipsis-v</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-envelope"></i> envelope</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-envelope-o"></i> envelope-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-envelope-square"></i> envelope-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-eraser"></i> eraser</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-exchange"></i> exchange</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-exclamation"></i> exclamation</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-exclamation-circle"></i> exclamation-circle</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-exclamation-triangle"></i> exclamation-triangle</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-external-link"></i> external-link</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-external-link-square"></i> external-link-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-eye"></i> eye</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-eye-slash"></i> eye-slash</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-eyedropper"></i> eyedropper</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-fax"></i> fax</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-female"></i> female</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-fighter-jet"></i> fighter-jet</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-archive-o"></i> file-archive-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-audio-o"></i> file-audio-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-code-o"></i> file-code-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-excel-o"></i> file-excel-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-image-o"></i> file-image-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-movie-o"></i> file-movie-o <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-pdf-o"></i> file-pdf-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-photo-o"></i> file-photo-o <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-picture-o"></i> file-picture-o <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-powerpoint-o"></i> file-powerpoint-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-sound-o"></i> file-sound-o <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-video-o"></i> file-video-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-word-o"></i> file-word-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-zip-o"></i> file-zip-o <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-film"></i> film</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-filter"></i> filter</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-fire"></i> fire</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-fire-extinguisher"></i> fire-extinguisher</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-flag"></i> flag</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-flag-checkered"></i> flag-checkered</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-flag-o"></i> flag-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-flash"></i> flash <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-flask"></i> flask</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-folder"></i> folder</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-folder-o"></i> folder-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-folder-open"></i> folder-open</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-folder-open-o"></i> folder-open-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-frown-o"></i> frown-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-futbol-o"></i> futbol-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-gamepad"></i> gamepad</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-gavel"></i> gavel</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-gear"></i> gear <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-gears"></i> gears <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-genderless"></i> genderless <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-gift"></i> gift</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-glass"></i> glass</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-globe"></i> globe</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-graduation-cap"></i> graduation-cap</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-group"></i> group <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-hdd-o"></i> hdd-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-headphones"></i> headphones</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-heart"></i> heart</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-heart-o"></i> heart-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-heartbeat"></i> heartbeat</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-history"></i> history</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-home"></i> home</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-hotel"></i> hotel <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-image"></i> image <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-inbox"></i> inbox</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-info"></i> info</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-info-circle"></i> info-circle</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-institution"></i> institution <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-key"></i> key</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-keyboard-o"></i> keyboard-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-language"></i> language</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-laptop"></i> laptop</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-leaf"></i> leaf</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-legal"></i> legal <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-lemon-o"></i> lemon-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-level-down"></i> level-down</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-level-up"></i> level-up</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-life-bouy"></i> life-bouy <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-life-buoy"></i> life-buoy <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-life-ring"></i> life-ring</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-life-saver"></i> life-saver <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-lightbulb-o"></i> lightbulb-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-line-chart"></i> line-chart</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-location-arrow"></i> location-arrow</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-lock"></i> lock</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-magic"></i> magic</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-magnet"></i> magnet</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-mail-forward"></i> mail-forward <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-mail-reply"></i> mail-reply <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-mail-reply-all"></i> mail-reply-all <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-male"></i> male</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-map-marker"></i> map-marker</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-meh-o"></i> meh-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-microphone"></i> microphone</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-microphone-slash"></i> microphone-slash</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-minus"></i> minus</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-minus-circle"></i> minus-circle</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-minus-square"></i> minus-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-minus-square-o"></i> minus-square-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-mobile"></i> mobile</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-mobile-phone"></i> mobile-phone <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-money"></i> money</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-moon-o"></i> moon-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-mortar-board"></i> mortar-board <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-motorcycle"></i> motorcycle</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-music"></i> music</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-navicon"></i> navicon <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-newspaper-o"></i> newspaper-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-paint-brush"></i> paint-brush</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-paper-plane"></i> paper-plane</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-paper-plane-o"></i> paper-plane-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-paw"></i> paw</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-pencil"></i> pencil</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-pencil-square"></i> pencil-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-pencil-square-o"></i> pencil-square-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-phone"></i> phone</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-phone-square"></i> phone-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-photo"></i> photo <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-picture-o"></i> picture-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-pie-chart"></i> pie-chart</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-plane"></i> plane</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-plug"></i> plug</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-plus"></i> plus</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-plus-circle"></i> plus-circle</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-plus-square"></i> plus-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-plus-square-o"></i> plus-square-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-power-off"></i> power-off</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-print"></i> print</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-puzzle-piece"></i> puzzle-piece</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-qrcode"></i> qrcode</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-question"></i> question</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-question-circle"></i> question-circle</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-quote-left"></i> quote-left</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-quote-right"></i> quote-right</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-random"></i> random</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-recycle"></i> recycle</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-refresh"></i> refresh</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-remove"></i> remove <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-reorder"></i> reorder <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-reply"></i> reply</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-reply-all"></i> reply-all</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-retweet"></i> retweet</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-road"></i> road</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-rocket"></i> rocket</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-rss"></i> rss</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-rss-square"></i> rss-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-search"></i> search</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-search-minus"></i> search-minus</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-search-plus"></i> search-plus</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-send"></i> send <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-send-o"></i> send-o <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-server"></i> server</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-share"></i> share</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-share-alt"></i> share-alt</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-share-alt-square"></i> share-alt-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-share-square"></i> share-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-share-square-o"></i> share-square-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-shield"></i> shield</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-ship"></i> ship</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-shopping-cart"></i> shopping-cart</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-sign-in"></i> sign-in</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-sign-out"></i> sign-out</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-signal"></i> signal</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-sitemap"></i> sitemap</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-sliders"></i> sliders</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-smile-o"></i> smile-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-soccer-ball-o"></i> soccer-ball-o <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-sort"></i> sort</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-sort-alpha-asc"></i> sort-alpha-asc</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-sort-alpha-desc"></i> sort-alpha-desc</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-sort-amount-asc"></i> sort-amount-asc</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-sort-amount-desc"></i> sort-amount-desc</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-sort-asc"></i> sort-asc</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-sort-desc"></i> sort-desc</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-sort-down"></i> sort-down <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-sort-numeric-asc"></i> sort-numeric-asc</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-sort-numeric-desc"></i> sort-numeric-desc</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-sort-up"></i> sort-up <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-space-shuttle"></i> space-shuttle</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-spinner"></i> spinner</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-spoon"></i> spoon</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-square"></i> square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-square-o"></i> square-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-star"></i> star</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-star-half"></i> star-half</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-star-half-empty"></i> star-half-empty <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-star-half-full"></i> star-half-full <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-star-half-o"></i> star-half-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-star-o"></i> star-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-street-view"></i> street-view</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-suitcase"></i> suitcase</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-sun-o"></i> sun-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-support"></i> support <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-tablet"></i> tablet</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-tachometer"></i> tachometer</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-tag"></i> tag</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-tags"></i> tags</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-tasks"></i> tasks</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-taxi"></i> taxi</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-terminal"></i> terminal</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-thumb-tack"></i> thumb-tack</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-thumbs-down"></i> thumbs-down</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-thumbs-o-down"></i> thumbs-o-down</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-thumbs-o-up"></i> thumbs-o-up</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-thumbs-up"></i> thumbs-up</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-ticket"></i> ticket</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-times"></i> times</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-times-circle"></i> times-circle</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-times-circle-o"></i> times-circle-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-tint"></i> tint</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-toggle-down"></i> toggle-down <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-toggle-left"></i> toggle-left <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-toggle-off"></i> toggle-off</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-toggle-on"></i> toggle-on</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-toggle-right"></i> toggle-right <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-toggle-up"></i> toggle-up <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-trash"></i> trash</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-trash-o"></i> trash-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-tree"></i> tree</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-trophy"></i> trophy</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-truck"></i> truck</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-tty"></i> tty</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-umbrella"></i> umbrella</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-university"></i> university</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-unlock"></i> unlock</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-unlock-alt"></i> unlock-alt</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-unsorted"></i> unsorted <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-upload"></i> upload</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-user"></i> user</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-user-plus"></i> user-plus</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-user-secret"></i> user-secret</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-user-times"></i> user-times</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-users"></i> users</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-video-camera"></i> video-camera</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-volume-down"></i> volume-down</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-volume-off"></i> volume-off</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-volume-up"></i> volume-up</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-warning"></i> warning <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-wheelchair"></i> wheelchair</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-wifi"></i> wifi</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-wrench"></i> wrench</div>\r\n  </div>\r\n</section>\r\n<section id="transportation">\r\n  <h2 class="page-header">Transportation Icons</h2>\r\n  <div class="row fontawesome-icon-list">\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-ambulance"></i> ambulance</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-automobile"></i> automobile <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bicycle"></i> bicycle</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bus"></i> bus</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cab"></i> cab <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-car"></i> car</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-fighter-jet"></i> fighter-jet</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-motorcycle"></i> motorcycle</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-plane"></i> plane</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-rocket"></i> rocket</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-ship"></i> ship</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-space-shuttle"></i> space-shuttle</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-subway"></i> subway</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-taxi"></i> taxi</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-train"></i> train</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-truck"></i> truck</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-wheelchair"></i> wheelchair</div>\r\n  </div>\r\n</section>\r\n<section id="gender">\r\n  <h2 class="page-header">Gender Icons</h2>\r\n  <div class="row fontawesome-icon-list">\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-circle-thin"></i> circle-thin</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-genderless"></i> genderless <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-mars"></i> mars</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-mars-double"></i> mars-double</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-mars-stroke"></i> mars-stroke</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-mars-stroke-h"></i> mars-stroke-h</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-mars-stroke-v"></i> mars-stroke-v</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-mercury"></i> mercury</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-neuter"></i> neuter</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-transgender"></i> transgender</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-transgender-alt"></i> transgender-alt</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-venus"></i> venus</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-venus-double"></i> venus-double</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-venus-mars"></i> venus-mars</div>\r\n  </div>\r\n</section>\r\n<section id="file-type">\r\n  <h2 class="page-header">File Type Icons</h2>\r\n  <div class="row fontawesome-icon-list">\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file"></i> file</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-archive-o"></i> file-archive-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-audio-o"></i> file-audio-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-code-o"></i> file-code-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-excel-o"></i> file-excel-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-image-o"></i> file-image-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-movie-o"></i> file-movie-o <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-o"></i> file-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-pdf-o"></i> file-pdf-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-photo-o"></i> file-photo-o <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-picture-o"></i> file-picture-o <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-powerpoint-o"></i> file-powerpoint-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-sound-o"></i> file-sound-o <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-text"></i> file-text</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-text-o"></i> file-text-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-video-o"></i> file-video-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-word-o"></i> file-word-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-zip-o"></i> file-zip-o <span class="text-muted">(alias)</span></div>\r\n  </div>\r\n</section>\r\n<section id="spinner">\r\n  <h2 class="page-header">Spinner Icons</h2>\r\n  <div class="row fontawesome-icon-list">\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-circle-o-notch"></i> circle-o-notch</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cog"></i> cog</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-gear"></i> gear <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-refresh"></i> refresh</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-spinner"></i> spinner</div>\r\n  </div>\r\n</section>\r\n<section id="form-control">\r\n  <h2 class="page-header">Form Control Icons</h2>\r\n  <div class="row fontawesome-icon-list">\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-check-square"></i> check-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-check-square-o"></i> check-square-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-circle"></i> circle</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-circle-o"></i> circle-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-dot-circle-o"></i> dot-circle-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-minus-square"></i> minus-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-minus-square-o"></i> minus-square-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-plus-square"></i> plus-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-plus-square-o"></i> plus-square-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-square"></i> square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-square-o"></i> square-o</div>\r\n  </div>\r\n</section>\r\n<section id="payment">\r\n  <h2 class="page-header">Payment Icons</h2>\r\n  <div class="row fontawesome-icon-list">\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cc-amex"></i> cc-amex</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cc-discover"></i> cc-discover</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cc-mastercard"></i> cc-mastercard</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cc-paypal"></i> cc-paypal</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cc-stripe"></i> cc-stripe</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cc-visa"></i> cc-visa</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-credit-card"></i> credit-card</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-google-wallet"></i> google-wallet</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-paypal"></i> paypal</div>\r\n  </div>\r\n</section>\r\n<section id="chart">\r\n  <h2 class="page-header">Chart Icons</h2>\r\n  <div class="row fontawesome-icon-list">\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-area-chart"></i> area-chart</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bar-chart"></i> bar-chart</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bar-chart-o"></i> bar-chart-o <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-line-chart"></i> line-chart</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-pie-chart"></i> pie-chart</div>\r\n  </div>\r\n</section>\r\n<section id="currency">\r\n  <h2 class="page-header">Currency Icons</h2>\r\n  <div class="row fontawesome-icon-list">\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bitcoin"></i> bitcoin <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-btc"></i> btc</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cny"></i> cny <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-dollar"></i> dollar <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-eur"></i> eur</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-euro"></i> euro <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-gbp"></i> gbp</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-ils"></i> ils</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-inr"></i> inr</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-jpy"></i> jpy</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-krw"></i> krw</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-money"></i> money</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-rmb"></i> rmb <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-rouble"></i> rouble <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-rub"></i> rub</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-ruble"></i> ruble <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-rupee"></i> rupee <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-shekel"></i> shekel <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-sheqel"></i> sheqel <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-try"></i> try</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-turkish-lira"></i> turkish-lira <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-usd"></i> usd</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-won"></i> won <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-yen"></i> yen <span class="text-muted">(alias)</span></div>\r\n  </div>\r\n</section>\r\n<section id="text-editor">\r\n  <h2 class="page-header">Text Editor Icons</h2>\r\n  <div class="row fontawesome-icon-list">\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-align-center"></i> align-center</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-align-justify"></i> align-justify</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-align-left"></i> align-left</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-align-right"></i> align-right</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bold"></i> bold</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-chain"></i> chain <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-chain-broken"></i> chain-broken</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-clipboard"></i> clipboard</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-columns"></i> columns</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-copy"></i> copy <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cut"></i> cut <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-dedent"></i> dedent <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-eraser"></i> eraser</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file"></i> file</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-o"></i> file-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-text"></i> file-text</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-file-text-o"></i> file-text-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-files-o"></i> files-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-floppy-o"></i> floppy-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-font"></i> font</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-header"></i> header</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-indent"></i> indent</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-italic"></i> italic</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-link"></i> link</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-list"></i> list</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-list-alt"></i> list-alt</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-list-ol"></i> list-ol</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-list-ul"></i> list-ul</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-outdent"></i> outdent</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-paperclip"></i> paperclip</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-paragraph"></i> paragraph</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-paste"></i> paste <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-repeat"></i> repeat</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-rotate-left"></i> rotate-left <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-rotate-right"></i> rotate-right <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-save"></i> save <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-scissors"></i> scissors</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-strikethrough"></i> strikethrough</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-subscript"></i> subscript</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-superscript"></i> superscript</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-table"></i> table</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-text-height"></i> text-height</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-text-width"></i> text-width</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-th"></i> th</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-th-large"></i> th-large</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-th-list"></i> th-list</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-underline"></i> underline</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-undo"></i> undo</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-unlink"></i> unlink <span class="text-muted">(alias)</span></div>\r\n  </div>\r\n</section>\r\n<section id="directional">\r\n  <h2 class="page-header">Directional Icons</h2>\r\n  <div class="row fontawesome-icon-list">\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-angle-double-down"></i> angle-double-down</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-angle-double-left"></i> angle-double-left</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-angle-double-right"></i> angle-double-right</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-angle-double-up"></i> angle-double-up</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-angle-down"></i> angle-down</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-angle-left"></i> angle-left</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-angle-right"></i> angle-right</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-angle-up"></i> angle-up</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-arrow-circle-down"></i> arrow-circle-down</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-arrow-circle-left"></i> arrow-circle-left</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-arrow-circle-o-down"></i> arrow-circle-o-down</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-arrow-circle-o-left"></i> arrow-circle-o-left</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-arrow-circle-o-right"></i> arrow-circle-o-right</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-arrow-circle-o-up"></i> arrow-circle-o-up</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-arrow-circle-right"></i> arrow-circle-right</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-arrow-circle-up"></i> arrow-circle-up</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-arrow-down"></i> arrow-down</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-arrow-left"></i> arrow-left</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-arrow-right"></i> arrow-right</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-arrow-up"></i> arrow-up</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-arrows"></i> arrows</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-arrows-alt"></i> arrows-alt</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-arrows-h"></i> arrows-h</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-arrows-v"></i> arrows-v</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-caret-down"></i> caret-down</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-caret-left"></i> caret-left</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-caret-right"></i> caret-right</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-caret-square-o-down"></i> caret-square-o-down</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-caret-square-o-left"></i> caret-square-o-left</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-caret-square-o-right"></i> caret-square-o-right</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-caret-square-o-up"></i> caret-square-o-up</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-caret-up"></i> caret-up</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-chevron-circle-down"></i> chevron-circle-down</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-chevron-circle-left"></i> chevron-circle-left</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-chevron-circle-right"></i> chevron-circle-right</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-chevron-circle-up"></i> chevron-circle-up</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-chevron-down"></i> chevron-down</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-chevron-left"></i> chevron-left</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-chevron-right"></i> chevron-right</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-chevron-up"></i> chevron-up</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-hand-o-down"></i> hand-o-down</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-hand-o-left"></i> hand-o-left</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-hand-o-right"></i> hand-o-right</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-hand-o-up"></i> hand-o-up</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-long-arrow-down"></i> long-arrow-down</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-long-arrow-left"></i> long-arrow-left</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-long-arrow-right"></i> long-arrow-right</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-long-arrow-up"></i> long-arrow-up</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-toggle-down"></i> toggle-down <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-toggle-left"></i> toggle-left <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-toggle-right"></i> toggle-right <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-toggle-up"></i> toggle-up <span class="text-muted">(alias)</span></div>\r\n  </div>\r\n</section>\r\n<section id="video-player">\r\n  <h2 class="page-header">Video Player Icons</h2>\r\n  <div class="row fontawesome-icon-list">\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-arrows-alt"></i> arrows-alt</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-backward"></i> backward</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-compress"></i> compress</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-eject"></i> eject</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-expand"></i> expand</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-fast-backward"></i> fast-backward</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-fast-forward"></i> fast-forward</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-forward"></i> forward</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-pause"></i> pause</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-play"></i> play</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-play-circle"></i> play-circle</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-play-circle-o"></i> play-circle-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-step-backward"></i> step-backward</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-step-forward"></i> step-forward</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-stop"></i> stop</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-youtube-play"></i> youtube-play</div>\r\n  </div>\r\n</section>\r\n<section id="brand">\r\n  <h2 class="page-header">Brand Icons</h2>\r\n  <div class="row fontawesome-icon-list margin-bottom-lg">\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-adn"></i> adn</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-android"></i> android</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-angellist"></i> angellist</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-apple"></i> apple</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-behance"></i> behance</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-behance-square"></i> behance-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bitbucket"></i> bitbucket</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bitbucket-square"></i> bitbucket-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-bitcoin"></i> bitcoin <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-btc"></i> btc</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-buysellads"></i> buysellads</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cc-amex"></i> cc-amex</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cc-discover"></i> cc-discover</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cc-mastercard"></i> cc-mastercard</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cc-paypal"></i> cc-paypal</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cc-stripe"></i> cc-stripe</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-cc-visa"></i> cc-visa</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-codepen"></i> codepen</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-connectdevelop"></i> connectdevelop</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-css3"></i> css3</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-dashcube"></i> dashcube</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-delicious"></i> delicious</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-deviantart"></i> deviantart</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-digg"></i> digg</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-dribbble"></i> dribbble</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-dropbox"></i> dropbox</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-drupal"></i> drupal</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-empire"></i> empire</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-facebook"></i> facebook</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-facebook-f"></i> facebook-f <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-facebook-official"></i> facebook-official</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-facebook-square"></i> facebook-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-flickr"></i> flickr</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-forumbee"></i> forumbee</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-foursquare"></i> foursquare</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-ge"></i> ge <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-git"></i> git</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-git-square"></i> git-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-github"></i> github</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-github-alt"></i> github-alt</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-github-square"></i> github-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-gittip"></i> gittip <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-google"></i> google</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-google-plus"></i> google-plus</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-google-plus-square"></i> google-plus-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-google-wallet"></i> google-wallet</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-gratipay"></i> gratipay</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-hacker-news"></i> hacker-news</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-html5"></i> html5</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-instagram"></i> instagram</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-ioxhost"></i> ioxhost</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-joomla"></i> joomla</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-jsfiddle"></i> jsfiddle</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-lastfm"></i> lastfm</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-lastfm-square"></i> lastfm-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-leanpub"></i> leanpub</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-linkedin"></i> linkedin</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-linkedin-square"></i> linkedin-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-linux"></i> linux</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-maxcdn"></i> maxcdn</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-meanpath"></i> meanpath</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-medium"></i> medium</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-openid"></i> openid</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-pagelines"></i> pagelines</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-paypal"></i> paypal</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-pied-piper"></i> pied-piper</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-pied-piper-alt"></i> pied-piper-alt</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-pinterest"></i> pinterest</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-pinterest-p"></i> pinterest-p</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-pinterest-square"></i> pinterest-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-qq"></i> qq</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-ra"></i> ra <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-rebel"></i> rebel</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-reddit"></i> reddit</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-reddit-square"></i> reddit-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-renren"></i> renren</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-sellsy"></i> sellsy</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-share-alt"></i> share-alt</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-share-alt-square"></i> share-alt-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-shirtsinbulk"></i> shirtsinbulk</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-simplybuilt"></i> simplybuilt</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-skyatlas"></i> skyatlas</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-skype"></i> skype</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-slack"></i> slack</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-slideshare"></i> slideshare</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-soundcloud"></i> soundcloud</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-spotify"></i> spotify</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-stack-exchange"></i> stack-exchange</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-stack-overflow"></i> stack-overflow</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-steam"></i> steam</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-steam-square"></i> steam-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-stumbleupon"></i> stumbleupon</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-stumbleupon-circle"></i> stumbleupon-circle</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-tencent-weibo"></i> tencent-weibo</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-trello"></i> trello</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-tumblr"></i> tumblr</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-tumblr-square"></i> tumblr-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-twitch"></i> twitch</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-twitter"></i> twitter</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-twitter-square"></i> twitter-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-viacoin"></i> viacoin</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-vimeo-square"></i> vimeo-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-vine"></i> vine</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-vk"></i> vk</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-wechat"></i> wechat <span class="text-muted">(alias)</span></div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-weibo"></i> weibo</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-weixin"></i> weixin</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-whatsapp"></i> whatsapp</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-windows"></i> windows</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-wordpress"></i> wordpress</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-xing"></i> xing</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-xing-square"></i> xing-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-yahoo"></i> yahoo</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-yelp"></i> yelp</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-youtube"></i> youtube</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-youtube-play"></i> youtube-play</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-youtube-square"></i> youtube-square</div>\r\n  </div>\r\n</section>\r\n<section id="medical">\r\n  <h2 class="page-header">Medical Icons</h2>\r\n  <div class="row fontawesome-icon-list">\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-ambulance"></i> ambulance</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-h-square"></i> h-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-heart"></i> heart</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-heart-o"></i> heart-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-heartbeat"></i> heartbeat</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-hospital-o"></i> hospital-o</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-medkit"></i> medkit</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-plus-square"></i> plus-square</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-stethoscope"></i> stethoscope</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-user-md"></i> user-md</div>\r\n    <div class="fa-hover col-md-3 col-sm-4"><i class="fa fa-wheelchair"></i> wheelchair</div>\r\n  </div>\r\n</section>\r\n', '', 1, 12, '2014-07-28 13:24:18', 651, '', '2015-05-18 13:01:41', 266, 0, '0000-00-00 00:00:00', '2014-07-28 13:24:18', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 13, 2, '', '', 1, 249, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(9, 74, 'Module variations', 'module-variations', '<p> </p>\r\n<div class="page-header">\r\n<h2>How to use</h2>\r\n</div>\r\n<blockquote>\r\n  <p>Module Class Suffix is a parameter in Joomla! modules. Setting this parameter causes Joomla! to either add a new CSS class or modify the existing CSS class for the div element for this specific module.</p>\r\n  <p>To use a module variation, just enter one of the following suffixes in the <strong>Module Class Suffix</strong> field of the module parameters:</p>\r\n</blockquote>\r\n<p> </p>\r\n<blockquote>\r\n  <p>mod_dark</p>\r\n</blockquote>\r\n\r\n<blockquote>\r\n  <p>mod_green</p>\r\n</blockquote>\r\n\r\n<blockquote>\r\n  <p>mod_yellow</p>\r\n</blockquote>\r\n\r\n<blockquote>\r\n  <p>mod_orange</p>\r\n</blockquote>\r\n\r\n<blockquote>\r\n  <p>mod_purple</p>\r\n</blockquote>\r\n\r\n<blockquote>\r\n  <p>mod_blue</p>\r\n</blockquote>\r\n\r\n\r\n<p> </p>\r\n<p><span class="label label-info">Heads up!</span> Make sure that you enter the suffix with a <strong>leading space</strong> otherwise the module styling will not be applied correctly.</p>\r\n<p> </p>\r\n<br>\r\n<div class="page-header">\r\n<h2>Extra suffixes</h2>\r\n</div>\r\n\r\n<blockquote>\r\n<p>no-padding</p>\r\n<small>Use this suffix in a module to apply a padding of 0 pixels.</small>\r\n</blockquote>\r\n<blockquote>\r\n<p>no-margin</p>\r\n<small>Use this suffix in a module to apply a margin of 0 pixels.</small>\r\n</blockquote>\r\n<blockquote>\r\n<p>formatModule</p>\r\n<small>Use this suffix to apply the default module style to a module in a spotlight position.</small>\r\n</blockquote>\r\n<blockquote>\r\n<p>padding15</p>\r\n<small>Use this suffix to apply a padding of 15 pixels to a module in a sidebar position.</small>\r\n</blockquote>\r\n<blockquote>\r\n<p>grey-bg</p>\r\n<small>Use this suffix in a menu item or module to apply a grey color as background color.</small>\r\n</blockquote>\r\n\r\n<blockquote>\r\n<p>mn-wall-portfolio</p>\r\n<small>Use this suffix in a Minitek Wall module to format the Wall.</small>\r\n</blockquote>\r\n\r\n<p> </p>', '', 1, 12, '2014-07-28 13:24:37', 651, '', '2015-07-29 16:23:02', 429, 0, '0000-00-00 00:00:00', '2014-07-28 13:24:37', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 32, 1, '', '', 1, 264, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(10, 77, 'Module positions', 'module-positions', '\r\n<div>\r\n    <div class="col-sm-3 bordered">\r\n        <p class="alert-info">Logo</p>\r\n    </div>\r\n    <div class="col-sm-3 bordered">\r\n        <p>mainmenu</p>\r\n    </div>\r\n    <div class="col-sm-2 bordered">\r\n        <p>login-popup</p>\r\n    </div>\r\n    <div class="col-sm-2 bordered">\r\n        <p>search-popup</p>\r\n    </div>\r\n    <div class="col-sm-2 bordered">\r\n        <p>top-popup</p>\r\n    </div>\r\n</div>\r\n\r\n<div>\r\n    <div class="col-sm-12 bordered">\r\n        <p>mn-slider</p>\r\n    </div>\r\n</div>\r\n\r\n<div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-1</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-2</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-3</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-4</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-5</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-6</p>\r\n    </div>\r\n</div>\r\n<div class="clearfix"></div>\r\n\r\n<div>\r\n    <div class="col-xs-12 bordered">\r\n        <p>mn-wrap1</p>\r\n    </div>\r\n</div>\r\n\r\n\r\n<div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-7</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-8</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-9</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-10</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-11</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-12</p>\r\n    </div>\r\n</div>\r\n\r\n\r\n<div>\r\n    <div class="col-xs-12 col-sm-12 bordered">\r\n        <p>mn-parallax1</p>\r\n    </div>\r\n</div>\r\n\r\n<div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-13</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-14</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-15</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-16</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-17</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-18</p>\r\n    </div>\r\n</div>\r\n\r\n<div col-xs-12>\r\n    <div class="col-xs-12 col-sm-3 no-padding">\r\n        <div class="bordered">\r\n            <p>sidebar-1</p>\r\n        </div>\r\n    </div>\r\n\r\n    <div class="col-xs-12 col-sm-6 no-padding">\r\n        <div class="bordered">\r\n            <p>mn-mastcol-top</p>\r\n        </div>\r\n        <div class="bordered">\r\n            <p>message</p>\r\n        </div>\r\n        <div class="bordered">\r\n            <p class="alert-info">component</p>\r\n        </div>\r\n        <div class="bordered">\r\n            <p>mn-mastcol-bottom</p>\r\n        </div>\r\n    </div>\r\n    \r\n    <div class="col-xs-12 col-sm-3 no-padding">\r\n        <div class="bordered">\r\n            <p>sidebar-2</p>\r\n        </div>\r\n    </div>\r\n</div>\r\n\r\n<div class="clearfix"></div>\r\n\r\n\r\n<div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-19</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-20</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-21</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-22</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-23</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-24</p>\r\n    </div>\r\n</div>\r\n\r\n\r\n<div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-25</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-26</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-27</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-28</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-29</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-30</p>\r\n    </div>\r\n</div>\r\n\r\n<div>\r\n    <div class="col-xs-12 bordered">\r\n        <p>navhelper</p>\r\n    </div>\r\n</div>\r\n\r\n<div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-31</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-32</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-33</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-34</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-35</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-36</p>\r\n    </div>\r\n</div>\r\n\r\n<div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-37</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-38</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-39</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-40</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-41</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>position-42</p>\r\n    </div>\r\n</div>\r\n\r\n\r\n<div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>footer-1</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>footer-2</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>footer-3</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>footer-4</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>footer-5</p>\r\n    </div>\r\n    <div class="col-xs-12 col-sm-2 bordered">\r\n        <p>footer-6</p>\r\n    </div>\r\n</div>\r\n\r\n\r\n<div>\r\n    <div class="col-xs-12 bordered">\r\n        <p>Copyright</p>\r\n    </div>\r\n</div>\r\n\r\n', '', 1, 12, '2014-07-28 13:27:54', 651, '', '2015-07-29 16:28:59', 429, 0, '0000-00-00 00:00:00', '2014-07-28 13:27:54', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 33, 0, '', '', 1, 217, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(11, 79, 'Archived Article I', 'archived-article-i', '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', 2, 2, '2014-07-28 14:19:45', 651, '', '2014-07-28 14:20:09', 444, 0, '0000-00-00 00:00:00', '2014-07-28 14:19:45', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 2, 4, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(12, 80, 'Archived Article II', 'archived-article-ii', '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', 2, 2, '2014-07-28 14:19:45', 651, '', '2014-07-28 14:20:34', 444, 0, '0000-00-00 00:00:00', '2014-07-28 14:19:45', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 3, 3, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(13, 81, 'Archived Article III', 'archived-article-iii', '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', 2, 2, '2014-07-28 14:19:45', 651, '', '2014-07-28 14:21:08', 444, 0, '0000-00-00 00:00:00', '2014-07-28 14:19:45', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 2, 2, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(46, 235, 'Improving visualization by using a new software', 'improving-visualization-by-using-a-new-software', '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', 1, 9, '2014-07-28 13:20:56', 651, '', '2015-07-19 15:14:20', 429, 0, '0000-00-00 00:00:00', '2014-07-28 13:20:56', '0000-00-00 00:00:00', '{"image_intro":"images\\/blueprint\\/articles\\/Improving_visualization_by_using_a_new_software.jpg","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"images\\/blueprint\\/articles\\/Improving_visualization_by_using_a_new_software.jpg","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 23, 1, '', '', 1, 64, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(49, 302, 'Experience and inspirational ideas', 'experience-and-inspirational-ideas', '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', 1, 9, '2014-07-28 13:20:56', 651, '', '2015-07-19 15:12:49', 429, 0, '0000-00-00 00:00:00', '2014-07-28 13:20:56', '0000-00-00 00:00:00', '{"image_intro":"images\\/blueprint\\/articles\\/Experience_and_inspirational_ideas.jpg","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"images\\/blueprint\\/articles\\/Experience_and_inspirational_ideas.jpg","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 23, 1, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(50, 303, 'The design of a luxury condominium tower', 'the-design-of-a-luxury-condominium-tower', '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', 1, 9, '2014-07-28 13:20:56', 651, '', '2015-07-19 15:12:03', 429, 0, '0000-00-00 00:00:00', '2014-07-28 13:20:56', '0000-00-00 00:00:00', '{"image_intro":"images\\/blueprint\\/articles\\/The_design_of_a_luxury_condominium_tower.jpg","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"images\\/blueprint\\/articles\\/The_design_of_a_luxury_condominium_tower.jpg","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 26, 1, '', '', 1, 21, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(51, 304, 'Buildings examples of Art Deco architecture', 'buildings-examples-of-art-deco-architecture', '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', 1, 9, '2014-07-28 13:20:56', 651, '', '2015-07-19 15:10:28', 429, 0, '0000-00-00 00:00:00', '2014-07-28 13:20:56', '0000-00-00 00:00:00', '{"image_intro":"images\\/blueprint\\/articles\\/Buildings_examples_of_Art_Deco_architecture.jpg","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"images\\/blueprint\\/articles\\/Buildings_examples_of_Art_Deco_architecture.jpg","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 28, 1, '', '', 1, 16, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(54, 307, 'Reading magazines helps our inspiration', 'reading-magazines-helps-our-inspiration', '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', 1, 10, '2014-07-28 13:20:56', 651, '', '2015-07-19 15:17:09', 429, 0, '0000-00-00 00:00:00', '2014-07-28 13:20:56', '0000-00-00 00:00:00', '{"image_intro":"images\\/blueprint\\/articles\\/Reading_magazines_helps_our_inspiration.jpg","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"images\\/blueprint\\/articles\\/Reading_magazines_helps_our_inspiration.jpg","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 24, 1, '', '', 1, 12, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(55, 308, 'Our latest and favourite city''s apartment interior', 'our-latest-and-favourite-city-s-apartment-interior', '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', 1, 10, '2014-07-28 13:20:56', 651, '', '2015-07-24 19:00:38', 429, 0, '0000-00-00 00:00:00', '2014-07-28 13:20:56', '0000-00-00 00:00:00', '{"image_intro":"images\\/blueprint\\/articles\\/Our_latest_and_favourite_city_s_apartment_interior.jpg","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"images\\/blueprint\\/articles\\/Our_latest_and_favourite_city_s_apartment_interior.jpg","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 22, 1, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(56, 309, 'Living room project outside the city limits', 'living-room-project-outside-the-city-limits', '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', 1, 10, '2014-07-28 13:20:56', 651, '', '2015-07-19 15:15:53', 429, 0, '0000-00-00 00:00:00', '2014-07-28 13:20:56', '0000-00-00 00:00:00', '{"image_intro":"images\\/blueprint\\/articles\\/Living_room_project_outside_the_city_limits.jpg","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"images\\/blueprint\\/articles\\/Living_room_project_outside_the_city_limits.jpg","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 24, 1, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(57, 310, 'Interior design in a famous city diner', 'interior-design-in-a-famous-city-diner', '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', 1, 10, '2014-07-28 13:20:56', 651, '', '2015-07-19 15:15:16', 429, 0, '0000-00-00 00:00:00', '2014-07-28 13:20:56', '0000-00-00 00:00:00', '{"image_intro":"images\\/blueprint\\/articles\\/Interior_design_in_a_famous_city_diner.jpg","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"images\\/blueprint\\/articles\\/Interior_design_in_a_famous_city_diner.jpg","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 21, 1, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(58, 488, 'We build the next level of construction design', '1', '<div class="mn-flexbox">\r\n	<div class="container text-center">\r\n		<div class="mn-slider-title">\r\n			<span class="animated fadeIn duration3">BLUEPRINT</span>\r\n		</div>\r\n		<div class="clearfix"></div>\r\n		<span class="mn-slider-desc animated fadeInUpBig duration3">We build the next level of construction design</span>\r\n	</div>\r\n</div>\r\n', '', 1, 15, '2015-05-18 21:34:40', 651, '', '2015-07-24 19:15:14', 429, 0, '0000-00-00 00:00:00', '2015-05-18 21:34:40', '0000-00-00 00:00:00', '{"image_intro":"images\\/blueprint\\/slider\\/slide01.jpg","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 22, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(59, 489, 'Our ideas are driven by imagination & quality', 'our-ideas-are-driven-by-imagination-quality', '<div class="mn-flexbox">\r\n	<div class="container text-center">\r\n		<div class="mn-slider-title">\r\n			<span class="animated fadeIn duration3">BLUEPRINT</span>\r\n		</div>\r\n		<div class="clearfix"></div>\r\n		<span class="mn-slider-desc animated fadeInUpBig duration3">Our ideas are driven by imagination &amp; quality</span>\r\n	</div>\r\n</div>\r\n', '', 1, 15, '2015-05-18 21:34:40', 651, '', '2015-07-24 19:15:14', 429, 0, '0000-00-00 00:00:00', '2015-05-18 21:34:40', '0000-00-00 00:00:00', '{"image_intro":"images\\/blueprint\\/slider\\/slide02.jpg","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 8, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(60, 490, 'Our projects are a result of your own vision & our experience', 'our-projects-are-a-result-of-your-own-vision-our-experience', '<div class="mn-flexbox">\r\n	<div class="container text-center">\r\n		<div class="mn-slider-title">\r\n			<span class="animated fadeIn duration3">BLUEPRINT</span>\r\n		</div>\r\n		<div class="clearfix"></div>\r\n		<span class="mn-slider-desc animated fadeInUpBig duration3">Our projects are a result of your own vision &amp; our experience</span>\r\n	</div>\r\n</div>\r\n', '', 1, 15, '2015-05-18 21:34:40', 651, '', '2015-07-24 19:15:14', 429, 0, '0000-00-00 00:00:00', '2015-05-18 21:34:40', '0000-00-00 00:00:00', '{"image_intro":"images\\/blueprint\\/slider\\/slide03.jpg","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 7, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(61, 507, 'About us', 'about-us', '<div class="row">\r\n\r\n\r\n	<div class="col-xs-12 mn-flex-con">\r\n		<div class="col-md-4 mn-about-team mn-flex-con duration2 mn-on-scroll animated fadeIn">\r\n			<div class="mn-about-team-desc">\r\n				<div class="mn-about-team-desc-inner text-left">\r\n					<h3>Web Developers</h3>\r\n					<p>Lorem Ipsum dolor sit amet, consectetur adipisicing elit sed do eiusmod tempor incididunt ut labore et dolore.</p>\r\n				</div>\r\n			</div>\r\n		</div>\r\n		<div class="col-md-4 mn-about-team  duration3 mn-on-scroll animated fadeIn">\r\n			<div class="mn-about-team-inner"> <img src="images/oxygen/about_team/team1.jpg" border="0" alt="team1">\r\n				<div class="hover-box">\r\n					<div class="hover-box-inner">\r\n						<p>John Doe</p>\r\n						<h3>Web Developer</h3>\r\n					</div>\r\n				</div>\r\n			</div>\r\n		</div>\r\n		<div class="col-md-4 mn-about-team duration2 mn-on-scroll animated fadeIn">\r\n			<div class="mn-about-team-inner"> <img src="images/oxygen/about_team/team2.jpg" border="0" alt="team2">\r\n				<div class="hover-box">\r\n					<div class="hover-box-inner">\r\n						<p>Paul Doe</p>\r\n						<h3>Web Developer</h3>\r\n					</div>\r\n				</div>\r\n			</div>\r\n		</div>\r\n	</div>\r\n	\r\n	\r\n	<div class="col-xs-12 mn-flex-con">\r\n		<div class="col-md-4 mn-about-team duration2 mn-on-scroll animated fadeIn">\r\n			<div class="mn-about-team-inner"> <img src="images/oxygen/about_team/team3.jpg" border="0" alt="team3">\r\n				<div class="hover-box">\r\n					<div class="hover-box-inner">\r\n						<p>Samantha Doe</p>\r\n						<h3>Web Designer</h3>\r\n					</div>\r\n				</div>\r\n			</div>\r\n		</div>\r\n		<div class="col-md-4 mn-about-team duration3 mn-on-scroll animated fadeIn">\r\n			<div class="mn-about-team-inner"> <img src="images/oxygen/about_team/team4.jpg" border="0" alt="team4">\r\n				<div class="hover-box">\r\n					<div class="hover-box-inner">\r\n						<p>Alex Doe</p>\r\n						<h3>Web Designer</h3>\r\n					</div>\r\n				</div>\r\n			</div>\r\n		</div>\r\n		<div class="col-md-4 mn-about-team mn-flex-con duration2 mn-on-scroll animated fadeIn ">\r\n			<div class="mn-about-team-desc">\r\n				<div class="mn-about-team-desc-inner text-right">\r\n					<h3>Designers</h3>\r\n					<p>Lorem Ipsum dolor sit amet, consectetur adipisicing elit sed do eiusmod tempor incididunt ut labore et dolore.</p>\r\n				</div>\r\n			</div>\r\n		</div>\r\n	</div>\r\n	\r\n	<div class="col-xs-12 mn-flex-con">\r\n		<div class="col-md-4 mn-about-team mn-flex-con duration2 mn-on-scroll animated fadeIn ">\r\n			<div class="mn-about-team-desc">\r\n				<div class="mn-about-team-desc-inner text-left">\r\n					<h3>Marketers</h3>\r\n					<p>Lorem Ipsum dolor sit amet, consectetur adipisicing elit sed do eiusmod tempor incididunt ut labore et dolore.</p>\r\n				</div>\r\n			</div>\r\n		</div>\r\n		<div class="col-md-4 mn-about-team duration2 mn-on-scroll animated fadeIn">\r\n			<div class="mn-about-team-inner"> <img src="images/oxygen/about_team/team5.jpg" border="0" alt="team5">\r\n				<div class="hover-box">\r\n					<div class="hover-box-inner">\r\n						<p>Peter Doe</p>\r\n						<h3>Marketer</h3>\r\n					</div>\r\n				</div>\r\n			</div>\r\n		</div>\r\n		<div class="col-md-4 mn-about-team duration2 mn-on-scroll animated fadeIn">\r\n			<div class="mn-about-team-inner"> <img src="images/oxygen/about_team/team6.jpg" border="0" alt="team6">\r\n				<div class="hover-box">\r\n					<div class="hover-box-inner">\r\n						<p>Helen Doe</p>\r\n						<h3>Marketer</h3>\r\n					</div>\r\n				</div>\r\n			</div>\r\n		</div>\r\n	</div>\r\n	\r\n	<div class="col-xs-12 mn-flex-con duration2 mn-on-scroll animated fadeIn">\r\n		<div class="col-md-4 mn-about-team ">\r\n			<div class="mn-about-team-inner"> <img src="images/oxygen/about_team/team7.jpg" border="0" alt="team7">\r\n				<div class="hover-box">\r\n					<div class="hover-box-inner">\r\n						<p>Kelly Doe</p>\r\n						<h3>Business Expert</h3>\r\n					</div>\r\n				</div>\r\n			</div>\r\n		</div>\r\n		<div class="col-md-4 mn-about-team duration2 mn-on-scroll animated fadeIn">\r\n			<div class="mn-about-team-inner"> <img src="images/oxygen/about_team/team8.jpg" border="0" alt="team8">\r\n				<div class="hover-box">\r\n					<div class="hover-box-inner">\r\n						<p>Kathrine Doe</p>\r\n						<h3>Business Expert</h3>\r\n					</div>\r\n				</div>\r\n			</div>\r\n		</div>\r\n		<div class="col-md-4 mn-about-team mn-flex-con duration2 mn-on-scroll animated fadeIn ">\r\n			<div class="mn-about-team-desc">\r\n				<div class="mn-about-team-desc-inner text-right">\r\n					<h3>Business Experts</h3>\r\n					<p>Lorem Ipsum dolor sit amet, consectetur adipisicing elit sed do eiusmod tempor incididunt ut labore et dolore.</p>\r\n				</div>\r\n			</div>\r\n		</div>\r\n	</div>\r\n	\r\n</div>\r\n', '', 1, 2, '2014-07-28 13:23:15', 651, '', '2015-05-28 16:21:45', 266, 0, '0000-00-00 00:00:00', '2014-07-28 13:23:15', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 40, 1, '', '', 1, 157, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(62, 525, 'Home', 'home', '', '', 1, 2, '2015-07-24 14:07:16', 651, '', '2015-07-24 14:07:16', 0, 0, '0000-00-00 00:00:00', '2015-07-24 14:07:16', '0000-00-00 00:00:00', '{"image_intro":"","float_intro":"","image_intro_alt":"","image_intro_caption":"","image_fulltext":"","float_fulltext":"","image_fulltext_alt":"","image_fulltext_caption":""}', '{"urla":false,"urlatext":"","targeta":"","urlb":false,"urlbtext":"","targetb":"","urlc":false,"urlctext":"","targetc":""}', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 1, 0, '', '', 1, 530, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');

DROP TABLE IF EXISTS `#__contentitem_tag_map`;
CREATE TABLE IF NOT EXISTS `#__contentitem_tag_map` (
  `type_alias` varchar(255) NOT NULL DEFAULT '',
  `core_content_id` int(10) unsigned NOT NULL COMMENT 'PK from the core content table',
  `content_item_id` int(11) NOT NULL COMMENT 'PK from the content type table',
  `tag_id` int(10) unsigned NOT NULL COMMENT 'PK from the tag table',
  `tag_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Date of most recent save for this tag-item',
  `type_id` mediumint(8) NOT NULL COMMENT 'PK from the content_type table'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Maps items from content tables to tags';

DROP TABLE IF EXISTS `#__content_frontpage`;
CREATE TABLE IF NOT EXISTS `#__content_frontpage` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `#__content_frontpage` (`content_id`, `ordering`) VALUES
(1, 11),
(2, 10),
(16, 8),
(17, 9),
(24, 6),
(25, 7),
(45, 4),
(46, 5),
(50, 3),
(52, 2),
(57, 1);

DROP TABLE IF EXISTS `#__content_rating`;
CREATE TABLE IF NOT EXISTS `#__content_rating` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(10) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(10) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT ''
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__content_types`;
CREATE TABLE IF NOT EXISTS `#__content_types` (
`type_id` int(10) unsigned NOT NULL,
  `type_title` varchar(255) NOT NULL DEFAULT '',
  `type_alias` varchar(255) NOT NULL DEFAULT '',
  `table` varchar(255) NOT NULL DEFAULT '',
  `rules` text NOT NULL,
  `field_mappings` text NOT NULL,
  `router` varchar(255) NOT NULL DEFAULT '',
  `content_history_options` varchar(5120) DEFAULT NULL COMMENT 'JSON string for com_contenthistory options'
) ENGINE=InnoDB AUTO_INCREMENT=16 DEFAULT CHARSET=utf8;

INSERT INTO `#__content_types` (`type_id`, `type_title`, `type_alias`, `table`, `rules`, `field_mappings`, `router`, `content_history_options`) VALUES
(1, 'Article', 'com_content.article', '{"special":{"dbtable":"#___content","key":"id","type":"Content","prefix":"JTable","config":"array()"},"common":{"dbtable":"#___ucm_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":{"core_content_item_id":"id","core_title":"title","core_state":"state","core_alias":"alias","core_created_time":"created","core_modified_time":"modified","core_body":"introtext", "core_hits":"hits","core_publish_up":"publish_up","core_publish_down":"publish_down","core_access":"access", "core_params":"attribs", "core_featured":"featured", "core_metadata":"metadata", "core_language":"language", "core_images":"images", "core_urls":"urls", "core_version":"version", "core_ordering":"ordering", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"catid", "core_xreference":"xreference", "asset_id":"asset_id"}, "special":{"fulltext":"fulltext"}}', 'ContentHelperRoute::getArticleRoute', '{"formFile":"administrator\\/components\\/com_content\\/models\\/forms\\/article.xml", "hideFields":["asset_id","checked_out","checked_out_time","version"],"ignoreChanges":["modified_by", "modified", "checked_out", "checked_out_time", "version", "hits"],"convertToInt":["publish_up", "publish_down", "featured", "ordering"],"displayLookup":[{"sourceColumn":"catid","targetTable":"#___categories","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"created_by","targetTable":"#___users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"access","targetTable":"#___viewlevels","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"modified_by","targetTable":"#___users","targetColumn":"id","displayColumn":"name"} ]}'),
(2, 'Weblink', 'com_weblinks.weblink', '{"special":{"dbtable":"#___weblinks","key":"id","type":"Weblink","prefix":"WeblinksTable","config":"array()"},"common":{"dbtable":"#___ucm_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":{"core_content_item_id":"id","core_title":"title","core_state":"state","core_alias":"alias","core_created_time":"created","core_modified_time":"modified","core_body":"description", "core_hits":"hits","core_publish_up":"publish_up","core_publish_down":"publish_down","core_access":"access", "core_params":"params", "core_featured":"featured", "core_metadata":"metadata", "core_language":"language", "core_images":"images", "core_urls":"urls", "core_version":"version", "core_ordering":"ordering", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"catid", "core_xreference":"xreference", "asset_id":"null"}, "special":{}}', 'WeblinksHelperRoute::getWeblinkRoute', '{"formFile":"administrator\\/components\\/com_weblinks\\/models\\/forms\\/weblink.xml", "hideFields":["asset_id","checked_out","checked_out_time","version","featured","images"], "ignoreChanges":["modified_by", "modified", "checked_out", "checked_out_time", "version", "hits"], "convertToInt":["publish_up", "publish_down", "featured", "ordering"], "displayLookup":[{"sourceColumn":"catid","targetTable":"#___categories","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"created_by","targetTable":"#___users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"access","targetTable":"#___viewlevels","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"modified_by","targetTable":"#___users","targetColumn":"id","displayColumn":"name"} ]}'),
(3, 'Contact', 'com_contact.contact', '{"special":{"dbtable":"#___contact_details","key":"id","type":"Contact","prefix":"ContactTable","config":"array()"},"common":{"dbtable":"#___ucm_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":{"core_content_item_id":"id","core_title":"name","core_state":"published","core_alias":"alias","core_created_time":"created","core_modified_time":"modified","core_body":"address", "core_hits":"hits","core_publish_up":"publish_up","core_publish_down":"publish_down","core_access":"access", "core_params":"params", "core_featured":"featured", "core_metadata":"metadata", "core_language":"language", "core_images":"image", "core_urls":"webpage", "core_version":"version", "core_ordering":"ordering", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"catid", "core_xreference":"xreference", "asset_id":"null"}, "special":{"con_position":"con_position","suburb":"suburb","state":"state","country":"country","postcode":"postcode","telephone":"telephone","fax":"fax","misc":"misc","email_to":"email_to","default_con":"default_con","user_id":"user_id","mobile":"mobile","sortname1":"sortname1","sortname2":"sortname2","sortname3":"sortname3"}}', 'ContactHelperRoute::getContactRoute', '{"formFile":"administrator\\/components\\/com_contact\\/models\\/forms\\/contact.xml","hideFields":["default_con","checked_out","checked_out_time","version","xreference"],"ignoreChanges":["modified_by", "modified", "checked_out", "checked_out_time", "version", "hits"],"convertToInt":["publish_up", "publish_down", "featured", "ordering"], "displayLookup":[ {"sourceColumn":"created_by","targetTable":"#___users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"catid","targetTable":"#___categories","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"modified_by","targetTable":"#___users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"access","targetTable":"#___viewlevels","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"user_id","targetTable":"#___users","targetColumn":"id","displayColumn":"name"} ] }'),
(4, 'Newsfeed', 'com_newsfeeds.newsfeed', '{"special":{"dbtable":"#___newsfeeds","key":"id","type":"Newsfeed","prefix":"NewsfeedsTable","config":"array()"},"common":{"dbtable":"#___ucm_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":{"core_content_item_id":"id","core_title":"name","core_state":"published","core_alias":"alias","core_created_time":"created","core_modified_time":"modified","core_body":"description", "core_hits":"hits","core_publish_up":"publish_up","core_publish_down":"publish_down","core_access":"access", "core_params":"params", "core_featured":"featured", "core_metadata":"metadata", "core_language":"language", "core_images":"images", "core_urls":"link", "core_version":"version", "core_ordering":"ordering", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"catid", "core_xreference":"xreference", "asset_id":"null"}, "special":{"numarticles":"numarticles","cache_time":"cache_time","rtl":"rtl"}}', 'NewsfeedsHelperRoute::getNewsfeedRoute', '{"formFile":"administrator\\/components\\/com_newsfeeds\\/models\\/forms\\/newsfeed.xml","hideFields":["asset_id","checked_out","checked_out_time","version"],"ignoreChanges":["modified_by", "modified", "checked_out", "checked_out_time", "version", "hits"],"convertToInt":["publish_up", "publish_down", "featured", "ordering"],"displayLookup":[{"sourceColumn":"catid","targetTable":"#___categories","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"created_by","targetTable":"#___users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"access","targetTable":"#___viewlevels","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"modified_by","targetTable":"#___users","targetColumn":"id","displayColumn":"name"} ]}'),
(5, 'User', 'com_users.user', '{"special":{"dbtable":"#___users","key":"id","type":"User","prefix":"JTable","config":"array()"},"common":{"dbtable":"#___ucm_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":{"core_content_item_id":"id","core_title":"name","core_state":"null","core_alias":"username","core_created_time":"registerdate","core_modified_time":"lastvisitDate","core_body":"null", "core_hits":"null","core_publish_up":"null","core_publish_down":"null","access":"null", "core_params":"params", "core_featured":"null", "core_metadata":"null", "core_language":"null", "core_images":"null", "core_urls":"null", "core_version":"null", "core_ordering":"null", "core_metakey":"null", "core_metadesc":"null", "core_catid":"null", "core_xreference":"null", "asset_id":"null"}, "special":{}}', 'UsersHelperRoute::getUserRoute', ''),
(6, 'Article Category', 'com_content.category', '{"special":{"dbtable":"#___categories","key":"id","type":"Category","prefix":"JTable","config":"array()"},"common":{"dbtable":"#___ucm_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":{"core_content_item_id":"id","core_title":"title","core_state":"published","core_alias":"alias","core_created_time":"created_time","core_modified_time":"modified_time","core_body":"description", "core_hits":"hits","core_publish_up":"null","core_publish_down":"null","core_access":"access", "core_params":"params", "core_featured":"null", "core_metadata":"metadata", "core_language":"language", "core_images":"null", "core_urls":"null", "core_version":"version", "core_ordering":"null", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"parent_id", "core_xreference":"null", "asset_id":"asset_id"}, "special":{"parent_id":"parent_id","lft":"lft","rgt":"rgt","level":"level","path":"path","extension":"extension","note":"note"}}', 'ContentHelperRoute::getCategoryRoute', '{"formFile":"administrator\\/components\\/com_categories\\/models\\/forms\\/category.xml", "hideFields":["asset_id","checked_out","checked_out_time","version","lft","rgt","level","path","extension"], "ignoreChanges":["modified_user_id", "modified_time", "checked_out", "checked_out_time", "version", "hits", "path"],"convertToInt":["publish_up", "publish_down"], "displayLookup":[{"sourceColumn":"created_user_id","targetTable":"#___users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"access","targetTable":"#___viewlevels","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"modified_user_id","targetTable":"#___users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"parent_id","targetTable":"#___categories","targetColumn":"id","displayColumn":"title"}]}'),
(7, 'Contact Category', 'com_contact.category', '{"special":{"dbtable":"#___categories","key":"id","type":"Category","prefix":"JTable","config":"array()"},"common":{"dbtable":"#___ucm_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":{"core_content_item_id":"id","core_title":"title","core_state":"published","core_alias":"alias","core_created_time":"created_time","core_modified_time":"modified_time","core_body":"description", "core_hits":"hits","core_publish_up":"null","core_publish_down":"null","core_access":"access", "core_params":"params", "core_featured":"null", "core_metadata":"metadata", "core_language":"language", "core_images":"null", "core_urls":"null", "core_version":"version", "core_ordering":"null", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"parent_id", "core_xreference":"null", "asset_id":"asset_id"}, "special":{"parent_id":"parent_id","lft":"lft","rgt":"rgt","level":"level","path":"path","extension":"extension","note":"note"}}', 'ContactHelperRoute::getCategoryRoute', '{"formFile":"administrator\\/components\\/com_categories\\/models\\/forms\\/category.xml", "hideFields":["asset_id","checked_out","checked_out_time","version","lft","rgt","level","path","extension"], "ignoreChanges":["modified_user_id", "modified_time", "checked_out", "checked_out_time", "version", "hits", "path"],"convertToInt":["publish_up", "publish_down"], "displayLookup":[{"sourceColumn":"created_user_id","targetTable":"#___users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"access","targetTable":"#___viewlevels","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"modified_user_id","targetTable":"#___users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"parent_id","targetTable":"#___categories","targetColumn":"id","displayColumn":"title"}]}'),
(8, 'Newsfeeds Category', 'com_newsfeeds.category', '{"special":{"dbtable":"#___categories","key":"id","type":"Category","prefix":"JTable","config":"array()"},"common":{"dbtable":"#___ucm_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":{"core_content_item_id":"id","core_title":"title","core_state":"published","core_alias":"alias","core_created_time":"created_time","core_modified_time":"modified_time","core_body":"description", "core_hits":"hits","core_publish_up":"null","core_publish_down":"null","core_access":"access", "core_params":"params", "core_featured":"null", "core_metadata":"metadata", "core_language":"language", "core_images":"null", "core_urls":"null", "core_version":"version", "core_ordering":"null", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"parent_id", "core_xreference":"null", "asset_id":"asset_id"}, "special":{"parent_id":"parent_id","lft":"lft","rgt":"rgt","level":"level","path":"path","extension":"extension","note":"note"}}', 'NewsfeedsHelperRoute::getCategoryRoute', '{"formFile":"administrator\\/components\\/com_categories\\/models\\/forms\\/category.xml", "hideFields":["asset_id","checked_out","checked_out_time","version","lft","rgt","level","path","extension"], "ignoreChanges":["modified_user_id", "modified_time", "checked_out", "checked_out_time", "version", "hits", "path"],"convertToInt":["publish_up", "publish_down"], "displayLookup":[{"sourceColumn":"created_user_id","targetTable":"#___users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"access","targetTable":"#___viewlevels","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"modified_user_id","targetTable":"#___users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"parent_id","targetTable":"#___categories","targetColumn":"id","displayColumn":"title"}]}'),
(9, 'Weblinks Category', 'com_weblinks.category', '{"special":{"dbtable":"#___categories","key":"id","type":"Category","prefix":"JTable","config":"array()"},"common":{"dbtable":"#___ucm_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":{"core_content_item_id":"id","core_title":"title","core_state":"published","core_alias":"alias","core_created_time":"created_time","core_modified_time":"modified_time","core_body":"description", "core_hits":"hits","core_publish_up":"null","core_publish_down":"null","core_access":"access", "core_params":"params", "core_featured":"null", "core_metadata":"metadata", "core_language":"language", "core_images":"null", "core_urls":"null", "core_version":"version", "core_ordering":"null", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"parent_id", "core_xreference":"null", "asset_id":"asset_id"}, "special":{"parent_id":"parent_id","lft":"lft","rgt":"rgt","level":"level","path":"path","extension":"extension","note":"note"}}', 'WeblinksHelperRoute::getCategoryRoute', '{"formFile":"administrator\\/components\\/com_categories\\/models\\/forms\\/category.xml", "hideFields":["asset_id","checked_out","checked_out_time","version","lft","rgt","level","path","extension"], "ignoreChanges":["modified_user_id", "modified_time", "checked_out", "checked_out_time", "version", "hits", "path"],"convertToInt":["publish_up", "publish_down"], "displayLookup":[{"sourceColumn":"created_user_id","targetTable":"#___users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"access","targetTable":"#___viewlevels","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"modified_user_id","targetTable":"#___users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"parent_id","targetTable":"#___categories","targetColumn":"id","displayColumn":"title"}]}'),
(10, 'Tag', 'com_tags.tag', '{"special":{"dbtable":"#___tags","key":"tag_id","type":"Tag","prefix":"TagsTable","config":"array()"},"common":{"dbtable":"#___ucm_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":{"core_content_item_id":"id","core_title":"title","core_state":"published","core_alias":"alias","core_created_time":"created_time","core_modified_time":"modified_time","core_body":"description", "core_hits":"hits","core_publish_up":"null","core_publish_down":"null","core_access":"access", "core_params":"params", "core_featured":"featured", "core_metadata":"metadata", "core_language":"language", "core_images":"images", "core_urls":"urls", "core_version":"version", "core_ordering":"null", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"null", "core_xreference":"null", "asset_id":"null"}, "special":{"parent_id":"parent_id","lft":"lft","rgt":"rgt","level":"level","path":"path"}}', 'TagsHelperRoute::getTagRoute', '{"formFile":"administrator\\/components\\/com_tags\\/models\\/forms\\/tag.xml", "hideFields":["checked_out","checked_out_time","version", "lft", "rgt", "level", "path", "urls", "publish_up", "publish_down"],"ignoreChanges":["modified_user_id", "modified_time", "checked_out", "checked_out_time", "version", "hits", "path"],"convertToInt":["publish_up", "publish_down"], "displayLookup":[{"sourceColumn":"created_user_id","targetTable":"#___users","targetColumn":"id","displayColumn":"name"}, {"sourceColumn":"access","targetTable":"#___viewlevels","targetColumn":"id","displayColumn":"title"}, {"sourceColumn":"modified_user_id","targetTable":"#___users","targetColumn":"id","displayColumn":"name"}]}'),
(11, 'Banner', 'com_banners.banner', '{"special":{"dbtable":"#___banners","key":"id","type":"Banner","prefix":"BannersTable","config":"array()"},"common":{"dbtable":"#___ucm_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":{"core_content_item_id":"id","core_title":"name","core_state":"published","core_alias":"alias","core_created_time":"created","core_modified_time":"modified","core_body":"description", "core_hits":"null","core_publish_up":"publish_up","core_publish_down":"publish_down","core_access":"access", "core_params":"params", "core_featured":"null", "core_metadata":"metadata", "core_language":"language", "core_images":"images", "core_urls":"link", "core_version":"version", "core_ordering":"ordering", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"catid", "core_xreference":"null", "asset_id":"null"}, "special":{"imptotal":"imptotal", "impmade":"impmade", "clicks":"clicks", "clickurl":"clickurl", "custombannercode":"custombannercode", "cid":"cid", "purchase_type":"purchase_type", "track_impressions":"track_impressions", "track_clicks":"track_clicks"}}', '', '{"formFile":"administrator\\/components\\/com_banners\\/models\\/forms\\/banner.xml", "hideFields":["checked_out","checked_out_time","version", "reset"],"ignoreChanges":["modified_by", "modified", "checked_out", "checked_out_time", "version", "imptotal", "impmade", "reset"], "convertToInt":["publish_up", "publish_down", "ordering"], "displayLookup":[{"sourceColumn":"catid","targetTable":"#___categories","targetColumn":"id","displayColumn":"title"}, {"sourceColumn":"cid","targetTable":"#___banner_clients","targetColumn":"id","displayColumn":"name"}, {"sourceColumn":"created_by","targetTable":"#___users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"modified_by","targetTable":"#___users","targetColumn":"id","displayColumn":"name"} ]}'),
(12, 'Banners Category', 'com_banners.category', '{"special":{"dbtable":"#___categories","key":"id","type":"Category","prefix":"JTable","config":"array()"},"common":{"dbtable":"#___ucm_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":{"core_content_item_id":"id","core_title":"title","core_state":"published","core_alias":"alias","core_created_time":"created_time","core_modified_time":"modified_time","core_body":"description", "core_hits":"hits","core_publish_up":"null","core_publish_down":"null","core_access":"access", "core_params":"params", "core_featured":"null", "core_metadata":"metadata", "core_language":"language", "core_images":"null", "core_urls":"null", "core_version":"version", "core_ordering":"null", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"parent_id", "core_xreference":"null", "asset_id":"asset_id"}, "special": {"parent_id":"parent_id","lft":"lft","rgt":"rgt","level":"level","path":"path","extension":"extension","note":"note"}}', '', '{"formFile":"administrator\\/components\\/com_categories\\/models\\/forms\\/category.xml", "hideFields":["asset_id","checked_out","checked_out_time","version","lft","rgt","level","path","extension"], "ignoreChanges":["modified_user_id", "modified_time", "checked_out", "checked_out_time", "version", "hits", "path"], "convertToInt":["publish_up", "publish_down"], "displayLookup":[{"sourceColumn":"created_user_id","targetTable":"#___users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"access","targetTable":"#___viewlevels","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"modified_user_id","targetTable":"#___users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"parent_id","targetTable":"#___categories","targetColumn":"id","displayColumn":"title"}]}'),
(13, 'Banner Client', 'com_banners.client', '{"special":{"dbtable":"#___banner_clients","key":"id","type":"Client","prefix":"BannersTable"}}', '', '', '', '{"formFile":"administrator\\/components\\/com_banners\\/models\\/forms\\/client.xml", "hideFields":["checked_out","checked_out_time"], "ignoreChanges":["checked_out", "checked_out_time"], "convertToInt":[], "displayLookup":[]}'),
(14, 'User Notes', 'com_users.note', '{"special":{"dbtable":"#___user_notes","key":"id","type":"Note","prefix":"UsersTable"}}', '', '', '', '{"formFile":"administrator\\/components\\/com_users\\/models\\/forms\\/note.xml", "hideFields":["checked_out","checked_out_time", "publish_up", "publish_down"],"ignoreChanges":["modified_user_id", "modified_time", "checked_out", "checked_out_time"], "convertToInt":["publish_up", "publish_down"],"displayLookup":[{"sourceColumn":"catid","targetTable":"#___categories","targetColumn":"id","displayColumn":"title"}, {"sourceColumn":"created_user_id","targetTable":"#___users","targetColumn":"id","displayColumn":"name"}, {"sourceColumn":"user_id","targetTable":"#___users","targetColumn":"id","displayColumn":"name"}, {"sourceColumn":"modified_user_id","targetTable":"#___users","targetColumn":"id","displayColumn":"name"}]}'),
(15, 'User Notes Category', 'com_users.category', '{"special":{"dbtable":"#___categories","key":"id","type":"Category","prefix":"JTable","config":"array()"},"common":{"dbtable":"#___ucm_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":{"core_content_item_id":"id","core_title":"title","core_state":"published","core_alias":"alias","core_created_time":"created_time","core_modified_time":"modified_time","core_body":"description", "core_hits":"hits","core_publish_up":"null","core_publish_down":"null","core_access":"access", "core_params":"params", "core_featured":"null", "core_metadata":"metadata", "core_language":"language", "core_images":"null", "core_urls":"null", "core_version":"version", "core_ordering":"null", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"parent_id", "core_xreference":"null", "asset_id":"asset_id"}, "special":{"parent_id":"parent_id","lft":"lft","rgt":"rgt","level":"level","path":"path","extension":"extension","note":"note"}}', '', '{"formFile":"administrator\\/components\\/com_categories\\/models\\/forms\\/category.xml", "hideFields":["checked_out","checked_out_time","version","lft","rgt","level","path","extension"], "ignoreChanges":["modified_user_id", "modified_time", "checked_out", "checked_out_time", "version", "hits", "path"], "convertToInt":["publish_up", "publish_down"], "displayLookup":[{"sourceColumn":"created_user_id","targetTable":"#___users","targetColumn":"id","displayColumn":"name"}, {"sourceColumn":"access","targetTable":"#___viewlevels","targetColumn":"id","displayColumn":"title"},{"sourceColumn":"modified_user_id","targetTable":"#___users","targetColumn":"id","displayColumn":"name"},{"sourceColumn":"parent_id","targetTable":"#___categories","targetColumn":"id","displayColumn":"title"}]}');

DROP TABLE IF EXISTS `#__core_log_searches`;
CREATE TABLE IF NOT EXISTS `#__core_log_searches` (
  `search_term` varchar(128) NOT NULL DEFAULT '',
  `hits` int(10) unsigned NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__extensions`;
CREATE TABLE IF NOT EXISTS `#__extensions` (
`extension_id` int(11) NOT NULL,
  `name` varchar(100) NOT NULL,
  `type` varchar(20) NOT NULL,
  `element` varchar(100) NOT NULL,
  `folder` varchar(100) NOT NULL,
  `client_id` tinyint(3) NOT NULL,
  `enabled` tinyint(3) NOT NULL DEFAULT '1',
  `access` int(10) unsigned NOT NULL DEFAULT '1',
  `protected` tinyint(3) NOT NULL DEFAULT '0',
  `manifest_cache` text NOT NULL,
  `params` text NOT NULL,
  `custom_data` text NOT NULL,
  `system_data` text NOT NULL,
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) DEFAULT '0',
  `state` int(11) DEFAULT '0'
) ENGINE=InnoDB AUTO_INCREMENT=10074 DEFAULT CHARSET=utf8;

INSERT INTO `#__extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES
(1, 'com_mailto', 'component', 'com_mailto', '', 0, 1, 1, 1, '{"name":"com_mailto","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_MAILTO_XML_DESCRIPTION","group":"","filename":"mailto"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(2, 'com_wrapper', 'component', 'com_wrapper', '', 0, 1, 1, 1, '{"name":"com_wrapper","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_WRAPPER_XML_DESCRIPTION","group":"","filename":"wrapper"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(3, 'com_admin', 'component', 'com_admin', '', 1, 1, 1, 1, '{"name":"com_admin","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_ADMIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(4, 'com_banners', 'component', 'com_banners', '', 1, 1, 1, 0, '{"name":"com_banners","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_BANNERS_XML_DESCRIPTION","group":"","filename":"banners"}', '{"purchase_type":"3","track_impressions":"0","track_clicks":"0","metakey_prefix":"","save_history":"1","history_limit":10}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(5, 'com_cache', 'component', 'com_cache', '', 1, 1, 1, 1, '{"name":"com_cache","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CACHE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(6, 'com_categories', 'component', 'com_categories', '', 1, 1, 1, 1, '{"name":"com_categories","type":"component","creationDate":"December 2007","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CATEGORIES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(7, 'com_checkin', 'component', 'com_checkin', '', 1, 1, 1, 1, '{"name":"com_checkin","type":"component","creationDate":"Unknown","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CHECKIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(8, 'com_contact', 'component', 'com_contact', '', 1, 1, 1, 0, '{"name":"com_contact","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CONTACT_XML_DESCRIPTION","group":"","filename":"contact"}', '{"contact_layout":"_:default","show_contact_category":"hide","save_history":"1","history_limit":10,"show_contact_list":"0","presentation_style":"sliders","show_name":"1","show_position":"1","show_email":"0","show_street_address":"1","show_suburb":"1","show_state":"1","show_postcode":"1","show_country":"1","show_telephone":"1","show_mobile":"1","show_fax":"1","show_webpage":"1","show_misc":"1","show_image":"1","image":"","allow_vcard":"0","show_articles":"0","show_profile":"0","show_links":"0","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_tags":"1","contact_icons":"0","icon_address":"","icon_email":"","icon_telephone":"","icon_mobile":"","icon_fax":"","icon_misc":"","category_layout":"_:default","show_category_title":"1","show_description":"1","show_description_image":"0","maxLevel":"-1","show_empty_categories":"0","show_subcat_desc":"1","show_cat_items":"1","show_cat_tags":"1","show_base_description":"1","maxLevelcat":"-1","show_empty_categories_cat":"0","show_subcat_desc_cat":"1","show_cat_items_cat":"1","filter_field":"1","show_pagination_limit":"1","show_headings":"1","show_position_headings":"1","show_email_headings":"0","show_telephone_headings":"1","show_mobile_headings":"0","show_fax_headings":"0","show_suburb_headings":"1","show_state_headings":"1","show_country_headings":"1","show_pagination":"2","show_pagination_results":"1","initial_sort":"ordering","captcha":"","show_email_form":"1","show_email_copy":"1","banned_email":"","banned_subject":"","banned_text":"","validate_session":"1","custom_reply":"0","redirect":"","show_feed_link":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(9, 'com_cpanel', 'component', 'com_cpanel', '', 1, 1, 1, 1, '{"name":"com_cpanel","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CPANEL_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10, 'com_installer', 'component', 'com_installer', '', 1, 1, 1, 1, '{"name":"com_installer","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_INSTALLER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(11, 'com_languages', 'component', 'com_languages', '', 1, 1, 1, 1, '{"name":"com_languages","type":"component","creationDate":"2006","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_LANGUAGES_XML_DESCRIPTION","group":""}', '{"administrator":"en-GB","site":"en-GB"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(12, 'com_login', 'component', 'com_login', '', 1, 1, 1, 1, '{"name":"com_login","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_LOGIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(13, 'com_media', 'component', 'com_media', '', 1, 1, 0, 1, '{"name":"com_media","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_MEDIA_XML_DESCRIPTION","group":"","filename":"media"}', '{"upload_extensions":"bmp,csv,doc,gif,ico,jpg,jpeg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,GIF,ICO,JPG,JPEG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS","upload_maxsize":"10","file_path":"images","image_path":"images","restrict_uploads":"1","allowed_media_usergroup":"3","check_mime":"1","image_extensions":"bmp,gif,jpg,png","ignore_extensions":"","upload_mime":"image\\/jpeg,image\\/gif,image\\/png,image\\/bmp,application\\/x-shockwave-flash,application\\/msword,application\\/excel,application\\/pdf,application\\/powerpoint,text\\/plain,application\\/x-zip","upload_mime_illegal":"text\\/html"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(14, 'com_menus', 'component', 'com_menus', '', 1, 1, 1, 1, '{"name":"com_menus","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_MENUS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(15, 'com_messages', 'component', 'com_messages', '', 1, 1, 1, 1, '{"name":"com_messages","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_MESSAGES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(16, 'com_modules', 'component', 'com_modules', '', 1, 1, 1, 1, '{"name":"com_modules","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_MODULES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(17, 'com_newsfeeds', 'component', 'com_newsfeeds', '', 1, 1, 1, 0, '{"name":"com_newsfeeds","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_NEWSFEEDS_XML_DESCRIPTION","group":"","filename":"newsfeeds"}', '{"newsfeed_layout":"_:default","save_history":"1","history_limit":5,"show_feed_image":"1","show_feed_description":"1","show_item_description":"1","feed_character_count":"0","feed_display_order":"des","float_first":"right","float_second":"right","show_tags":"1","category_layout":"_:default","show_category_title":"1","show_description":"1","show_description_image":"1","maxLevel":"-1","show_empty_categories":"0","show_subcat_desc":"1","show_cat_items":"1","show_cat_tags":"1","show_base_description":"1","maxLevelcat":"-1","show_empty_categories_cat":"0","show_subcat_desc_cat":"1","show_cat_items_cat":"1","filter_field":"1","show_pagination_limit":"1","show_headings":"1","show_articles":"0","show_link":"1","show_pagination":"1","show_pagination_results":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(18, 'com_plugins', 'component', 'com_plugins', '', 1, 1, 1, 1, '{"name":"com_plugins","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_PLUGINS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(19, 'com_search', 'component', 'com_search', '', 1, 1, 1, 0, '{"name":"com_search","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_SEARCH_XML_DESCRIPTION","group":"","filename":"search"}', '{"enabled":"0","show_date":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(20, 'com_templates', 'component', 'com_templates', '', 1, 1, 1, 1, '{"name":"com_templates","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_TEMPLATES_XML_DESCRIPTION","group":""}', '{"template_positions_display":"1","upload_limit":"2","image_formats":"gif,bmp,jpg,jpeg,png","source_formats":"txt,less,ini,xml,js,php,css","font_formats":"woff,ttf,otf","compressed_formats":"zip"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(21, 'com_weblinks', 'component', 'com_weblinks', '', 1, 1, 1, 0, '{"name":"com_weblinks","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.4.1","description":"COM_WEBLINKS_XML_DESCRIPTION","group":"","filename":"weblinks"}', '{"target":"0","save_history":"1","history_limit":5,"count_clicks":"1","icons":1,"link_icons":"","float_first":"right","float_second":"right","show_tags":"1","category_layout":"_:default","show_category_title":"1","show_description":"1","show_description_image":"1","maxLevel":"-1","show_empty_categories":"0","show_subcat_desc":"1","show_cat_num_links":"1","show_cat_tags":"1","show_base_description":"1","maxLevelcat":"-1","show_empty_categories_cat":"0","show_subcat_desc_cat":"1","show_cat_num_links_cat":"1","filter_field":"1","show_pagination_limit":"1","show_headings":"0","show_link_description":"1","show_link_hits":"1","show_pagination":"2","show_pagination_results":"1","show_feed_link":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(22, 'com_content', 'component', 'com_content', '', 1, 1, 0, 1, '{"name":"com_content","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CONTENT_XML_DESCRIPTION","group":"","filename":"content"}', '{"article_layout":"_:default","show_title":"1","link_titles":"1","show_intro":"1","info_block_position":"0","show_category":"1","link_category":"1","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"1","show_item_navigation":"1","show_vote":"0","show_readmore":"1","show_readmore_title":"1","readmore_limit":"100","show_tags":"1","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"0","urls_position":"0","show_publishing_options":"1","show_article_options":"1","save_history":"0","history_limit":0,"show_urls_images_frontend":"0","show_urls_images_backend":"1","targeta":0,"targetb":0,"targetc":0,"float_intro":"left","float_fulltext":"left","category_layout":"_:blog","show_category_heading_title_text":"1","show_category_title":"0","show_description":"0","show_description_image":"0","maxLevel":"1","show_empty_categories":"0","show_no_articles":"1","show_subcat_desc":"1","show_cat_num_articles":"0","show_cat_tags":"1","show_base_description":"1","maxLevelcat":"-1","show_empty_categories_cat":"0","show_subcat_desc_cat":"1","show_cat_num_articles_cat":"1","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"0","show_subcategory_content":"0","show_pagination_limit":"1","filter_field":"hide","show_headings":"1","list_show_date":"0","date_format":"","list_show_hits":"1","list_show_author":"1","orderby_pri":"order","orderby_sec":"rdate","order_date":"published","show_pagination":"2","show_pagination_results":"1","show_feed_link":"1","feed_summary":"0","feed_show_readmore":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(23, 'com_config', 'component', 'com_config', '', 1, 1, 0, 1, '{"name":"com_config","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CONFIG_XML_DESCRIPTION","group":""}', '{"filters":{"1":{"filter_type":"NH","filter_tags":"","filter_attributes":""},"9":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"6":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"7":{"filter_type":"NONE","filter_tags":"","filter_attributes":""},"2":{"filter_type":"NH","filter_tags":"","filter_attributes":""},"3":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"4":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"5":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"8":{"filter_type":"NONE","filter_tags":"","filter_attributes":""}}}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(24, 'com_redirect', 'component', 'com_redirect', '', 1, 1, 0, 1, '{"name":"com_redirect","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_REDIRECT_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(25, 'com_users', 'component', 'com_users', '', 1, 1, 0, 1, '{"name":"com_users","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_USERS_XML_DESCRIPTION","group":"","filename":"users"}', '{"allowUserRegistration":"1","new_usertype":"2","guest_usergroup":"9","sendpassword":"1","useractivation":"1","mail_to_admin":"0","captcha":"","frontend_userparams":"1","site_language":"0","change_login_name":"0","reset_count":"10","reset_time":"1","minimum_length":"4","minimum_integers":"0","minimum_symbols":"0","minimum_uppercase":"0","save_history":"1","history_limit":5,"mailSubjectPrefix":"","mailBodySuffix":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(27, 'com_finder', 'component', 'com_finder', '', 1, 1, 0, 0, '{"name":"com_finder","type":"component","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2014 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_FINDER_XML_DESCRIPTION","group":""}', '{"show_description":"1","description_length":255,"allow_empty_query":"0","show_url":"1","show_advanced":"1","expand_advanced":"0","show_date_filters":"0","highlight_terms":"1","opensearch_name":"","opensearch_description":"","batch_size":"50","memory_table_limit":30000,"title_multiplier":"1.7","text_multiplier":"0.7","meta_multiplier":"1.2","path_multiplier":"2.0","misc_multiplier":"0.3","stemmer":"snowball"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(28, 'com_joomlaupdate', 'component', 'com_joomlaupdate', '', 1, 1, 0, 1, '{"name":"com_joomlaupdate","type":"component","creationDate":"February 2012","author":"Joomla! Project","copyright":"(C) 2005 - 2014 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_JOOMLAUPDATE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(29, 'com_tags', 'component', 'com_tags', '', 1, 1, 1, 1, '{"name":"com_tags","type":"component","creationDate":"December 2013","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.1.0","description":"COM_TAGS_XML_DESCRIPTION","group":"","filename":"tags"}', '{"tag_layout":"_:default","save_history":"1","history_limit":5,"show_tag_title":"0","tag_list_show_tag_image":"0","tag_list_show_tag_description":"0","tag_list_image":"","show_tag_num_items":"0","tag_list_orderby":"title","tag_list_orderby_direction":"ASC","show_headings":"0","tag_list_show_date":"0","tag_list_show_item_image":"0","tag_list_show_item_description":"0","tag_list_item_maximum_characters":0,"return_any_or_all":"1","include_children":"0","maximum":200,"tag_list_language_filter":"all","tags_layout":"_:default","all_tags_orderby":"title","all_tags_orderby_direction":"ASC","all_tags_show_tag_image":"0","all_tags_show_tag_descripion":"0","all_tags_tag_maximum_characters":20,"all_tags_show_tag_hits":"0","filter_field":"1","show_pagination_limit":"1","show_pagination":"2","show_pagination_results":"1","tag_field_ajax_mode":"1","show_feed_link":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(30, 'com_contenthistory', 'component', 'com_contenthistory', '', 1, 1, 1, 0, '{"name":"com_contenthistory","type":"component","creationDate":"May 2013","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.2.0","description":"COM_CONTENTHISTORY_XML_DESCRIPTION","group":"","filename":"contenthistory"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(31, 'com_ajax', 'component', 'com_ajax', '', 1, 1, 1, 0, '{"name":"com_ajax","type":"component","creationDate":"August 2013","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.2.0","description":"COM_AJAX_XML_DESCRIPTION","group":"","filename":"ajax"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(32, 'com_postinstall', 'component', 'com_postinstall', '', 1, 1, 1, 1, '{"name":"com_postinstall","type":"component","creationDate":"September 2013","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.2.0","description":"COM_POSTINSTALL_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(101, 'SimplePie', 'library', 'simplepie', '', 0, 1, 1, 1, '{"name":"SimplePie","type":"library","creationDate":"2004","author":"SimplePie","copyright":"Copyright (c) 2004-2009, Ryan Parman and Geoffrey Sneddon","authorEmail":"","authorUrl":"http:\\/\\/simplepie.org\\/","version":"1.2","description":"LIB_SIMPLEPIE_XML_DESCRIPTION","group":"","filename":"simplepie"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(102, 'phputf8', 'library', 'phputf8', '', 0, 1, 1, 1, '{"name":"phputf8","type":"library","creationDate":"2006","author":"Harry Fuecks","copyright":"Copyright various authors","authorEmail":"hfuecks@gmail.com","authorUrl":"http:\\/\\/sourceforge.net\\/projects\\/phputf8","version":"0.5","description":"LIB_PHPUTF8_XML_DESCRIPTION","group":"","filename":"phputf8"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(103, 'Joomla! Platform', 'library', 'joomla', '', 0, 1, 1, 1, '{"name":"Joomla! Platform","type":"library","creationDate":"2008","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"http:\\/\\/www.joomla.org","version":"13.1","description":"LIB_JOOMLA_XML_DESCRIPTION","group":"","filename":"joomla"}', '{"mediaversion":"ea4c79eef278b4c6e82507858227b7a6"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(104, 'IDNA Convert', 'library', 'idna_convert', '', 0, 1, 1, 1, '{"name":"IDNA Convert","type":"library","creationDate":"2004","author":"phlyLabs","copyright":"2004-2011 phlyLabs Berlin, http:\\/\\/phlylabs.de","authorEmail":"phlymail@phlylabs.de","authorUrl":"http:\\/\\/phlylabs.de","version":"0.8.0","description":"LIB_IDNA_XML_DESCRIPTION","group":"","filename":"idna_convert"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(105, 'FOF', 'library', 'fof', '', 0, 1, 1, 1, '{"name":"FOF","type":"library","creationDate":"2015-04-22 13:15:32","author":"Nicholas K. Dionysopoulos \\/ Akeeba Ltd","copyright":"(C)2011-2015 Nicholas K. Dionysopoulos","authorEmail":"nicholas@akeebabackup.com","authorUrl":"https:\\/\\/www.akeebabackup.com","version":"2.4.3","description":"LIB_FOF_XML_DESCRIPTION","group":"","filename":"fof"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(106, 'PHPass', 'library', 'phpass', '', 0, 1, 1, 1, '{"name":"PHPass","type":"library","creationDate":"2004-2006","author":"Solar Designer","copyright":"","authorEmail":"solar@openwall.com","authorUrl":"http:\\/\\/www.openwall.com\\/phpass\\/","version":"0.3","description":"LIB_PHPASS_XML_DESCRIPTION","group":"","filename":"phpass"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(200, 'mod_articles_archive', 'module', 'mod_articles_archive', '', 0, 1, 1, 0, '{"name":"mod_articles_archive","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_ARTICLES_ARCHIVE_XML_DESCRIPTION","group":"","filename":"mod_articles_archive"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(201, 'mod_articles_latest', 'module', 'mod_articles_latest', '', 0, 1, 1, 0, '{"name":"mod_articles_latest","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_LATEST_NEWS_XML_DESCRIPTION","group":"","filename":"mod_articles_latest"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(202, 'mod_articles_popular', 'module', 'mod_articles_popular', '', 0, 1, 1, 0, '{"name":"mod_articles_popular","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_POPULAR_XML_DESCRIPTION","group":"","filename":"mod_articles_popular"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(203, 'mod_banners', 'module', 'mod_banners', '', 0, 1, 1, 0, '{"name":"mod_banners","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_BANNERS_XML_DESCRIPTION","group":"","filename":"mod_banners"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(204, 'mod_breadcrumbs', 'module', 'mod_breadcrumbs', '', 0, 1, 1, 1, '{"name":"mod_breadcrumbs","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_BREADCRUMBS_XML_DESCRIPTION","group":"","filename":"mod_breadcrumbs"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(205, 'mod_custom', 'module', 'mod_custom', '', 0, 1, 1, 1, '{"name":"mod_custom","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_CUSTOM_XML_DESCRIPTION","group":"","filename":"mod_custom"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(206, 'mod_feed', 'module', 'mod_feed', '', 0, 1, 1, 0, '{"name":"mod_feed","type":"module","creationDate":"July 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_FEED_XML_DESCRIPTION","group":"","filename":"mod_feed"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(207, 'mod_footer', 'module', 'mod_footer', '', 0, 1, 1, 0, '{"name":"mod_footer","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_FOOTER_XML_DESCRIPTION","group":"","filename":"mod_footer"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(208, 'mod_login', 'module', 'mod_login', '', 0, 1, 1, 1, '{"name":"mod_login","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_LOGIN_XML_DESCRIPTION","group":"","filename":"mod_login"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(209, 'mod_menu', 'module', 'mod_menu', '', 0, 1, 1, 1, '{"name":"mod_menu","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_MENU_XML_DESCRIPTION","group":"","filename":"mod_menu"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(210, 'mod_articles_news', 'module', 'mod_articles_news', '', 0, 1, 1, 0, '{"name":"mod_articles_news","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_ARTICLES_NEWS_XML_DESCRIPTION","group":"","filename":"mod_articles_news"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(211, 'mod_random_image', 'module', 'mod_random_image', '', 0, 1, 1, 0, '{"name":"mod_random_image","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_RANDOM_IMAGE_XML_DESCRIPTION","group":"","filename":"mod_random_image"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(212, 'mod_related_items', 'module', 'mod_related_items', '', 0, 1, 1, 0, '{"name":"mod_related_items","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_RELATED_XML_DESCRIPTION","group":"","filename":"mod_related_items"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(213, 'mod_search', 'module', 'mod_search', '', 0, 1, 1, 0, '{"name":"mod_search","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_SEARCH_XML_DESCRIPTION","group":"","filename":"mod_search"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(214, 'mod_stats', 'module', 'mod_stats', '', 0, 1, 1, 0, '{"name":"mod_stats","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_STATS_XML_DESCRIPTION","group":"","filename":"mod_stats"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(215, 'mod_syndicate', 'module', 'mod_syndicate', '', 0, 1, 1, 1, '{"name":"mod_syndicate","type":"module","creationDate":"May 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_SYNDICATE_XML_DESCRIPTION","group":"","filename":"mod_syndicate"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(216, 'mod_users_latest', 'module', 'mod_users_latest', '', 0, 1, 1, 0, '{"name":"mod_users_latest","type":"module","creationDate":"December 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_USERS_LATEST_XML_DESCRIPTION","group":"","filename":"mod_users_latest"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(217, 'mod_weblinks', 'module', 'mod_weblinks', '', 0, 1, 1, 0, '{"name":"mod_weblinks","type":"module","creationDate":"July 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.4.1","description":"MOD_WEBLINKS_XML_DESCRIPTION","group":"","filename":"mod_weblinks"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(218, 'mod_whosonline', 'module', 'mod_whosonline', '', 0, 1, 1, 0, '{"name":"mod_whosonline","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_WHOSONLINE_XML_DESCRIPTION","group":"","filename":"mod_whosonline"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(219, 'mod_wrapper', 'module', 'mod_wrapper', '', 0, 1, 1, 0, '{"name":"mod_wrapper","type":"module","creationDate":"October 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_WRAPPER_XML_DESCRIPTION","group":"","filename":"mod_wrapper"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(220, 'mod_articles_category', 'module', 'mod_articles_category', '', 0, 1, 1, 0, '{"name":"mod_articles_category","type":"module","creationDate":"February 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_ARTICLES_CATEGORY_XML_DESCRIPTION","group":"","filename":"mod_articles_category"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(221, 'mod_articles_categories', 'module', 'mod_articles_categories', '', 0, 1, 1, 0, '{"name":"mod_articles_categories","type":"module","creationDate":"February 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_ARTICLES_CATEGORIES_XML_DESCRIPTION","group":"","filename":"mod_articles_categories"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(222, 'mod_languages', 'module', 'mod_languages', '', 0, 1, 1, 1, '{"name":"mod_languages","type":"module","creationDate":"February 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_LANGUAGES_XML_DESCRIPTION","group":"","filename":"mod_languages"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(223, 'mod_finder', 'module', 'mod_finder', '', 0, 1, 0, 0, '{"name":"mod_finder","type":"module","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2014 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_FINDER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(300, 'mod_custom', 'module', 'mod_custom', '', 1, 1, 1, 1, '{"name":"mod_custom","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_CUSTOM_XML_DESCRIPTION","group":"","filename":"mod_custom"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(301, 'mod_feed', 'module', 'mod_feed', '', 1, 1, 1, 0, '{"name":"mod_feed","type":"module","creationDate":"July 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_FEED_XML_DESCRIPTION","group":"","filename":"mod_feed"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(302, 'mod_latest', 'module', 'mod_latest', '', 1, 1, 1, 0, '{"name":"mod_latest","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_LATEST_XML_DESCRIPTION","group":"","filename":"mod_latest"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(303, 'mod_logged', 'module', 'mod_logged', '', 1, 1, 1, 0, '{"name":"mod_logged","type":"module","creationDate":"January 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_LOGGED_XML_DESCRIPTION","group":"","filename":"mod_logged"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(304, 'mod_login', 'module', 'mod_login', '', 1, 1, 1, 1, '{"name":"mod_login","type":"module","creationDate":"March 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_LOGIN_XML_DESCRIPTION","group":"","filename":"mod_login"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(305, 'mod_menu', 'module', 'mod_menu', '', 1, 1, 1, 0, '{"name":"mod_menu","type":"module","creationDate":"March 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_MENU_XML_DESCRIPTION","group":"","filename":"mod_menu"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(307, 'mod_popular', 'module', 'mod_popular', '', 1, 1, 1, 0, '{"name":"mod_popular","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_POPULAR_XML_DESCRIPTION","group":"","filename":"mod_popular"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(308, 'mod_quickicon', 'module', 'mod_quickicon', '', 1, 1, 1, 1, '{"name":"mod_quickicon","type":"module","creationDate":"Nov 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_QUICKICON_XML_DESCRIPTION","group":"","filename":"mod_quickicon"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(309, 'mod_status', 'module', 'mod_status', '', 1, 1, 1, 0, '{"name":"mod_status","type":"module","creationDate":"Feb 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_STATUS_XML_DESCRIPTION","group":"","filename":"mod_status"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(310, 'mod_submenu', 'module', 'mod_submenu', '', 1, 1, 1, 0, '{"name":"mod_submenu","type":"module","creationDate":"Feb 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_SUBMENU_XML_DESCRIPTION","group":"","filename":"mod_submenu"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(311, 'mod_title', 'module', 'mod_title', '', 1, 1, 1, 0, '{"name":"mod_title","type":"module","creationDate":"Nov 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_TITLE_XML_DESCRIPTION","group":"","filename":"mod_title"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(312, 'mod_toolbar', 'module', 'mod_toolbar', '', 1, 1, 1, 1, '{"name":"mod_toolbar","type":"module","creationDate":"Nov 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_TOOLBAR_XML_DESCRIPTION","group":"","filename":"mod_toolbar"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(313, 'mod_multilangstatus', 'module', 'mod_multilangstatus', '', 1, 1, 1, 0, '{"name":"mod_multilangstatus","type":"module","creationDate":"September 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_MULTILANGSTATUS_XML_DESCRIPTION","group":"","filename":"mod_multilangstatus"}', '{"cache":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(314, 'mod_version', 'module', 'mod_version', '', 1, 1, 1, 0, '{"name":"mod_version","type":"module","creationDate":"January 2012","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2014 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_VERSION_XML_DESCRIPTION","group":""}', '{"format":"short","product":"1","cache":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(315, 'mod_stats_admin', 'module', 'mod_stats_admin', '', 1, 1, 1, 0, '{"name":"mod_stats_admin","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_STATS_XML_DESCRIPTION","group":"","filename":"mod_stats_admin"}', '{"serverinfo":"0","siteinfo":"0","counter":"0","increase":"0","cache":"1","cache_time":"900","cachemode":"static"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(316, 'mod_tags_popular', 'module', 'mod_tags_popular', '', 0, 1, 1, 0, '{"name":"mod_tags_popular","type":"module","creationDate":"January 2013","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.1.0","description":"MOD_TAGS_POPULAR_XML_DESCRIPTION","group":"","filename":"mod_tags_popular"}', '{"maximum":"5","timeframe":"alltime","owncache":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(317, 'mod_tags_similar', 'module', 'mod_tags_similar', '', 0, 1, 1, 0, '{"name":"mod_tags_similar","type":"module","creationDate":"January 2013","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.1.0","description":"MOD_TAGS_SIMILAR_XML_DESCRIPTION","group":"","filename":"mod_tags_similar"}', '{"maximum":"5","matchtype":"any","owncache":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(400, 'plg_authentication_gmail', 'plugin', 'gmail', 'authentication', 0, 0, 1, 0, '{"name":"plg_authentication_gmail","type":"plugin","creationDate":"February 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_GMAIL_XML_DESCRIPTION","group":"","filename":"gmail"}', '{"applysuffix":"0","suffix":"","verifypeer":"1","user_blacklist":""}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(401, 'plg_authentication_joomla', 'plugin', 'joomla', 'authentication', 0, 1, 1, 1, '{"name":"plg_authentication_joomla","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_AUTH_JOOMLA_XML_DESCRIPTION","group":"","filename":"joomla"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(402, 'plg_authentication_ldap', 'plugin', 'ldap', 'authentication', 0, 0, 1, 0, '{"name":"plg_authentication_ldap","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_LDAP_XML_DESCRIPTION","group":"","filename":"ldap"}', '{"host":"","port":"389","use_ldapV3":"0","negotiate_tls":"0","no_referrals":"0","auth_method":"bind","base_dn":"","search_string":"","users_dn":"","username":"admin","password":"bobby7","ldap_fullname":"fullName","ldap_email":"mail","ldap_uid":"uid"}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(403, 'plg_content_contact', 'plugin', 'contact', 'content', 0, 1, 1, 0, '{"name":"plg_content_contact","type":"plugin","creationDate":"January 2014","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.2.2","description":"PLG_CONTENT_CONTACT_XML_DESCRIPTION","group":"","filename":"contact"}', '', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(404, 'plg_content_emailcloak', 'plugin', 'emailcloak', 'content', 0, 1, 1, 0, '{"name":"plg_content_emailcloak","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_CONTENT_EMAILCLOAK_XML_DESCRIPTION","group":"","filename":"emailcloak"}', '{"mode":"1"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(406, 'plg_content_loadmodule', 'plugin', 'loadmodule', 'content', 0, 1, 1, 0, '{"name":"plg_content_loadmodule","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_LOADMODULE_XML_DESCRIPTION","group":"","filename":"loadmodule"}', '{"style":"xhtml"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(407, 'plg_content_pagebreak', 'plugin', 'pagebreak', 'content', 0, 1, 1, 0, '{"name":"plg_content_pagebreak","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_CONTENT_PAGEBREAK_XML_DESCRIPTION","group":"","filename":"pagebreak"}', '{"title":"1","multipage_toc":"1","showall":"1"}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(408, 'plg_content_pagenavigation', 'plugin', 'pagenavigation', 'content', 0, 1, 1, 0, '{"name":"plg_content_pagenavigation","type":"plugin","creationDate":"January 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_PAGENAVIGATION_XML_DESCRIPTION","group":"","filename":"pagenavigation"}', '{"position":"1"}', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(409, 'plg_content_vote', 'plugin', 'vote', 'content', 0, 1, 1, 0, '{"name":"plg_content_vote","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_VOTE_XML_DESCRIPTION","group":"","filename":"vote"}', '', '', '', 0, '0000-00-00 00:00:00', 6, 0),
(410, 'plg_editors_codemirror', 'plugin', 'codemirror', 'editors', 0, 1, 1, 1, '{"name":"plg_editors_codemirror","type":"plugin","creationDate":"28 March 2011","author":"Marijn Haverbeke","copyright":"Copyright (C) 2014 by Marijn Haverbeke <marijnh@gmail.com> and others","authorEmail":"marijnh@gmail.com","authorUrl":"http:\\/\\/codemirror.net\\/","version":"5.3","description":"PLG_CODEMIRROR_XML_DESCRIPTION","group":"","filename":"codemirror"}', '{"lineNumbers":"1","lineWrapping":"1","matchTags":"1","matchBrackets":"1","marker-gutter":"1","autoCloseTags":"1","autoCloseBrackets":"1","autoFocus":"1","theme":"default","tabmode":"indent"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(411, 'plg_editors_none', 'plugin', 'none', 'editors', 0, 1, 1, 1, '{"name":"plg_editors_none","type":"plugin","creationDate":"September 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_NONE_XML_DESCRIPTION","group":"","filename":"none"}', '', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(412, 'plg_editors_tinymce', 'plugin', 'tinymce', 'editors', 0, 1, 1, 0, '{"name":"plg_editors_tinymce","type":"plugin","creationDate":"2005-2014","author":"Moxiecode Systems AB","copyright":"Moxiecode Systems AB","authorEmail":"N\\/A","authorUrl":"tinymce.moxiecode.com","version":"4.1.7","description":"PLG_TINY_XML_DESCRIPTION","group":"","filename":"tinymce"}', '{"skin":"0","skin_admin":"0","mode":"1","mobile":"0","entity_encoding":"raw","lang_mode":"1","text_direction":"ltr","content_css":"1","content_css_custom":"","relative_urls":"1","newlines":"0","invalid_elements":"script,applet,iframe","valid_elements":"i[class]","extended_elements":"","html_height":"550","html_width":"750","resizing":"1","resize_horizontal":"1","element_path":"1","fonts":"1","paste":"1","searchreplace":"1","insertdate":"1","colors":"1","table":"1","smilies":"1","hr":"1","link":"1","media":"1","print":"1","directionality":"1","fullscreen":"1","alignment":"1","visualchars":"1","visualblocks":"1","nonbreaking":"1","template":"1","blockquote":"1","wordcount":"1","image_advtab":"1","advlist":"1","autosave":"1","contextmenu":"1","inlinepopups":"1","custom_plugin":"","custom_button":""}', '', '', 0, '0000-00-00 00:00:00', 3, 0);
INSERT INTO `#__extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES
(413, 'plg_editors-xtd_article', 'plugin', 'article', 'editors-xtd', 0, 1, 1, 0, '{"name":"plg_editors-xtd_article","type":"plugin","creationDate":"October 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_ARTICLE_XML_DESCRIPTION","group":"","filename":"article"}', '', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(414, 'plg_editors-xtd_image', 'plugin', 'image', 'editors-xtd', 0, 1, 1, 0, '{"name":"plg_editors-xtd_image","type":"plugin","creationDate":"August 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_IMAGE_XML_DESCRIPTION","group":"","filename":"image"}', '', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(415, 'plg_editors-xtd_pagebreak', 'plugin', 'pagebreak', 'editors-xtd', 0, 1, 1, 0, '{"name":"plg_editors-xtd_pagebreak","type":"plugin","creationDate":"August 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_EDITORSXTD_PAGEBREAK_XML_DESCRIPTION","group":"","filename":"pagebreak"}', '', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(416, 'plg_editors-xtd_readmore', 'plugin', 'readmore', 'editors-xtd', 0, 1, 1, 0, '{"name":"plg_editors-xtd_readmore","type":"plugin","creationDate":"March 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_READMORE_XML_DESCRIPTION","group":"","filename":"readmore"}', '', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(417, 'plg_search_categories', 'plugin', 'categories', 'search', 0, 1, 1, 0, '{"name":"plg_search_categories","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SEARCH_CATEGORIES_XML_DESCRIPTION","group":"","filename":"categories"}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(418, 'plg_search_contacts', 'plugin', 'contacts', 'search', 0, 1, 1, 0, '{"name":"plg_search_contacts","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SEARCH_CONTACTS_XML_DESCRIPTION","group":"","filename":"contacts"}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(419, 'plg_search_content', 'plugin', 'content', 'search', 0, 1, 1, 0, '{"name":"plg_search_content","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SEARCH_CONTENT_XML_DESCRIPTION","group":"","filename":"content"}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(420, 'plg_search_newsfeeds', 'plugin', 'newsfeeds', 'search', 0, 1, 1, 0, '{"name":"plg_search_newsfeeds","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SEARCH_NEWSFEEDS_XML_DESCRIPTION","group":"","filename":"newsfeeds"}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(421, 'plg_search_weblinks', 'plugin', 'weblinks', 'search', 0, 1, 1, 0, '{"name":"plg_search_weblinks","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.4.1","description":"PLG_SEARCH_WEBLINKS_XML_DESCRIPTION","group":"","filename":"weblinks"}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(422, 'plg_system_languagefilter', 'plugin', 'languagefilter', 'system', 0, 0, 1, 1, '{"name":"plg_system_languagefilter","type":"plugin","creationDate":"July 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SYSTEM_LANGUAGEFILTER_XML_DESCRIPTION","group":"","filename":"languagefilter"}', '', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(423, 'plg_system_p3p', 'plugin', 'p3p', 'system', 0, 1, 1, 0, '{"name":"plg_system_p3p","type":"plugin","creationDate":"September 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_P3P_XML_DESCRIPTION","group":"","filename":"p3p"}', '{"headers":"NOI ADM DEV PSAi COM NAV OUR OTRo STP IND DEM"}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(424, 'plg_system_cache', 'plugin', 'cache', 'system', 0, 0, 1, 1, '{"name":"plg_system_cache","type":"plugin","creationDate":"February 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_CACHE_XML_DESCRIPTION","group":"","filename":"cache"}', '{"browsercache":"0","cachetime":"15"}', '', '', 0, '0000-00-00 00:00:00', 9, 0),
(425, 'plg_system_debug', 'plugin', 'debug', 'system', 0, 1, 1, 0, '{"name":"plg_system_debug","type":"plugin","creationDate":"December 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_DEBUG_XML_DESCRIPTION","group":"","filename":"debug"}', '{"profile":"1","queries":"1","memory":"1","language_files":"1","language_strings":"1","strip-first":"1","strip-prefix":"","strip-suffix":""}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(426, 'plg_system_log', 'plugin', 'log', 'system', 0, 1, 1, 1, '{"name":"plg_system_log","type":"plugin","creationDate":"April 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_LOG_XML_DESCRIPTION","group":"","filename":"log"}', '', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(427, 'plg_system_redirect', 'plugin', 'redirect', 'system', 0, 0, 1, 1, '{"name":"plg_system_redirect","type":"plugin","creationDate":"April 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SYSTEM_REDIRECT_XML_DESCRIPTION","group":"","filename":"redirect"}', '', '', '', 0, '0000-00-00 00:00:00', 6, 0),
(428, 'plg_system_remember', 'plugin', 'remember', 'system', 0, 1, 1, 1, '{"name":"plg_system_remember","type":"plugin","creationDate":"April 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_REMEMBER_XML_DESCRIPTION","group":"","filename":"remember"}', '', '', '', 0, '0000-00-00 00:00:00', 7, 0),
(429, 'plg_system_sef', 'plugin', 'sef', 'system', 0, 1, 1, 0, '{"name":"plg_system_sef","type":"plugin","creationDate":"December 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SEF_XML_DESCRIPTION","group":"","filename":"sef"}', '', '', '', 0, '0000-00-00 00:00:00', 8, 0),
(430, 'plg_system_logout', 'plugin', 'logout', 'system', 0, 1, 1, 1, '{"name":"plg_system_logout","type":"plugin","creationDate":"April 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SYSTEM_LOGOUT_XML_DESCRIPTION","group":"","filename":"logout"}', '', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(431, 'plg_user_contactcreator', 'plugin', 'contactcreator', 'user', 0, 0, 1, 0, '{"name":"plg_user_contactcreator","type":"plugin","creationDate":"August 2009","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_CONTACTCREATOR_XML_DESCRIPTION","group":"","filename":"contactcreator"}', '{"autowebpage":"","category":"34","autopublish":"0"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(432, 'plg_user_joomla', 'plugin', 'joomla', 'user', 0, 1, 1, 0, '{"name":"plg_user_joomla","type":"plugin","creationDate":"December 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_USER_JOOMLA_XML_DESCRIPTION","group":"","filename":"joomla"}', '{"strong_passwords":"1","autoregister":"1"}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(433, 'plg_user_profile', 'plugin', 'profile', 'user', 0, 0, 1, 0, '{"name":"plg_user_profile","type":"plugin","creationDate":"January 2008","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_USER_PROFILE_XML_DESCRIPTION","group":"","filename":"profile"}', '{"register-require_address1":"1","register-require_address2":"1","register-require_city":"1","register-require_region":"1","register-require_country":"1","register-require_postal_code":"1","register-require_phone":"1","register-require_website":"1","register-require_favoritebook":"1","register-require_aboutme":"1","register-require_tos":"1","register-require_dob":"1","profile-require_address1":"1","profile-require_address2":"1","profile-require_city":"1","profile-require_region":"1","profile-require_country":"1","profile-require_postal_code":"1","profile-require_phone":"1","profile-require_website":"1","profile-require_favoritebook":"1","profile-require_aboutme":"1","profile-require_tos":"1","profile-require_dob":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(434, 'plg_extension_joomla', 'plugin', 'joomla', 'extension', 0, 1, 1, 1, '{"name":"plg_extension_joomla","type":"plugin","creationDate":"May 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_EXTENSION_JOOMLA_XML_DESCRIPTION","group":"","filename":"joomla"}', '', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(435, 'plg_content_joomla', 'plugin', 'joomla', 'content', 0, 1, 1, 0, '{"name":"plg_content_joomla","type":"plugin","creationDate":"November 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_CONTENT_JOOMLA_XML_DESCRIPTION","group":"","filename":"joomla"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(436, 'plg_system_languagecode', 'plugin', 'languagecode', 'system', 0, 0, 1, 0, '{"name":"plg_system_languagecode","type":"plugin","creationDate":"November 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SYSTEM_LANGUAGECODE_XML_DESCRIPTION","group":"","filename":"languagecode"}', '', '', '', 0, '0000-00-00 00:00:00', 10, 0),
(437, 'plg_quickicon_joomlaupdate', 'plugin', 'joomlaupdate', 'quickicon', 0, 1, 1, 1, '{"name":"plg_quickicon_joomlaupdate","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_QUICKICON_JOOMLAUPDATE_XML_DESCRIPTION","group":"","filename":"joomlaupdate"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(438, 'plg_quickicon_extensionupdate', 'plugin', 'extensionupdate', 'quickicon', 0, 1, 1, 1, '{"name":"plg_quickicon_extensionupdate","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_QUICKICON_EXTENSIONUPDATE_XML_DESCRIPTION","group":"","filename":"extensionupdate"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(439, 'plg_captcha_recaptcha', 'plugin', 'recaptcha', 'captcha', 0, 0, 1, 0, '{"name":"plg_captcha_recaptcha","type":"plugin","creationDate":"December 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.4.0","description":"PLG_CAPTCHA_RECAPTCHA_XML_DESCRIPTION","group":"","filename":"recaptcha"}', '{"public_key":"","private_key":"","theme":"clean"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(440, 'plg_system_highlight', 'plugin', 'highlight', 'system', 0, 1, 1, 0, '{"name":"plg_system_highlight","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2014 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SYSTEM_HIGHLIGHT_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 7, 0),
(441, 'plg_content_finder', 'plugin', 'finder', 'content', 0, 0, 1, 0, '{"name":"plg_content_finder","type":"plugin","creationDate":"December 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2014 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_CONTENT_FINDER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(442, 'plg_finder_categories', 'plugin', 'categories', 'finder', 0, 1, 1, 0, '{"name":"plg_finder_categories","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_FINDER_CATEGORIES_XML_DESCRIPTION","group":"","filename":"categories"}', '', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(443, 'plg_finder_contacts', 'plugin', 'contacts', 'finder', 0, 1, 1, 0, '{"name":"plg_finder_contacts","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_FINDER_CONTACTS_XML_DESCRIPTION","group":"","filename":"contacts"}', '', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(444, 'plg_finder_content', 'plugin', 'content', 'finder', 0, 1, 1, 0, '{"name":"plg_finder_content","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_FINDER_CONTENT_XML_DESCRIPTION","group":"","filename":"content"}', '', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(445, 'plg_finder_newsfeeds', 'plugin', 'newsfeeds', 'finder', 0, 1, 1, 0, '{"name":"plg_finder_newsfeeds","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_FINDER_NEWSFEEDS_XML_DESCRIPTION","group":"","filename":"newsfeeds"}', '', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(446, 'plg_finder_weblinks', 'plugin', 'weblinks', 'finder', 0, 1, 1, 0, '{"name":"plg_finder_weblinks","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.4.1","description":"PLG_FINDER_WEBLINKS_XML_DESCRIPTION","group":"","filename":"weblinks"}', '', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(447, 'plg_finder_tags', 'plugin', 'tags', 'finder', 0, 1, 1, 0, '{"name":"plg_finder_tags","type":"plugin","creationDate":"February 2013","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_FINDER_TAGS_XML_DESCRIPTION","group":"","filename":"tags"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(448, 'plg_twofactorauth_totp', 'plugin', 'totp', 'twofactorauth', 0, 0, 1, 0, '{"name":"plg_twofactorauth_totp","type":"plugin","creationDate":"August 2013","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.2.0","description":"PLG_TWOFACTORAUTH_TOTP_XML_DESCRIPTION","group":"","filename":"totp"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(449, 'plg_authentication_cookie', 'plugin', 'cookie', 'authentication', 0, 1, 1, 0, '{"name":"plg_authentication_cookie","type":"plugin","creationDate":"July 2013","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2014 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_AUTH_COOKIE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(450, 'plg_twofactorauth_yubikey', 'plugin', 'yubikey', 'twofactorauth', 0, 0, 1, 0, '{"name":"plg_twofactorauth_yubikey","type":"plugin","creationDate":"September 2013","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.2.0","description":"PLG_TWOFACTORAUTH_YUBIKEY_XML_DESCRIPTION","group":"","filename":"yubikey"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(451, 'plg_search_tags', 'plugin', 'tags', 'search', 0, 1, 1, 0, '{"name":"plg_search_tags","type":"plugin","creationDate":"March 2014","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SEARCH_TAGS_XML_DESCRIPTION","group":"","filename":"tags"}', '{"search_limit":"50","show_tagged_items":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(503, 'beez3', 'template', 'beez3', '', 0, 1, 1, 0, '{"name":"beez3","type":"template","creationDate":"25 November 2009","author":"Angie Radtke","copyright":"Copyright (C) 2005 - 2015 Open Source Matters, Inc. All rights reserved.","authorEmail":"a.radtke@derauftritt.de","authorUrl":"http:\\/\\/www.der-auftritt.de","version":"3.1.0","description":"TPL_BEEZ3_XML_DESCRIPTION","group":"","filename":"templateDetails"}', '{"wrapperSmall":"53","wrapperLarge":"72","sitetitle":"","sitedescription":"","navposition":"center","templatecolor":"nature"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(504, 'hathor', 'template', 'hathor', '', 1, 1, 1, 0, '{"name":"hathor","type":"template","creationDate":"May 2010","author":"Andrea Tarr","copyright":"Copyright (C) 2005 - 2015 Open Source Matters, Inc. All rights reserved.","authorEmail":"hathor@tarrconsulting.com","authorUrl":"http:\\/\\/www.tarrconsulting.com","version":"3.0.0","description":"TPL_HATHOR_XML_DESCRIPTION","group":"","filename":"templateDetails"}', '{"showSiteName":"0","colourChoice":"0","boldText":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(506, 'protostar', 'template', 'protostar', '', 0, 1, 1, 0, '{"name":"protostar","type":"template","creationDate":"4\\/30\\/2012","author":"Kyle Ledbetter","copyright":"Copyright (C) 2005 - 2015 Open Source Matters, Inc. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"","version":"1.0","description":"TPL_PROTOSTAR_XML_DESCRIPTION","group":"","filename":"templateDetails"}', '{"templateColor":"","logoFile":"","googleFont":"1","googleFontName":"Open+Sans","fluidContainer":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(507, 'isis', 'template', 'isis', '', 1, 1, 1, 0, '{"name":"isis","type":"template","creationDate":"3\\/30\\/2012","author":"Kyle Ledbetter","copyright":"Copyright (C) 2005 - 2015 Open Source Matters, Inc. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"","version":"1.0","description":"TPL_ISIS_XML_DESCRIPTION","group":"","filename":"templateDetails"}', '{"templateColor":"","logoFile":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(600, 'English (en-GB)', 'language', 'en-GB', '', 0, 1, 1, 1, '{"name":"English (en-GB)","type":"language","creationDate":"2013-03-07","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.4.2","description":"en-GB site language","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(601, 'English (en-GB)', 'language', 'en-GB', '', 1, 1, 1, 1, '{"name":"English (en-GB)","type":"language","creationDate":"2013-03-07","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.4.2","description":"en-GB administrator language","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(700, 'files_joomla', 'file', 'joomla', '', 0, 1, 1, 1, '{"name":"files_joomla","type":"file","creationDate":"June 2015","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.4.3","description":"FILES_JOOMLA_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(801, 'pkg_weblinks', 'package', 'pkg_weblinks', '', 0, 1, 1, 0, '{"name":"pkg_weblinks","type":"package","creationDate":"December 2012","author":"Joomla! Project","copyright":"(C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.4.1","description":"PKG_WEBLINKS_XML_DESCRIPTION","group":"","filename":"pkg_weblinks"}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10000, 'T3 Framework', 'plugin', 't3', 'system', 0, 1, 1, 0, '{"name":"T3 Framework","type":"plugin","creationDate":"July 30, 2015","author":"JoomlArt.com","copyright":"Copyright (C) 2005 - 2015 Open Source Matters. All rights reserved.","authorEmail":"info@joomlart.com","authorUrl":"http:\\/\\/www.t3-framework.org","version":"2.5.0","description":"\\n\\t\\n\\t<div align=\\"center\\">\\n\\t\\t<div class=\\"alert alert-success\\" style=\\"background-color:#DFF0D8;border-color:#D6E9C6;color: #468847;padding: 1px 0;\\">\\n\\t\\t\\t\\t<a href=\\"http:\\/\\/t3-framework.org\\/\\"><img src=\\"http:\\/\\/joomlart.s3.amazonaws.com\\/images\\/jat3v3-documents\\/message-installation\\/logo.png\\" alt=\\"some_text\\" width=\\"300\\" height=\\"99\\"><\\/a>\\n\\t\\t\\t\\t<h4><a href=\\"http:\\/\\/t3-framework.org\\/\\" title=\\"\\">Home<\\/a> | <a href=\\"http:\\/\\/demo.t3-framework.org\\/\\" title=\\"\\">Demo<\\/a> | <a href=\\"http:\\/\\/t3-framework.org\\/documentation\\" title=\\"\\">Document<\\/a> | <a href=\\"https:\\/\\/github.com\\/t3framework\\/t3\\/blob\\/master\\/CHANGELOG.md\\" title=\\"\\">Changelog<\\/a><\\/h4>\\n\\t\\t<p> <\\/p>\\n\\t\\t<p>Copyright 2004 - 2015 <a href=''http:\\/\\/www.joomlart.com\\/'' title=''Visit Joomlart.com!''>JoomlArt.com<\\/a>.<\\/p>\\n\\t\\t<\\/div>\\n     <style>table.adminform{width: 100%;}<\\/style>\\n\\t <\\/div>\\n\\t\\t\\n\\t","group":"","filename":"t3"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10002, 'com_k2', 'component', 'com_k2', '', 1, 1, 0, 0, '{"name":"COM_K2","type":"component","creationDate":"December 8th, 2014","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2014 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.9","description":"Thank you for installing K2 by JoomlaWorks, the powerful content extension for Joomla!","group":""}', '{"enable_css":"1","jQueryHandling":"1.8remote","backendJQueryHandling":"remote","userName":"1","userImage":"1","userDescription":"1","userURL":"1","userEmail":"0","userFeedLink":"1","userFeedIcon":"1","userItemCount":"10","userItemTitle":"1","userItemTitleLinked":"1","userItemDateCreated":"1","userItemImage":"1","userItemIntroText":"1","userItemCategory":"1","userItemTags":"0","userItemCommentsAnchor":"1","userItemReadMore":"0","userItemK2Plugins":"1","tagItemCount":"10","tagItemTitle":"1","tagItemTitleLinked":"1","tagItemDateCreated":"1","tagItemImage":"1","tagItemIntroText":"1","tagItemCategory":"1","tagItemReadMore":"0","tagItemExtraFields":"0","tagOrdering":"","tagFeedLink":"1","tagFeedIcon":"1","genericItemCount":"10","genericItemTitle":"1","genericItemTitleLinked":"1","genericItemDateCreated":"1","genericItemImage":"1","genericItemIntroText":"1","genericItemCategory":"1","genericItemReadMore":"0","genericItemExtraFields":"0","genericFeedLink":"1","genericFeedIcon":"1","feedLimit":"10","feedItemImage":"1","feedImgSize":"S","feedItemIntroText":"1","feedTextWordLimit":"","feedItemFullText":"1","feedItemTags":"0","feedItemVideo":"0","feedItemGallery":"0","feedItemAttachments":"0","feedBogusEmail":"","introTextCleanup":"0","introTextCleanupExcludeTags":"","introTextCleanupTagAttr":"","fullTextCleanup":"0","fullTextCleanupExcludeTags":"","fullTextCleanupTagAttr":"","xssFiltering":"0","linkPopupWidth":"900","linkPopupHeight":"600","imagesQuality":"70","itemImageXS":"120","itemImageS":"365","itemImageM":"625","itemImageL":"830","itemImageXL":"1270","itemImageGeneric":"850","catImageWidth":"609","catImageDefault":"1","userImageWidth":"150","userImageDefault":"1","commenterImgWidth":"48","onlineImageEditor":"splashup","imageTimestamp":"0","imageMemoryLimit":"","socialButtonCode":"","twitterUsername":"","facebookImage":"Medium","comments":"1","commentsOrdering":"DESC","commentsLimit":"10","commentsFormPosition":"below","commentsPublishing":"0","commentsReporting":"0","commentsReportRecipient":"","inlineCommentsModeration":"0","gravatar":"0","antispam":"0","recaptchaForRegistered":"0","akismetForRegistered":"0","commentsFormNotes":"0","commentsFormNotesText":"","frontendEditing":"1","showImageTab":"1","showImageGalleryTab":"1","showVideoTab":"1","showExtraFieldsTab":"1","showAttachmentsTab":"1","showK2Plugins":"1","sideBarDisplayFrontend":"0","mergeEditors":"1","sideBarDisplay":"1","attachmentsFolder":"","hideImportButton":"0","googleSearch":"0","googleSearchContainer":"k2GoogleSearchContainer","K2UserProfile":"0","K2UserGroup":"1","redirect":"101","adminSearch":"simple","cookieDomain":"","taggingSystem":"1","lockTags":"0","showTagFilter":"0","k2TagNorm":"0","k2TagNormCase":"lower","k2TagNormAdditionalReplacements":"","recaptcha_public_key":"admin","recaptcha_private_key":"4683","recaptcha_theme":"clean","recaptchaOnRegistration":"0","akismetApiKey":"","stopForumSpam":"0","stopForumSpamApiKey":"","showItemsCounterAdmin":"1","showChildCatItems":"1","disableCompactOrdering":"0","metaDescLimit":"150","enforceSEFReplacements":"0","SEFReplacements":"À|A, Á|A, Â|A, Ã|A, Ä|A, Å|A, à|a, á|a, â|a, ã|a, ä|a, å|a, Ā|A, ā|a, Ă|A, ă|a, Ą|A, ą|a, Ç|C, ç|c, Ć|C, ć|c, Ĉ|C, ĉ|c, Ċ|C, ċ|c, Č|C, č|c, Ð|D, ð|d, Ď|D, ď|d, Đ|D, đ|d, È|E, É|E, Ê|E, Ë|E, è|e, é|e, ê|e, ë|e, Ē|E, ē|e, Ĕ|E, ĕ|e, Ė|E, ė|e, Ę|E, ę|e, Ě|E, ě|e, Ĝ|G, ĝ|g, Ğ|G, ğ|g, Ġ|G, ġ|g, Ģ|G, ģ|g, Ĥ|H, ĥ|h, Ħ|H, ħ|h, Ì|I, Í|I, Î|I, Ï|I, ì|i, í|i, î|i, ï|i, Ĩ|I, ĩ|i, Ī|I, ī|i, Ĭ|I, ĭ|i, Į|I, į|i, İ|I, ı|i, Ĵ|J, ĵ|j, Ķ|K, ķ|k, ĸ|k, Ĺ|L, ĺ|l, Ļ|L, ļ|l, Ľ|L, ľ|l, Ŀ|L, ŀ|l, Ł|L, ł|l, Ñ|N, ñ|n, Ń|N, ń|n, Ņ|N, ņ|n, Ň|N, ň|n, ŉ|n, Ŋ|N, ŋ|n, Ò|O, Ó|O, Ô|O, Õ|O, Ö|O, Ø|O, ò|o, ó|o, ô|o, õ|o, ö|o, ø|o, Ō|O, ō|o, Ŏ|O, ŏ|o, Ő|O, ő|o, Ŕ|R, ŕ|r, Ŗ|R, ŗ|r, Ř|R, ř|r, Ś|S, ś|s, Ŝ|S, ŝ|s, Ş|S, ş|s, Š|S, š|s, ſ|s, Ţ|T, ţ|t, Ť|T, ť|t, Ŧ|T, ŧ|t, Ù|U, Ú|U, Û|U, Ü|U, ù|u, ú|u, û|u, ü|u, Ũ|U, ũ|u, Ū|U, ū|u, Ŭ|U, ŭ|u, Ů|U, ů|u, Ű|U, ű|u, Ų|U, ų|u, Ŵ|W, ŵ|w, Ý|Y, ý|y, ÿ|y, Ŷ|Y, ŷ|y, Ÿ|Y, Ź|Z, ź|z, Ż|Z, ż|z, Ž|Z, ž|z, α|a, β|b, γ|g, δ|d, ε|e, ζ|z, η|h, θ|th, ι|i, κ|k, λ|l, μ|m, ν|n, ξ|x, ο|o, π|p, ρ|r, σ|s, τ|t, υ|y, φ|f, χ|ch, ψ|ps, ω|w, Α|A, Β|B, Γ|G, Δ|D, Ε|E, Ζ|Z, Η|H, Θ|Th, Ι|I, Κ|K, Λ|L, Μ|M, Ξ|X, Ο|O, Π|P, Ρ|R, Σ|S, Τ|T, Υ|Y, Φ|F, Χ|Ch, Ψ|Ps, Ω|W, ά|a, έ|e, ή|h, ί|i, ό|o, ύ|y, ώ|w, Ά|A, Έ|E, Ή|H, Ί|I, Ό|O, Ύ|Y, Ώ|W, ϊ|i, ΐ|i, ϋ|y, ς|s, А|A, Ӑ|A, Ӓ|A, Ә|E, Ӛ|E, Ӕ|E, Б|B, В|V, Г|G, Ґ|G, Ѓ|G, Ғ|G, Ӷ|G, y|Y, Д|D, Е|E, Ѐ|E, Ё|YO, Ӗ|E, Ҽ|E, Ҿ|E, Є|YE, Ж|ZH, Ӂ|DZH, Җ|ZH, Ӝ|DZH, З|Z, Ҙ|Z, Ӟ|DZ, Ӡ|DZ, Ѕ|DZ, И|I, Ѝ|I, Ӥ|I, Ӣ|I, І|I, Ї|JI, Ӏ|I, Й|Y, Ҋ|Y, Ј|J, К|K, Қ|Q, Ҟ|Q, Ҡ|K, Ӄ|Q, Ҝ|K, Л|L, Ӆ|L, Љ|L, М|M, Ӎ|M, Н|N, Ӊ|N, Ң|N, Ӈ|N, Ҥ|N, Њ|N, О|O, Ӧ|O, Ө|O, Ӫ|O, Ҩ|O, П|P, Ҧ|PF, Р|P, Ҏ|P, С|S, Ҫ|S, Т|T, Ҭ|TH, Ћ|T, Ќ|K, У|U, Ў|U, Ӳ|U, Ӱ|U, Ӯ|U, Ү|U, Ұ|U, Ф|F, Х|H, Ҳ|H, Һ|H, Ц|TS, Ҵ|TS, Ч|CH, Ӵ|CH, Ҷ|CH, Ӌ|CH, Ҹ|CH, Џ|DZ, Ш|SH, Щ|SHT, Ъ|A, Ы|Y, Ӹ|Y, Ь|Y, Ҍ|Y, Э|E, Ӭ|E, Ю|YU, Я|YA, а|a, ӑ|a, ӓ|a, ә|e, ӛ|e, ӕ|e, б|b, в|v, г|g, ґ|g, ѓ|g, ғ|g, ӷ|g, y|y, д|d, е|e, ѐ|e, ё|yo, ӗ|e, ҽ|e, ҿ|e, є|ye, ж|zh, ӂ|dzh, җ|zh, ӝ|dzh, з|z, ҙ|z, ӟ|dz, ӡ|dz, ѕ|dz, и|i, ѝ|i, ӥ|i, ӣ|i, і|i, ї|ji, Ӏ|i, й|y, ҋ|y, ј|j, к|k, қ|q, ҟ|q, ҡ|k, ӄ|q, ҝ|k, л|l, ӆ|l, љ|l, м|m, ӎ|m, н|n, ӊ|n, ң|n, ӈ|n, ҥ|n, њ|n, о|o, ӧ|o, ө|o, ӫ|o, ҩ|o, п|p, ҧ|pf, р|p, ҏ|p, с|s, ҫ|s, т|t, ҭ|th, ћ|t, ќ|k, у|u, ў|u, ӳ|u, ӱ|u, ӯ|u, ү|u, ұ|u, ф|f, х|h, ҳ|h, һ|h, ц|ts, ҵ|ts, ч|ch, ӵ|ch, ҷ|ch, ӌ|ch, ҹ|ch, џ|dz, ш|sh, щ|sht, ъ|a, ы|y, ӹ|y, ь|y, ҍ|y, э|e, ӭ|e, ю|yu, я|ya","k2Sef":"0","k2SefLabelCat":"content","k2SefLabelTag":"tag","k2SefLabelUser":"author","k2SefLabelSearch":"search","k2SefLabelDate":"date","k2SefLabelItem":"0","k2SefLabelItemCustomPrefix":"","k2SefInsertItemId":"1","k2SefItemIdTitleAliasSep":"dash","k2SefUseItemTitleAlias":"1","k2SefInsertCatId":"1","k2SefCatIdTitleAliasSep":"dash","k2SefUseCatTitleAlias":"1","sh404SefLabelCat":"","sh404SefLabelUser":"blog","sh404SefLabelItem":"2","sh404SefTitleAlias":"alias","sh404SefModK2ContentFeedAlias":"feed","sh404SefInsertItemId":"0","sh404SefInsertUniqueItemId":"0","cbIntegration":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10003, 'plg_finder_k2', 'plugin', 'k2', 'finder', 0, 0, 1, 0, '{"name":"plg_finder_k2","type":"plugin","creationDate":"December 8th, 2014","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2014 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.9","description":"PLG_FINDER_K2_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10004, 'Search - K2', 'plugin', 'k2', 'search', 0, 1, 1, 0, '{"name":"Search - K2","type":"plugin","creationDate":"December 8th, 2014","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2014 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.9","description":"K2_THIS_PLUGIN_EXTENDS_THE_DEFAULT_JOOMLA_SEARCH_FUNCTIONALITY_TO_K2_CONTENT","group":""}', '{"search_limit":"50","search_tags":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10005, 'System - K2', 'plugin', 'k2', 'system', 0, 1, 1, 0, '{"name":"System - K2","type":"plugin","creationDate":"December 8th, 2014","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2014 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.9","description":"K2_THE_K2_SYSTEM_PLUGIN_IS_USED_TO_ASSIST_THE_PROPER_FUNCTIONALITY_OF_THE_K2_COMPONENT_SITE_WIDE_MAKE_SURE_ITS_ALWAYS_PUBLISHED_WHEN_THE_K2_COMPONENT_IS_INSTALLED","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10006, 'User - K2', 'plugin', 'k2', 'user', 0, 1, 1, 0, '{"name":"User - K2","type":"plugin","creationDate":"December 8th, 2014","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2014 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.9","description":"K2_A_USER_SYNCHRONIZATION_PLUGIN_FOR_K2","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10007, 'Josetta - K2 Categories', 'plugin', 'k2category', 'josetta_ext', 0, 1, 1, 0, '{"name":"Josetta - K2 Categories","type":"plugin","creationDate":"December 8th, 2014","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2014 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.9","description":"","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10008, 'Josetta - K2 Items', 'plugin', 'k2item', 'josetta_ext', 0, 1, 1, 0, '{"name":"Josetta - K2 Items","type":"plugin","creationDate":"June 7th, 2012","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2014 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.9","description":"","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10009, 'K2 Comments', 'module', 'mod_k2_comments', '', 0, 1, 0, 0, '{"name":"K2 Comments","type":"module","creationDate":"December 8th, 2014","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2014 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.9","description":"MOD_K2_COMMENTS_DESCRIPTION","group":""}', '{"moduleclass_sfx":"","module_usage":"","":"K2_TOP_COMMENTERS","catfilter":"0","category_id":"","comments_limit":"5","comments_word_limit":"10","commenterName":"1","commentAvatar":"1","commentAvatarWidthSelect":"custom","commentAvatarWidth":"50","commentDate":"1","commentDateFormat":"absolute","commentLink":"1","itemTitle":"1","itemCategory":"1","feed":"1","commenters_limit":"5","commenterNameOrUsername":"1","commenterAvatar":"1","commenterAvatarWidthSelect":"custom","commenterAvatarWidth":"50","commenterLink":"1","commenterCommentsCounter":"1","commenterLatestComment":"1","cache":"1","cache_time":"900"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10010, 'K2 Content', 'module', 'mod_k2_content', '', 0, 1, 0, 0, '{"name":"K2 Content","type":"module","creationDate":"December 8th, 2014","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2014 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.9","description":"K2_MOD_K2_CONTENT_DESCRIPTION","group":""}', '{"moduleclass_sfx":"","getTemplate":"Default","source":"filter","":"K2_OTHER_OPTIONS","catfilter":"0","category_id":"","getChildren":"0","itemCount":"5","itemsOrdering":"","FeaturedItems":"1","popularityRange":"","videosOnly":"0","item":"","items":"","itemTitle":"1","itemAuthor":"1","itemAuthorAvatar":"1","itemAuthorAvatarWidthSelect":"custom","itemAuthorAvatarWidth":"50","userDescription":"1","itemIntroText":"1","itemIntroTextWordLimit":"","itemImage":"1","itemImgSize":"Small","itemVideo":"1","itemVideoCaption":"1","itemVideoCredits":"1","itemAttachments":"1","itemTags":"1","itemCategory":"1","itemDateCreated":"1","itemHits":"1","itemReadMore":"1","itemExtraFields":"0","itemCommentsCounter":"1","feed":"1","itemPreText":"","itemCustomLink":"0","itemCustomLinkTitle":"","itemCustomLinkURL":"http:\\/\\/","itemCustomLinkMenuItem":"","K2Plugins":"1","JPlugins":"1","cache":"1","cache_time":"900"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10011, 'K2 Tools', 'module', 'mod_k2_tools', '', 0, 1, 0, 0, '{"name":"K2 Tools","type":"module","creationDate":"December 8th, 2014","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2014 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.9","description":"K2_TOOLS","group":""}', '{"moduleclass_sfx":"","module_usage":"0","":"K2_CUSTOM_CODE_SETTINGS","archiveItemsCounter":"1","archiveCategory":"","authors_module_category":"","authorItemsCounter":"1","authorAvatar":"1","authorAvatarWidthSelect":"custom","authorAvatarWidth":"50","authorLatestItem":"1","calendarCategory":"","home":"","seperator":"","root_id":"","end_level":"","categoriesListOrdering":"","categoriesListItemsCounter":"1","root_id2":"","catfilter":"0","category_id":"","getChildren":"0","liveSearch":"","width":"20","text":"","button":"","imagebutton":"","button_text":"","min_size":"75","max_size":"300","cloud_limit":"30","cloud_category":"0","cloud_category_recursive":"0","customCode":"","parsePhp":"0","K2Plugins":"0","JPlugins":"0","cache":"1","cache_time":"900"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10012, 'K2 Users', 'module', 'mod_k2_users', '', 0, 1, 0, 0, '{"name":"K2 Users","type":"module","creationDate":"December 8th, 2014","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2014 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.9","description":"K2_MOD_K2_USERS_DESCRTIPTION","group":""}', '{"moduleclass_sfx":"","getTemplate":"Default","source":"0","":"K2_DISPLAY_OPTIONS","filter":"1","K2UserGroup":"","ordering":"1","limit":"4","userIDs":"","userName":"1","userAvatar":"1","userAvatarWidthSelect":"custom","userAvatarWidth":"50","userDescription":"1","userDescriptionWordLimit":"","userURL":"1","userEmail":"0","userFeed":"1","userItemCount":"1","cache":"1","cache_time":"900"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10013, 'K2 User', 'module', 'mod_k2_user', '', 0, 1, 0, 0, '{"name":"K2 User","type":"module","creationDate":"December 8th, 2014","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2014 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.9","description":"K2_MOD_K2_USER_DESCRIPTION","group":""}', '{"moduleclass_sfx":"","pretext":"","":"K2_LOGIN_LOGOUT_REDIRECTION","name":"1","userAvatar":"1","userAvatarWidthSelect":"custom","userAvatarWidth":"50","menu":"","login":"","logout":"","usesecure":"0","cache":"0","cache_time":"900"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10014, 'K2 Quick Icons (admin)', 'module', 'mod_k2_quickicons', '', 1, 1, 2, 0, '{"name":"K2 Quick Icons (admin)","type":"module","creationDate":"December 8th, 2014","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2014 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.9","description":"K2_QUICKICONS_FOR_USE_IN_THE_JOOMLA_CONTROL_PANEL_DASHBOARD_PAGE","group":""}', '{"modCSSStyling":"1","modLogo":"1","cache":"0","cache_time":"900"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10015, 'K2 Stats (admin)', 'module', 'mod_k2_stats', '', 1, 1, 2, 0, '{"name":"K2 Stats (admin)","type":"module","creationDate":"December 8th, 2014","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2014 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"2.6.9","description":"K2_STATS_FOR_USE_IN_THE_K2_DASHBOARD_PAGE","group":""}', '{"latestItems":"1","popularItems":"1","mostCommentedItems":"1","latestComments":"1","statistics":"1","cache":"0","cache_time":"900"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10048, 'Minitek contact module', 'module', 'mod_minitek_contact', '', 0, 1, 0, 0, '{"name":"Minitek contact module","type":"module","creationDate":"December 2013","author":"Minitek.gr","copyright":"Copyright (C) 2011-2015 Minitek.gr. All rights reserved.","authorEmail":"","authorUrl":"www.minitek.gr","version":"3.0.1","description":"\\n\\t\\n\\t\\t  <h1>Minitek Contact Module<\\/h1>\\n\\t\\t\\n\\t","group":""}', '{"auto_module_id":"1","custom_module_id":"","load_jquery":"0","load_phpthumb":"1","load_fancybox":"1","load_fontawesome":"1","enable_cache":"0","cache_time":"30"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10049, 'AllVideos (by JoomlaWorks)', 'plugin', 'jw_allvideos', 'content', 0, 1, 1, 0, '{"name":"AllVideos (by JoomlaWorks)","type":"plugin","creationDate":"April 20th, 2015","author":"JoomlaWorks","copyright":"Copyright (c) 2006 - 2015 JoomlaWorks Ltd. All rights reserved.","authorEmail":"please-use-the-contact-form@joomlaworks.net","authorUrl":"www.joomlaworks.net","version":"4.7.0","description":"JW_PLG_AV_XML_DESC","group":"","filename":"jw_allvideos"}', '{"playerTemplate":"Classic","vfolder":"images\\/videos","vwidth":"400","vheight":"300","transparency":"transparent","background":"#010101","controls":"1","backgroundQT":"black","afolder":"images\\/audio","awidth":"480","aheight":"24","abackground":"#010101","afrontcolor":"#FFFFFF","alightcolor":"#00ADE3","allowAudioDownloading":"0","autoplay":"0","jwPlayerLoading":"local","jwPlayerAPIKey":"","jwPlayerCDNUrl":"","gzipScripts":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10063, 'Minitek K2 Tools', 'plugin', 'minitekk2tools', 'k2', 0, 1, 1, 0, '{"name":"Minitek K2 Tools","type":"plugin","creationDate":"June 2014","author":"Minitek.gr","copyright":"Copyright (c) 2011 - 2014 Minitek.gr. All rights reserved.","authorEmail":"","authorUrl":"http:\\/\\/www.minitek.gr","version":"3.0.1","description":"\\n\\t\\n\\t\\t<div>\\n\\t\\t  \\t<h1>Minitek K2 Tools Plugin<\\/h1>\\n\\t\\t\\t\\n\\t\\t\\t<p>Copyright (C) 2014 Minitek.gr<\\/p>\\n\\t\\t<\\/div>\\n\\t\\t\\n\\t","group":"","filename":"minitekk2tools"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10064, 'Minitek Slider for Articles', 'module', 'mod_minitek_slider', '', 0, 1, 0, 0, '{"name":"Minitek Slider for Articles","type":"module","creationDate":"December 2014","author":"Minitek.gr","copyright":"Copyright (C) 2011-2015 Minitek.gr. All rights reserved.","authorEmail":"","authorUrl":"www.minitek.gr","version":"3.0.2","description":"\\n\\t\\n\\t\\t<h1>Minitek Slider for Articles<\\/h1>\\n\\t\\t<p>An impressive, feature-rich and elegant responsive slider for Joomla articles.<\\/p>\\n\\t\\t\\n\\t","group":"","filename":"mod_minitek_slider"}', '{"auto_module_id":"1","custom_module_id":"","count":"5","category_filtering_type":"1","show_child_category_articles":"0","levels":"1","author_filtering_type":"1","author_alias_filtering_type":"1","show_front":"show","date_filtering":"off","date_field":"a.created","relative_date":"30","show_date_field":"created","show_date_format":"Y-m-d H:i:s","article_ordering":"a.title","article_ordering_direction":"ASC","image_type":"introtext","image_width":"864","image_height":"354","minimum_height":"150","show_thumbs":"1","thumb_width":"80","thumb_height":"60","skin":"pacific","slider_effect":"random","mobile_slider_effect":"random","easing":"linear","mobile_easing":"linear","autoplay":"1","mobile_autoplay":"1","autoplay_speed":"5000","transition_speed":"700","play_pause_buttons":"1","pause_on_click":"1","pause_on_hover":"1","show_arrows":"1","autohide_arrows":"0","mobile_autohide_arrows":"0","show_bullets":"1","opacity_on_grid":"0","loader":"pie","loader_color":"#eeeeee","loader_bg_color":"#222222","loader_opacity":".8","loader_padding":"2","loader_stroke":"7","pie_diameter":"38","pie_position":"rightTop","bar_position":"bottom","bar_direction":"leftToRight","load_jquery":"0","load_easing":"1","load_phpthumb":"1","enable_cache":"0","cache_time":"30"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10066, 'Blueprint', 'template', 'blueprint', '', 0, 1, 1, 0, '{"name":"Blueprint","type":"template","creationDate":"1 August 2015","author":"minitek.gr","copyright":"Copyright (C), Minitek. All Rights Reserved.","authorEmail":"info@minitek.gr","authorUrl":"http:\\/\\/www.minitek.gr","version":"3.0.2","description":"\\n\\t\\t<div align=\\"center\\">\\n\\t\\t\\t<div class=\\"alert alert-success\\" style=\\"background-color:#edf4ff;border-color:#a0c7ff;color: #468847;padding: 10px;\\">\\n\\t\\t\\t<h4><a href=\\"http:\\/\\/www.minitek.gr\\/\\" title=\\"\\">Home<\\/a> | <a href=\\"http:\\/\\/demo.minitek.gr\\/joomla-templates\\/blueprint\\" title=\\"\\">Demo<\\/a> | <a href=\\"http:\\/\\/www.minitek.gr\\/support\\" title=\\"\\">Documentation<\\/a><\\/h4>\\n\\t\\t\\t<p> <\\/p>\\n\\t\\t\\t<span style=\\"color:#FF0000\\">Note: Blueprint requires T3 plugin to be installed and enabled.<\\/span><p><\\/p>\\n\\t\\t\\t<p>Copyright 2011 - 2015 <a href=''http:\\/\\/www.minitek.gr\\/'' title=''Visit minitek.gr!''>Minitek.gr<\\/a>.<\\/p>\\n\\t\\t\\t<\\/div>\\n\\t\\t\\t<style>table.adminform{width: 100%;}<\\/style>\\n\\t\\t\\t<\\/div>\\n\\t","group":"","filename":"templateDetails"}', '{"back-to-top":"1","mncookie":"1","header-slider":"1","modalbg":"","cookielink":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10069, 'Minitek Wall', 'component', 'com_minitekwall', '', 1, 1, 0, 0, '{"name":"Minitek Wall","type":"component","creationDate":"April 2014","author":"Minitek","copyright":"Copyright (c) 2011-2014 Minitek. All rights reserved.","authorEmail":"","authorUrl":"http:\\/\\/www.minitek.gr\\/","version":"3.0.4","description":"\\n\\t\\n\\t\\t<h1>Minitek Wall<\\/h1>\\n\\t\\t<p>Minitek Wall is the most powerful and robust Grid system for Joomla!<\\/p>\\n\\t\\t\\n\\t","group":"","filename":"minitekwall"}', '{"load_fontawesome":"1","load_fancybox":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10070, 'Minitek Wall module', 'module', 'mod_minitekwall', '', 0, 1, 0, 0, '{"name":"Minitek Wall module","type":"module","creationDate":"August 2014","author":"Minitek.gr","copyright":"Copyright (C) 2011-2014 Minitek.gr. All rights reserved.","authorEmail":"","authorUrl":"www.minitek.gr","version":"3.0.3","description":"\\n\\t\\n\\t\\t<h1>Minitek Wall module<\\/h1>\\n\\t\\t<p>Minitek Wall is the most powerful and robust grid system for Joomla!<\\/p>\\n\\t\\t\\n  ","group":"","filename":"mod_minitekwall"}', '{"moduleclass_sfx":"","auto_module_id":"1","custom_module_id":"","module_id":"","load_jquery":"0","load_fontawesome":"1","load_fancybox":"1","enable_cache":"0","cache_time":"30"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10072, 'F0F (NEW) DO NOT REMOVE', 'library', 'lib_f0f', '', 0, 1, 1, 0, '{"name":"F0F (NEW) DO NOT REMOVE","type":"library","creationDate":"2015-05-26 13:37:16","author":"Nicholas K. Dionysopoulos \\/ Akeeba Ltd","copyright":"(C)2011-2014 Nicholas K. Dionysopoulos","authorEmail":"nicholas@akeebabackup.com","authorUrl":"https:\\/\\/www.akeebabackup.com","version":"revB8F517E-1432636636","description":"Framework-on-Framework (FOF) newer version - DO NOT REMOVE - The rapid component development framework for Joomla!. This package is the newer version of FOF, not the one shipped with Joomla! as the official Joomla! RAD Layer. The Joomla! RAD Layer has ceased development in March 2014. DO NOT UNINSTALL THIS PACKAGE, IT IS *** N O T *** A DUPLICATE OF THE ''FOF'' PACKAGE. REMOVING EITHER FOF PACKAGE WILL BREAK YOUR SITE.","group":"","filename":"lib_f0f"}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0);

DROP TABLE IF EXISTS `#__finder_filters`;
CREATE TABLE IF NOT EXISTS `#__finder_filters` (
`filter_id` int(10) unsigned NOT NULL,
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `state` tinyint(1) NOT NULL DEFAULT '1',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL,
  `created_by_alias` varchar(255) NOT NULL,
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `map_count` int(10) unsigned NOT NULL DEFAULT '0',
  `data` text NOT NULL,
  `params` mediumtext
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__finder_links`;
CREATE TABLE IF NOT EXISTS `#__finder_links` (
`link_id` int(10) unsigned NOT NULL,
  `url` varchar(255) NOT NULL,
  `route` varchar(255) NOT NULL,
  `title` varchar(255) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `indexdate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `md5sum` varchar(32) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '1',
  `state` int(5) DEFAULT '1',
  `access` int(5) DEFAULT '0',
  `language` varchar(8) NOT NULL,
  `publish_start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `list_price` double unsigned NOT NULL DEFAULT '0',
  `sale_price` double unsigned NOT NULL DEFAULT '0',
  `type_id` int(11) NOT NULL,
  `object` mediumblob NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__finder_links_terms0`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms0` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__finder_links_terms1`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms1` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__finder_links_terms2`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms2` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__finder_links_terms3`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms3` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__finder_links_terms4`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms4` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__finder_links_terms5`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms5` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__finder_links_terms6`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms6` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__finder_links_terms7`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms7` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__finder_links_terms8`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms8` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__finder_links_terms9`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms9` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__finder_links_termsa`;
CREATE TABLE IF NOT EXISTS `#__finder_links_termsa` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__finder_links_termsb`;
CREATE TABLE IF NOT EXISTS `#__finder_links_termsb` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__finder_links_termsc`;
CREATE TABLE IF NOT EXISTS `#__finder_links_termsc` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__finder_links_termsd`;
CREATE TABLE IF NOT EXISTS `#__finder_links_termsd` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__finder_links_termse`;
CREATE TABLE IF NOT EXISTS `#__finder_links_termse` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__finder_links_termsf`;
CREATE TABLE IF NOT EXISTS `#__finder_links_termsf` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__finder_taxonomy`;
CREATE TABLE IF NOT EXISTS `#__finder_taxonomy` (
`id` int(10) unsigned NOT NULL,
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL,
  `state` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `access` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` tinyint(1) unsigned NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__finder_taxonomy_map`;
CREATE TABLE IF NOT EXISTS `#__finder_taxonomy_map` (
  `link_id` int(10) unsigned NOT NULL,
  `node_id` int(10) unsigned NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__finder_terms`;
CREATE TABLE IF NOT EXISTS `#__finder_terms` (
`term_id` int(10) unsigned NOT NULL,
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` float unsigned NOT NULL DEFAULT '0',
  `soundex` varchar(75) NOT NULL,
  `links` int(10) NOT NULL DEFAULT '0',
  `language` char(3) NOT NULL DEFAULT ''
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__finder_terms_common`;
CREATE TABLE IF NOT EXISTS `#__finder_terms_common` (
  `term` varchar(75) NOT NULL,
  `language` varchar(3) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `#__finder_terms_common` (`term`, `language`) VALUES
('a', 'en'),
('about', 'en'),
('after', 'en'),
('ago', 'en'),
('all', 'en'),
('am', 'en'),
('an', 'en'),
('and', 'en'),
('ani', 'en'),
('any', 'en'),
('are', 'en'),
('aren''t', 'en'),
('as', 'en'),
('at', 'en'),
('be', 'en'),
('but', 'en'),
('by', 'en'),
('for', 'en'),
('from', 'en'),
('get', 'en'),
('go', 'en'),
('how', 'en'),
('if', 'en'),
('in', 'en'),
('into', 'en'),
('is', 'en'),
('isn''t', 'en'),
('it', 'en'),
('its', 'en'),
('me', 'en'),
('more', 'en'),
('most', 'en'),
('must', 'en'),
('my', 'en'),
('new', 'en'),
('no', 'en'),
('none', 'en'),
('not', 'en'),
('noth', 'en'),
('nothing', 'en'),
('of', 'en'),
('off', 'en'),
('often', 'en'),
('old', 'en'),
('on', 'en'),
('onc', 'en'),
('once', 'en'),
('onli', 'en'),
('only', 'en'),
('or', 'en'),
('other', 'en'),
('our', 'en'),
('ours', 'en'),
('out', 'en'),
('over', 'en'),
('page', 'en'),
('she', 'en'),
('should', 'en'),
('small', 'en'),
('so', 'en'),
('some', 'en'),
('than', 'en'),
('thank', 'en'),
('that', 'en'),
('the', 'en'),
('their', 'en'),
('theirs', 'en'),
('them', 'en'),
('then', 'en'),
('there', 'en'),
('these', 'en'),
('they', 'en'),
('this', 'en'),
('those', 'en'),
('thus', 'en'),
('time', 'en'),
('times', 'en'),
('to', 'en'),
('too', 'en'),
('true', 'en'),
('under', 'en'),
('until', 'en'),
('up', 'en'),
('upon', 'en'),
('use', 'en'),
('user', 'en'),
('users', 'en'),
('veri', 'en'),
('version', 'en'),
('very', 'en'),
('via', 'en'),
('want', 'en'),
('was', 'en'),
('way', 'en'),
('were', 'en'),
('what', 'en'),
('when', 'en'),
('where', 'en'),
('whi', 'en'),
('which', 'en'),
('who', 'en'),
('whom', 'en'),
('whose', 'en'),
('why', 'en'),
('wide', 'en'),
('will', 'en'),
('with', 'en'),
('within', 'en'),
('without', 'en'),
('would', 'en'),
('yes', 'en'),
('yet', 'en'),
('you', 'en'),
('your', 'en'),
('yours', 'en');

DROP TABLE IF EXISTS `#__finder_tokens`;
CREATE TABLE IF NOT EXISTS `#__finder_tokens` (
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` float unsigned NOT NULL DEFAULT '1',
  `context` tinyint(1) unsigned NOT NULL DEFAULT '2',
  `language` char(3) NOT NULL DEFAULT ''
) ENGINE=MEMORY DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__finder_tokens_aggregate`;
CREATE TABLE IF NOT EXISTS `#__finder_tokens_aggregate` (
  `term_id` int(10) unsigned NOT NULL,
  `map_suffix` char(1) NOT NULL,
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `term_weight` float unsigned NOT NULL,
  `context` tinyint(1) unsigned NOT NULL DEFAULT '2',
  `context_weight` float unsigned NOT NULL,
  `total_weight` float unsigned NOT NULL,
  `language` char(3) NOT NULL DEFAULT ''
) ENGINE=MEMORY DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__finder_types`;
CREATE TABLE IF NOT EXISTS `#__finder_types` (
`id` int(10) unsigned NOT NULL,
  `title` varchar(100) NOT NULL,
  `mime` varchar(100) NOT NULL
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8;

INSERT INTO `#__finder_types` (`id`, `title`, `mime`) VALUES
(1, 'Tag', ''),
(2, 'Category', ''),
(3, 'Contact', ''),
(4, 'Article', ''),
(5, 'News Feed', ''),
(6, 'Web Link', '');

DROP TABLE IF EXISTS `#__k2_attachments`;
CREATE TABLE IF NOT EXISTS `#__k2_attachments` (
`id` int(11) NOT NULL,
  `itemID` int(11) NOT NULL,
  `filename` varchar(255) NOT NULL,
  `title` varchar(255) NOT NULL,
  `titleAttribute` text NOT NULL,
  `hits` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__k2_categories`;
CREATE TABLE IF NOT EXISTS `#__k2_categories` (
`id` int(11) unsigned NOT NULL,
  `name` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `parent` int(11) DEFAULT '0',
  `extraFieldsGroup` int(11) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `image` varchar(255) NOT NULL,
  `params` text NOT NULL,
  `trash` smallint(6) NOT NULL DEFAULT '0',
  `plugins` text NOT NULL,
  `language` char(7) NOT NULL
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;

INSERT INTO `#__k2_categories` (`id`, `name`, `alias`, `description`, `parent`, `extraFieldsGroup`, `published`, `access`, `ordering`, `image`, `params`, `trash`, `plugins`, `language`) VALUES
(1, 'Blueprint', 'blueprint', '', 0, 0, 1, 1, 1, '', '{"inheritFrom":"0","theme":"","num_leading_items":"0","num_leading_columns":"1","leadingImgSize":"Large","num_primary_items":"0","num_primary_columns":"2","primaryImgSize":"Medium","num_secondary_items":"0","num_secondary_columns":"1","secondaryImgSize":"Small","num_links":"0","num_links_columns":"1","linksImgSize":"XSmall","catCatalogMode":"1","catFeaturedItems":"1","catOrdering":"","catPagination":"2","catPaginationResults":"1","catTitle":"0","catTitleItemCounter":"0","catDescription":"0","catImage":"0","catFeedLink":"0","catFeedIcon":"0","subCategories":"1","subCatColumns":"2","subCatOrdering":"order","subCatTitle":"1","subCatTitleItemCounter":"0","subCatDescription":"0","subCatImage":"1","itemImageXS":"","itemImageS":"","itemImageM":"","itemImageL":"","itemImageXL":"","catItemTitle":"1","catItemTitleLinked":"1","catItemFeaturedNotice":"0","catItemAuthor":"1","catItemDateCreated":"1","catItemRating":"0","catItemImage":"1","catItemIntroText":"1","catItemIntroTextWordLimit":"","catItemExtraFields":"0","catItemHits":"0","catItemCategory":"1","catItemTags":"1","catItemAttachments":"0","catItemAttachmentsCounter":"0","catItemVideo":"0","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"0","catItemImageGallery":"0","catItemDateModified":"0","catItemReadMore":"1","catItemCommentsAnchor":"1","catItemK2Plugins":"1","itemDateCreated":"1","itemTitle":"1","itemFeaturedNotice":"1","itemAuthor":"1","itemFontResizer":"1","itemPrintButton":"1","itemEmailButton":"1","itemSocialButton":"1","itemVideoAnchor":"1","itemImageGalleryAnchor":"1","itemCommentsAnchor":"1","itemRating":"1","itemImage":"1","itemImgSize":"Large","itemImageMainCaption":"1","itemImageMainCredits":"1","itemIntroText":"1","itemFullText":"1","itemExtraFields":"1","itemDateModified":"1","itemHits":"1","itemCategory":"1","itemTags":"1","itemAttachments":"1","itemAttachmentsCounter":"1","itemVideo":"1","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"0","itemVideoCaption":"1","itemVideoCredits":"1","itemImageGallery":"1","itemNavigation":"1","itemComments":"1","itemTwitterButton":"1","itemFacebookButton":"1","itemGooglePlusOneButton":"1","itemAuthorBlock":"1","itemAuthorImage":"1","itemAuthorDescription":"1","itemAuthorURL":"1","itemAuthorEmail":"0","itemAuthorLatest":"1","itemAuthorLatestLimit":"5","itemRelated":"1","itemRelatedLimit":"5","itemRelatedTitle":"1","itemRelatedCategory":"0","itemRelatedImageSize":"0","itemRelatedIntrotext":"0","itemRelatedFulltext":"0","itemRelatedAuthor":"0","itemRelatedMedia":"0","itemRelatedImageGallery":"0","itemK2Plugins":"1","catMetaDesc":"","catMetaKey":"","catMetaRobots":"","catMetaAuthor":""}', 0, '', '*'),
(2, '3D Visualization', '3d-visualization', '', 1, 0, 1, 1, 4, '2.jpg', '{"inheritFrom":"0","theme":"portfolio","num_leading_items":"0","num_leading_columns":"1","leadingImgSize":"XLarge","num_primary_items":"4","num_primary_columns":"2","primaryImgSize":"Medium","num_secondary_items":"0","num_secondary_columns":"1","secondaryImgSize":"Small","num_links":"0","num_links_columns":"1","linksImgSize":"XSmall","catCatalogMode":"0","catFeaturedItems":"1","catOrdering":"","catPagination":"2","catPaginationResults":"1","catTitle":"1","catTitleItemCounter":"0","catDescription":"0","catImage":"0","catFeedLink":"0","catFeedIcon":"0","subCategories":"1","subCatColumns":"2","subCatOrdering":"","subCatTitle":"0","subCatTitleItemCounter":"0","subCatDescription":"0","subCatImage":"0","itemImageXS":"","itemImageS":"","itemImageM":"","itemImageL":"","itemImageXL":"","catItemTitle":"1","catItemTitleLinked":"1","catItemFeaturedNotice":"0","catItemAuthor":"1","catItemDateCreated":"1","catItemRating":"0","catItemImage":"1","catItemIntroText":"1","catItemIntroTextWordLimit":"","catItemExtraFields":"0","catItemHits":"0","catItemCategory":"0","catItemTags":"0","catItemAttachments":"0","catItemAttachmentsCounter":"0","catItemVideo":"0","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"0","catItemImageGallery":"0","catItemDateModified":"0","catItemReadMore":"0","catItemCommentsAnchor":"0","catItemK2Plugins":"1","itemDateCreated":"1","itemTitle":"1","itemFeaturedNotice":"1","itemAuthor":"1","itemFontResizer":"0","itemPrintButton":"0","itemEmailButton":"0","itemSocialButton":"1","itemVideoAnchor":"0","itemImageGalleryAnchor":"0","itemCommentsAnchor":"1","itemRating":"0","itemImage":"1","itemImgSize":"XLarge","itemImageMainCaption":"1","itemImageMainCredits":"1","itemIntroText":"1","itemFullText":"1","itemExtraFields":"1","itemDateModified":"1","itemHits":"1","itemCategory":"1","itemTags":"1","itemAttachments":"1","itemAttachmentsCounter":"1","itemVideo":"1","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"1","itemVideoCaption":"1","itemVideoCredits":"1","itemImageGallery":"1","itemNavigation":"1","itemComments":"1","itemTwitterButton":"1","itemFacebookButton":"1","itemGooglePlusOneButton":"1","itemAuthorBlock":"1","itemAuthorImage":"1","itemAuthorDescription":"1","itemAuthorURL":"1","itemAuthorEmail":"1","itemAuthorLatest":"0","itemAuthorLatestLimit":"5","itemRelated":"1","itemRelatedLimit":"4","itemRelatedTitle":"1","itemRelatedCategory":"0","itemRelatedImageSize":"0","itemRelatedIntrotext":"1","itemRelatedFulltext":"0","itemRelatedAuthor":"0","itemRelatedMedia":"0","itemRelatedImageGallery":"0","itemK2Plugins":"1","catMetaDesc":"","catMetaKey":"","catMetaRobots":"","catMetaAuthor":""}', 0, '', '*'),
(3, 'Interior Design', 'interior-design', '', 1, 0, 1, 1, 3, '3.jpg', '{"inheritFrom":"0","theme":"minitek1","num_leading_items":"0","num_leading_columns":"1","leadingImgSize":"XLarge","num_primary_items":"8","num_primary_columns":"1","primaryImgSize":"Small","num_secondary_items":"0","num_secondary_columns":"1","secondaryImgSize":"Small","num_links":"0","num_links_columns":"1","linksImgSize":"none","catCatalogMode":"0","catFeaturedItems":"1","catOrdering":"","catPagination":"2","catPaginationResults":"1","catTitle":"1","catTitleItemCounter":"0","catDescription":"1","catImage":"0","catFeedLink":"0","catFeedIcon":"0","subCategories":"1","subCatColumns":"2","subCatOrdering":"","subCatTitle":"1","subCatTitleItemCounter":"1","subCatDescription":"1","subCatImage":"1","itemImageXS":"","itemImageS":"","itemImageM":"","itemImageL":"","itemImageXL":"","catItemTitle":"1","catItemTitleLinked":"1","catItemFeaturedNotice":"1","catItemAuthor":"0","catItemDateCreated":"1","catItemRating":"0","catItemImage":"1","catItemIntroText":"1","catItemIntroTextWordLimit":"45","catItemExtraFields":"0","catItemHits":"0","catItemCategory":"0","catItemTags":"0","catItemAttachments":"0","catItemAttachmentsCounter":"0","catItemVideo":"0","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"0","catItemImageGallery":"0","catItemDateModified":"0","catItemReadMore":"0","catItemCommentsAnchor":"0","catItemK2Plugins":"1","itemDateCreated":"1","itemTitle":"1","itemFeaturedNotice":"1","itemAuthor":"1","itemFontResizer":"0","itemPrintButton":"1","itemEmailButton":"1","itemSocialButton":"1","itemVideoAnchor":"1","itemImageGalleryAnchor":"1","itemCommentsAnchor":"1","itemRating":"0","itemImage":"1","itemImgSize":"Large","itemImageMainCaption":"1","itemImageMainCredits":"1","itemIntroText":"1","itemFullText":"1","itemExtraFields":"1","itemDateModified":"0","itemHits":"1","itemCategory":"1","itemTags":"1","itemAttachments":"1","itemAttachmentsCounter":"1","itemVideo":"1","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"0","itemVideoCaption":"1","itemVideoCredits":"1","itemImageGallery":"1","itemNavigation":"1","itemComments":"1","itemTwitterButton":"0","itemFacebookButton":"0","itemGooglePlusOneButton":"0","itemAuthorBlock":"1","itemAuthorImage":"1","itemAuthorDescription":"1","itemAuthorURL":"1","itemAuthorEmail":"0","itemAuthorLatest":"0","itemAuthorLatestLimit":"5","itemRelated":"0","itemRelatedLimit":"5","itemRelatedTitle":"1","itemRelatedCategory":"0","itemRelatedImageSize":"0","itemRelatedIntrotext":"0","itemRelatedFulltext":"0","itemRelatedAuthor":"0","itemRelatedMedia":"0","itemRelatedImageGallery":"0","itemK2Plugins":"1","catMetaDesc":"","catMetaKey":"","catMetaRobots":"","catMetaAuthor":""}', 0, '', '*'),
(4, 'Space Planning', 'space-planning', '', 1, 0, 1, 1, 2, '4.jpg', '{"inheritFrom":"0","theme":"minitek2","num_leading_items":"0","num_leading_columns":"1","leadingImgSize":"Large","num_primary_items":"4","num_primary_columns":"2","primaryImgSize":"Medium","num_secondary_items":"0","num_secondary_columns":"1","secondaryImgSize":"Small","num_links":"0","num_links_columns":"1","linksImgSize":"XSmall","catCatalogMode":"0","catFeaturedItems":"1","catOrdering":"","catPagination":"2","catPaginationResults":"1","catTitle":"1","catTitleItemCounter":"0","catDescription":"0","catImage":"0","catFeedLink":"0","catFeedIcon":"0","subCategories":"1","subCatColumns":"2","subCatOrdering":"","subCatTitle":"1","subCatTitleItemCounter":"0","subCatDescription":"1","subCatImage":"1","itemImageXS":"","itemImageS":"","itemImageM":"","itemImageL":"","itemImageXL":"","catItemTitle":"1","catItemTitleLinked":"1","catItemFeaturedNotice":"1","catItemAuthor":"0","catItemDateCreated":"1","catItemRating":"0","catItemImage":"1","catItemIntroText":"0","catItemIntroTextWordLimit":"45","catItemExtraFields":"0","catItemHits":"0","catItemCategory":"0","catItemTags":"0","catItemAttachments":"0","catItemAttachmentsCounter":"0","catItemVideo":"0","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"0","catItemImageGallery":"0","catItemDateModified":"0","catItemReadMore":"0","catItemCommentsAnchor":"0","catItemK2Plugins":"1","itemDateCreated":"1","itemTitle":"1","itemFeaturedNotice":"1","itemAuthor":"1","itemFontResizer":"1","itemPrintButton":"1","itemEmailButton":"1","itemSocialButton":"1","itemVideoAnchor":"1","itemImageGalleryAnchor":"1","itemCommentsAnchor":"1","itemRating":"0","itemImage":"1","itemImgSize":"XLarge","itemImageMainCaption":"1","itemImageMainCredits":"1","itemIntroText":"1","itemFullText":"1","itemExtraFields":"0","itemDateModified":"1","itemHits":"1","itemCategory":"1","itemTags":"1","itemAttachments":"1","itemAttachmentsCounter":"1","itemVideo":"1","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"0","itemVideoCaption":"1","itemVideoCredits":"1","itemImageGallery":"1","itemNavigation":"1","itemComments":"1","itemTwitterButton":"1","itemFacebookButton":"1","itemGooglePlusOneButton":"1","itemAuthorBlock":"1","itemAuthorImage":"1","itemAuthorDescription":"1","itemAuthorURL":"1","itemAuthorEmail":"0","itemAuthorLatest":"0","itemAuthorLatestLimit":"5","itemRelated":"0","itemRelatedLimit":"5","itemRelatedTitle":"0","itemRelatedCategory":"0","itemRelatedImageSize":"0","itemRelatedIntrotext":"0","itemRelatedFulltext":"0","itemRelatedAuthor":"0","itemRelatedMedia":"0","itemRelatedImageGallery":"0","itemK2Plugins":"1","catMetaDesc":"","catMetaKey":"","catMetaRobots":"","catMetaAuthor":""}', 0, '', '*'),
(5, 'Architecture', 'architecture', '', 1, 0, 1, 1, 1, '5.jpg', '{"inheritFrom":"0","theme":"","num_leading_items":"0","num_leading_columns":"1","leadingImgSize":"XLarge","num_primary_items":"4","num_primary_columns":"1","primaryImgSize":"Large","num_secondary_items":"0","num_secondary_columns":"1","secondaryImgSize":"Small","num_links":"0","num_links_columns":"1","linksImgSize":"XSmall","catCatalogMode":"0","catFeaturedItems":"1","catOrdering":"","catPagination":"2","catPaginationResults":"1","catTitle":"1","catTitleItemCounter":"0","catDescription":"1","catImage":"0","catFeedLink":"0","catFeedIcon":"0","subCategories":"1","subCatColumns":"2","subCatOrdering":"","subCatTitle":"1","subCatTitleItemCounter":"1","subCatDescription":"1","subCatImage":"1","itemImageXS":"","itemImageS":"","itemImageM":"","itemImageL":"","itemImageXL":"","catItemTitle":"1","catItemTitleLinked":"1","catItemFeaturedNotice":"0","catItemAuthor":"1","catItemDateCreated":"1","catItemRating":"0","catItemImage":"1","catItemIntroText":"1","catItemIntroTextWordLimit":"44","catItemExtraFields":"0","catItemHits":"0","catItemCategory":"0","catItemTags":"0","catItemAttachments":"0","catItemAttachmentsCounter":"0","catItemVideo":"0","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"0","catItemImageGallery":"0","catItemDateModified":"0","catItemReadMore":"0","catItemCommentsAnchor":"0","catItemK2Plugins":"1","itemDateCreated":"1","itemTitle":"1","itemFeaturedNotice":"1","itemAuthor":"1","itemFontResizer":"0","itemPrintButton":"0","itemEmailButton":"0","itemSocialButton":"0","itemVideoAnchor":"1","itemImageGalleryAnchor":"1","itemCommentsAnchor":"1","itemRating":"0","itemImage":"1","itemImgSize":"Large","itemImageMainCaption":"1","itemImageMainCredits":"1","itemIntroText":"1","itemFullText":"1","itemExtraFields":"1","itemDateModified":"1","itemHits":"1","itemCategory":"1","itemTags":"1","itemAttachments":"1","itemAttachmentsCounter":"1","itemVideo":"1","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"1","itemVideoCaption":"1","itemVideoCredits":"1","itemImageGallery":"1","itemNavigation":"1","itemComments":"1","itemTwitterButton":"1","itemFacebookButton":"1","itemGooglePlusOneButton":"1","itemAuthorBlock":"1","itemAuthorImage":"1","itemAuthorDescription":"1","itemAuthorURL":"1","itemAuthorEmail":"1","itemAuthorLatest":"0","itemAuthorLatestLimit":"5","itemRelated":"0","itemRelatedLimit":"4","itemRelatedTitle":"0","itemRelatedCategory":"0","itemRelatedImageSize":"Medium","itemRelatedIntrotext":"0","itemRelatedFulltext":"0","itemRelatedAuthor":"0","itemRelatedMedia":"0","itemRelatedImageGallery":"0","itemK2Plugins":"1","catMetaDesc":"","catMetaKey":"","catMetaRobots":"","catMetaAuthor":""}', 0, '', '*');

DROP TABLE IF EXISTS `#__k2_comments`;
CREATE TABLE IF NOT EXISTS `#__k2_comments` (
`id` int(11) NOT NULL,
  `itemID` int(11) NOT NULL,
  `userID` int(11) NOT NULL,
  `userName` varchar(255) NOT NULL,
  `commentDate` datetime NOT NULL,
  `commentText` text NOT NULL,
  `commentEmail` varchar(255) NOT NULL,
  `commentURL` varchar(255) NOT NULL,
  `published` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;

INSERT INTO `#__k2_comments` (`id`, `itemID`, `userID`, `userName`, `commentDate`, `commentText`, `commentEmail`, `commentURL`, `published`) VALUES
(1, 39, 445, 'John Doe', '2015-05-28 11:26:23', 'Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque.', 'JohnDoe@anymail.com', '', 1),
(2, 39, 446, 'Samantha Doe', '2015-05-28 11:27:19', 'Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis.', 'SamanthaVerdi@anymail.com', '', 1);

DROP TABLE IF EXISTS `#__k2_extra_fields`;
CREATE TABLE IF NOT EXISTS `#__k2_extra_fields` (
`id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `value` text NOT NULL,
  `type` varchar(255) NOT NULL,
  `group` int(11) NOT NULL,
  `published` tinyint(4) NOT NULL,
  `ordering` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__k2_extra_fields_groups`;
CREATE TABLE IF NOT EXISTS `#__k2_extra_fields_groups` (
`id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__k2_items`;
CREATE TABLE IF NOT EXISTS `#__k2_items` (
`id` int(11) NOT NULL,
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) DEFAULT NULL,
  `catid` int(11) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `video` text,
  `gallery` varchar(255) DEFAULT NULL,
  `extra_fields` text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
  `extra_fields_search` text NOT NULL,
  `created` datetime NOT NULL,
  `created_by` int(11) NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL,
  `checked_out` int(10) unsigned NOT NULL,
  `checked_out_time` datetime NOT NULL,
  `modified` datetime NOT NULL,
  `modified_by` int(11) NOT NULL DEFAULT '0',
  `publish_up` datetime NOT NULL,
  `publish_down` datetime NOT NULL,
  `trash` smallint(6) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `featured` smallint(6) NOT NULL DEFAULT '0',
  `featured_ordering` int(11) NOT NULL DEFAULT '0',
  `image_caption` text NOT NULL,
  `image_credits` varchar(255) NOT NULL,
  `video_caption` text NOT NULL,
  `video_credits` varchar(255) NOT NULL,
  `hits` int(10) unsigned NOT NULL,
  `params` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `metakey` text NOT NULL,
  `plugins` text NOT NULL,
  `language` char(7) NOT NULL
) ENGINE=InnoDB AUTO_INCREMENT=75 DEFAULT CHARSET=utf8;

INSERT INTO `#__k2_items` (`id`, `title`, `alias`, `catid`, `published`, `introtext`, `fulltext`, `video`, `gallery`, `extra_fields`, `extra_fields_search`, `created`, `created_by`, `created_by_alias`, `checked_out`, `checked_out_time`, `modified`, `modified_by`, `publish_up`, `publish_down`, `trash`, `access`, `ordering`, `featured`, `featured_ordering`, `image_caption`, `image_credits`, `video_caption`, `video_credits`, `hits`, `params`, `metadesc`, `metadata`, `metakey`, `plugins`, `language`) VALUES
(34, 'Working and suggesting new ideas', 'working-and-suggesting-new-ideas', 4, 1, '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', NULL, NULL, '[]', '', '2014-11-05 00:00:00', 445, '', 0, '0000-00-00 00:00:00', '2015-07-29 18:42:33', 445, '2014-08-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 6, 0, 0, '', '', '', '', 13, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(35, 'Web surfing and relaxing for inspiration', 'web-surfing-and-relaxing-for-inspiration', 4, 1, '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', NULL, NULL, '[]', '', '2014-11-05 00:00:00', 445, '', 0, '0000-00-00 00:00:00', '2015-07-29 18:42:29', 445, '2014-08-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 3, 0, 0, '', '', '', '', 36, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(37, 'The latest techniques in 3D technology', 'the-latest-techniques-in-3d-technology', 2, 1, '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', NULL, NULL, '[]', '', '2015-02-12 23:49:44', 446, '', 0, '0000-00-00 00:00:00', '2015-07-29 18:44:14', 445, '2014-08-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 1, 0, 0, '', '', '', '', 27, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(38, 'Taking 3D visualization to the next level', 'taking-3d-visualization-to-the-next-level', 2, 1, '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', NULL, NULL, '[]', '', '2015-02-12 23:49:44', 445, '', 0, '0000-00-00 00:00:00', '2015-07-29 18:44:10', 445, '2014-08-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 2, 0, 0, '', '', '', '', 28, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(39, 'Improving visualization by using a new software', 'improving-visualization-by-using-a-new-software', 2, 1, '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', NULL, NULL, '[]', '', '2015-02-12 23:49:44', 445, '', 0, '0000-00-00 00:00:00', '2015-07-29 18:44:06', 445, '2014-08-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 6, 1, 4, '', '', '', '', 108, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(40, 'Exterior visualization of a big city building', 'exterior-visualization-of-a-big-city-building', 2, 1, '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', NULL, NULL, '[]', '', '2015-02-12 23:49:44', 445, '', 0, '0000-00-00 00:00:00', '2015-07-29 18:44:02', 445, '2014-08-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 4, 1, 2, '', '', '', '', 146, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(41, 'This is a simple and amazing decoration', 'this-is-a-simple-and-amazing-decoration', 3, 1, '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', '', NULL, '[]', '', '2015-02-13 00:08:24', 445, '', 0, '0000-00-00 00:00:00', '2015-07-29 18:43:22', 445, '2014-08-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 6, 0, 0, '', '', '', '', 14, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(42, 'Sometimes the color choice is more than difficult', 'sometimes-the-color-choice-is-more-than-difficult', 3, 1, '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', '', NULL, '[]', '', '2015-02-13 00:08:24', 445, '', 0, '0000-00-00 00:00:00', '2015-07-29 18:43:15', 445, '2014-08-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 3, 0, 0, '', '', '', '', 50, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(43, 'Experience and inspirational ideas', 'experience-and-inspirational-ideas', 4, 1, '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', NULL, NULL, '[]', '', '2015-02-13 00:13:41', 445, '', 0, '0000-00-00 00:00:00', '2015-07-29 18:42:25', 445, '2014-08-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 5, 0, 0, '', '', '', '', 1, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(44, 'Comfy and minimalistic style', 'comfy-and-minimalistic-style', 4, 1, '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', NULL, NULL, '[]', '', '2015-02-13 00:13:41', 445, '', 0, '0000-00-00 00:00:00', '2015-07-29 18:42:20', 445, '2014-08-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 2, 0, 0, '', '', '', '', 18, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(45, 'The world''s tallest buildings', 'the-world-s-tallest-buildings', 5, 1, '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', NULL, NULL, '[]', '', '2015-02-13 00:18:17', 445, '', 0, '0000-00-00 00:00:00', '2015-07-29 18:41:44', 445, '2014-11-10 00:00:00', '0000-00-00 00:00:00', 0, 1, 6, 0, 0, '', '', '', '', 1, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(46, 'The design of a luxury condominium towers', 'the-design-of-a-luxury-condominium-towers', 5, 1, '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', NULL, NULL, '[]', '', '2015-02-13 00:18:17', 445, '', 0, '0000-00-00 00:00:00', '2015-07-29 18:41:39', 445, '2014-08-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 5, 0, 1, '', '', '', '', 8, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(47, 'Redevelopment of former power station building', 'redevelopment-of-former-power-station-building', 5, 1, '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', NULL, NULL, '[]', '', '2015-02-13 00:18:17', 445, '', 0, '0000-00-00 00:00:00', '2015-07-29 18:41:35', 445, '2014-08-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 4, 0, 0, '', '', '', '', 31, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(48, 'One of the most famous museums globally', 'one-of-the-most-famous-museums-globally', 5, 1, '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', NULL, NULL, '[]', '', '2015-02-13 00:18:17', 445, '', 0, '0000-00-00 00:00:00', '2015-07-29 18:41:30', 445, '2014-08-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 2, 0, 0, '', '', '', '', 42, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(49, 'Reading magazines helps our inspiration', 'reading-magazines-helps-our-inspiration', 3, 1, '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', '', NULL, '[]', '', '2015-03-04 23:07:56', 445, '', 0, '0000-00-00 00:00:00', '2015-07-29 18:43:11', 445, '2014-08-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 5, 0, 0, '', '', '', '', 11, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*');
INSERT INTO `#__k2_items` (`id`, `title`, `alias`, `catid`, `published`, `introtext`, `fulltext`, `video`, `gallery`, `extra_fields`, `extra_fields_search`, `created`, `created_by`, `created_by_alias`, `checked_out`, `checked_out_time`, `modified`, `modified_by`, `publish_up`, `publish_down`, `trash`, `access`, `ordering`, `featured`, `featured_ordering`, `image_caption`, `image_credits`, `video_caption`, `video_credits`, `hits`, `params`, `metadesc`, `metadata`, `metakey`, `plugins`, `language`) VALUES
(50, 'Our latest and favourite city''s apartment interior', 'our-latest-and-favourite-city-s-apartment-interior', 3, 1, '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', '', NULL, '[]', '', '2015-03-04 23:07:56', 445, '', 0, '0000-00-00 00:00:00', '2015-07-29 18:43:07', 445, '2014-08-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 2, 0, 0, '', '', '', '', 16, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(67, 'An interior''s hotel visualization project', 'an-interior-s-hotel-visualization-project', 2, 1, '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', NULL, NULL, '[]', '', '2015-03-24 18:56:08', 445, '', 0, '0000-00-00 00:00:00', '2015-07-29 18:43:58', 445, '2014-08-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 5, 1, 3, '', '', '', '', 4, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(68, 'A 3D model of a house created in perfection', 'a-3d-model-of-a-house-created-in-perfection', 2, 1, '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', NULL, NULL, '[]', '', '2015-03-24 18:56:08', 445, '', 0, '0000-00-00 00:00:00', '2015-07-29 18:43:54', 445, '2014-08-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 3, 1, 1, '', '', '', '', 30, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(69, 'Living room project outside the city limits', 'living-room-project-outside-the-city-limits', 3, 1, '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', '', NULL, '[]', '', '2015-03-24 19:09:26', 445, '', 0, '0000-00-00 00:00:00', '2015-07-29 18:43:02', 445, '2014-08-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 4, 0, 0, '', '', '', '', 2, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(70, 'Interior design in a famous city diner', 'interior-design-in-a-famous-city-diner', 3, 1, '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', '', NULL, '[]', '', '2015-03-24 19:09:26', 445, '', 0, '0000-00-00 00:00:00', '2015-07-29 18:42:58', 445, '2014-08-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 1, 0, 0, '', '', '', '', 24, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(71, 'A white space ready for space planning', 'a-white-space-ready-for-space-planning', 4, 1, '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', NULL, NULL, '[]', '', '2015-03-24 19:16:21', 445, '', 0, '0000-00-00 00:00:00', '2015-07-29 18:42:15', 445, '2014-08-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 4, 0, 0, '', '', '', '', 3, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(72, 'A prototype of a kitchen''s interior', 'a-prototype-of-a-kitchen-s-interior', 4, 1, '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', NULL, NULL, '[]', '', '2015-03-24 19:16:21', 445, '', 0, '0000-00-00 00:00:00', '2015-07-29 18:42:11', 445, '2014-08-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 1, 0, 0, '', '', '', '', 19, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(73, 'Buildings examples of Art Deco architecture', 'buildings-examples-of-art-deco-architecture', 5, 1, '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', NULL, NULL, '[]', '', '2015-03-24 19:23:26', 445, '', 0, '0000-00-00 00:00:00', '2015-07-29 18:41:26', 445, '2014-08-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 3, 0, 0, '', '', '', '', 31, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*'),
(74, 'A latest mall architectonic project', 'a-latest-mall-architectonic-project', 5, 1, '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.</p>\r\n', '\r\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.</p>', NULL, NULL, '[]', '', '2015-03-24 19:23:26', 445, '', 0, '0000-00-00 00:00:00', '2015-07-29 18:41:22', 445, '2014-08-05 00:00:00', '0000-00-00 00:00:00', 0, 1, 1, 0, 0, '', '', '', '', 108, '{"catItemTitle":"","catItemTitleLinked":"","catItemFeaturedNotice":"","catItemAuthor":"","catItemDateCreated":"","catItemRating":"","catItemImage":"","catItemIntroText":"","catItemExtraFields":"","catItemHits":"","catItemCategory":"","catItemTags":"","catItemAttachments":"","catItemAttachmentsCounter":"","catItemVideo":"","catItemVideoWidth":"","catItemVideoHeight":"","catItemAudioWidth":"","catItemAudioHeight":"","catItemVideoAutoPlay":"","catItemImageGallery":"","catItemDateModified":"","catItemReadMore":"","catItemCommentsAnchor":"","catItemK2Plugins":"","itemDateCreated":"","itemTitle":"","itemFeaturedNotice":"","itemAuthor":"","itemFontResizer":"","itemPrintButton":"","itemEmailButton":"","itemSocialButton":"","itemVideoAnchor":"","itemImageGalleryAnchor":"","itemCommentsAnchor":"","itemRating":"","itemImage":"","itemImgSize":"","itemImageMainCaption":"","itemImageMainCredits":"","itemIntroText":"","itemFullText":"","itemExtraFields":"","itemDateModified":"","itemHits":"","itemCategory":"","itemTags":"","itemAttachments":"","itemAttachmentsCounter":"","itemVideo":"","itemVideoWidth":"","itemVideoHeight":"","itemAudioWidth":"","itemAudioHeight":"","itemVideoAutoPlay":"","itemVideoCaption":"","itemVideoCredits":"","itemImageGallery":"","itemNavigation":"","itemComments":"","itemTwitterButton":"","itemFacebookButton":"","itemGooglePlusOneButton":"","itemAuthorBlock":"","itemAuthorImage":"","itemAuthorDescription":"","itemAuthorURL":"","itemAuthorEmail":"","itemAuthorLatest":"","itemAuthorLatestLimit":"","itemRelated":"","itemRelatedLimit":"","itemRelatedTitle":"","itemRelatedCategory":"","itemRelatedImageSize":"","itemRelatedIntrotext":"","itemRelatedFulltext":"","itemRelatedAuthor":"","itemRelatedMedia":"","itemRelatedImageGallery":"","itemK2Plugins":""}', '', 'robots=\nauthor=', '', '', '*');

DROP TABLE IF EXISTS `#__k2_rating`;
CREATE TABLE IF NOT EXISTS `#__k2_rating` (
  `itemID` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(11) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(11) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT ''
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `#__k2_rating` (`itemID`, `rating_sum`, `rating_count`, `lastip`) VALUES
(33, 4, 1, '78.87.101.62'),
(36, 1, 1, '178.59.159.192');

DROP TABLE IF EXISTS `#__k2_tags`;
CREATE TABLE IF NOT EXISTS `#__k2_tags` (
`id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0'
) ENGINE=InnoDB AUTO_INCREMENT=411 DEFAULT CHARSET=utf8;

INSERT INTO `#__k2_tags` (`id`, `name`, `published`) VALUES
(380, 'architecture', 1),
(381, 'mall', 1),
(382, 'project', 1),
(383, 'art', 1),
(384, 'buildings', 1),
(385, 'museums', 1),
(386, 'train', 1),
(387, 'station', 1),
(388, 'design', 1),
(389, 'towers', 1),
(390, 'space', 1),
(391, 'kitchen', 1),
(392, 'minimalistic', 1),
(393, 'experience', 1),
(394, 'ideas', 1),
(395, 'web', 1),
(396, 'inspiration', 1),
(397, 'surfing', 1),
(398, 'working', 1),
(399, 'interior', 1),
(400, 'city', 1),
(401, 'room', 1),
(402, 'apartment', 1),
(403, 'color', 1),
(404, 'decoration', 1),
(405, 'Visualization', 1),
(406, 'house', 1),
(407, 'exterior', 1),
(408, 'software', 1),
(409, 'techniques', 1),
(410, 'technology', 1);

DROP TABLE IF EXISTS `#__k2_tags_xref`;
CREATE TABLE IF NOT EXISTS `#__k2_tags_xref` (
`id` int(11) NOT NULL,
  `tagID` int(11) NOT NULL,
  `itemID` int(11) NOT NULL
) ENGINE=InnoDB AUTO_INCREMENT=159 DEFAULT CHARSET=utf8;

INSERT INTO `#__k2_tags_xref` (`id`, `tagID`, `itemID`) VALUES
(80, 380, 74),
(81, 381, 74),
(82, 382, 74),
(83, 380, 73),
(84, 383, 73),
(85, 384, 73),
(86, 380, 48),
(87, 383, 48),
(88, 384, 48),
(89, 385, 48),
(90, 380, 47),
(91, 384, 47),
(92, 386, 47),
(93, 387, 47),
(94, 380, 46),
(95, 388, 46),
(96, 389, 46),
(97, 380, 45),
(98, 384, 45),
(99, 383, 45),
(100, 390, 72),
(101, 380, 72),
(102, 391, 72),
(103, 390, 71),
(104, 380, 71),
(105, 383, 71),
(106, 392, 44),
(107, 390, 44),
(108, 393, 43),
(109, 394, 43),
(110, 380, 43),
(111, 390, 43),
(112, 395, 35),
(113, 390, 35),
(114, 396, 35),
(115, 397, 35),
(116, 380, 34),
(117, 394, 34),
(118, 398, 34),
(119, 399, 70),
(120, 400, 70),
(121, 388, 70),
(122, 399, 69),
(123, 388, 69),
(124, 382, 69),
(125, 400, 69),
(126, 401, 69),
(127, 399, 50),
(128, 388, 50),
(129, 402, 50),
(130, 399, 49),
(131, 388, 49),
(132, 396, 49),
(133, 399, 42),
(134, 388, 42),
(135, 403, 42),
(136, 399, 41),
(137, 388, 41),
(138, 404, 41),
(139, 405, 68),
(140, 380, 68),
(141, 406, 68),
(142, 399, 67),
(143, 405, 67),
(144, 382, 67),
(145, 407, 40),
(146, 405, 40),
(147, 400, 40),
(148, 384, 40),
(149, 405, 39),
(150, 408, 39),
(151, 383, 39),
(152, 405, 38),
(153, 382, 38),
(154, 383, 38),
(155, 399, 38),
(156, 405, 37),
(157, 409, 37),
(158, 410, 37);

DROP TABLE IF EXISTS `#__k2_users`;
CREATE TABLE IF NOT EXISTS `#__k2_users` (
`id` int(11) NOT NULL,
  `userID` int(11) NOT NULL,
  `userName` varchar(255) DEFAULT NULL,
  `gender` enum('m','f') NOT NULL DEFAULT 'm',
  `description` text NOT NULL,
  `image` varchar(255) DEFAULT NULL,
  `url` varchar(255) DEFAULT NULL,
  `group` int(11) NOT NULL DEFAULT '0',
  `plugins` text NOT NULL,
  `ip` varchar(15) NOT NULL,
  `hostname` varchar(255) NOT NULL,
  `notes` text NOT NULL
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

INSERT INTO `#__k2_users` (`id`, `userID`, `userName`, `gender`, `description`, `image`, `url`, `group`, `plugins`, `ip`, `hostname`, `notes`) VALUES
(2, 445, 'John Doe', 'm', '', '2.jpg', '', 1, '', '78.87.136.79', '78-136-79.adsl.cyta.gr', ''),
(3, 446, 'Samantha Doe', 'f', '', '3.jpg', '', 1, '', '78.87.136.79', '78-136-79.adsl.cyta.gr', '');

DROP TABLE IF EXISTS `#__k2_user_groups`;
CREATE TABLE IF NOT EXISTS `#__k2_user_groups` (
`id` int(10) unsigned NOT NULL,
  `name` varchar(255) NOT NULL,
  `permissions` text NOT NULL
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;

INSERT INTO `#__k2_user_groups` (`id`, `name`, `permissions`) VALUES
(1, 'Registered', '{"comment":"1","frontEdit":"0","add":"0","editOwn":"0","editAll":"0","publish":"0","inheritance":0,"categories":"all"}'),
(2, 'Site Owner', '{"comment":"1","frontEdit":"1","add":"1","editOwn":"1","editAll":"1","publish":"1","inheritance":1,"categories":"all"}');

DROP TABLE IF EXISTS `#__languages`;
CREATE TABLE IF NOT EXISTS `#__languages` (
`lang_id` int(11) unsigned NOT NULL,
  `lang_code` char(7) NOT NULL,
  `title` varchar(50) NOT NULL,
  `title_native` varchar(50) NOT NULL,
  `sef` varchar(50) NOT NULL,
  `image` varchar(50) NOT NULL,
  `description` varchar(512) NOT NULL,
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `sitename` varchar(1024) NOT NULL DEFAULT '',
  `published` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

INSERT INTO `#__languages` (`lang_id`, `lang_code`, `title`, `title_native`, `sef`, `image`, `description`, `metakey`, `metadesc`, `sitename`, `published`, `access`, `ordering`) VALUES
(1, 'en-GB', 'English (UK)', 'English (UK)', 'en', 'en', '', '', '', '', 1, 1, 1);

DROP TABLE IF EXISTS `#__menu`;
CREATE TABLE IF NOT EXISTS `#__menu` (
`id` int(11) NOT NULL,
  `menutype` varchar(24) NOT NULL COMMENT 'The type of menu this item belongs to. FK to #___menu_types.menutype',
  `title` varchar(255) NOT NULL COMMENT 'The display title of the menu item.',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL COMMENT 'The SEF alias of the menu item.',
  `note` varchar(255) NOT NULL DEFAULT '',
  `path` varchar(1024) NOT NULL COMMENT 'The computed path of the menu item based on the alias field.',
  `link` varchar(1024) NOT NULL COMMENT 'The actually link the menu item refers to.',
  `type` varchar(16) NOT NULL COMMENT 'The type of link: Component, URL, Alias, Separator',
  `published` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The published state of the menu link.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '1' COMMENT 'The parent menu item in the menu tree.',
  `level` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The relative level in the tree.',
  `component_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #___extensions.id',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #___users.id',
  `checked_out_time` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'The time the menu item was checked out.',
  `browserNav` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The click behaviour of the link.',
  `access` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The access level required to view the menu item.',
  `img` varchar(255) NOT NULL COMMENT 'The image of the menu item.',
  `template_style_id` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL COMMENT 'JSON encoded data for the menu item.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `home` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Indicates if this menu item is the home or default page.',
  `language` char(7) NOT NULL DEFAULT '',
  `client_id` tinyint(4) NOT NULL DEFAULT '0'
) ENGINE=InnoDB AUTO_INCREMENT=454 DEFAULT CHARSET=utf8;

INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES
(1, '', 'Menu_Item_Root', 'root', '', '', '', '', 1, 0, 0, 0, 0, '0000-00-00 00:00:00', 0, 0, '', 0, '', 0, 217, 0, '*', 0),
(2, 'menu', 'com_banners', 'Banners', '', 'Banners', 'index.php?option=com_banners', 'component', 0, 1, 1, 4, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners', 0, '', 1, 10, 0, '*', 1),
(3, 'menu', 'com_banners', 'Banners', '', 'Banners/Banners', 'index.php?option=com_banners', 'component', 0, 2, 2, 4, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners', 0, '', 2, 3, 0, '*', 1),
(4, 'menu', 'com_banners_categories', 'Categories', '', 'Banners/Categories', 'index.php?option=com_categories&extension=com_banners', 'component', 0, 2, 2, 6, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-cat', 0, '', 4, 5, 0, '*', 1),
(5, 'menu', 'com_banners_clients', 'Clients', '', 'Banners/Clients', 'index.php?option=com_banners&view=clients', 'component', 0, 2, 2, 4, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-clients', 0, '', 6, 7, 0, '*', 1),
(6, 'menu', 'com_banners_tracks', 'Tracks', '', 'Banners/Tracks', 'index.php?option=com_banners&view=tracks', 'component', 0, 2, 2, 4, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-tracks', 0, '', 8, 9, 0, '*', 1),
(7, 'menu', 'com_contact', 'Contacts', '', 'Contacts', 'index.php?option=com_contact', 'component', 0, 1, 1, 8, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact', 0, '', 139, 144, 0, '*', 1),
(8, 'menu', 'com_contact', 'Contacts', '', 'Contacts/Contacts', 'index.php?option=com_contact', 'component', 0, 7, 2, 8, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact', 0, '', 140, 141, 0, '*', 1),
(9, 'menu', 'com_contact_categories', 'Categories', '', 'Contacts/Categories', 'index.php?option=com_categories&extension=com_contact', 'component', 0, 7, 2, 6, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact-cat', 0, '', 142, 143, 0, '*', 1),
(10, 'menu', 'com_messages', 'Messaging', '', 'Messaging', 'index.php?option=com_messages', 'component', 0, 1, 1, 15, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages', 0, '', 145, 150, 0, '*', 1),
(11, 'menu', 'com_messages_add', 'New Private Message', '', 'Messaging/New Private Message', 'index.php?option=com_messages&task=message.add', 'component', 0, 10, 2, 15, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages-add', 0, '', 146, 147, 0, '*', 1),
(12, 'menu', 'com_messages_read', 'Read Private Message', '', 'Messaging/Read Private Message', 'index.php?option=com_messages', 'component', 0, 10, 2, 15, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages-read', 0, '', 148, 149, 0, '*', 1),
(13, 'menu', 'com_newsfeeds', 'News Feeds', '', 'News Feeds', 'index.php?option=com_newsfeeds', 'component', 0, 1, 1, 17, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds', 0, '', 151, 156, 0, '*', 1),
(14, 'menu', 'com_newsfeeds_feeds', 'Feeds', '', 'News Feeds/Feeds', 'index.php?option=com_newsfeeds', 'component', 0, 13, 2, 17, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds', 0, '', 152, 153, 0, '*', 1),
(15, 'menu', 'com_newsfeeds_categories', 'Categories', '', 'News Feeds/Categories', 'index.php?option=com_categories&extension=com_newsfeeds', 'component', 0, 13, 2, 6, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds-cat', 0, '', 154, 155, 0, '*', 1),
(16, 'menu', 'com_redirect', 'Redirect', '', 'Redirect', 'index.php?option=com_redirect', 'component', 0, 1, 1, 24, 0, '0000-00-00 00:00:00', 0, 0, 'class:redirect', 0, '', 157, 158, 0, '*', 1),
(17, 'menu', 'com_search', 'Basic Search', '', 'Basic Search', 'index.php?option=com_search', 'component', 0, 1, 1, 19, 0, '0000-00-00 00:00:00', 0, 0, 'class:search', 0, '', 159, 160, 0, '*', 1),
(21, 'menu', 'com_finder', 'Smart Search', '', 'Smart Search', 'index.php?option=com_finder', 'component', 0, 1, 1, 27, 0, '0000-00-00 00:00:00', 0, 0, 'class:finder', 0, '', 161, 162, 0, '*', 1),
(22, 'menu', 'com_joomlaupdate', 'Joomla! Update', '', 'Joomla! Update', 'index.php?option=com_joomlaupdate', 'component', 1, 1, 1, 28, 0, '0000-00-00 00:00:00', 0, 0, 'class:joomlaupdate', 0, '', 163, 164, 0, '*', 1),
(23, 'main', 'com_tags', 'Tags', '', 'Tags', 'index.php?option=com_tags', 'component', 0, 1, 1, 29, 0, '0000-00-00 00:00:00', 0, 1, 'class:tags', 0, '', 165, 166, 0, '', 1),
(24, 'main', 'com_postinstall', 'Post-installation messages', '', 'Post-installation messages', 'index.php?option=com_postinstall', 'component', 0, 1, 1, 32, 0, '0000-00-00 00:00:00', 0, 1, 'class:postinstall', 0, '', 167, 168, 0, '*', 1),
(101, 'mainmenu', 'Home', 'home', '', 'home', 'index.php?option=com_content&view=article&id=62', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 91, '{"show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_tags":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"Home - Blueprint","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 11, 12, 1, '*', 0),
(113, 'mainmenu', 'Pages', 'pages', '', 'pages', '', 'separator', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu_image":"","menu_text":1}', 13, 24, 0, '*', 0),
(115, 'mainmenu', 'Contact', 'contact', '', 'pages/contact', 'index.php?option=com_content&view=article&id=62', 'component', 1, 113, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 95, '{"show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_tags":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 20, 21, 0, '*', 0),
(116, 'mainmenu', 'FAQ', 'faq', '', 'pages/faq', 'index.php?option=com_content&view=article&id=5', 'component', 1, 113, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"0","link_titles":"0","show_intro":"","info_block_position":"","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"0","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"0","show_tags":"","show_noauth":"0","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"Frequently Asked Questions","pageclass_sfx":" faq","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 22, 23, 0, '*', 0),
(117, 'mainmenu', 'Categories', 'categories', '', 'k2/categories', 'index.php?option=com_k2&view=itemlist&layout=category&task=category&id=1', 'component', 1, 118, 2, 10002, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"categories":["1"],"singleCatOrdering":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":"0","page_heading":"Categories","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 68, 77, 0, '*', 0),
(118, 'mainmenu', 'K2', 'k2', '', 'k2', 'index.php?Itemid=', 'alias', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"117","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 67, 86, 0, '*', 0),
(119, 'mainmenu', 'Typography', 'typography', '', 'explore/typography', 'index.php?option=com_content&view=article&id=8', 'component', 1, 121, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"0","link_titles":"0","show_intro":"","info_block_position":"","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"0","show_tags":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":" typography col-padding10","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 56, 57, 0, '*', 0),
(120, 'mainmenu', 'Module positions', 'module-positions', '', 'explore/module-positions', 'index.php?option=com_content&view=article&id=10', 'component', 1, 121, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"0","link_titles":"0","show_intro":"","info_block_position":"","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"0","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"0","show_tags":"","show_noauth":"0","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":" mod-pos","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 58, 59, 0, '*', 0),
(121, 'mainmenu', 'Explore', 'explore', '', 'explore', 'index.php?Itemid=', 'alias', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"120","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 39, 66, 0, '*', 0),
(122, 'mainmenu', 'Module variations', 'module-variations', '', 'explore/module-variations', 'index.php?option=com_content&view=article&id=9', 'component', 1, 121, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"0","link_titles":"","show_intro":"","info_block_position":"","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"0","show_tags":"0","show_noauth":"0","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"Module variations and Suffixes","pageclass_sfx":" col-padding10","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 60, 61, 0, '*', 0),
(123, 'mainmenu', 'Extra features', '2014-07-28-13-57-52', '', 'explore/2014-07-28-13-57-52', 'http://getbootstrap.com/components/', 'url', 1, 121, 2, 0, 0, '0000-00-00 00:00:00', 2, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 62, 63, 0, '*', 0),
(124, 'mainmenu', 'Responsive design', '2014-07-28-14-04-54', '', 'explore/2014-07-28-14-04-54', 'http://getbootstrap.com/css/#responsive-utilities', 'url', 1, 121, 2, 0, 0, '0000-00-00 00:00:00', 2, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 64, 65, 0, '*', 0),
(125, 'mainmenu', 'Template themes', 'template-themes', '', 'explore/template-themes', 'index.php?Itemid=', 'alias', 1, 121, 2, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"101","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 40, 55, 0, '*', 0),
(127, 'mainmenu', 'Joomla', 'joomla', '', 'joomla', '#', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 87, 138, 0, '*', 0),
(128, 'mainmenu', 'Category blog', 'category-blog', '', 'joomla/content/category-blog', 'index.php?option=com_content&view=category&layout=blog&id=9', 'component', 1, 129, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_heading_title_text":"","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","show_cat_tags":"","page_subheading":"","num_leading_articles":"","num_intro_articles":"","num_columns":"1","num_links":"","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"date","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 95, 96, 0, '*', 0),
(129, 'mainmenu', 'Content', 'content', '', 'joomla/content', 'index.php?Itemid=', 'alias', 1, 127, 2, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"128","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 88, 107, 0, '*', 0),
(130, 'mainmenu', 'Single article', 'single-article', '', 'joomla/content/single-article', 'index.php?option=com_content&view=article&id=50', 'component', 1, 129, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_tags":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 97, 98, 0, '*', 0),
(131, 'mainmenu', 'List all categories', 'list-all-categories', '', 'joomla/content/list-all-categories', 'index.php?option=com_content&view=categories&id=8', 'component', 1, 129, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"","categories_description":"","maxLevelcat":"","show_empty_categories_cat":"","show_subcat_desc_cat":"","show_cat_num_articles_cat":"","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"6","num_columns":"2","num_links":"6","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_pagination_limit":"","filter_field":"","show_headings":"","list_show_date":"","date_format":"","list_show_hits":"","list_show_author":"","display_num":"10","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 99, 100, 0, '*', 0),
(132, 'mainmenu', 'Category list', 'category-list', '', 'joomla/content/category-list', 'index.php?option=com_content&view=category&id=10', 'component', 1, 129, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_category_heading_title":"","show_subcat_desc":"","show_cat_num_articles":"","show_cat_tags":"","page_subheading":"","show_pagination_limit":"","filter_field":"","show_headings":"","list_show_date":"","date_format":"","list_show_hits":"","list_show_author":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","display_num":"10","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 101, 102, 0, '*', 0),
(133, 'mainmenu', 'Featured articles', 'featured-articles', '', 'joomla/content/featured-articles', 'index.php?option=com_content&view=featured', 'component', 1, 129, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"featured_categories":[""],"layout_type":"blog","num_leading_articles":"","num_intro_articles":"","num_columns":"1","num_links":"","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_tags":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 103, 104, 0, '*', 0),
(134, 'mainmenu', 'Archived articles', 'archived-articles', '', 'joomla/content/archived-articles', 'index.php?option=com_content&view=archive', 'component', 1, 129, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"orderby_sec":"alpha","order_date":"created","display_num":"5","filter_field":"","introtext_limit":"100","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","link_titles":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_hits":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 105, 106, 0, '*', 0),
(135, 'mainmenu', 'Login form', 'login-form', '', 'joomla/users/login-form', 'index.php?option=com_users&view=login', 'component', 1, 136, 3, 25, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"login_redirect_url":"","logindescription_show":"1","login_description":"","login_image":"","logout_redirect_url":"","logoutdescription_show":"1","logout_description":"","logout_image":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 109, 110, 0, '*', 0),
(136, 'mainmenu', 'Users', 'users', '', 'joomla/users', 'index.php?Itemid=', 'alias', 1, 127, 2, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"135","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 108, 117, 0, '*', 0),
(137, 'mainmenu', 'Registration form', 'registration-form', '', 'joomla/users/registration-form', 'index.php?option=com_users&view=registration', 'component', 1, 136, 3, 25, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 111, 112, 0, '*', 0),
(138, 'mainmenu', 'Username reminder request', 'username-reminder-request', '', 'joomla/users/username-reminder-request', 'index.php?option=com_users&view=remind', 'component', 1, 136, 3, 25, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 113, 114, 0, '*', 0),
(139, 'mainmenu', 'Password reset', 'password-reset', '', 'joomla/users/password-reset', 'index.php?option=com_users&view=reset', 'component', 1, 136, 3, 25, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 115, 116, 0, '*', 0),
(140, 'mainmenu', 'Search', 'search', '', 'joomla/search', 'index.php?option=com_search&view=search', 'component', 1, 127, 2, 19, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"search_areas":"","show_date":"","searchphrase":"0","ordering":"newest","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"Search","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 118, 119, 0, '*', 0),
(141, 'mainmenu', 'Contacts', 'contacts', '', 'joomla/contacts', 'index.php?Itemid=', 'alias', 1, 127, 2, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"142","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 120, 129, 0, '*', 0),
(142, 'mainmenu', 'List all contacts categories', 'list-all-contacts-categories', '', 'joomla/contacts/list-all-contacts-categories', 'index.php?option=com_contact&view=categories&id=0', 'component', 1, 141, 3, 8, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"","categories_description":"","maxLevelcat":"","show_empty_categories_cat":"","show_subcat_desc_cat":"","show_cat_items_cat":"","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_subcat_desc":"","show_cat_items":"","filter_field":"","show_pagination_limit":"","show_headings":"","show_position_headings":"","show_email_headings":"","show_telephone_headings":"","show_mobile_headings":"","show_fax_headings":"","show_suburb_headings":"","show_state_headings":"","show_country_headings":"","show_pagination":"","show_pagination_results":"","presentation_style":"","show_contact_category":"","show_contact_list":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","show_feed_link":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 121, 122, 0, '*', 0),
(143, 'mainmenu', 'List contacts in a category', 'list-contacts-in-a-category', '', 'joomla/contacts/list-contacts-in-a-category', 'index.php?option=com_contact&view=category&id=14', 'component', 1, 141, 3, 8, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_subcat_desc":"","show_cat_items":"","filter_field":"","show_pagination_limit":"","show_headings":"","show_position_headings":"","show_email_headings":"","show_telephone_headings":"","show_mobile_headings":"","show_fax_headings":"","show_suburb_headings":"","show_state_headings":"","show_country_headings":"","show_pagination":"","show_pagination_results":"","initial_sort":"","presentation_style":"","show_contact_category":"","show_contact_list":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","show_feed_link":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 123, 124, 0, '*', 0),
(144, 'mainmenu', 'Single contact', 'single-contact', '', 'joomla/contacts/single-contact', 'index.php?option=com_contact&view=contact&id=1', 'component', 1, 141, 3, 8, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"presentation_style":"","show_contact_category":"hide","show_contact_list":"0","show_tags":"","show_name":"0","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 125, 126, 0, '*', 0),
(145, 'mainmenu', 'Featured contacts', 'featured-contacts', '', 'joomla/contacts/featured-contacts', 'index.php?option=com_contact&view=featured', 'component', 1, 141, 3, 8, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_pagination_limit":"","show_headings":"","show_position_headings":"","show_email_headings":"","show_telephone_headings":"","show_mobile_headings":"","show_fax_headings":"","show_suburb_headings":"","show_state_headings":"","show_country_headings":"","show_pagination":"","show_pagination_results":"","presentation_style":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 127, 128, 0, '*', 0),
(146, 'mainmenu', 'Template pages', 'template-pages', '', 'joomla/template-pages', 'index.php?Itemid=', 'alias', 1, 127, 2, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"147","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 130, 137, 0, '*', 0),
(147, 'mainmenu', 'Iframe wrapper', 'iframe-wrapper', '', 'joomla/template-pages/iframe-wrapper', 'index.php?option=com_wrapper&view=wrapper', 'component', 1, 146, 3, 2, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"url":"http:\\/\\/www.minitek.gr\\/","scrolling":"auto","width":"100%","height":"500","height_auto":"0","add_scheme":"1","frameborder":"1","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 131, 132, 0, '*', 0),
(148, 'mainmenu', '404 error page', '2014-07-28-15-45-00', '', 'joomla/template-pages/2014-07-28-15-45-00', '404-error-page', 'url', 1, 146, 3, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 133, 134, 0, '*', 0),
(149, 'mainmenu', 'Page breaks', 'page-breaks', '', 'joomla/template-pages/page-breaks', 'index.php?option=com_content&view=article&id=7', 'component', 1, 146, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"0","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_tags":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 135, 136, 0, '*', 0),
(150, 'mainmenu', 'Architecture - Style 1', 'style-1', '', 'k2/categories/style-1', 'index.php?option=com_k2&view=itemlist&layout=category&task=category&id=5', 'component', 1, 117, 3, 10002, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"categories":["5"],"singleCatOrdering":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 69, 70, 0, '*', 0),
(151, 'mainmenu', 'Space Planning - Style 2', 'style-2', '', 'k2/categories/style-2', 'index.php?option=com_k2&view=itemlist&layout=category&task=category&id=4', 'component', 1, 117, 3, 10002, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"categories":["4"],"singleCatOrdering":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 71, 72, 0, '*', 0),
(152, 'mainmenu', 'Interior Design - Style 3', 'style-3', '', 'k2/categories/style-3', 'index.php?option=com_k2&view=itemlist&layout=category&task=category&id=3', 'component', 1, 117, 3, 10002, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"categories":["3"],"singleCatOrdering":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 73, 74, 0, '*', 0),
(153, 'mainmenu', '3D Visualization - Style 4', 'style-4', '', 'k2/categories/style-4', 'index.php?option=com_k2&view=itemlist&layout=category&task=category&id=2', 'component', 1, 117, 3, 10002, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"categories":["2"],"singleCatOrdering":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 75, 76, 0, '*', 0),
(154, 'mainmenu', 'Item', 'item', '', 'k2/item', 'index.php?option=com_k2&view=item&layout=item&id=46', 'component', 1, 118, 2, 10002, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 78, 79, 0, '*', 0),
(155, 'mainmenu', 'Tag', 'tag', '', 'k2/tag', 'index.php?option=com_k2&view=itemlist&layout=tag&tag=interior&task=tag', 'component', 1, 118, 2, 10002, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"theme":"default","tagOrdering":"","tagFeedLink":"1","tagFeedIcon":"1","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":"1","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 80, 81, 0, '*', 0),
(156, 'mainmenu', 'User page', 'user-page', '', 'k2/user-page', 'index.php?option=com_k2&view=itemlist&layout=user&id=445&task=user', 'component', 1, 118, 2, 10002, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"theme":"default","userCategoriesFilter":["1","2","3","4","5"],"userOrdering":"","userFeedLink":"1","userFeedIcon":"1","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 82, 83, 0, '*', 0),
(157, 'mainmenu', 'Latest items (2 columns)', 'latest-items-2-columns', '', 'k2/latest-items-2-columns', 'index.php?option=com_k2&view=latest&layout=latest', 'component', 1, 118, 2, 10002, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"theme":"default","source":"1","latestItemsCols":"2","latestItemsLimit":"4","latestItemsDisplayEffect":"first","userName":"1","userImage":"1","userDescription":"1","userURL":"1","userEmail":"0","userFeed":"1","categoryIDs":["2","3","4","5"],"categoryTitle":"1","categoryDescription":"0","categoryImage":"0","categoryFeed":"0","latestItemTitle":"1","latestItemTitleLinked":"1","latestItemDateCreated":"0","latestItemImage":"1","latestItemImageSize":"Large","latestItemVideo":"0","latestItemVideoWidth":"","latestItemVideoHeight":"","latestItemAudioWidth":"","latestItemAudioHeight":"","latestItemVideoAutoPlay":"0","latestItemIntroText":"0","latestItemCategory":"0","latestItemTags":"0","latestItemReadMore":"0","latestItemCommentsAnchor":"0","feedLink":"1","latestItemK2Plugins":"0","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"Latest items","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 84, 85, 0, '*', 0),
(268, 'mainmenu', 'Grey', 'grey', '', 'explore/template-themes/grey', 'index.php?Itemid=', 'alias', 1, 125, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"101","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/th-ico\\/grey-th.jpg","menu_text":1}', 41, 42, 0, '*', 0),
(269, 'mainmenu', 'Orange', 'orange', '', 'explore/template-themes/orange', 'index.php?option=com_content&view=article&id=62', 'component', 1, 125, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 99, '{"show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_tags":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/th-ico\\/orange-th.jpg","menu_text":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 51, 52, 0, '*', 0),
(270, 'mainmenu', 'Purple', 'purple', '', 'explore/template-themes/purple', 'index.php?option=com_content&view=article&id=62', 'component', 1, 125, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 100, '{"show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_tags":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/th-ico\\/purple-th.jpg","menu_text":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 53, 54, 0, '*', 0),
(296, 'mainmenu', 'Layout', 'layout', '', 'layout', 'index.php?Itemid=', 'alias', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"298","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 25, 38, 0, '*', 0),
(297, 'mainmenu', 'Content / 1 Sidebar', 'content-1-sidebar', '', 'layout/content-1-sidebar', 'index.php?option=com_k2&view=item&layout=item&id=40', 'component', 1, 296, 2, 10002, 0, '0000-00-00 00:00:00', 0, 1, '', 94, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 26, 27, 0, '*', 0),
(298, 'mainmenu', '1 Sidebar / Content', '1-sidebar-content', '', 'layout/1-sidebar-content', 'index.php?option=com_k2&view=item&layout=item&id=39', 'component', 1, 296, 2, 10002, 0, '0000-00-00 00:00:00', 0, 1, '', 93, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 28, 29, 0, '*', 0),
(300, 'mainmenu', 'Content / 2 Sidebars', 'content-2-sidebars', '', 'layout/content-2-sidebars', 'index.php?option=com_k2&view=item&layout=item&id=38', 'component', 1, 296, 2, 10002, 0, '0000-00-00 00:00:00', 0, 1, '', 94, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 30, 31, 0, '*', 0),
(301, 'mainmenu', '2 Sidebars / Content ', '2-sidebars-content', '', 'layout/2-sidebars-content', 'index.php?option=com_k2&view=item&layout=item&id=35', 'component', 1, 296, 2, 10002, 0, '0000-00-00 00:00:00', 0, 1, '', 93, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 32, 33, 0, '*', 0),
(302, 'mainmenu', 'Joomla Categories', 'joomla-categories', '', 'joomla/content/joomla-categories', 'index.php?Itemid=', 'alias', 1, 129, 3, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"306","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 89, 94, 0, '*', 0),
(305, 'mainmenu', 'Category 2', 'category-2', '', 'joomla/content/joomla-categories/category-2', 'index.php?option=com_content&view=category&layout=blog&id=9', 'component', 1, 302, 4, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_heading_title_text":"","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","show_cat_tags":"","page_subheading":"","num_leading_articles":"","num_intro_articles":"","num_columns":"1","num_links":"","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"0","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 92, 93, 0, '*', 0),
(306, 'mainmenu', 'Category 1', 'category-1', '', 'joomla/content/joomla-categories/category-1', 'index.php?option=com_content&view=category&layout=blog&id=10', 'component', 1, 302, 4, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_heading_title_text":"","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","show_cat_tags":"","page_subheading":"","num_leading_articles":"","num_intro_articles":"","num_columns":"1","num_links":"","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_featured":"","show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"0","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_tags":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 90, 91, 0, '*', 0),
(309, 'mainmenu', 'Portfolio', 'portfolio', '', 'pages/portfolio', 'index.php?option=com_content&view=article&id=62', 'component', 1, 113, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 95, '{"show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_tags":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 14, 15, 0, '*', 0),
(347, 'mainmenu', '2 Sidebars', '2-sidebars', '', 'layout/2-sidebars', 'index.php?option=com_k2&view=item&layout=item&id=37', 'component', 1, 296, 2, 10002, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 34, 35, 0, '*', 0),
(348, 'mainmenu', 'No Sidebar', 'no-sidebar', '', 'layout/no-sidebar', 'index.php?option=com_k2&view=item&layout=item&id=73', 'component', 1, 296, 2, 10002, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 36, 37, 0, '*', 0),
(349, 'main', 'COM_K2', 'com-k2', '', 'com-k2', 'index.php?option=com_k2', 'component', 0, 1, 1, 10002, 0, '0000-00-00 00:00:00', 0, 1, '../media/k2/assets/images/system/k2_16x16.png', 0, '', 169, 190, 0, '', 1),
(350, 'main', 'K2_ITEMS', 'k2-items', '', 'com-k2/k2-items', 'index.php?option=com_k2&view=items', 'component', 0, 349, 2, 10002, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '', 170, 171, 0, '', 1),
(351, 'main', 'K2_CATEGORIES', 'k2-categories', '', 'com-k2/k2-categories', 'index.php?option=com_k2&view=categories', 'component', 0, 349, 2, 10002, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '', 172, 173, 0, '', 1),
(352, 'main', 'K2_TAGS', 'k2-tags', '', 'com-k2/k2-tags', 'index.php?option=com_k2&view=tags', 'component', 0, 349, 2, 10002, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '', 174, 175, 0, '', 1),
(353, 'main', 'K2_COMMENTS', 'k2-comments', '', 'com-k2/k2-comments', 'index.php?option=com_k2&view=comments', 'component', 0, 349, 2, 10002, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '', 176, 177, 0, '', 1),
(354, 'main', 'K2_USERS', 'k2-users', '', 'com-k2/k2-users', 'index.php?option=com_k2&view=users', 'component', 0, 349, 2, 10002, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '', 178, 179, 0, '', 1),
(355, 'main', 'K2_USER_GROUPS', 'k2-user-groups', '', 'com-k2/k2-user-groups', 'index.php?option=com_k2&view=usergroups', 'component', 0, 349, 2, 10002, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '', 180, 181, 0, '', 1),
(356, 'main', 'K2_EXTRA_FIELDS', 'k2-extra-fields', '', 'com-k2/k2-extra-fields', 'index.php?option=com_k2&view=extrafields', 'component', 0, 349, 2, 10002, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '', 182, 183, 0, '', 1),
(357, 'main', 'K2_EXTRA_FIELD_GROUPS', 'k2-extra-field-groups', '', 'com-k2/k2-extra-field-groups', 'index.php?option=com_k2&view=extrafieldsgroups', 'component', 0, 349, 2, 10002, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '', 184, 185, 0, '', 1),
(358, 'main', 'K2_MEDIA_MANAGER', 'k2-media-manager', '', 'com-k2/k2-media-manager', 'index.php?option=com_k2&view=media', 'component', 0, 349, 2, 10002, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '', 186, 187, 0, '', 1),
(359, 'main', 'K2_INFORMATION', 'k2-information', '', 'com-k2/k2-information', 'index.php?option=com_k2&view=info', 'component', 0, 349, 2, 10002, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '', 188, 189, 0, '', 1),
(372, 'mainmenu', 'Minitek Wall', 'minitek-wall', '', 'pages/minitek-wall', 'index.php?option=com_minitekwall&view=wall', 'component', 1, 113, 2, 10069, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"module_id":"2","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 18, 19, 0, '*', 0),
(377, 'mainmenu', 'Blue', 'blue', '', 'explore/template-themes/blue', 'index.php?option=com_content&view=article&id=62', 'component', 1, 125, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 96, '{"show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_tags":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/th-ico\\/blue-th.jpg","menu_text":1,"page_title":"","show_page_heading":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 47, 48, 0, '*', 0),
(383, 'about', 'PORTFOLIO', 'portfolio', '', 'portfolio', '#', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 191, 192, 0, '*', 0),
(384, 'about', 'ABOUT', 'about', '', 'about', '#', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 193, 194, 0, '*', 0),
(397, 'about', 'CLIENTS', 'clients', '', 'clients', '#', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 195, 196, 0, '*', 0);
INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES
(399, 'mainmenu', 'Yellow', 'yellow', '', 'explore/template-themes/yellow', 'index.php?option=com_content&view=article&id=62', 'component', 1, 125, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 101, '{"show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_tags":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/th-ico\\/yellow-th.jpg","menu_text":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 49, 50, 0, '*', 0),
(410, 'mainmenu', 'Green', 'green', '', 'explore/template-themes/green', 'index.php?option=com_content&view=article&id=62', 'component', 1, 125, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 98, '{"show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_tags":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/th-ico\\/green-th.jpg","menu_text":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 45, 46, 0, '*', 0),
(425, 'mainmenu', 'About us', 'about-us', '', 'pages/about-us', 'index.php?option=com_content&view=article&id=62', 'component', 1, 113, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 95, '{"show_title":"0","link_titles":"0","show_intro":"","info_block_position":"","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"0","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"0","show_tags":"","show_noauth":"0","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 16, 17, 0, '*', 0),
(441, 'main', 'COM_MINITEKWALL_ADMIN_MENU', 'com-minitekwall-admin-menu', '', 'com-minitekwall-admin-menu', 'index.php?option=com_minitekwall', 'component', 0, 1, 1, 10069, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_minitekwall/assets/images/dashboard/icons/icon-16-mls.png', 0, '', 201, 210, 0, '', 1),
(442, 'main', 'COM_MINITEKWALL_DASHBOARD', 'com-minitekwall-dashboard', '', 'com-minitekwall-admin-menu/com-minitekwall-dashboard', 'index.php?option=com_minitekwall', 'component', 0, 441, 2, 10069, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, '', 202, 203, 0, '', 1),
(443, 'main', 'COM_MINITEKWALL_MODULE_INSTANCES', 'com-minitekwall-module-instances', '', 'com-minitekwall-admin-menu/com-minitekwall-module-instances', 'index.php?option=com_minitekwall&view=instances', 'component', 0, 441, 2, 10069, 0, '0000-00-00 00:00:00', 0, 1, 'class:instance', 0, '', 204, 205, 0, '', 1),
(444, 'main', 'COM_MINITEKWALL_MODULES', 'com-minitekwall-modules', '', 'com-minitekwall-admin-menu/com-minitekwall-modules', 'index.php?option=com_minitekwall&view=modules', 'component', 0, 441, 2, 10069, 0, '0000-00-00 00:00:00', 0, 1, 'class:module', 0, '', 206, 207, 0, '', 1),
(445, 'main', 'COM_MINITEKWALL_ABOUT', 'com-minitekwall-about', '', 'com-minitekwall-admin-menu/com-minitekwall-about', 'index.php?option=com_minitekwall&view=about', 'component', 0, 441, 2, 10069, 0, '0000-00-00 00:00:00', 0, 1, 'class:info', 0, '', 208, 209, 0, '', 1),
(446, 'about', 'OFFICE LOCATION', 'office-location', '', 'office-location', '#', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 197, 198, 0, '*', 0),
(447, 'about', 'COMPANY POLICY', 'company-policy', '', 'company-policy', '#', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 199, 200, 0, '*', 0),
(448, 'main', 'com_weblinks', 'com-weblinks', '', 'com-weblinks', 'index.php?option=com_weblinks', 'component', 0, 1, 1, 21, 0, '0000-00-00 00:00:00', 0, 1, 'class:weblinks', 0, '', 211, 216, 0, '', 1),
(449, 'main', 'com_weblinks_links', 'com-weblinks-links', '', 'com-weblinks/com-weblinks-links', 'index.php?option=com_weblinks', 'component', 0, 448, 2, 21, 0, '0000-00-00 00:00:00', 0, 1, 'class:weblinks', 0, '', 212, 213, 0, '', 1),
(450, 'main', 'com_weblinks_categories', 'com-weblinks-categories', '', 'com-weblinks/com-weblinks-categories', 'index.php?option=com_categories&extension=com_weblinks', 'component', 0, 448, 2, 21, 0, '0000-00-00 00:00:00', 0, 1, 'class:weblinks-cat', 0, '', 214, 215, 0, '', 1),
(453, 'mainmenu', 'Brown', 'brown', '', 'explore/template-themes/brown', 'index.php?option=com_content&view=article&id=62', 'component', 1, 125, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 97, '{"show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_tags":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/th-ico\\/brown-th.jpg","menu_text":1,"page_title":"","show_page_heading":"0","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 43, 44, 0, '*', 0);

DROP TABLE IF EXISTS `#__menu_types`;
CREATE TABLE IF NOT EXISTS `#__menu_types` (
`id` int(10) unsigned NOT NULL,
  `menutype` varchar(24) NOT NULL,
  `title` varchar(48) NOT NULL,
  `description` varchar(255) NOT NULL DEFAULT ''
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;

INSERT INTO `#__menu_types` (`id`, `menutype`, `title`, `description`) VALUES
(1, 'mainmenu', 'Main Menu', 'The main menu for the site'),
(4, 'about', 'About', 'About');

DROP TABLE IF EXISTS `#__messages`;
CREATE TABLE IF NOT EXISTS `#__messages` (
`message_id` int(10) unsigned NOT NULL,
  `user_id_from` int(10) unsigned NOT NULL DEFAULT '0',
  `user_id_to` int(10) unsigned NOT NULL DEFAULT '0',
  `folder_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `date_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `priority` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(255) NOT NULL DEFAULT '',
  `message` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__messages_cfg`;
CREATE TABLE IF NOT EXISTS `#__messages_cfg` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `cfg_name` varchar(100) NOT NULL DEFAULT '',
  `cfg_value` varchar(255) NOT NULL DEFAULT ''
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__minitek_wall_instances`;
CREATE TABLE IF NOT EXISTS `#__minitek_wall_instances` (
`id` int(10) unsigned NOT NULL,
  `type_id` int(10) unsigned NOT NULL DEFAULT '0',
  `joomla_type` text NOT NULL,
  `jomsocial_type` text NOT NULL,
  `k2_type` text NOT NULL,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `title` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `description` mediumtext NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `attribs` varchar(5120) NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL COMMENT 'The language code for the instance.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.'
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

INSERT INTO `#__minitek_wall_instances` (`id`, `type_id`, `joomla_type`, `jomsocial_type`, `k2_type`, `asset_id`, `title`, `alias`, `description`, `state`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `attribs`, `ordering`, `access`, `language`, `xreference`) VALUES
(1, 1, '{"joomla_mode":"ja","joomla_articles_mode":"normal","joomla_articles_title":"JOOMLA_ARTICLES","enable_joomla_articles_title":"1","joomla_articles_category_filtering_type":"1","joomla_articles_catid":["9","10"],"joomla_articles_show_child_category_articles":"1","joomla_articles_levels":"1","joomla_articles_author_filtering_type":"1","joomla_articles_created_by":[""],"joomla_articles_author_alias_filtering_type":"1","joomla_articles_created_by_alias":[""],"joomla_articles_date_filtering":"off","joomla_articles_date_field":"a.created","joomla_articles_start_date_range":"","joomla_articles_end_date_range":"","joomla_articles_relative_date":"30","joomla_articles_show_front":"show","joomla_articles_excluded_articles":"","joomla_articles_article_ordering":"a.title","joomla_articles_article_ordering_direction":"ASC","enable_joomla_article_photo":"1","joomla_article_image_type":"introtext","joomla_article_crop_images":"1","joomla_article_crop_width":"600","joomla_article_crop_height":"450","enable_joomla_article_introtext":"1","joomla_article_introtext_limit":"15","enable_joomla_article_category":"1","enable_joomla_article_author":"1","enable_joomla_article_date":"1","joomla_article_date_field":"created","joomla_article_date_format":"F d, Y","joomla_categories_title":"JOOMLA_CATEGORIES","enable_joomla_categories_title":"1","joomla_categories_include_categories":"2","joomla_categories_search_categories_children":"1","enable_joomla_category_photo":"1","joomla_category_crop_images":"0","joomla_category_crop_width":"400","joomla_category_crop_height":"300","enable_joomla_category_description":"1","joomla_category_description_limit":"15","enable_joomla_category_items_count":"1","joomla_categories_ordering":"alpha"}', '', '', 510, 'Home Wall', 'home-wall', '', 1, '2015-07-19 13:43:06', 429, '', '2015-07-19 13:49:56', 429, 0, '0000-00-00 00:00:00', '2015-07-19 13:43:06', '0000-00-00 00:00:00', '', 0, 1, '', '');

DROP TABLE IF EXISTS `#__minitek_wall_modules`;
CREATE TABLE IF NOT EXISTS `#__minitek_wall_modules` (
`id` int(11) unsigned NOT NULL,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL,
  `instance_id` int(10) unsigned NOT NULL DEFAULT '0',
  `description` text NOT NULL,
  `module_type` text NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00'
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;

INSERT INTO `#__minitek_wall_modules` (`id`, `asset_id`, `name`, `instance_id`, `description`, `module_type`, `published`, `checked_out`, `checked_out_time`) VALUES
(1, 511, 'Home Wall', 1, '', '{"grid":"98o","mas_cols":"3","gutter":"0","themeType":"2","detailBox":"1","detailBoxBackground":"#ffffff","detailBoxBackgroundOpacity":"0.75","detailBoxTextColor":"1","detailBoxTitle":"0","detailBoxCategory":"0","detailBoxType":"0","detailBoxAuthor":"0","detailBoxDate":"0","detailBoxIntrotext":"0","detailBoxCount":"0","hoverBox":"1","hoverBoxEffect":"1","hoverBoxEffectSpeed":"0.4","hoverBoxContentEffect":"1","hoverBoxContentEffectSpeed":"0.4","hoverBoxTheme":"black","hoverBoxTextColor":"2","hoverBoxTitle":"1","hoverBoxCategory":"1","hoverBoxType":"0","hoverBoxAuthor":"0","hoverBoxDate":"0","hoverBoxIntrotext":"0","hoverBoxLinkButton":"0","hoverBoxFancyButton":"0","pagination":"0","starting_limit":"6","filter_type":"1","category_filters":"0","tag_filters":"0"}', 1, 0, '0000-00-00 00:00:00'),
(2, 527, 'Minitek Wall 1', 1, '', '{"grid":"5b","mas_cols":"4","gutter":"5","themeType":"2","detailBox":"1","detailBoxBackground":"#050000","detailBoxBackgroundOpacity":"0.4","detailBoxTextColor":"2","detailBoxTitle":"1","detailBoxCategory":"0","detailBoxType":"0","detailBoxAuthor":"0","detailBoxDate":"0","detailBoxIntrotext":"0","detailBoxCount":"0","hoverBox":"1","hoverBoxEffect":"1","hoverBoxEffectSpeed":"0.4","hoverBoxContentEffect":"1","hoverBoxContentEffectSpeed":"0.4","hoverBoxTheme":"black","hoverBoxTextColor":"2","hoverBoxTitle":"1","hoverBoxCategory":"1","hoverBoxType":"0","hoverBoxAuthor":"0","hoverBoxDate":"0","hoverBoxIntrotext":"0","hoverBoxLinkButton":"1","hoverBoxFancyButton":"1","pagination":"0","starting_limit":"5","filter_type":"1","category_filters":"1","tag_filters":"0"}', 1, 0, '0000-00-00 00:00:00');

DROP TABLE IF EXISTS `#__minitek_wall_types`;
CREATE TABLE IF NOT EXISTS `#__minitek_wall_types` (
  `id` int(10) unsigned NOT NULL,
  `value` varchar(200) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `#__minitek_wall_types` (`id`, `value`) VALUES
(1, 'Joomla'),
(2, 'K2'),
(3, 'Jomsocial');

DROP TABLE IF EXISTS `#__modules`;
CREATE TABLE IF NOT EXISTS `#__modules` (
`id` int(11) NOT NULL,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #___assets table.',
  `title` varchar(100) NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `content` text NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `position` varchar(50) NOT NULL DEFAULT '',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `module` varchar(50) DEFAULT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `showtitle` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL
) ENGINE=InnoDB AUTO_INCREMENT=360 DEFAULT CHARSET=utf8;

INSERT INTO `#__modules` (`id`, `asset_id`, `title`, `note`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `published`, `module`, `access`, `showtitle`, `params`, `client_id`, `language`) VALUES
(2, 56, 'Login', '', '', 1, 'login', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_login', 1, 1, '', 1, '*'),
(3, 57, 'Popular Articles', '', '', 3, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_popular', 3, 1, '{"count":"5","catid":"","user_id":"0","layout":"_:default","moduleclass_sfx":"","cache":"0","automatic_title":"1"}', 1, '*'),
(4, 58, 'Recently Added Articles', '', '', 4, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_latest', 3, 1, '{"count":"5","ordering":"c_dsc","catid":"","user_id":"0","layout":"_:default","moduleclass_sfx":"","cache":"0","automatic_title":"1"}', 1, '*'),
(8, 59, 'Toolbar', '', '', 1, 'toolbar', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_toolbar', 3, 1, '', 1, '*'),
(9, 60, 'Quick Icons', '', '', 1, 'icon', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_quickicon', 3, 1, '', 1, '*'),
(10, 61, 'Logged-in Users', '', '', 2, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_logged', 3, 1, '{"count":"5","name":"1","layout":"_:default","moduleclass_sfx":"","cache":"0","automatic_title":"1"}', 1, '*'),
(12, 62, 'Admin Menu', '', '', 1, 'menu', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 3, 1, '{"layout":"","moduleclass_sfx":"","shownew":"1","showhelp":"1","cache":"0"}', 1, '*'),
(13, 63, 'Admin Submenu', '', '', 1, 'submenu', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_submenu', 3, 1, '', 1, '*'),
(14, 64, 'User Status', '', '', 2, 'status', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_status', 3, 1, '', 1, '*'),
(15, 65, 'Title', '', '', 1, 'title', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_title', 3, 1, '', 1, '*'),
(79, 68, 'Multilanguage status', '', '', 1, 'status', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_multilangstatus', 3, 1, '{"layout":"_:default","moduleclass_sfx":"","cache":"0"}', 1, '*'),
(86, 69, 'Joomla Version', '', '', 1, 'footer', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_version', 3, 1, '{"format":"short","product":"1","layout":"_:default","moduleclass_sfx":"","cache":"0"}', 1, '*'),
(92, 60, 'K2 Quick Icons (admin)', '', '', 0, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_k2_quickicons', 1, 1, '', 1, '*'),
(93, 61, 'K2 Stats (admin)', '', '', 0, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_k2_stats', 1, 1, '', 1, '*'),
(94, 82, 'Off Canvas Menu', '', '', 1, 'off-canvas', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 0, '{"menutype":"mainmenu","base":"","startLevel":"1","endLevel":"2","showAllChildren":"1","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(95, 91, 'Latest Articles', '', '', 1, 'sidebar-2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_k2_content', 1, 1, '{"moduleclass_sfx":" mn-module-dark","getTemplate":"minitek","source":"filter","catfilter":"1","category_id":["1"],"getChildren":"1","itemCount":"3","itemsOrdering":"","FeaturedItems":"1","popularityRange":"","videosOnly":"0","item":"0","items":["","",""],"itemTitle":"1","itemAuthor":"0","itemAuthorAvatar":"0","itemAuthorAvatarWidthSelect":"inherit","itemAuthorAvatarWidth":"50","userDescription":"0","itemIntroText":"1","itemIntroTextWordLimit":"6","itemImage":"1","itemImgSize":"XSmall","itemVideo":"0","itemVideoCaption":"0","itemVideoCredits":"0","itemAttachments":"0","itemTags":"0","itemCategory":"0","itemDateCreated":"0","itemHits":"0","itemReadMore":"0","itemExtraFields":"0","itemCommentsCounter":"0","feed":"0","itemPreText":"","itemCustomLink":"0","itemCustomLinkTitle":"","itemCustomLinkURL":"http:\\/\\/","itemCustomLinkMenuItem":"150","K2Plugins":"1","JPlugins":"1","cache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(96, 92, 'Copyright', '', '<div class="col-sm-9">\r\n  <small>Copyright &copy; 2015 Minitek. All Rights Reserved. Designed by <a title="Visit Minitek.gr!" href="http://www.minitek.gr/">minitek.gr</a>.</small>\r\n<small><a href="http://www.joomla.org">Joomla!</a> is Free Software released under the <a href="http://www.gnu.org/licenses/gpl-2.0.html">GNU General Public License.</a></small>\r\n</div>\r\n\r\n<div class="col-sm-3 poweredby">\r\n  <a class="t3-logo t3-logo-small t3-logo-light" href="http://t3-framework.org" target="_blank"></a>\r\n</div>\r\n', 1, 'Copyright', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" no-margin","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(119, 115, 'Login', '', '', 1, 'login-popup', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_login', 1, 1, '{"pretext":"","posttext":"","login":"","logout":"","greeting":"1","name":"0","usesecure":"0","usetext":"0","layout":"_:default","moduleclass_sfx":" no-margin","cache":"0","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(120, 116, 'Search', '', '', 1, 'search-popup', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_search', 1, 1, '{"label":"","width":"20","text":"","button":"1","button_pos":"left","imagebutton":"0","button_text":"","opensearch":"0","opensearch_title":"","set_itemid":"0","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(122, 118, 'Tags', '', '', 1, 'sidebar-2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_k2_tools', 1, 1, '{"moduleclass_sfx":" mn-module-dark","module_usage":"7","archiveItemsCounter":"1","archiveCategory":"0","authors_module_category":"0","authorItemsCounter":"1","authorAvatar":"1","authorAvatarWidthSelect":"custom","authorAvatarWidth":"50","authorLatestItem":"1","calendarCategory":"0","home":"","seperator":"","root_id":"0","end_level":"","categoriesListOrdering":"","categoriesListItemsCounter":"1","root_id2":"0","catfilter":"0","getChildren":"0","liveSearch":"","width":"20","text":"","button":"","imagebutton":"","button_text":"","min_size":"75","max_size":"300","cloud_limit":"30","cloud_category":["0"],"cloud_category_recursive":"0","customCode":"","parsePhp":"0","K2Plugins":"0","JPlugins":"0","cache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(123, 119, 'Latest Comments', '', '', 1, 'sidebar-2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_k2_comments', 1, 1, '{"moduleclass_sfx":" mn-module-dark","module_usage":"0","catfilter":"0","comments_limit":"3","comments_word_limit":"8","commenterName":"1","commentAvatar":"1","commentAvatarWidthSelect":"custom","commentAvatarWidth":"50","commentDate":"0","commentDateFormat":"absolute","commentLink":"1","itemTitle":"0","itemCategory":"0","feed":"0","commenters_limit":"5","commenterNameOrUsername":"1","commenterAvatar":"1","commenterAvatarWidthSelect":"custom","commenterAvatarWidth":"50","commenterLink":"1","commenterCommentsCounter":"1","commenterLatestComment":"1","cache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(133, 138, 'Off-canvas Social', '', '<ul class="social-media-icons">\r\n  <li class="facebook">\r\n    <a class="facebook" href="#"><i class="fa fa-facebook"></i></a>\r\n  </li>\r\n  <li class="twitter">\r\n    <a class="twitter" href="#"><i class="fa fa-twitter"></i></a>\r\n  </li>\r\n  <li class="google-plus">\r\n    <a class="google-plus" href="#"><i class="fa fa-google-plus"></i></a>\r\n  </li>\r\n  <li class="linkedin">\r\n    <a class="linkedin" href="#"><i class="fa fa-linkedin"></i></a>\r\n  </li>\r\n  <li class="pinterest">\r\n    <a class="pinterest" href="#"><i class="fa fa-pinterest"></i></a>\r\n  </li>\r\n</ul>', 1, 'off-canvas', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(134, 147, 'Blog Categories', '', '', 10, 'sidebar-2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_categories', 1, 1, '{"parent":"8","show_description":"0","numitems":"0","show_children":"0","count":"0","maxlevel":"0","layout":"_:default","item_heading":"4","moduleclass_sfx":" mn-module-dark","owncache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(135, 148, 'Category Articles', '', '', 9, 'sidebar-2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_category', 1, 1, '{"mode":"dynamic","show_on_article_page":"1","show_front":"show","count":"0","category_filtering_type":"1","catid":[""],"show_child_category_articles":"0","levels":"1","author_filtering_type":"1","created_by":[""],"author_alias_filtering_type":"1","created_by_alias":[""],"excluded_articles":"","date_filtering":"off","date_field":"a.created","start_date_range":"","end_date_range":"","relative_date":"30","article_ordering":"a.title","article_ordering_direction":"ASC","article_grouping":"none","article_grouping_direction":"ksort","month_year_format":"F Y","link_titles":"1","show_date":"0","show_date_field":"created","show_date_format":"Y-m-d H:i:s","show_category":"0","show_hits":"0","show_author":"0","show_introtext":"0","introtext_limit":"100","show_readmore":"0","show_readmore_title":"1","readmore_limit":"15","layout":"_:default","moduleclass_sfx":" mn-module-dark","owncache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(136, 149, 'mod_dark', '', '', 1, 'position-37', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_k2_tools', 1, 1, '{"moduleclass_sfx":" mod_dark formatModule","module_usage":"4","archiveItemsCounter":"1","archiveCategory":"0","authors_module_category":"0","authorItemsCounter":"1","authorAvatar":"1","authorAvatarWidthSelect":"custom","authorAvatarWidth":"50","authorLatestItem":"1","calendarCategory":"0","home":"","seperator":"","root_id":"0","end_level":"","categoriesListOrdering":"","categoriesListItemsCounter":"1","root_id2":"0","catfilter":"0","getChildren":"0","liveSearch":"","width":"20","text":"","button":"","imagebutton":"","button_text":"","min_size":"75","max_size":"300","cloud_limit":"30","cloud_category":["0"],"cloud_category_recursive":"0","customCode":"","parsePhp":"0","K2Plugins":"0","JPlugins":"0","cache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(137, 150, 'mod_yellow', '', '', 1, 'position-39', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_k2_tools', 1, 1, '{"moduleclass_sfx":" mod_yellow formatModule","module_usage":"4","archiveItemsCounter":"1","archiveCategory":"0","authors_module_category":"0","authorItemsCounter":"1","authorAvatar":"1","authorAvatarWidthSelect":"custom","authorAvatarWidth":"50","authorLatestItem":"1","calendarCategory":"0","home":"","seperator":"","root_id":"0","end_level":"","categoriesListOrdering":"","categoriesListItemsCounter":"1","root_id2":"0","catfilter":"0","getChildren":"0","liveSearch":"","width":"20","text":"","button":"","imagebutton":"","button_text":"","min_size":"75","max_size":"300","cloud_limit":"30","cloud_category":["0"],"cloud_category_recursive":"0","customCode":"","parsePhp":"0","K2Plugins":"0","JPlugins":"0","cache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(138, 151, 'mod_orange', '', '', 1, 'position-39', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_k2_tools', 1, 1, '{"moduleclass_sfx":" mod_orange formatModule","module_usage":"4","archiveItemsCounter":"1","archiveCategory":"0","authors_module_category":"0","authorItemsCounter":"1","authorAvatar":"1","authorAvatarWidthSelect":"custom","authorAvatarWidth":"50","authorLatestItem":"1","calendarCategory":"0","home":"","seperator":"","root_id":"0","end_level":"","categoriesListOrdering":"","categoriesListItemsCounter":"1","root_id2":"0","catfilter":"0","getChildren":"0","liveSearch":"","width":"20","text":"","button":"","imagebutton":"","button_text":"","min_size":"75","max_size":"300","cloud_limit":"30","cloud_category":["0"],"cloud_category_recursive":"0","customCode":"","parsePhp":"0","K2Plugins":"0","JPlugins":"0","cache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(139, 152, 'mod_blue', '', '', 1, 'position-37', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_k2_tools', 1, 1, '{"moduleclass_sfx":" mod_blue formatModule","module_usage":"4","archiveItemsCounter":"1","archiveCategory":"0","authors_module_category":"0","authorItemsCounter":"1","authorAvatar":"1","authorAvatarWidthSelect":"custom","authorAvatarWidth":"50","authorLatestItem":"1","calendarCategory":"0","home":"","seperator":"","root_id":"0","end_level":"","categoriesListOrdering":"","categoriesListItemsCounter":"1","root_id2":"0","catfilter":"0","getChildren":"0","liveSearch":"","width":"20","text":"","button":"","imagebutton":"","button_text":"","min_size":"75","max_size":"300","cloud_limit":"30","cloud_category":["0"],"cloud_category_recursive":"0","customCode":"","parsePhp":"0","K2Plugins":"0","JPlugins":"0","cache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(142, 156, 'mod_green', '', '', 1, 'position-38', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_k2_tools', 1, 1, '{"moduleclass_sfx":" mod_green formatModule","module_usage":"4","archiveItemsCounter":"1","archiveCategory":"0","authors_module_category":"0","authorItemsCounter":"1","authorAvatar":"1","authorAvatarWidthSelect":"custom","authorAvatarWidth":"50","authorLatestItem":"1","calendarCategory":"0","home":"","seperator":"","root_id":"0","end_level":"","categoriesListOrdering":"","categoriesListItemsCounter":"1","root_id2":"0","catfilter":"0","getChildren":"0","liveSearch":"","width":"20","text":"","button":"","imagebutton":"","button_text":"","min_size":"75","max_size":"300","cloud_limit":"30","cloud_category":["0"],"cloud_category_recursive":"0","customCode":"","parsePhp":"0","K2Plugins":"0","JPlugins":"0","cache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(143, 157, 'mod_purple', '', '', 1, 'position-38', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_k2_tools', 1, 1, '{"moduleclass_sfx":" mod_purple formatModule ","module_usage":"4","archiveItemsCounter":"1","archiveCategory":"0","authors_module_category":"0","authorItemsCounter":"1","authorAvatar":"1","authorAvatarWidthSelect":"custom","authorAvatarWidth":"50","authorLatestItem":"1","calendarCategory":"0","home":"","seperator":"","root_id":"0","end_level":"","categoriesListOrdering":"","categoriesListItemsCounter":"1","root_id2":"0","catfilter":"0","getChildren":"0","liveSearch":"","width":"20","text":"","button":"","imagebutton":"","button_text":"","min_size":"75","max_size":"300","cloud_limit":"30","cloud_category":["0"],"cloud_category_recursive":"0","customCode":"","parsePhp":"0","K2Plugins":"0","JPlugins":"0","cache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(169, 213, 'Tags', '', '', 1, 'sidebar-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_k2_tools', 1, 1, '{"moduleclass_sfx":" mn-module-dark","module_usage":"7","archiveItemsCounter":"1","archiveCategory":"0","authors_module_category":"0","authorItemsCounter":"1","authorAvatar":"1","authorAvatarWidthSelect":"custom","authorAvatarWidth":"50","authorLatestItem":"1","calendarCategory":"0","home":"","seperator":"","root_id":"0","end_level":"","categoriesListOrdering":"","categoriesListItemsCounter":"1","root_id2":"0","catfilter":"0","getChildren":"0","liveSearch":"","width":"20","text":"","button":"","imagebutton":"","button_text":"","min_size":"75","max_size":"300","cloud_limit":"30","cloud_category":["0"],"cloud_category_recursive":"0","customCode":"","parsePhp":"0","K2Plugins":"0","JPlugins":"0","cache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(170, 214, 'Categories', '', '', 7, 'sidebar-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_k2_tools', 1, 1, '{"moduleclass_sfx":" mn-module-dark","module_usage":"4","archiveItemsCounter":"1","archiveCategory":"0","authors_module_category":"0","authorItemsCounter":"1","authorAvatar":"1","authorAvatarWidthSelect":"custom","authorAvatarWidth":"50","authorLatestItem":"1","calendarCategory":"0","home":"","seperator":"","root_id":"1","end_level":"","categoriesListOrdering":"","categoriesListItemsCounter":"0","root_id2":"0","catfilter":"0","getChildren":"0","liveSearch":"","width":"20","text":"","button":"","imagebutton":"","button_text":"","min_size":"75","max_size":"300","cloud_limit":"30","cloud_category":["0"],"cloud_category_recursive":"0","customCode":"","parsePhp":"0","K2Plugins":"0","JPlugins":"0","cache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(171, 215, 'Latest Comments', '', '', 1, 'sidebar-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_k2_comments', 1, 1, '{"moduleclass_sfx":" mn-module-dark","module_usage":"0","catfilter":"0","comments_limit":"3","comments_word_limit":"8","commenterName":"1","commentAvatar":"1","commentAvatarWidthSelect":"custom","commentAvatarWidth":"50","commentDate":"0","commentDateFormat":"absolute","commentLink":"1","itemTitle":"0","itemCategory":"0","feed":"0","commenters_limit":"5","commenterNameOrUsername":"1","commenterAvatar":"1","commenterAvatarWidthSelect":"custom","commenterAvatarWidth":"50","commenterLink":"1","commenterCommentsCounter":"1","commenterLatestComment":"1","cache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(173, 217, 'Login', '', '', 10, 'sidebar-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_login', 1, 1, '{"pretext":"","posttext":"","login":"","logout":"","greeting":"1","name":"0","usesecure":"0","usetext":"0","layout":"_:default","moduleclass_sfx":"","cache":"0","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(175, 219, 'Article Categories', '', '', 11, 'sidebar-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_categories', 1, 1, '{"parent":"8","show_description":"0","numitems":"0","show_children":"0","count":"0","maxlevel":"0","layout":"_:default","item_heading":"4","moduleclass_sfx":"","owncache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(176, 220, 'Article Categories', '', '', 8, 'sidebar-2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_categories', 1, 1, '{"parent":"8","show_description":"0","numitems":"0","show_children":"0","count":"0","maxlevel":"0","layout":"_:default","item_heading":"4","moduleclass_sfx":"","owncache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(177, 221, 'Login', '', '', 7, 'sidebar-2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_login', 1, 1, '{"pretext":"","posttext":"","login":"","logout":"","greeting":"1","name":"0","usesecure":"0","usetext":"0","layout":"_:default","moduleclass_sfx":"","cache":"0","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(179, 223, 'Scroll Button', '', '<div class="scroll-top"><i class="fa fa-angle-up"></i></div>', 1, 'scroll-button', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(181, 241, 'Breadcrumbs', '', '', 1, 'navhelper', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_breadcrumbs', 1, 1, '{"showHere":"1","showHome":"1","homeText":"","showLast":"1","separator":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(211, 278, 'Parallax1', '', '<div class="mn-parallax-background">\r\n	<div class="container mn-parallax-inner">\r\n		<div class="mn-title-parallax">\r\n			<h2 class="duration2 mn-on-scroll animated fadeInUp delay2">We are truly committed to fulfill your vision in every step of the way<br>\r\n			<strong>Bring your dream home into reality with some help from the experts</strong></h2>\r\n		</div>\r\n	</div>\r\n</div>\r\n', 1, 'mn-parallax1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"0","backgroundimage":"images\\/blueprint\\/parallax\\/parallax01.jpg","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(242, 338, 'Contact us title', '', '<h3 class="module-big-title "><span>We want to hear about your ideas</span></h3>', 1, 'mn-mastcol-top', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" no-margin","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(272, 371, 'Most Popular', '', '', 1, 'sidebar-2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_k2_content', 1, 1, '{"moduleclass_sfx":"","getTemplate":"minitek1","source":"filter","catfilter":"0","getChildren":"0","itemCount":"5","itemsOrdering":"","FeaturedItems":"1","popularityRange":"","videosOnly":"0","item":"0","itemTitle":"1","itemAuthor":"1","itemAuthorAvatar":"1","itemAuthorAvatarWidthSelect":"custom","itemAuthorAvatarWidth":"50","userDescription":"1","itemIntroText":"1","itemIntroTextWordLimit":"","itemImage":"1","itemImgSize":"Small","itemVideo":"1","itemVideoCaption":"1","itemVideoCredits":"1","itemAttachments":"1","itemTags":"1","itemCategory":"1","itemDateCreated":"1","itemHits":"1","itemReadMore":"1","itemExtraFields":"0","itemCommentsCounter":"1","feed":"1","itemPreText":"","itemCustomLink":"0","itemCustomLinkTitle":"","itemCustomLinkURL":"http:\\/\\/","itemCustomLinkMenuItem":"162","K2Plugins":"1","JPlugins":"1","cache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(314, 452, 'Browse by Category', '', '', 1, 'top-popup', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_k2_tools', 1, 1, '{"moduleclass_sfx":"","module_usage":"4","archiveItemsCounter":"0","archiveCategory":"0","authors_module_category":"0","authorItemsCounter":"0","authorAvatar":"1","authorAvatarWidthSelect":"custom","authorAvatarWidth":"50","authorLatestItem":"1","calendarCategory":"0","home":"","seperator":"","root_id":"1","end_level":"","categoriesListOrdering":"","categoriesListItemsCounter":"0","root_id2":"0","catfilter":"0","getChildren":"0","liveSearch":"","width":"20","text":"","button":"","imagebutton":"","button_text":"","min_size":"75","max_size":"300","cloud_limit":"30","cloud_category":["0"],"cloud_category_recursive":"0","customCode":"","parsePhp":"0","K2Plugins":"0","JPlugins":"0","cache":"1","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(316, 454, 'K2 Category Title', '', '<h3 class="module-big-title "><span>See our completed projects</span></h3>', 1, 'position-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" no-margin","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(334, 486, 'Home Slider', '', '', 1, 'mn-slider', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_minitek_slider', 1, 1, '{"moduleclass_sfx":"","auto_module_id":"1","custom_module_id":"","count":"5","category_filtering_type":"1","catid":["15"],"show_child_category_articles":"0","levels":"1","author_filtering_type":"1","created_by":[""],"author_alias_filtering_type":"1","created_by_alias":[""],"show_front":"show","date_filtering":"off","date_field":"a.created","start_date_range":"","end_date_range":"","relative_date":"30","show_date_field":"created","show_date_format":"Y-m-d H:i:s","excluded_articles":"","article_ordering":"a.id","article_ordering_direction":"DESC","image_type":"introtext","image_width":"1600","image_height":"835","minimum_height":"500","show_thumbs":"1","thumb_width":"200","thumb_height":"130","skin":"camera_white_skin","slider_effect":"random","mobile_slider_effect":"random","easing":"linear","mobile_easing":"linear","autoplay":"0","mobile_autoplay":"1","autoplay_speed":"5000","transition_speed":"700","play_pause_buttons":"0","pause_on_click":"1","pause_on_hover":"1","show_arrows":"1","autohide_arrows":"0","mobile_autohide_arrows":"0","show_bullets":"1","opacity_on_grid":"0","loader":"pie","loader_color":"#eeeeee","loader_bg_color":"#222222","loader_opacity":".8","loader_padding":"2","loader_stroke":"7","pie_diameter":"38","pie_position":"rightTop","bar_position":"bottom","bar_direction":"leftToRight","load_jquery":"0","load_easing":"1","load_phpthumb":"1","enable_cache":"0","cache_time":"30","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(338, 495, 'Footer Social', '', '<div class="footer-social-icons">\r\n	<ul>\r\n		<li class="fafacebook"> <a class="facebook" href="#"><i class="fa fa-facebook"></i></a> </li>\r\n		<li class="twitter"> <a class="twitter" href="#"><i class="fa fa-twitter"></i></a> </li>\r\n		<li class="linkedin"> <a class="linkedin" href="#"><i class="fa fa-linkedin"></i></a> </li>\r\n		<li class="google-plus"> <a class="google-plus" href="#"><i class="fa fa-google-plus"></i></a> </li>\r\n	</ul>\r\n</div>\r\n', 1, 'footer-2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(346, 506, 'Minitek Wall Title', '', '<div class="mn-mod-header">\r\n	<div class="mn-title">\r\n		<h2>Mintek Wall</h2>\r\n	</div>\r\n\r\n</div>\r\n', 1, 'mn-mastcol-top', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(349, 514, 'Home Creators', '', '<div class="grid cs-style-3 mn-team">\r\n	<div class="col-md-4">\r\n		<figure> <img src="images/blueprint/team/team01.jpg" border="0" alt="John Doe">\r\n			<figcaption>\r\n			<p>Let’s Connect</p>\r\n			<div class="mn-team-social">\r\n				<ul>\r\n					<li class="fafacebook"> <a class="facebook" href="#"><i class="fa fa-facebook"></i></a> </li>\r\n					<li class="twitter"> <a class="twitter" href="#"><i class="fa fa-twitter"></i></a> </li>\r\n				</ul>\r\n			</div>			\r\n			</figcaption>\r\n		</figure>\r\n		<figdesc>\r\n			<h3>JOHN DOE</h3>\r\n			<h4>ARCHITECTURAL DRAWING / TEXTURING</h4>\r\n		</figdesc>\r\n	</div>\r\n	<div class="col-md-4">\r\n		<figure>\r\n			<img src="images/blueprint/team/team02.jpg" border="0" alt="PAUL DOE">\r\n			<figcaption>\r\n			<p>Let’s Connect</p>\r\n			<div class="mn-team-social">\r\n				<ul>\r\n					<li class="fafacebook"> <a class="facebook" href="#"><i class="fa fa-facebook"></i></a> </li>\r\n					<li class="twitter"> <a class="twitter" href="#"><i class="fa fa-twitter"></i></a> </li>\r\n				</ul>\r\n			</div>			\r\n			</figcaption>\r\n		</figure>\r\n		<figdesc>\r\n			<h3>PAUL DOE</h3>\r\n			<h4>INTERIOR DESIGN / SPACE ANLYSIS</h4>\r\n		</figdesc>\r\n	</div>\r\n	<div class="col-md-4">\r\n		<figure> <img src="images/blueprint/team/team03.jpg" border="0" alt="DAVID DOE">\r\n			<figcaption>\r\n			<p>Let’s Connect</p>\r\n			<div class="mn-team-social">\r\n				<ul>\r\n					<li class="fafacebook"> <a class="facebook" href="#"><i class="fa fa-facebook"></i></a> </li>\r\n					<li class="twitter"> <a class="twitter" href="#"><i class="fa fa-twitter"></i></a> </li>\r\n				</ul>\r\n			</div>			\r\n			</figcaption>\r\n		</figure>\r\n		<figdesc>\r\n			<h3>DAVID DOE</h3>\r\n			<h4>NDUSTRIAL DESIGN &amp; 3D MODELLING / ANIMATION</h4>\r\n		</figdesc>\r\n	</div>\r\n</div>\r\n', 2, 'position-13', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(350, 515, 'Home Wall', '', '', 2, 'mn-wrap', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_minitekwall', 1, 0, '{"moduleclass_sfx":" mn-wall-portfolio no-margin","auto_module_id":"1","custom_module_id":"","module_id":"1","load_jquery":"0","load_fontawesome":"1","load_fancybox":"1","enable_cache":"0","cache_time":"30","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(351, 516, 'Home our principles', '', '<div class="mn-module-title">\r\n	<h3 class="mn-module-title-up">We begin a new project considering</h3>\r\n	<h3 class="mn-module-title-down">OUR PRINCIPLES</h3>\r\n</div>\r\n<div class="row">\r\n	<div class="col-xs-12 col-md-3 mn-features text-center duration2 mn-on-scroll animated fadeInUp">\r\n		<div class="mn-features-inner">\r\n			<div class="mn-features-ico"><i class="mn-ficons-vision"></i> </div>\r\n			<div class="mn-features-title">\r\n				<h3><a href="#">VISION</a></h3>\r\n			</div>\r\n			<div class="mn-features-desc">\r\n				<p>Lorem Ipsum dolor sit amet consectetur adipisicing elit sed do eiusmod tempor incididunt ut labore et dolore.</p>\r\n			</div>\r\n		</div>\r\n	</div>\r\n	<div class="col-xs-12 col-md-3 mn-features text-center duration3 mn-on-scroll animated fadeInUp">\r\n		<div class="mn-features-inner">\r\n			<div class="mn-features-ico"><i class="mn-ficons-minimalism"></i></div>\r\n			<div class="mn-features-title">\r\n				<h3><a href="#">MINIMALISM</a></h3>\r\n			</div>\r\n			<div class="mn-features-desc">\r\n				<p>Lorem Ipsum dolor sit amet consectetur adipisicing elit sed do eiusmod tempor incididunt ut labore et dolore.</p>\r\n			</div>\r\n		</div>\r\n	</div>\r\n	<div class="col-xs-12 col-md-3 mn-features text-center duration4 mn-on-scroll animated fadeInUp">\r\n		<div class="mn-features-inner">\r\n			<div class="mn-features-ico"><i class="mn-ficons-safety"></i></div>\r\n			<div class="mn-features-title">\r\n				<h3><a href="#">SAFETY</a></h3>\r\n			</div>\r\n			<div class="mn-features-desc">\r\n				<p>Lorem Ipsum dolor sit amet consectetur adipisicing elit sed do eiusmod tempor incididunt ut labore et dolore.</p>\r\n			</div>\r\n		</div>\r\n	</div>\r\n	<div class="col-xs-12 col-md-3 mn-features text-center duration4 mn-on-scroll animated fadeInUp">\r\n		<div class="mn-features-inner">\r\n			<div class="mn-features-ico"><i class="mn-ficons-quality"></i></div>\r\n			<div class="mn-features-title">\r\n				<h3><a href="#">QUALITY</a></h3>\r\n			</div>\r\n			<div class="mn-features-desc">\r\n				<p>Lorem Ipsum dolor sit amet consectetur adipisicing elit sed do eiusmod tempor incididunt ut labore et dolore.</p>\r\n			</div>\r\n		</div>\r\n	</div>\r\n</div>\r\n', 1, 'position-7', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(352, 517, 'Home Contact', '', '', 3, 'position-19', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_minitek_contact', 1, 0, '{"moduleclass_sfx":"","auto_module_id":"1","custom_module_id":"","id":"1","enable_cache":"0","cache_time":"30","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(353, 518, 'Home Features', '', '<div class="mn-typo row">\r\n\r\n	<div class="mn-typo-inner col-xs-12">\r\n		<div class="col-md-4 mn-typo-ico">\r\n						<h3 class="mn-ico-title">MINIMAL DESIGN</h3>\r\n			<i class="mn-ficons-design"></i>\r\n		</div>\r\n		\r\n		<div class="col-md-8 mn-typo-desc">\r\n			<p>Building first evolved out of the dynamics between needs  and means (available building materials and attendant skills). As human cultures developed and knowledge began to be formalized.\r\n			Through oral traditions and practices building became a craft, and "architecture" is the name given to the most highly formalized and respected versions of that craft.</p>\r\n		</div>\r\n	</div>\r\n	\r\n	<div class="clearfix"></div>	\r\n\r\n\r\n\r\n	<div class="mn-typo-inner col-xs-12">\r\n	\r\n		<div class="col-md-4 mn-typo-ico hidden-md hidden-lg">\r\n			<h3 class="mn-ico-title">YOUR VISION</h3>\r\n			<i class="mn-ficons-glasses"></i>\r\n		</div>\r\n	\r\n		<div class="col-md-8 mn-typo-desc">\r\n			<p>With the emerging knowledge in scientific fields and the rise of new materials and technology, architecture and engineering began to separate and the architect began to concentrate on aesthetics.\r\n			There was also the rise of the "gentleman architect" who usually dealt with wealthy clients and concentrated predominantly on visual qualities.</p>\r\n		</div>\r\n		\r\n		<div class="col-md-4 mn-typo-ico hidden-xs hidden-sm">\r\n			<h3 class="mn-ico-title">YOUR VISION</h3>\r\n			<i class="mn-ficons-glasses"></i>\r\n		</div>\r\n	</div>\r\n	\r\n	<div class="clearfix"></div>\r\n		\r\n	<div class="mn-typo-inner col-xs-12">\r\n		<div class="col-md-4 mn-typo-ico">\r\n			<h3 class="mn-ico-title">NEW HOME</h3>\r\n			<i class="mn-ficons-home"></i>\r\n		</div>\r\n		\r\n		<div class="col-md-8 mn-typo-desc">\r\n			<p>Architectural drawings are made according to a set of conventions, which include particular views (floor plan, section etc.), sheet sizes, units of measurement and scales, annotation and cross referencing.\r\n			Conventionally, drawings were made in ink on paper or a similar material, and any copies required had to be laboriously made by hand. </p>\r\n		</div>\r\n	</div>\r\n	\r\n	<div class="clearfix"></div>	\r\n\r\n</div>', 1, 'position-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":" no-margin","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(354, 519, 'Footer Menu', '', '', 1, 'footer-1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 0, '{"menutype":"about","base":"","startLevel":"1","endLevel":"0","showAllChildren":"1","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(355, 520, 'Home Contact Title', '', '<div class="mn-module-title">\r\n	<h3 class="mn-module-title-up">Let’s talk about your vision</h3>\r\n	<h3 class="mn-module-title-down">CONTACT US</h3>\r\n</div>', 1, 'position-19', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(356, 522, 'Home The Creators Title', '', '<h3 class="module-big-title "><span>The Creators</span></h3>', 1, 'position-13', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(357, 523, 'Home Latest Projects Title', '', '<h3 class="module-big-title "><span>Latest Projects</span></h3>', 1, 'mn-wrap', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(358, 524, 'Off Canvas Search', '', '', 1, 'off-canvas-search', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_search', 1, 1, '{"label":"","width":"","text":"","button":"0","button_pos":"left","imagebutton":"0","button_text":"","opensearch":"1","opensearch_title":"","set_itemid":"0","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*');

DROP TABLE IF EXISTS `#__modules_menu`;
CREATE TABLE IF NOT EXISTS `#__modules_menu` (
  `moduleid` int(11) NOT NULL DEFAULT '0',
  `menuid` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `#__modules_menu` (`moduleid`, `menuid`) VALUES
(2, 0),
(3, 0),
(4, 0),
(6, 0),
(7, 0),
(8, 0),
(9, 0),
(10, 0),
(12, 0),
(13, 0),
(14, 0),
(15, 0),
(79, 0),
(86, 0),
(92, 0),
(93, 0),
(94, 0),
(95, 128),
(95, 130),
(95, 133),
(95, 150),
(95, 152),
(95, 154),
(95, 155),
(95, 156),
(95, 297),
(95, 300),
(95, 301),
(95, 347),
(95, 385),
(95, 388),
(96, 0),
(97, 0),
(99, 0),
(100, 0),
(119, 0),
(120, 0),
(122, 150),
(122, 152),
(122, 154),
(122, 155),
(122, 156),
(122, 297),
(122, 300),
(122, 347),
(122, 385),
(122, 388),
(123, 150),
(123, 152),
(123, 154),
(123, 155),
(123, 156),
(123, 297),
(123, 300),
(123, 347),
(123, 385),
(123, 388),
(133, 0),
(134, 128),
(134, 130),
(134, 133),
(134, 303),
(134, 304),
(134, 305),
(134, 306),
(134, 307),
(134, 308),
(135, 128),
(135, 130),
(135, 133),
(135, 303),
(135, 304),
(135, 305),
(135, 306),
(135, 307),
(135, 308),
(136, 122),
(137, 122),
(138, 122),
(139, 122),
(142, 122),
(143, 122),
(169, 298),
(169, 301),
(170, 298),
(170, 301),
(170, 347),
(171, 298),
(171, 301),
(171, 347),
(173, 300),
(173, 347),
(175, 300),
(175, 347),
(176, 301),
(177, 301),
(179, 0),
(181, 128),
(181, 130),
(181, 131),
(181, 132),
(181, 133),
(181, 134),
(181, 150),
(181, 151),
(181, 152),
(181, 153),
(181, 154),
(181, 155),
(181, 156),
(181, 157),
(181, 297),
(181, 298),
(181, 300),
(181, 301),
(181, 302),
(181, 305),
(181, 306),
(181, 307),
(181, 308),
(211, 101),
(211, 268),
(211, 269),
(211, 270),
(211, 377),
(211, 399),
(211, 410),
(233, 0),
(242, 115),
(242, 141),
(242, 142),
(242, 143),
(242, 144),
(242, 145),
(272, 101),
(314, 0),
(316, 117),
(316, 118),
(334, 101),
(334, 268),
(334, 269),
(334, 270),
(334, 377),
(334, 399),
(334, 410),
(334, 453),
(338, 0),
(341, 0),
(342, 0),
(346, 372),
(349, 101),
(349, 268),
(349, 269),
(349, 270),
(349, 377),
(349, 399),
(349, 410),
(349, 425),
(349, 453),
(350, 101),
(350, 268),
(350, 269),
(350, 270),
(350, 309),
(350, 377),
(350, 399),
(350, 410),
(350, 453),
(351, 101),
(351, 268),
(351, 269),
(351, 270),
(351, 309),
(351, 377),
(351, 399),
(351, 410),
(351, 453),
(352, 101),
(352, 115),
(352, 268),
(352, 269),
(352, 270),
(352, 377),
(352, 399),
(352, 410),
(352, 425),
(352, 453),
(353, 101),
(353, 268),
(353, 269),
(353, 270),
(353, 377),
(353, 399),
(353, 410),
(353, 453),
(354, 0),
(355, 101),
(355, 115),
(355, 268),
(355, 269),
(355, 270),
(355, 377),
(355, 399),
(355, 410),
(355, 425),
(355, 453),
(356, 101),
(356, 268),
(356, 269),
(356, 270),
(356, 377),
(356, 399),
(356, 410),
(356, 425),
(356, 453),
(357, 101),
(357, 268),
(357, 269),
(357, 270),
(357, 309),
(357, 377),
(357, 399),
(357, 410),
(357, 453),
(358, 0);

DROP TABLE IF EXISTS `#__newsfeeds`;
CREATE TABLE IF NOT EXISTS `#__newsfeeds` (
  `catid` int(11) NOT NULL DEFAULT '0',
`id` int(10) unsigned NOT NULL,
  `name` varchar(100) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `link` varchar(200) NOT NULL DEFAULT '',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `numarticles` int(10) unsigned NOT NULL DEFAULT '1',
  `cache_time` int(10) unsigned NOT NULL DEFAULT '3600',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rtl` tinyint(4) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `description` text NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `images` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__overrider`;
CREATE TABLE IF NOT EXISTS `#__overrider` (
`id` int(10) NOT NULL COMMENT 'Primary Key',
  `constant` varchar(255) NOT NULL,
  `string` text NOT NULL,
  `file` varchar(255) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__postinstall_messages`;
CREATE TABLE IF NOT EXISTS `#__postinstall_messages` (
`postinstall_message_id` bigint(20) unsigned NOT NULL,
  `extension_id` bigint(20) NOT NULL DEFAULT '700' COMMENT 'FK to #___extensions',
  `title_key` varchar(255) NOT NULL DEFAULT '' COMMENT 'Lang key for the title',
  `description_key` varchar(255) NOT NULL DEFAULT '' COMMENT 'Lang key for description',
  `action_key` varchar(255) NOT NULL DEFAULT '',
  `language_extension` varchar(255) NOT NULL DEFAULT 'com_postinstall' COMMENT 'Extension holding lang keys',
  `language_client_id` tinyint(3) NOT NULL DEFAULT '1',
  `type` varchar(10) NOT NULL DEFAULT 'link' COMMENT 'Message type - message, link, action',
  `action_file` varchar(255) DEFAULT '' COMMENT 'RAD URI to the PHP file containing action method',
  `action` varchar(255) DEFAULT '' COMMENT 'Action method name or URL',
  `condition_file` varchar(255) DEFAULT NULL COMMENT 'RAD URI to file holding display condition method',
  `condition_method` varchar(255) DEFAULT NULL COMMENT 'Display condition method, must return boolean',
  `version_introduced` varchar(50) NOT NULL DEFAULT '3.2.0' COMMENT 'Version when this message was introduced',
  `enabled` tinyint(3) NOT NULL DEFAULT '1'
) ENGINE=InnoDB AUTO_INCREMENT=47 DEFAULT CHARSET=utf8;

INSERT INTO `#__postinstall_messages` (`postinstall_message_id`, `extension_id`, `title_key`, `description_key`, `action_key`, `language_extension`, `language_client_id`, `type`, `action_file`, `action`, `condition_file`, `condition_method`, `version_introduced`, `enabled`) VALUES
(1, 700, 'PLG_TWOFACTORAUTH_TOTP_POSTINSTALL_TITLE', 'PLG_TWOFACTORAUTH_TOTP_POSTINSTALL_BODY', 'PLG_TWOFACTORAUTH_TOTP_POSTINSTALL_ACTION', 'plg_twofactorauth_totp', 1, 'action', 'site://plugins/twofactorauth/totp/postinstall/actions.php', 'twofactorauth_postinstall_action', 'site://plugins/twofactorauth/totp/postinstall/actions.php', 'twofactorauth_postinstall_condition', '3.2.0', 1),
(2, 700, 'COM_CPANEL_MSG_EACCELERATOR_TITLE', 'COM_CPANEL_MSG_EACCELERATOR_BODY', 'COM_CPANEL_MSG_EACCELERATOR_BUTTON', 'com_cpanel', 1, 'action', 'admin://components/com_admin/postinstall/eaccelerator.php', 'admin_postinstall_eaccelerator_action', 'admin://components/com_admin/postinstall/eaccelerator.php', 'admin_postinstall_eaccelerator_condition', '3.2.0', 1),
(3, 700, 'COM_CPANEL_WELCOME_BEGINNERS_TITLE', 'COM_CPANEL_WELCOME_BEGINNERS_MESSAGE', '', 'com_cpanel', 1, 'message', '', '', '', '', '3.2.0', 1),
(4, 700, 'COM_CPANEL_MSG_PHPVERSION_TITLE', 'COM_CPANEL_MSG_PHPVERSION_BODY', '', 'com_cpanel', 1, 'message', '', '', 'admin://components/com_admin/postinstall/phpversion.php', 'admin_postinstall_phpversion_condition', '3.2.2', 1),
(5, 10025, 'AKEEBA_POSTSETUP_LBL_CONFWIZ', 'AKEEBA_POSTSETUP_DESC_CONFWIZ', 'AKEEBA_POSTSETUP_BTN_RUN_CONFWIZ', 'com_akeeba', 1, 'action', 'admin://components/com_akeeba/helpers/postinstall.php', 'com_akeeba_postinstall_confwiz_action', 'admin://components/com_akeeba/helpers/postinstall.php', 'com_akeeba_postinstall_confwiz_condition', '4.0.0', 1),
(7, 10025, 'AKEEBA_POSTSETUP_LBL_ACCEPTLICENSE', 'AKEEBA_POSTSETUP_DESC_ACCEPTLICENSE', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1),
(8, 10025, 'AKEEBA_POSTSETUP_LBL_ACCEPTSUPPORT', 'AKEEBA_POSTSETUP_DESC_ACCEPTSUPPORT', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1),
(9, 10025, 'AKEEBA_POSTSETUP_LBL_ACCEPTBACKUPTEST', 'AKEEBA_POSTSETUP_DESC_ACCEPTBACKUPTEST', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1),
(10, 10036, 'AKEEBA_POSTSETUP_LBL_CONFWIZ', 'AKEEBA_POSTSETUP_DESC_CONFWIZ', 'AKEEBA_POSTSETUP_BTN_RUN_CONFWIZ', 'com_akeeba', 1, 'action', 'admin://components/com_akeeba/helpers/postinstall.php', 'com_akeeba_postinstall_confwiz_action', 'admin://components/com_akeeba/helpers/postinstall.php', 'com_akeeba_postinstall_confwiz_condition', '4.0.0', 1),
(12, 10036, 'AKEEBA_POSTSETUP_LBL_ACCEPTLICENSE', 'AKEEBA_POSTSETUP_DESC_ACCEPTLICENSE', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1),
(13, 10036, 'AKEEBA_POSTSETUP_LBL_ACCEPTSUPPORT', 'AKEEBA_POSTSETUP_DESC_ACCEPTSUPPORT', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1),
(14, 10036, 'AKEEBA_POSTSETUP_LBL_ACCEPTBACKUPTEST', 'AKEEBA_POSTSETUP_DESC_ACCEPTBACKUPTEST', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1),
(15, 10041, 'AKEEBA_POSTSETUP_LBL_CONFWIZ', 'AKEEBA_POSTSETUP_DESC_CONFWIZ', 'AKEEBA_POSTSETUP_BTN_RUN_CONFWIZ', 'com_akeeba', 1, 'action', 'admin://components/com_akeeba/helpers/postinstall.php', 'com_akeeba_postinstall_confwiz_action', 'admin://components/com_akeeba/helpers/postinstall.php', 'com_akeeba_postinstall_confwiz_condition', '4.0.0', 1),
(17, 10041, 'AKEEBA_POSTSETUP_LBL_ACCEPTLICENSE', 'AKEEBA_POSTSETUP_DESC_ACCEPTLICENSE', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1),
(18, 10041, 'AKEEBA_POSTSETUP_LBL_ACCEPTSUPPORT', 'AKEEBA_POSTSETUP_DESC_ACCEPTSUPPORT', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1),
(19, 10041, 'AKEEBA_POSTSETUP_LBL_ACCEPTBACKUPTEST', 'AKEEBA_POSTSETUP_DESC_ACCEPTBACKUPTEST', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1),
(20, 10045, 'AKEEBA_POSTSETUP_LBL_CONFWIZ', 'AKEEBA_POSTSETUP_DESC_CONFWIZ', 'AKEEBA_POSTSETUP_BTN_RUN_CONFWIZ', 'com_akeeba', 1, 'action', 'admin://components/com_akeeba/helpers/postinstall.php', 'com_akeeba_postinstall_confwiz_action', 'admin://components/com_akeeba/helpers/postinstall.php', 'com_akeeba_postinstall_confwiz_condition', '4.0.0', 1),
(21, 10045, 'AKEEBA_POSTSETUP_LBL_ACCEPTLICENSE', 'AKEEBA_POSTSETUP_DESC_ACCEPTLICENSE', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1),
(22, 10045, 'AKEEBA_POSTSETUP_LBL_ACCEPTSUPPORT', 'AKEEBA_POSTSETUP_DESC_ACCEPTSUPPORT', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1),
(23, 10045, 'AKEEBA_POSTSETUP_LBL_ACCEPTBACKUPTEST', 'AKEEBA_POSTSETUP_DESC_ACCEPTBACKUPTEST', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1),
(24, 700, 'COM_CPANEL_MSG_HTACCESS_TITLE', 'COM_CPANEL_MSG_HTACCESS_BODY', '', 'com_cpanel', 1, 'message', '', '', 'admin://components/com_admin/postinstall/htaccess.php', 'admin_postinstall_htaccess_condition', '3.4.0', 1),
(25, 700, 'COM_CPANEL_MSG_ROBOTS_TITLE', 'COM_CPANEL_MSG_ROBOTS_BODY', '', 'com_cpanel', 1, 'message', '', '', '', '', '3.3.0', 1),
(26, 10053, 'AKEEBA_POSTSETUP_LBL_CONFWIZ', 'AKEEBA_POSTSETUP_DESC_CONFWIZ', 'AKEEBA_POSTSETUP_BTN_RUN_CONFWIZ', 'com_akeeba', 1, 'action', 'admin://components/com_akeeba/helpers/postinstall.php', 'com_akeeba_postinstall_confwiz_action', 'admin://components/com_akeeba/helpers/postinstall.php', 'com_akeeba_postinstall_confwiz_condition', '4.0.0', 1),
(27, 10053, 'AKEEBA_POSTSETUP_LBL_ACCEPTLICENSE', 'AKEEBA_POSTSETUP_DESC_ACCEPTLICENSE', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1),
(28, 10053, 'AKEEBA_POSTSETUP_LBL_ACCEPTSUPPORT', 'AKEEBA_POSTSETUP_DESC_ACCEPTSUPPORT', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1),
(29, 10053, 'AKEEBA_POSTSETUP_LBL_ACCEPTBACKUPTEST', 'AKEEBA_POSTSETUP_DESC_ACCEPTBACKUPTEST', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1),
(30, 700, 'COM_CPANEL_MSG_LANGUAGEACCESS340_TITLE', 'COM_CPANEL_MSG_LANGUAGEACCESS340_BODY', '', 'com_cpanel', 1, 'message', '', '', 'admin://components/com_admin/postinstall/languageaccess340.php', 'admin_postinstall_languageaccess340_condition', '3.4.1', 1),
(31, 10058, 'AKEEBA_POSTSETUP_LBL_CONFWIZ', 'AKEEBA_POSTSETUP_DESC_CONFWIZ', 'AKEEBA_POSTSETUP_BTN_RUN_CONFWIZ', 'com_akeeba', 1, 'action', 'admin://components/com_akeeba/helpers/postinstall.php', 'com_akeeba_postinstall_confwiz_action', 'admin://components/com_akeeba/helpers/postinstall.php', 'com_akeeba_postinstall_confwiz_condition', '4.0.0', 1),
(32, 10058, 'AKEEBA_POSTSETUP_LBL_ACCEPTLICENSE', 'AKEEBA_POSTSETUP_DESC_ACCEPTLICENSE', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1),
(33, 10058, 'AKEEBA_POSTSETUP_LBL_ACCEPTSUPPORT', 'AKEEBA_POSTSETUP_DESC_ACCEPTSUPPORT', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1),
(34, 10058, 'AKEEBA_POSTSETUP_LBL_ACCEPTBACKUPTEST', 'AKEEBA_POSTSETUP_DESC_ACCEPTBACKUPTEST', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1),
(35, 10065, 'AKEEBA_POSTSETUP_LBL_CONFWIZ', 'AKEEBA_POSTSETUP_DESC_CONFWIZ', 'AKEEBA_POSTSETUP_BTN_RUN_CONFWIZ', 'com_akeeba', 1, 'action', 'admin://components/com_akeeba/helpers/postinstall.php', 'com_akeeba_postinstall_confwiz_action', 'admin://components/com_akeeba/helpers/postinstall.php', 'com_akeeba_postinstall_confwiz_condition', '4.0.0', 1),
(36, 10065, 'AKEEBA_POSTSETUP_LBL_ACCEPTLICENSE', 'AKEEBA_POSTSETUP_DESC_ACCEPTLICENSE', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1),
(37, 10065, 'AKEEBA_POSTSETUP_LBL_ACCEPTSUPPORT', 'AKEEBA_POSTSETUP_DESC_ACCEPTSUPPORT', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1),
(38, 10065, 'AKEEBA_POSTSETUP_LBL_ACCEPTBACKUPTEST', 'AKEEBA_POSTSETUP_DESC_ACCEPTBACKUPTEST', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1),
(39, 10067, 'AKEEBA_POSTSETUP_LBL_CONFWIZ', 'AKEEBA_POSTSETUP_DESC_CONFWIZ', 'AKEEBA_POSTSETUP_BTN_RUN_CONFWIZ', 'com_akeeba', 1, 'action', 'admin://components/com_akeeba/helpers/postinstall.php', 'com_akeeba_postinstall_confwiz_action', 'admin://components/com_akeeba/helpers/postinstall.php', 'com_akeeba_postinstall_confwiz_condition', '4.0.0', 1),
(40, 10067, 'AKEEBA_POSTSETUP_LBL_ACCEPTLICENSE', 'AKEEBA_POSTSETUP_DESC_ACCEPTLICENSE', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1),
(41, 10067, 'AKEEBA_POSTSETUP_LBL_ACCEPTSUPPORT', 'AKEEBA_POSTSETUP_DESC_ACCEPTSUPPORT', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1),
(42, 10067, 'AKEEBA_POSTSETUP_LBL_ACCEPTBACKUPTEST', 'AKEEBA_POSTSETUP_DESC_ACCEPTBACKUPTEST', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1),
(43, 10071, 'AKEEBA_POSTSETUP_LBL_CONFWIZ', 'AKEEBA_POSTSETUP_DESC_CONFWIZ', 'AKEEBA_POSTSETUP_BTN_RUN_CONFWIZ', 'com_akeeba', 1, 'action', 'admin://components/com_akeeba/helpers/postinstall.php', 'com_akeeba_postinstall_confwiz_action', 'admin://components/com_akeeba/helpers/postinstall.php', 'com_akeeba_postinstall_confwiz_condition', '4.0.0', 1),
(44, 10071, 'AKEEBA_POSTSETUP_LBL_ACCEPTLICENSE', 'AKEEBA_POSTSETUP_DESC_ACCEPTLICENSE', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1),
(45, 10071, 'AKEEBA_POSTSETUP_LBL_ACCEPTSUPPORT', 'AKEEBA_POSTSETUP_DESC_ACCEPTSUPPORT', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1),
(46, 10071, 'AKEEBA_POSTSETUP_LBL_ACCEPTBACKUPTEST', 'AKEEBA_POSTSETUP_DESC_ACCEPTBACKUPTEST', 'AKEEBA_POSTSETUP_BTN_I_CONFIRM_THIS', 'com_akeeba', 1, 'message', '', '', '', '', '4.0.0', 1);

DROP TABLE IF EXISTS `#__redirect_links`;
CREATE TABLE IF NOT EXISTS `#__redirect_links` (
`id` int(10) unsigned NOT NULL,
  `old_url` varchar(255) NOT NULL,
  `new_url` varchar(255) DEFAULT NULL,
  `referer` varchar(150) NOT NULL,
  `comment` varchar(255) NOT NULL,
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(4) NOT NULL,
  `created_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `header` smallint(3) NOT NULL DEFAULT '301'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__schemas`;
CREATE TABLE IF NOT EXISTS `#__schemas` (
  `extension_id` int(11) NOT NULL,
  `version_id` varchar(20) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `#__schemas` (`extension_id`, `version_id`) VALUES
(21, '3.4.0'),
(700, '3.4.0-2015-02-26'),
(10069, '0.0.6');

DROP TABLE IF EXISTS `#__session`;
CREATE TABLE IF NOT EXISTS `#__session` (
  `session_id` varchar(200) NOT NULL DEFAULT '',
  `client_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `guest` tinyint(4) unsigned DEFAULT '1',
  `time` varchar(14) DEFAULT '',
  `data` mediumtext,
  `userid` int(11) DEFAULT '0',
  `username` varchar(150) DEFAULT ''
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `#__session` (`session_id`, `client_id`, `guest`, `time`, `data`, `userid`, `username`) VALUES
('fqj1o5cddbc180lc6pt1j0lav5', 0, 1, '1438373637', '__default|a:9:{s:15:"session.counter";i:9;s:19:"session.timer.start";i:1438372064;s:18:"session.timer.last";i:1438373624;s:17:"session.timer.now";i:1438373636;s:22:"session.client.browser";s:109:"Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/44.0.2403.125 Safari/537.36";s:8:"registry";O:24:"Joomla\\Registry\\Registry":2:{s:7:"\\0\\0\\0data";O:8:"stdClass":0:{}s:9:"separator";s:1:".";}s:4:"user";O:5:"JUser":26:{s:9:"\\0\\0\\0isRoot";b:0;s:2:"id";i:0;s:4:"name";N;s:8:"username";N;s:5:"email";N;s:8:"password";N;s:14:"password_clear";s:0:"";s:5:"block";N;s:9:"sendEmail";i:0;s:12:"registerDate";N;s:13:"lastvisitDate";N;s:10:"activation";N;s:6:"params";N;s:6:"groups";a:1:{i:0;s:1:"9";}s:5:"guest";i:1;s:13:"lastResetTime";N;s:10:"resetCount";N;s:12:"requireReset";N;s:10:"\\0\\0\\0_params";O:24:"Joomla\\Registry\\Registry":2:{s:7:"\\0\\0\\0data";O:8:"stdClass":0:{}s:9:"separator";s:1:".";}s:14:"\\0\\0\\0_authGroups";a:2:{i:0;i:1;i:1;i:9;}s:14:"\\0\\0\\0_authLevels";a:3:{i:0;i:1;i:1;i:1;i:2;i:5;}s:15:"\\0\\0\\0_authActions";N;s:12:"\\0\\0\\0_errorMsg";N;s:13:"\\0\\0\\0userHelper";O:18:"JUserWrapperHelper":0:{}s:10:"\\0\\0\\0_errors";a:0:{}s:3:"aid";i:0;}s:13:"session.token";s:32:"2ba4deb00e2f3c3027f0bcf6c37799b4";s:16:"com_mailto.links";a:1:{s:40:"675bf016e1dd7c65db8db5897f4c2a210406b38b";O:8:"stdClass":2:{s:4:"link";s:92:"http://localhost/development/templates/2015/blueprint/mn_blueprint_quick_start_301/index.php";s:6:"expiry";i:1438373624;}}}', 0, ''),
('g8sg87v4adfnio05vjobfh7up3', 1, 0, '1438373648', '__default|a:8:{s:15:"session.counter";i:21;s:19:"session.timer.start";i:1438373455;s:18:"session.timer.last";i:1438373644;s:17:"session.timer.now";i:1438373645;s:22:"session.client.browser";s:109:"Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/44.0.2403.125 Safari/537.36";s:8:"registry";O:24:"Joomla\\Registry\\Registry":2:{s:7:"\\0\\0\\0data";O:8:"stdClass":6:{s:11:"application";O:8:"stdClass":1:{s:4:"lang";s:5:"en-GB";}s:11:"com_plugins";O:8:"stdClass":1:{s:7:"plugins";O:8:"stdClass":4:{s:6:"filter";O:8:"stdClass":4:{s:6:"search";s:4:"cach";s:6:"access";i:0;s:7:"enabled";s:0:"";s:6:"folder";s:0:"";}s:8:"ordercol";s:6:"folder";s:9:"orderdirn";s:3:"asc";s:10:"limitstart";i:0;}}s:6:"global";O:8:"stdClass":1:{s:4:"list";O:8:"stdClass":1:{s:5:"limit";i:20;}}s:9:"com_cache";O:8:"stdClass":1:{s:5:"cache";O:8:"stdClass":1:{s:8:"ordercol";s:5:"group";}}s:13:"com_templates";O:8:"stdClass":1:{s:4:"edit";O:8:"stdClass":1:{s:5:"style";O:8:"stdClass":2:{s:2:"id";a:0:{}s:4:"data";N;}}}s:13:"com_installer";O:8:"stdClass":3:{s:7:"message";s:0:"";s:17:"extension_message";s:0:"";s:12:"redirect_url";N;}}s:9:"separator";s:1:".";}s:4:"user";O:5:"JUser":29:{s:9:"\\0\\0\\0isRoot";b:1;s:2:"id";s:3:"651";s:4:"name";s:10:"Super User";s:8:"username";s:5:"admin";s:5:"email";s:21:"dimostenisv@gmail.com";s:8:"password";s:60:"$2y$10$ochmi2OBRIo62Aod3dWGi.1N6lGw0L5zvuTcqMIIBDCMDQfC3heNe";s:14:"password_clear";s:0:"";s:5:"block";s:1:"0";s:9:"sendEmail";s:1:"1";s:12:"registerDate";s:19:"2015-07-31 19:27:01";s:13:"lastvisitDate";s:19:"2015-07-31 19:47:59";s:10:"activation";s:1:"0";s:6:"params";s:0:"";s:6:"groups";a:1:{i:8;s:1:"8";}s:5:"guest";i:0;s:13:"lastResetTime";s:19:"0000-00-00 00:00:00";s:10:"resetCount";s:1:"0";s:12:"requireReset";s:1:"0";s:10:"\\0\\0\\0_params";O:24:"Joomla\\Registry\\Registry":2:{s:7:"\\0\\0\\0data";O:8:"stdClass":0:{}s:9:"separator";s:1:".";}s:14:"\\0\\0\\0_authGroups";a:2:{i:0;i:1;i:1;i:8;}s:14:"\\0\\0\\0_authLevels";a:5:{i:0;i:1;i:1;i:1;i:2;i:2;i:3;i:3;i:4;i:6;}s:15:"\\0\\0\\0_authActions";N;s:12:"\\0\\0\\0_errorMsg";N;s:13:"\\0\\0\\0userHelper";O:18:"JUserWrapperHelper":0:{}s:10:"\\0\\0\\0_errors";a:0:{}s:3:"aid";i:0;s:6:"otpKey";s:0:"";s:4:"otep";s:0:"";s:3:"gid";i:1000;}s:13:"session.token";s:32:"adb9b1f11cf6a284b5f5607a5b82bb87";}', 651, 'admin');

DROP TABLE IF EXISTS `#__tags`;
CREATE TABLE IF NOT EXISTS `#__tags` (
`id` int(10) unsigned NOT NULL,
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) unsigned NOT NULL DEFAULT '0',
  `path` varchar(255) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` mediumtext NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `metadesc` varchar(1024) NOT NULL COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) NOT NULL COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` text NOT NULL,
  `urls` text NOT NULL,
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00'
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

INSERT INTO `#__tags` (`id`, `parent_id`, `lft`, `rgt`, `level`, `path`, `title`, `alias`, `note`, `description`, `published`, `checked_out`, `checked_out_time`, `access`, `params`, `metadesc`, `metakey`, `metadata`, `created_user_id`, `created_time`, `created_by_alias`, `modified_user_id`, `modified_time`, `images`, `urls`, `hits`, `language`, `version`, `publish_up`, `publish_down`) VALUES
(1, 0, 0, 1, 0, '', 'ROOT', 'root', '', '', 1, 0, '0000-00-00 00:00:00', 1, '', '', '', '', 651, '2011-01-01 00:00:01', '', 0, '0000-00-00 00:00:00', '', '', 0, '*', 1, '0000-00-00 00:00:00', '0000-00-00 00:00:00');

DROP TABLE IF EXISTS `#__template_styles`;
CREATE TABLE IF NOT EXISTS `#__template_styles` (
`id` int(10) unsigned NOT NULL,
  `template` varchar(50) NOT NULL DEFAULT '',
  `client_id` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `home` char(7) NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL DEFAULT '',
  `params` text NOT NULL
) ENGINE=InnoDB AUTO_INCREMENT=102 DEFAULT CHARSET=utf8;

INSERT INTO `#__template_styles` (`id`, `template`, `client_id`, `home`, `title`, `params`) VALUES
(4, 'beez3', 0, '0', 'Beez3 - Default', '{"wrapperSmall":"53","wrapperLarge":"72","logo":"images\\/joomla_black.gif","sitetitle":"Joomla!","sitedescription":"Open Source Content Management","navposition":"left","templatecolor":"personal","html5":"0"}'),
(5, 'hathor', 1, '0', 'Hathor - Default', '{"showSiteName":"0","colourChoice":"","boldText":"0"}'),
(7, 'protostar', 0, '0', 'protostar - Default', '{"templateColor":"","logoFile":"","googleFont":"1","googleFontName":"Open+Sans","fluidContainer":"0"}'),
(8, 'isis', 1, '1', 'isis - Default', '{"templateColor":"","logoFile":""}'),
(91, 'blueprint', 0, '0', 'Blueprint - Default - Home', '{"back-to-top":"1","mncookie":"1","header-slider":"1","modalbg":"images\\/blueprint\\/modal\\/modal.jpg","cookielink":null,"t3_template":"1","devmode":"0","themermode":"1","legacy_css":"0","responsive":"1","non_responsive_width":"970px","build_rtl":"0","t3-assets":"t3-assets","t3-rmvlogo":"1","minify":"1","minify_js":"1","minify_js_tool":"jsmin","minify_exclude":null,"link_titles":null,"theme":"","logotype":"image","sitename":"","slogan":"","logoimage":"images\\/blueprint\\/logo\\/logo_home.png","enable_logoimage_sm":"1","logoimage_sm":"images\\/blueprint\\/logo\\/logo.png","mainlayout":"default-home","sublayout":"","mm_type":"mainmenu","navigation_trigger":"hover","navigation_type":"megamenu","navigation_animation":null,"navigation_animation_duration":"400","mm_config":"{\\"mainmenu\\":{\\"item-113\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":309,\\"width\\":12}]]}},\\"item-296\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":297,\\"width\\":12}]]}},\\"item-121\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":125,\\"width\\":12}]]}},\\"item-118\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":117,\\"width\\":12}]]}},\\"item-117\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":150,\\"width\\":12}]]}},\\"item-127\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":129,\\"width\\":12}]]}},\\"item-129\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":302,\\"width\\":12}]]}},\\"item-302\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":306,\\"width\\":12}]]}},\\"item-136\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":135,\\"width\\":12}]]}},\\"item-141\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":142,\\"width\\":12}]]}},\\"item-146\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":147,\\"width\\":12}]]}}}}","navigation_collapse_enable":"0","addon_offcanvas_enable":"1","addon_offcanvas_effect":"off-canvas-effect-4","snippet_open_head":null,"snippet_close_head":null,"snippet_open_body":null,"snippet_close_body":null,"snippet_debug":"0","theme_extras_k2":["-1"],"theme_extras_minitek-typo":["-1"],"theme_extras_minitek":["-1"],"theme_extras_typography":["-1"]}'),
(92, 'blueprint', 0, '1', 'Blueprint - Default', '{"back-to-top":"1","mncookie":"1","header-slider":"1","modalbg":"images\\/blueprint\\/modal\\/modal.jpg","cookielink":null,"t3_template":"1","devmode":"0","themermode":"1","legacy_css":"0","responsive":"1","non_responsive_width":"970px","build_rtl":"0","t3-assets":"t3-assets","t3-rmvlogo":"1","minify":"1","minify_js":"1","minify_js_tool":"jsmin","minify_exclude":null,"link_titles":null,"theme":"","logotype":"image","sitename":"","slogan":"","logoimage":"images\\/blueprint\\/logo\\/logo.png","enable_logoimage_sm":"0","logoimage_sm":"","mainlayout":"default","sublayout":"","mm_type":"mainmenu","navigation_trigger":"hover","navigation_type":"megamenu","navigation_animation":null,"navigation_animation_duration":"400","mm_config":"{\\"mainmenu\\":{\\"item-113\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":309,\\"width\\":12}]]}},\\"item-296\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":297,\\"width\\":12}]]}},\\"item-121\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":125,\\"width\\":12}]]}},\\"item-118\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":117,\\"width\\":12}]]}},\\"item-117\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":150,\\"width\\":12}]]}},\\"item-127\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":129,\\"width\\":12}]]}},\\"item-129\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":302,\\"width\\":12}]]}},\\"item-302\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":306,\\"width\\":12}]]}},\\"item-136\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":135,\\"width\\":12}]]}},\\"item-141\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":142,\\"width\\":12}]]}},\\"item-146\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":147,\\"width\\":12}]]}}}}","navigation_collapse_enable":"0","addon_offcanvas_enable":"1","addon_offcanvas_effect":"off-canvas-effect-4","snippet_open_head":null,"snippet_close_head":null,"snippet_open_body":null,"snippet_close_body":null,"snippet_debug":"0","theme_extras_k2":["-1"],"theme_extras_minitek-typo":["-1"],"theme_extras_minitek":["-1"],"theme_extras_typography":["-1"],"mm_config_needupdate":""}'),
(93, 'blueprint', 0, '0', 'Blueprint - Default - Content Right', '{"back-to-top":"1","mncookie":"1","header-slider":"1","modalbg":"images\\/blueprint\\/modal\\/modal.jpg","cookielink":null,"t3_template":"1","devmode":"0","themermode":"1","legacy_css":"0","responsive":"1","non_responsive_width":"970px","build_rtl":"0","t3-assets":"t3-assets","t3-rmvlogo":"1","minify":"1","minify_js":"1","minify_js_tool":"jsmin","minify_exclude":null,"link_titles":null,"theme":"","logotype":"image","sitename":"","slogan":"","logoimage":"images\\/blueprint\\/logo\\/logo.png","enable_logoimage_sm":"0","logoimage_sm":"","mainlayout":"default-content-right","sublayout":"","mm_type":"mainmenu","navigation_trigger":"hover","navigation_type":"megamenu","navigation_animation":null,"navigation_animation_duration":"400","mm_config":"{\\"mainmenu\\":{\\"item-113\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":309,\\"width\\":12}]]}},\\"item-296\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":297,\\"width\\":12}]]}},\\"item-121\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":125,\\"width\\":12}]]}},\\"item-118\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":117,\\"width\\":12}]]}},\\"item-117\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":150,\\"width\\":12}]]}},\\"item-127\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":129,\\"width\\":12}]]}},\\"item-129\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":302,\\"width\\":12}]]}},\\"item-302\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":306,\\"width\\":12}]]}},\\"item-136\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":135,\\"width\\":12}]]}},\\"item-141\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":142,\\"width\\":12}]]}},\\"item-146\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":147,\\"width\\":12}]]}}}}","navigation_collapse_enable":"0","addon_offcanvas_enable":"1","addon_offcanvas_effect":"off-canvas-effect-4","snippet_open_head":null,"snippet_close_head":null,"snippet_open_body":null,"snippet_close_body":null,"snippet_debug":"0","theme_extras_k2":["-1"],"theme_extras_minitek-typo":["-1"],"theme_extras_minitek":["-1"],"theme_extras_typography":["-1"],"mm_config_needupdate":""}'),
(94, 'blueprint', 0, '0', 'Blueprint - Default - Content Left', '{"back-to-top":"1","mncookie":"1","header-slider":"1","modalbg":"images\\/blueprint\\/modal\\/modal.jpg","cookielink":null,"t3_template":"1","devmode":"0","themermode":"1","legacy_css":"0","responsive":"1","non_responsive_width":"970px","build_rtl":"0","t3-assets":"t3-assets","t3-rmvlogo":"1","minify":"1","minify_js":"1","minify_js_tool":"jsmin","minify_exclude":null,"link_titles":null,"theme":"","logotype":"image","sitename":"","slogan":"","logoimage":"images\\/blueprint\\/logo\\/logo.png","enable_logoimage_sm":"0","logoimage_sm":"","mainlayout":"default-content-left","sublayout":"","mm_type":"mainmenu","navigation_trigger":"hover","navigation_type":"megamenu","navigation_animation":null,"navigation_animation_duration":"400","mm_config":"{\\"mainmenu\\":{\\"item-113\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":309,\\"width\\":12}]]}},\\"item-296\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":297,\\"width\\":12}]]}},\\"item-121\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":125,\\"width\\":12}]]}},\\"item-118\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":117,\\"width\\":12}]]}},\\"item-117\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":150,\\"width\\":12}]]}},\\"item-127\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":129,\\"width\\":12}]]}},\\"item-129\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":302,\\"width\\":12}]]}},\\"item-302\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":306,\\"width\\":12}]]}},\\"item-136\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":135,\\"width\\":12}]]}},\\"item-141\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":142,\\"width\\":12}]]}},\\"item-146\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":147,\\"width\\":12}]]}}}}","navigation_collapse_enable":"0","addon_offcanvas_enable":"1","addon_offcanvas_effect":"off-canvas-effect-4","snippet_open_head":null,"snippet_close_head":null,"snippet_open_body":null,"snippet_close_body":null,"snippet_debug":"0","theme_extras_k2":["-1"],"theme_extras_minitek-typo":["-1"],"theme_extras_minitek":["-1"],"theme_extras_typography":["-1"],"mm_config_needupdate":""}'),
(95, 'blueprint', 0, '0', 'Blueprint - Default - No Component', '{"back-to-top":"1","mncookie":"1","header-slider":"1","modalbg":"images\\/blueprint\\/modal\\/modal.jpg","cookielink":null,"t3_template":"1","devmode":"0","themermode":"1","legacy_css":"0","responsive":"1","non_responsive_width":"970px","build_rtl":"0","t3-assets":"t3-assets","t3-rmvlogo":"1","minify":"1","minify_js":"1","minify_js_tool":"jsmin","minify_exclude":null,"link_titles":null,"logotype":"image","sitename":"","slogan":"","logoimage":"images\\/blueprint\\/logo\\/logo.png","enable_logoimage_sm":"0","logoimage_sm":"","mainlayout":"default-home","sublayout":"","mm_type":"mainmenu","navigation_trigger":"hover","navigation_type":"megamenu","navigation_animation":null,"navigation_animation_duration":"400","mm_config":"{\\"mainmenu\\":{\\"item-113\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":309,\\"width\\":12}]]}},\\"item-296\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":297,\\"width\\":12}]]}},\\"item-121\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":125,\\"width\\":12}]]}},\\"item-118\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":117,\\"width\\":12}]]}},\\"item-117\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":150,\\"width\\":12}]]}},\\"item-127\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":129,\\"width\\":12}]]}},\\"item-129\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":302,\\"width\\":12}]]}},\\"item-302\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":306,\\"width\\":12}]]}},\\"item-136\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":135,\\"width\\":12}]]}},\\"item-141\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":142,\\"width\\":12}]]}},\\"item-146\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":147,\\"width\\":12}]]}}}}","navigation_collapse_enable":"0","addon_offcanvas_enable":"1","addon_offcanvas_effect":"off-canvas-effect-4","snippet_open_head":null,"snippet_close_head":null,"snippet_open_body":null,"snippet_close_body":null,"snippet_debug":"0","theme_extras_k2":["-1"],"theme_extras_minitek-typo":["-1"],"theme_extras_minitek":["-1"],"theme_extras_typography":["-1"],"mm_config_needupdate":""}'),
(96, 'blueprint', 0, '0', 'Blueprint - Default - Home - Blue', '{"back-to-top":"1","mncookie":"1","header-slider":"1","modalbg":"images\\/blueprint\\/modal\\/modal.jpg","cookielink":"","t3_template":"1","devmode":"0","themermode":"1","legacy_css":"0","responsive":"1","non_responsive_width":"970px","build_rtl":"0","t3-assets":"t3-assets","t3-rmvlogo":"1","minify":"1","minify_js":"1","minify_js_tool":"jsmin","minify_exclude":"","link_titles":"","theme":"blue","logotype":"image","sitename":"","slogan":"","logoimage":"images\\/blueprint\\/logo\\/logo_home.png","enable_logoimage_sm":"1","logoimage_sm":"images\\/blueprint\\/logo\\/logo.png","mainlayout":"default-home","sublayout":"","mm_type":"mainmenu","navigation_trigger":"hover","navigation_type":"megamenu","navigation_animation":"","navigation_animation_duration":"400","mm_config":"{\\"mainmenu\\":{\\"item-113\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":309,\\"width\\":12}]]}},\\"item-296\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":297,\\"width\\":12}]]}},\\"item-121\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":125,\\"width\\":12}]]}},\\"item-118\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":117,\\"width\\":12}]]}},\\"item-117\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":150,\\"width\\":12}]]}},\\"item-127\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":129,\\"width\\":12}]]}},\\"item-129\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":302,\\"width\\":12}]]}},\\"item-302\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":306,\\"width\\":12}]]}},\\"item-136\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":135,\\"width\\":12}]]}},\\"item-141\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":142,\\"width\\":12}]]}},\\"item-146\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":147,\\"width\\":12}]]}}}}","navigation_collapse_enable":"0","addon_offcanvas_enable":"1","addon_offcanvas_effect":"off-canvas-effect-4","snippet_open_head":"","snippet_close_head":"","snippet_open_body":"","snippet_close_body":"","snippet_debug":"0","theme_extras_k2":["-1"],"theme_extras_minitek-typo":["-1"],"theme_extras_minitek":["-1"],"theme_extras_typography":["-1"]}'),
(97, 'blueprint', 0, '0', 'Blueprint - Default - Home - Brown', '{"back-to-top":"1","mncookie":"1","header-slider":"1","modalbg":"images\\/blueprint\\/modal\\/modal.jpg","cookielink":null,"t3_template":"1","devmode":"0","themermode":"1","legacy_css":"0","responsive":"1","non_responsive_width":"970px","build_rtl":"0","t3-assets":"t3-assets","t3-rmvlogo":"1","minify":"1","minify_js":"1","minify_js_tool":"jsmin","minify_exclude":null,"link_titles":null,"theme":"brown","logotype":"image","sitename":"","slogan":"","logoimage":"images\\/blueprint\\/logo\\/logo_home.png","enable_logoimage_sm":"1","logoimage_sm":"images\\/blueprint\\/logo\\/logo.png","mainlayout":"default-home","sublayout":"","mm_type":"mainmenu","navigation_trigger":"hover","navigation_type":"megamenu","navigation_animation":null,"navigation_animation_duration":"400","mm_config":"{\\"mainmenu\\":{\\"item-113\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":309,\\"width\\":12}]]}},\\"item-296\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":297,\\"width\\":12}]]}},\\"item-121\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":125,\\"width\\":12}]]}},\\"item-118\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":117,\\"width\\":12}]]}},\\"item-117\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":150,\\"width\\":12}]]}},\\"item-127\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":129,\\"width\\":12}]]}},\\"item-129\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":302,\\"width\\":12}]]}},\\"item-302\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":306,\\"width\\":12}]]}},\\"item-136\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":135,\\"width\\":12}]]}},\\"item-141\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":142,\\"width\\":12}]]}},\\"item-146\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":147,\\"width\\":12}]]}}}}","navigation_collapse_enable":"0","addon_offcanvas_enable":"1","addon_offcanvas_effect":"off-canvas-effect-4","snippet_open_head":null,"snippet_close_head":null,"snippet_open_body":null,"snippet_close_body":null,"snippet_debug":"0","theme_extras_k2":["-1"],"theme_extras_minitek-typo":["-1"],"theme_extras_minitek":["-1"],"theme_extras_typography":["-1"],"mm_config_needupdate":""}'),
(98, 'blueprint', 0, '0', 'Blueprint - Default - Home - Green', '{"back-to-top":"1","mncookie":"1","header-slider":"1","modalbg":"images\\/blueprint\\/modal\\/modal.jpg","cookielink":null,"t3_template":"1","devmode":"0","themermode":"1","legacy_css":"0","responsive":"1","non_responsive_width":"970px","build_rtl":"0","t3-assets":"t3-assets","t3-rmvlogo":"1","minify":"1","minify_js":"1","minify_js_tool":"jsmin","minify_exclude":null,"link_titles":null,"theme":"green","logotype":"image","sitename":"","slogan":"","logoimage":"images\\/blueprint\\/logo\\/logo_home.png","enable_logoimage_sm":"1","logoimage_sm":"images\\/blueprint\\/logo\\/logo.png","mainlayout":"default-home","sublayout":"","mm_type":"mainmenu","navigation_trigger":"hover","navigation_type":"megamenu","navigation_animation":null,"navigation_animation_duration":"400","mm_config":"{\\"mainmenu\\":{\\"item-113\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":309,\\"width\\":12}]]}},\\"item-296\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":297,\\"width\\":12}]]}},\\"item-121\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":125,\\"width\\":12}]]}},\\"item-118\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":117,\\"width\\":12}]]}},\\"item-117\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":150,\\"width\\":12}]]}},\\"item-127\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":129,\\"width\\":12}]]}},\\"item-129\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":302,\\"width\\":12}]]}},\\"item-302\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":306,\\"width\\":12}]]}},\\"item-136\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":135,\\"width\\":12}]]}},\\"item-141\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":142,\\"width\\":12}]]}},\\"item-146\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":147,\\"width\\":12}]]}}}}","navigation_collapse_enable":"0","addon_offcanvas_enable":"1","addon_offcanvas_effect":"off-canvas-effect-4","snippet_open_head":null,"snippet_close_head":null,"snippet_open_body":null,"snippet_close_body":null,"snippet_debug":"0","theme_extras_k2":["-1"],"theme_extras_minitek-typo":["-1"],"theme_extras_minitek":["-1"],"theme_extras_typography":["-1"],"mm_config_needupdate":""}'),
(99, 'blueprint', 0, '0', 'Blueprint - Default - Home - Orange', '{"back-to-top":"1","mncookie":"1","header-slider":"1","modalbg":"images\\/blueprint\\/modal\\/modal.jpg","cookielink":null,"t3_template":"1","devmode":"0","themermode":"1","legacy_css":"0","responsive":"1","non_responsive_width":"970px","build_rtl":"0","t3-assets":"t3-assets","t3-rmvlogo":"1","minify":"1","minify_js":"1","minify_js_tool":"jsmin","minify_exclude":null,"link_titles":null,"theme":"orange","logotype":"image","sitename":"","slogan":"","logoimage":"images\\/blueprint\\/logo\\/logo_home.png","enable_logoimage_sm":"1","logoimage_sm":"images\\/blueprint\\/logo\\/logo.png","mainlayout":"default-home","sublayout":"","mm_type":"mainmenu","navigation_trigger":"hover","navigation_type":"megamenu","navigation_animation":null,"navigation_animation_duration":"400","mm_config":"{\\"mainmenu\\":{\\"item-113\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":309,\\"width\\":12}]]}},\\"item-296\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":297,\\"width\\":12}]]}},\\"item-121\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":125,\\"width\\":12}]]}},\\"item-118\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":117,\\"width\\":12}]]}},\\"item-117\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":150,\\"width\\":12}]]}},\\"item-127\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":129,\\"width\\":12}]]}},\\"item-129\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":302,\\"width\\":12}]]}},\\"item-302\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":306,\\"width\\":12}]]}},\\"item-136\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":135,\\"width\\":12}]]}},\\"item-141\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":142,\\"width\\":12}]]}},\\"item-146\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":147,\\"width\\":12}]]}}}}","navigation_collapse_enable":"0","addon_offcanvas_enable":"1","addon_offcanvas_effect":"off-canvas-effect-4","snippet_open_head":null,"snippet_close_head":null,"snippet_open_body":null,"snippet_close_body":null,"snippet_debug":"0","theme_extras_k2":["-1"],"theme_extras_minitek-typo":["-1"],"theme_extras_minitek":["-1"],"theme_extras_typography":["-1"],"mm_config_needupdate":""}'),
(100, 'blueprint', 0, '0', 'Blueprint - Default - Home - Purple', '{"back-to-top":"1","mncookie":"1","header-slider":"1","modalbg":"images\\/blueprint\\/modal\\/modal.jpg","cookielink":null,"t3_template":"1","devmode":"0","themermode":"1","legacy_css":"0","responsive":"1","non_responsive_width":"970px","build_rtl":"0","t3-assets":"t3-assets","t3-rmvlogo":"1","minify":"1","minify_js":"1","minify_js_tool":"jsmin","minify_exclude":null,"link_titles":null,"theme":"purple","logotype":"image","sitename":"","slogan":"","logoimage":"images\\/blueprint\\/logo\\/logo_home.png","enable_logoimage_sm":"1","logoimage_sm":"images\\/blueprint\\/logo\\/logo.png","mainlayout":"default-home","sublayout":"","mm_type":"mainmenu","navigation_trigger":"hover","navigation_type":"megamenu","navigation_animation":null,"navigation_animation_duration":"400","mm_config":"{\\"mainmenu\\":{\\"item-113\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":309,\\"width\\":12}]]}},\\"item-296\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":297,\\"width\\":12}]]}},\\"item-121\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":125,\\"width\\":12}]]}},\\"item-118\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":117,\\"width\\":12}]]}},\\"item-117\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":150,\\"width\\":12}]]}},\\"item-127\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":129,\\"width\\":12}]]}},\\"item-129\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":302,\\"width\\":12}]]}},\\"item-302\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":306,\\"width\\":12}]]}},\\"item-136\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":135,\\"width\\":12}]]}},\\"item-141\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":142,\\"width\\":12}]]}},\\"item-146\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":147,\\"width\\":12}]]}}}}","navigation_collapse_enable":"0","addon_offcanvas_enable":"1","addon_offcanvas_effect":"off-canvas-effect-4","snippet_open_head":null,"snippet_close_head":null,"snippet_open_body":null,"snippet_close_body":null,"snippet_debug":"0","theme_extras_k2":["-1"],"theme_extras_minitek-typo":["-1"],"theme_extras_minitek":["-1"],"theme_extras_typography":["-1"],"mm_config_needupdate":""}'),
(101, 'blueprint', 0, '0', 'Blueprint - Default - Home - Yellow', '{"back-to-top":"1","mncookie":"1","header-slider":"1","modalbg":"images\\/blueprint\\/modal\\/modal.jpg","cookielink":null,"t3_template":"1","devmode":"0","themermode":"1","legacy_css":"0","responsive":"1","non_responsive_width":"970px","build_rtl":"0","t3-assets":"t3-assets","t3-rmvlogo":"1","minify":"1","minify_js":"1","minify_js_tool":"jsmin","minify_exclude":null,"link_titles":null,"theme":"yellow","logotype":"image","sitename":"","slogan":"","logoimage":"images\\/blueprint\\/logo\\/logo_home.png","enable_logoimage_sm":"1","logoimage_sm":"images\\/blueprint\\/logo\\/logo.png","mainlayout":"default-home","sublayout":"","mm_type":"mainmenu","navigation_trigger":"hover","navigation_type":"megamenu","navigation_animation":null,"navigation_animation_duration":"400","mm_config":"{\\"mainmenu\\":{\\"item-113\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":309,\\"width\\":12}]]}},\\"item-296\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":297,\\"width\\":12}]]}},\\"item-121\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":125,\\"width\\":12}]]}},\\"item-118\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":117,\\"width\\":12}]]}},\\"item-117\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":150,\\"width\\":12}]]}},\\"item-127\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":129,\\"width\\":12}]]}},\\"item-129\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":302,\\"width\\":12}]]}},\\"item-302\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":306,\\"width\\":12}]]}},\\"item-136\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":135,\\"width\\":12}]]}},\\"item-141\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":142,\\"width\\":12}]]}},\\"item-146\\":{\\"sub\\":{\\"rows\\":[[{\\"item\\":147,\\"width\\":12}]]}}}}","navigation_collapse_enable":"0","addon_offcanvas_enable":"1","addon_offcanvas_effect":"off-canvas-effect-4","snippet_open_head":null,"snippet_close_head":null,"snippet_open_body":null,"snippet_close_body":null,"snippet_debug":"0","theme_extras_k2":["-1"],"theme_extras_minitek-typo":["-1"],"theme_extras_minitek":["-1"],"theme_extras_typography":["-1"],"mm_config_needupdate":""}');

DROP TABLE IF EXISTS `#__ucm_base`;
CREATE TABLE IF NOT EXISTS `#__ucm_base` (
  `ucm_id` int(10) unsigned NOT NULL,
  `ucm_item_id` int(10) NOT NULL,
  `ucm_type_id` int(11) NOT NULL,
  `ucm_language_id` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__ucm_content`;
CREATE TABLE IF NOT EXISTS `#__ucm_content` (
`core_content_id` int(10) unsigned NOT NULL,
  `core_type_alias` varchar(255) NOT NULL DEFAULT '' COMMENT 'FK to the content types table',
  `core_title` varchar(255) NOT NULL,
  `core_alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `core_body` mediumtext NOT NULL,
  `core_state` tinyint(1) NOT NULL DEFAULT '0',
  `core_checked_out_time` varchar(255) NOT NULL DEFAULT '',
  `core_checked_out_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `core_access` int(10) unsigned NOT NULL DEFAULT '0',
  `core_params` text NOT NULL,
  `core_featured` tinyint(4) unsigned NOT NULL DEFAULT '0',
  `core_metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `core_created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `core_created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `core_created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `core_modified_user_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Most recent user that modified',
  `core_modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `core_language` char(7) NOT NULL,
  `core_publish_up` datetime NOT NULL,
  `core_publish_down` datetime NOT NULL,
  `core_content_item_id` int(10) unsigned DEFAULT NULL COMMENT 'ID from the individual type table',
  `asset_id` int(10) unsigned DEFAULT NULL COMMENT 'FK to the #___assets table.',
  `core_images` text NOT NULL,
  `core_urls` text NOT NULL,
  `core_hits` int(10) unsigned NOT NULL DEFAULT '0',
  `core_version` int(10) unsigned NOT NULL DEFAULT '1',
  `core_ordering` int(11) NOT NULL DEFAULT '0',
  `core_metakey` text NOT NULL,
  `core_metadesc` text NOT NULL,
  `core_catid` int(10) unsigned NOT NULL DEFAULT '0',
  `core_xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `core_type_id` int(10) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Contains core content data in name spaced fields';

DROP TABLE IF EXISTS `#__ucm_history`;
CREATE TABLE IF NOT EXISTS `#__ucm_history` (
`version_id` int(10) unsigned NOT NULL,
  `ucm_item_id` int(10) unsigned NOT NULL,
  `ucm_type_id` int(10) unsigned NOT NULL,
  `version_note` varchar(255) NOT NULL DEFAULT '' COMMENT 'Optional version name',
  `save_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `editor_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `character_count` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Number of characters in this version.',
  `sha1_hash` varchar(50) NOT NULL DEFAULT '' COMMENT 'SHA1 hash of the version_data column.',
  `version_data` mediumtext NOT NULL COMMENT 'json-encoded string of version data',
  `keep_forever` tinyint(4) NOT NULL DEFAULT '0' COMMENT '0=auto delete; 1=keep'
) ENGINE=InnoDB AUTO_INCREMENT=232 DEFAULT CHARSET=utf8;

INSERT INTO `#__ucm_history` (`version_id`, `ucm_item_id`, `ucm_type_id`, `version_note`, `save_date`, `editor_user_id`, `character_count`, `sha1_hash`, `version_data`, `keep_forever`) VALUES
(5, 1, 1, '', '2014-07-28 13:20:56', 651, 2629, 'd5c6ce724a34154c988469cf7417a5ed7db9d2b5', '{"id":1,"asset_id":66,"title":"Article1","alias":"article1","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:20:56","created_by":"444","created_by_alias":"","modified":"","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-07-28 13:20:56","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(6, 2, 1, '', '2014-07-28 13:21:13', 651, 2629, '30fb293ce8fa59c65f70a2983d4c6f12213f6310', '{"id":2,"asset_id":67,"title":"Article2","alias":"article2","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:21:13","created_by":"444","created_by_alias":"","modified":"","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-07-28 13:21:13","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(7, 3, 1, '', '2014-07-28 13:21:34', 651, 2630, '158ff409c643e9a762193e86b2d44e9777a89393', '{"id":3,"asset_id":68,"title":"Article3","alias":"article3","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"10","created":"2014-07-28 13:21:34","created_by":"444","created_by_alias":"","modified":"","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-07-28 13:21:34","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(8, 4, 1, '', '2014-07-28 13:21:47', 651, 2630, '59cd6ff1dd5b750bcdd73316f24c6c76420706b9', '{"id":4,"asset_id":69,"title":"Article4","alias":"article4","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"10","created":"2014-07-28 13:21:47","created_by":"444","created_by_alias":"","modified":"","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-07-28 13:21:47","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(19, 14, 7, '', '2014-07-28 13:29:17', 651, 540, 'b947f1537ead1fd4629254646f47c31d589e5e31', '{"id":14,"asset_id":78,"parent_id":"1","lft":"25","rgt":26,"level":1,"path":null,"extension":"com_contact","title":"Contacts category I","alias":"contacts-category-i","note":"","description":"","published":"1","checked_out":null,"checked_out_time":null,"access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"444","created_time":"2014-07-28 13:29:17","modified_user_id":null,"modified_time":null,"hits":"0","language":"*","version":null}', 0),
(23, 11, 1, '', '2014-07-28 14:19:45', 651, 1658, '5cf935f9d5412accc99a9416af8a6ec182ac44fe', '{"id":11,"asset_id":79,"title":"Archived Article I","alias":"archived-article-i","introtext":"","fulltext":"","state":1,"catid":"2","created":"2014-07-28 14:19:45","created_by":"444","created_by_alias":"","modified":"","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-07-28 14:19:45","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(24, 11, 1, '', '2014-07-28 14:20:09', 651, 2688, '7a78e0d603dde9ed0f53dc5babbe56afd4524875', '{"id":11,"asset_id":"79","title":"Archived Article I","alias":"archived-article-i","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"2","created":"2014-07-28 14:19:45","created_by":"444","created_by_alias":"","modified":"2014-07-28 14:20:09","modified_by":"444","checked_out":"444","checked_out_time":"2014-07-28 14:19:45","publish_up":"2014-07-28 14:19:45","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":2,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(25, 12, 1, '', '2014-07-28 14:20:13', 651, 2656, '19574bfb67e666d348cbf00d811c8327d9eb6e0e', '{"id":12,"asset_id":80,"title":"Archived Article I (2)","alias":"archived-article-i-2","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":0,"catid":"2","created":"2014-07-28 14:19:45","created_by":"444","created_by_alias":"","modified":"2014-07-28 14:20:09","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-07-28 14:19:45","publish_down":"","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(26, 12, 1, '', '2014-07-28 14:20:27', 651, 2671, '0260b6e62607f04f9c6fa8f8a3a6f0bc77fbb40f', '{"id":12,"asset_id":"80","title":"Archived Article II","alias":"archived-article-ii","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":0,"catid":"2","created":"2014-07-28 14:19:45","created_by":"444","created_by_alias":"","modified":"2014-07-28 14:20:27","modified_by":"444","checked_out":"444","checked_out_time":"2014-07-28 14:20:13","publish_up":"2014-07-28 14:19:45","publish_down":"","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":2,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(27, 12, 1, '', '2014-07-28 14:20:34', 651, 2690, 'baba4033c6fa1f7c13e38f5c8858499f30f10d63', '{"id":12,"asset_id":"80","title":"Archived Article II","alias":"archived-article-ii","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"2","created":"2014-07-28 14:19:45","created_by":"444","created_by_alias":"","modified":"2014-07-28 14:20:34","modified_by":"444","checked_out":"444","checked_out_time":"2014-07-28 14:20:27","publish_up":"2014-07-28 14:19:45","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":3,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(28, 13, 1, '', '2014-07-28 14:20:37', 651, 2658, '90e141963b50544cb07a995c9e19124f59f04f7b', '{"id":13,"asset_id":81,"title":"Archived Article II (2)","alias":"archived-article-ii-2","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":0,"catid":"2","created":"2014-07-28 14:19:45","created_by":"444","created_by_alias":"","modified":"2014-07-28 14:20:34","modified_by":null,"checked_out":null,"checked_out_time":null,"publish_up":"2014-07-28 14:19:45","publish_down":"","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":1,"ordering":null,"metakey":"","metadesc":"","access":"1","hits":null,"metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(29, 13, 1, '', '2014-07-28 14:21:08', 651, 2692, '1c2534f56f14f4fa508f8084d5cbba62f3dc8705', '{"id":13,"asset_id":"81","title":"Archived Article III","alias":"archived-article-iii","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"2","created":"2014-07-28 14:19:45","created_by":"444","created_by_alias":"","modified":"2014-07-28 14:21:08","modified_by":"444","checked_out":"444","checked_out_time":"2014-07-28 14:20:56","publish_up":"2014-07-28 14:19:45","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":2,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(43, 3, 1, '', '2014-08-04 20:40:16', 651, 2667, '25548025812db7a7f825bc0e749461c8aefaf8e1', '{"id":3,"asset_id":"68","title":"Article3","alias":"article3","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:21:34","created_by":"444","created_by_alias":"","modified":"2014-08-04 20:40:16","modified_by":"444","checked_out":"444","checked_out_time":"2014-08-04 20:40:12","publish_up":"2014-07-28 13:21:34","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":2,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(44, 4, 1, '', '2014-08-04 20:40:25', 651, 2667, '635df629b5a0289164c5cdee9afc7026b36cceb0', '{"id":4,"asset_id":"69","title":"Article4","alias":"article4","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:21:47","created_by":"444","created_by_alias":"","modified":"2014-08-04 20:40:25","modified_by":"444","checked_out":"444","checked_out_time":"2014-08-04 20:40:20","publish_up":"2014-07-28 13:21:47","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":2,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(48, 21, 1, '', '2014-08-04 20:40:40', 651, 2668, 'e8662566d483f26bb88bec9cf24f71f85d1342a1', '{"id":21,"asset_id":90,"title":"Article1","alias":"article1","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":"1","catid":10,"created":"2014-07-28 13:20:56","created_by":"444","created_by_alias":"","modified":"2014-07-28 13:21:00","modified_by":"444","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-07-28 13:20:56","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"2","ordering":"1","metakey":"","metadesc":"","access":"1","hits":"16","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"1","language":"*","xreference":""}', 0),
(49, 21, 1, '', '2014-08-04 20:40:57', 651, 2670, '080e0ed74352dcfd4e6c2a2a72fcfb6a392b9f2c', '{"id":21,"asset_id":"90","title":"Article5","alias":"article5","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"10","created":"2014-07-28 13:20:56","created_by":"444","created_by_alias":"","modified":"2014-08-04 20:40:57","modified_by":"444","checked_out":"444","checked_out_time":"2014-08-04 20:40:47","publish_up":"2014-07-28 13:20:56","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":3,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"16","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"1","language":"*","xreference":""}', 0),
(54, 1, 1, '', '2014-08-22 12:20:45', 651, 2796, 'a6afcdd3884751901229ec5b669ddd441cd0b896', '{"id":1,"asset_id":"66","title":"Article1","alias":"article1","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:20:56","created_by":"444","created_by_alias":"","modified":"2014-08-22 12:20:45","modified_by":"444","checked_out":"444","checked_out_time":"2014-08-22 12:20:24","publish_up":"2014-07-28 13:20:56","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/techjungle\\\\\\/articles\\\\\\/the_best_laptop_for_2014.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/techjungle\\\\\\/articles\\\\\\/the_best_laptop_for_2014.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":3,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"34","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"1","language":"*","xreference":""}', 0);
INSERT INTO `#__ucm_history` (`version_id`, `ucm_item_id`, `ucm_type_id`, `version_note`, `save_date`, `editor_user_id`, `character_count`, `sha1_hash`, `version_data`, `keep_forever`) VALUES
(55, 1, 1, '', '2014-08-22 12:24:17', 651, 2851, 'e5e4f45a9ecd7a0774280197047a4886c8de2a2c', '{"id":1,"asset_id":"66","title":"A gaming laptop more powerful than desktops","alias":"a-gaming-laptop-more-powerful-than-desktops","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:20:56","created_by":"444","created_by_alias":"","modified":"2014-08-22 12:24:17","modified_by":"444","checked_out":"444","checked_out_time":"2014-08-22 12:20:45","publish_up":"2014-07-28 13:20:56","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/techjungle\\\\\\/articles\\\\\\/article01.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/techjungle\\\\\\/articles\\\\\\/the_best_laptop_for_2014.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":4,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"35","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"1","language":"*","xreference":""}', 0),
(56, 2, 1, '', '2014-08-22 12:25:31', 651, 2798, '1f94416d1db7ef2340168f238df8fa18ed42d922', '{"id":2,"asset_id":"67","title":"THE BEST LAPTOP FOR 2014","alias":"the-best-laptop-for-2014","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:21:13","created_by":"444","created_by_alias":"","modified":"2014-08-22 12:25:31","modified_by":"444","checked_out":"444","checked_out_time":"2014-08-22 12:24:37","publish_up":"2014-07-28 13:21:13","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/techjungle\\\\\\/articles\\\\\\/article02.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/techjungle\\\\\\/articles\\\\\\/article02.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":3,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"15","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"1","language":"*","xreference":""}', 0),
(57, 3, 1, '', '2014-08-22 12:26:44', 651, 2817, '947c770b4e6f1530f37cae9d51ec38b92760c0f5', '{"id":3,"asset_id":"68","title":"A business tablet to replace books","alias":"a-business-tablet-to-replace-books","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:21:34","created_by":"444","created_by_alias":"","modified":"2014-08-22 12:26:44","modified_by":"444","checked_out":"444","checked_out_time":"2014-08-22 12:26:04","publish_up":"2014-07-28 13:21:34","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/techjungle\\\\\\/articles\\\\\\/article03.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/techjungle\\\\\\/articles\\\\\\/article03.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":3,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"2","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(58, 2, 1, '', '2014-08-22 12:27:22', 651, 2798, 'b64fb93ce1098fe74aee718bde21221ee29a07cd', '{"id":2,"asset_id":"67","title":"The best laptop for 2014","alias":"the-best-laptop-for-2014","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:21:13","created_by":"444","created_by_alias":"","modified":"2014-08-22 12:27:22","modified_by":"444","checked_out":"444","checked_out_time":"2014-08-22 12:27:15","publish_up":"2014-07-28 13:21:13","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/techjungle\\\\\\/articles\\\\\\/article02.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/techjungle\\\\\\/articles\\\\\\/article02.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":6,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"15","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"1","language":"*","xreference":""}', 0),
(59, 4, 1, '', '2014-08-22 12:28:37', 651, 2855, 'cdc8e980d768899a0a9708972b8149a5d8e36866', '{"id":4,"asset_id":"69","title":"A cheap and smart way to communicate in public places","alias":"a-cheap-and-smart-way-to-communicate-in-public-places","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:21:47","created_by":"444","created_by_alias":"","modified":"2014-08-22 12:28:37","modified_by":"444","checked_out":"444","checked_out_time":"2014-08-22 12:27:54","publish_up":"2014-07-28 13:21:47","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/techjungle\\\\\\/articles\\\\\\/article04.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/techjungle\\\\\\/articles\\\\\\/article04.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":3,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"0","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(60, 21, 1, '', '2014-08-22 12:31:41', 651, 2810, 'fab0121bd567849f656123c22314717f4b2b08d5', '{"id":21,"asset_id":"90","title":"Speed boost and image quality","alias":"speed-boost-and-image-quality","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"10","created":"2014-07-28 13:20:56","created_by":"444","created_by_alias":"","modified":"2014-08-22 12:31:41","modified_by":"444","checked_out":"444","checked_out_time":"2014-08-22 12:30:52","publish_up":"2014-07-28 13:20:56","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/techjungle\\\\\\/articles\\\\\\/article05.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/techjungle\\\\\\/articles\\\\\\/article05.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":4,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"17","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"1","language":"*","xreference":""}', 0),
(64, 1, 1, '', '2014-08-22 12:35:06', 651, 2836, '8730bf7188b5588d267f5a3fa5b55cc07b04ce33', '{"id":1,"asset_id":"66","title":"A gaming laptop more powerful than desktops","alias":"a-gaming-laptop-more-powerful-than-desktops","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:20:56","created_by":"444","created_by_alias":"","modified":"2014-08-22 12:35:06","modified_by":"444","checked_out":"444","checked_out_time":"2014-08-22 12:34:41","publish_up":"2014-07-28 13:20:56","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/techjungle\\\\\\/articles\\\\\\/article01.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/techjungle\\\\\\/articles\\\\\\/article01.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":5,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"38","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"1","language":"*","xreference":""}', 0),
(67, 1, 3, '', '2014-08-22 15:51:30', 651, 1876, 'a3a0dff3cc43c798b3ebe1229ae6fb9bf93337ad', '{"id":1,"name":"John Doe","alias":"john-doe","con_position":"","address":"2411 Any Street","suburb":"Any Town","state":"","country":"United Kingdom","postcode":"","telephone":"Q+123 456 7890","fax":"fax","misc":"If you have any enquiry then you may simply get in touch<br>\\r\\nand we will get back to you as soon as possible ","image":"images\\/techjungle\\/contact\\/contact.jpg","email_to":"info@youremail.you","default_con":0,"published":"1","checked_out":"444","checked_out_time":"2014-08-22 15:51:19","ordering":"1","params":"{\\"show_contact_category\\":\\"\\",\\"show_contact_list\\":\\"\\",\\"presentation_style\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_name\\":\\"\\",\\"show_position\\":\\"\\",\\"show_email\\":\\"\\",\\"show_street_address\\":\\"\\",\\"show_suburb\\":\\"\\",\\"show_state\\":\\"\\",\\"show_postcode\\":\\"\\",\\"show_country\\":\\"\\",\\"show_telephone\\":\\"\\",\\"show_mobile\\":\\"\\",\\"show_fax\\":\\"\\",\\"show_webpage\\":\\"\\",\\"show_misc\\":\\"\\",\\"show_image\\":\\"\\",\\"allow_vcard\\":\\"\\",\\"show_articles\\":\\"\\",\\"show_profile\\":\\"\\",\\"show_links\\":\\"\\",\\"linka_name\\":\\"\\",\\"linka\\":false,\\"linkb_name\\":\\"\\",\\"linkb\\":false,\\"linkc_name\\":\\"\\",\\"linkc\\":false,\\"linkd_name\\":\\"\\",\\"linkd\\":false,\\"linke_name\\":\\"\\",\\"linke\\":\\"\\",\\"contact_layout\\":\\"\\",\\"show_email_form\\":\\"\\",\\"show_email_copy\\":\\"\\",\\"banned_email\\":\\"\\",\\"banned_subject\\":\\"\\",\\"banned_text\\":\\"\\",\\"validate_session\\":\\"\\",\\"custom_reply\\":\\"\\",\\"redirect\\":\\"\\"}","user_id":"445","catid":"14","access":"1","mobile":"Q+999 456 7890","webpage":"","sortname1":"","sortname2":"","sortname3":"","language":"*","created":"2014-07-28 13:30:42","created_by":"444","created_by_alias":"","modified":"2014-08-22 15:51:30","modified_by":"444","metakey":"","metadesc":"","metadata":"{\\"robots\\":\\"\\",\\"rights\\":\\"\\"}","featured":"1","xreference":"","publish_up":"0000-00-00 00:00:00","publish_down":"0000-00-00 00:00:00","version":9,"hits":"42"}', 0),
(72, 21, 1, '', '2014-08-25 16:10:47', 651, 2818, 'f30b5862f7a327157dcae4077d76c126dea9ca86', '{"id":21,"asset_id":"90","title":"Speed boost and image quality","alias":"speed-boost-and-image-quality","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"10","created":"2014-07-28 13:20:56","created_by":"444","created_by_alias":"","modified":"2014-08-25 16:10:47","modified_by":"445","checked_out":"445","checked_out_time":"2014-08-25 16:10:18","publish_up":"2014-07-28 13:20:56","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/techjungle\\\\\\/articles\\\\\\/minitek_water.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/techjungle\\\\\\/articles\\\\\\/minitek_water.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":5,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"17","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"1","language":"*","xreference":""}', 0),
(76, 4, 1, '', '2014-08-25 16:14:17', 651, 2863, '3ed4562ea37f908fa5a8e4ed05df1ecce85e23d2', '{"id":4,"asset_id":"69","title":"A cheap and smart way to communicate in public places","alias":"a-cheap-and-smart-way-to-communicate-in-public-places","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:21:47","created_by":"444","created_by_alias":"","modified":"2014-08-25 16:14:17","modified_by":"445","checked_out":"445","checked_out_time":"2014-08-25 16:13:56","publish_up":"2014-07-28 13:21:47","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/techjungle\\\\\\/articles\\\\\\/minitek_water.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/techjungle\\\\\\/articles\\\\\\/minitek_water.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":4,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"1","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(77, 3, 1, '', '2014-08-25 16:14:32', 651, 2825, 'f230c7517f1f978c468820bcd79bf3900ab28ab3', '{"id":3,"asset_id":"68","title":"A business tablet to replace books","alias":"a-business-tablet-to-replace-books","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:21:34","created_by":"444","created_by_alias":"","modified":"2014-08-25 16:14:32","modified_by":"445","checked_out":"445","checked_out_time":"2014-08-25 16:13:58","publish_up":"2014-07-28 13:21:34","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/techjungle\\\\\\/articles\\\\\\/minitek_water.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/techjungle\\\\\\/articles\\\\\\/minitek_water.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":5,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"4","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(78, 2, 1, '', '2014-08-25 16:14:48', 651, 2806, 'd5e37403604f0f08140bd5f76652c3cd0da58c10', '{"id":2,"asset_id":"67","title":"The best laptop for 2014","alias":"the-best-laptop-for-2014","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:21:13","created_by":"444","created_by_alias":"","modified":"2014-08-25 16:14:48","modified_by":"445","checked_out":"445","checked_out_time":"2014-08-25 16:13:59","publish_up":"2014-07-28 13:21:13","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/techjungle\\\\\\/articles\\\\\\/minitek_water.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/techjungle\\\\\\/articles\\\\\\/minitek_water.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":7,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"19","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"1","language":"*","xreference":""}', 0),
(79, 1, 1, '', '2014-08-25 16:15:03', 651, 2844, '56d760c11835f3d5a6c4161b0616ca66c50a3283', '{"id":1,"asset_id":"66","title":"A gaming laptop more powerful than desktops","alias":"a-gaming-laptop-more-powerful-than-desktops","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:20:56","created_by":"444","created_by_alias":"","modified":"2014-08-25 16:15:03","modified_by":"445","checked_out":"445","checked_out_time":"2014-08-25 16:14:00","publish_up":"2014-07-28 13:20:56","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/techjungle\\\\\\/articles\\\\\\/minitek_water.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/techjungle\\\\\\/articles\\\\\\/minitek_water.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":6,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"49","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"1","language":"*","xreference":""}', 0),
(112, 18, 6, '', '2014-09-12 12:39:43', 651, 839, '31c60805c3bffda44854f62a497e93b7df1ac7f5', '{"id":18,"asset_id":198,"parent_id":"1","lft":"33","rgt":34,"level":1,"path":null,"extension":"com_content","title":"Music Production","alias":"music-production","note":"","description":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.<\\/p>","published":"1","checked_out":null,"checked_out_time":null,"access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/categories\\\\\\/music production.jpg\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"400","created_time":"2014-09-12 12:39:43","modified_user_id":null,"modified_time":null,"hits":"0","language":"*","version":null}', 0),
(113, 18, 6, '', '2014-09-12 12:39:57', 651, 891, '2ab610a2e0be79f07eff51eb76023db59efac8ff', '{"id":18,"asset_id":"198","parent_id":"17","lft":"32","rgt":33,"level":2,"path":"music-production","extension":"com_content","title":"Music Production","alias":"music-production","note":"","description":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.<\\/p>","published":"1","checked_out":"400","checked_out_time":"2014-09-12 12:39:43","access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/categories\\\\\\/music production.jpg\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"400","created_time":"2014-09-12 12:39:43","modified_user_id":"400","modified_time":"2014-09-12 12:39:57","hits":"0","language":"*","version":"1"}', 0),
(115, 18, 6, '', '2014-09-14 19:01:16', 651, 903, 'a4629f93b7316d056e52ace92853f449c6fed2a8', '{"id":18,"asset_id":"198","parent_id":"17","lft":"32","rgt":"33","level":"2","path":"magazine\\/music-production","extension":"com_content","title":"Event Managment","alias":"event-managment","note":"","description":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.<\\/p>","published":"1","checked_out":"400","checked_out_time":"2014-09-14 19:00:56","access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/categories\\\\\\/music production.jpg\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"400","created_time":"2014-09-12 12:39:43","modified_user_id":"400","modified_time":"2014-09-14 19:01:16","hits":"0","language":"*","version":"1"}', 0),
(116, 19, 6, '', '2014-09-14 19:01:40', 651, 553, 'edadb5409c540ab135b193490cd20a38f8b86802', '{"id":19,"asset_id":200,"parent_id":"1","lft":"35","rgt":36,"level":1,"path":null,"extension":"com_content","title":"Video AndMusic Production","alias":"video-andmusic-production","note":"","description":"","published":"1","checked_out":null,"checked_out_time":null,"access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"400","created_time":"2014-09-14 19:01:40","modified_user_id":null,"modified_time":null,"hits":"0","language":"*","version":null}', 0),
(117, 19, 6, '', '2014-09-14 19:02:02', 651, 854, '7978167d6f2781a3480dcf2ee43991c336aa5a9e', '{"id":19,"asset_id":"200","parent_id":"17","lft":"34","rgt":35,"level":2,"path":"video-andmusic-production","extension":"com_content","title":"Video AndMusic Production","alias":"video-andmusic-production","note":"","description":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.<\\/p>","published":"1","checked_out":"400","checked_out_time":"2014-09-14 19:01:53","access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"400","created_time":"2014-09-14 19:01:40","modified_user_id":"400","modified_time":"2014-09-14 19:02:02","hits":"0","language":"*","version":"1"}', 0),
(120, 21, 1, '', '2014-09-14 19:07:18', 651, 2874, 'cc422945a7df4406b7b6dbf088eca10200b3e1f0', '{"id":21,"asset_id":"90","title":"A Modern Sound Approach","alias":"a-modern-sound-approach","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"10","created":"2014-07-28 13:20:56","created_by":"400","created_by_alias":"","modified":"2014-09-14 19:07:18","modified_by":"400","checked_out":"400","checked_out_time":"2014-09-14 19:04:38","publish_up":"2014-07-28 13:20:56","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/magazine\\\\\\/audio_solution\\\\\\/A-Modern-Sound-Approach.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/magazine\\\\\\/audio_solution\\\\\\/A-Modern-Sound-Approach.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":6,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"18","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0);
INSERT INTO `#__ucm_history` (`version_id`, `ucm_item_id`, `ucm_type_id`, `version_note`, `save_date`, `editor_user_id`, `character_count`, `sha1_hash`, `version_data`, `keep_forever`) VALUES
(122, 33, 1, '', '2014-09-14 19:08:25', 651, 2879, '1e9dc59ed4eee981cade07d318a598a5f2ad8824', '{"id":33,"asset_id":203,"title":"A Modern Sound Approach (2)","alias":"a-modern-sound-approach-2","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":"1","catid":10,"created":"2014-07-28 13:20:56","created_by":"400","created_by_alias":"","modified":"2014-09-14 19:07:23","modified_by":"400","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-07-28 13:20:56","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/magazine\\\\\\/audio_solution\\\\\\/A-Modern-Sound-Approach.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/magazine\\\\\\/audio_solution\\\\\\/A-Modern-Sound-Approach.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"7","ordering":"1","metakey":"","metadesc":"","access":"1","hits":"18","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(123, 34, 1, '', '2014-09-14 19:08:25', 651, 2863, '68b4c3dd23c8238f2ea3641f042a8e8c47a6b4cf', '{"id":34,"asset_id":204,"title":"Colors and Melodies (2)","alias":"colors-and-melodies-2","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":"1","catid":10,"created":"2014-07-28 13:21:13","created_by":"400","created_by_alias":"","modified":"2014-09-14 19:08:15","modified_by":"400","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-07-28 13:21:13","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/magazine\\\\\\/audio_solution\\\\\\/Colors-and-Melodies.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/magazine\\\\\\/audio_solution\\\\\\/Colors-and-Melodies.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"7","ordering":"0","metakey":"","metadesc":"","access":"1","hits":"12","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(124, 33, 1, '', '2014-09-14 19:09:25', 651, 2847, '5c6b771816fe268e9821637af2e0f5204e51d40b', '{"id":33,"asset_id":"203","title":"Old School Audio","alias":"old-school-audio","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"10","created":"2014-07-28 13:20:56","created_by":"400","created_by_alias":"","modified":"2014-09-14 19:09:25","modified_by":"400","checked_out":"400","checked_out_time":"2014-09-14 19:08:30","publish_up":"2014-07-28 13:20:56","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/magazine\\\\\\/audio_solution\\\\\\/Old-School-Audio.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/magazine\\\\\\/audio_solution\\\\\\/Old-School-Audio.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":8,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"18","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(125, 34, 1, '', '2014-09-14 19:09:46', 651, 2855, '6b48cddb524a06228160d7a1ebf03ce5b757dfc7', '{"id":34,"asset_id":"204","title":"the Mysterious Man","alias":"the-mysterious-man","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"10","created":"2014-07-28 13:21:13","created_by":"400","created_by_alias":"","modified":"2014-09-14 19:09:46","modified_by":"400","checked_out":"400","checked_out_time":"2014-09-14 19:09:31","publish_up":"2014-07-28 13:21:13","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/magazine\\\\\\/audio_solution\\\\\\/the-Mysterious-Man.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/magazine\\\\\\/audio_solution\\\\\\/the-Mysterious-Man.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":8,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"12","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(128, 18, 6, '', '2014-09-14 22:03:38', 651, 897, '491e71bb0bb7da4661121c29530f88e2282dd197', '{"id":"18","asset_id":"198","parent_id":"8","lft":"22","rgt":23,"level":2,"path":"magazine\\/event-managment","extension":"com_content","title":"Event Managment","alias":"event-managment","note":"","description":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.<\\/p>","published":"1","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/categories\\\\\\/music production.jpg\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"400","created_time":"2014-09-12 12:39:43","modified_user_id":"400","modified_time":"2014-09-14 22:03:38","hits":"0","language":"*","version":"1"}', 0),
(129, 19, 6, '', '2014-09-14 22:03:38', 651, 863, 'a27c8cd37bfb33b40f53456fb20e5ebb2b8f278b', '{"id":"19","asset_id":"200","parent_id":"8","lft":"24","rgt":25,"level":2,"path":"magazine\\/video-andmusic-production","extension":"com_content","title":"Video AndMusic Production","alias":"video-andmusic-production","note":"","description":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.<\\/p>","published":"1","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"400","created_time":"2014-09-14 19:01:40","modified_user_id":"400","modified_time":"2014-09-14 22:03:38","hits":"0","language":"*","version":"1"}', 0),
(133, 1, 3, '', '2014-09-16 14:01:08', 651, 1871, '7029d5e2f0d54289c06f0ce33a43dd0c936fee05', '{"id":1,"name":"John Doe","alias":"john-doe","con_position":"","address":"2411 Any Street","suburb":"Any Town","state":"","country":"United Kingdom","postcode":"","telephone":"Q+123 456 7890","fax":"fax","misc":"If you have any enquiry then you may simply get in touch<br>\\r\\nand we will get back to you as soon as possible ","image":"images\\/echo\\/contact\\/contact.jpg","email_to":"info@youremail.you","default_con":0,"published":"1","checked_out":"400","checked_out_time":"2014-09-16 13:59:55","ordering":"1","params":"{\\"show_contact_category\\":\\"\\",\\"show_contact_list\\":\\"\\",\\"presentation_style\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_name\\":\\"\\",\\"show_position\\":\\"\\",\\"show_email\\":\\"\\",\\"show_street_address\\":\\"\\",\\"show_suburb\\":\\"\\",\\"show_state\\":\\"\\",\\"show_postcode\\":\\"\\",\\"show_country\\":\\"\\",\\"show_telephone\\":\\"\\",\\"show_mobile\\":\\"\\",\\"show_fax\\":\\"\\",\\"show_webpage\\":\\"\\",\\"show_misc\\":\\"\\",\\"show_image\\":\\"\\",\\"allow_vcard\\":\\"\\",\\"show_articles\\":\\"\\",\\"show_profile\\":\\"\\",\\"show_links\\":\\"\\",\\"linka_name\\":\\"\\",\\"linka\\":false,\\"linkb_name\\":\\"\\",\\"linkb\\":false,\\"linkc_name\\":\\"\\",\\"linkc\\":false,\\"linkd_name\\":\\"\\",\\"linkd\\":false,\\"linke_name\\":\\"\\",\\"linke\\":\\"\\",\\"contact_layout\\":\\"\\",\\"show_email_form\\":\\"\\",\\"show_email_copy\\":\\"\\",\\"banned_email\\":\\"\\",\\"banned_subject\\":\\"\\",\\"banned_text\\":\\"\\",\\"validate_session\\":\\"\\",\\"custom_reply\\":\\"\\",\\"redirect\\":\\"\\"}","user_id":"445","catid":"14","access":"1","mobile":"Q+999 456 7890","webpage":"","sortname1":"","sortname2":"","sortname3":"","language":"*","created":"2014-07-28 13:30:42","created_by":"400","created_by_alias":"","modified":"2014-09-16 14:01:08","modified_by":"400","metakey":"","metadesc":"","metadata":"{\\"robots\\":\\"\\",\\"rights\\":\\"\\"}","featured":"1","xreference":"","publish_up":"0000-00-00 00:00:00","publish_down":"0000-00-00 00:00:00","version":10,"hits":"96"}', 0),
(134, 4, 1, '', '2014-09-16 17:54:46', 651, 2885, '99022319a55e4b83cf79e6c42ce8bbdd5fe7695a', '{"id":4,"asset_id":"69","title":"City Photography and Direction","alias":"city-photography-and-direction","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:21:47","created_by":"400","created_by_alias":"","modified":"2014-09-16 17:54:46","modified_by":"400","checked_out":"400","checked_out_time":"2014-09-16 17:54:12","publish_up":"2014-07-28 13:21:47","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/City-Photography-and-Direction.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/City-Photography-and-Direction.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":5,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"1","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(135, 3, 1, '', '2014-09-16 17:55:20', 651, 2833, 'dd568e8288e0f9df9061847bd082ba29729f43c1', '{"id":3,"asset_id":"68","title":"Eastern Reverence","alias":"eastern-reverence","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:21:34","created_by":"400","created_by_alias":"","modified":"2014-09-16 17:55:20","modified_by":"400","checked_out":"400","checked_out_time":"2014-09-16 17:54:52","publish_up":"2014-07-28 13:21:34","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/Eastern-Reverence.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/Eastern-Reverence.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":6,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"4","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(136, 2, 1, '', '2014-09-16 17:55:52', 651, 2906, 'f2c8c1696c69a1571789ea45f19859104ae5f60f', '{"id":2,"asset_id":"67","title":"Make Your Red Backround Work Better","alias":"make-your-red-backround-work-better","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:21:13","created_by":"400","created_by_alias":"","modified":"2014-09-16 17:55:52","modified_by":"400","checked_out":"400","checked_out_time":"2014-09-16 17:55:25","publish_up":"2014-07-28 13:21:13","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/Make-Your-Red-Backround-Work-Better.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/Make-Your-Red-Backround-Work-Better.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":8,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"20","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"1","language":"*","xreference":""}', 0),
(137, 1, 1, '', '2014-09-16 17:57:00', 651, 2862, 'a3d0a515962f83a006dffea1fb9df6c3aec48545', '{"id":1,"asset_id":"66","title":"The Breathing Commercial","alias":"the-breathing-commercial","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:20:56","created_by":"400","created_by_alias":"","modified":"2014-09-16 17:57:00","modified_by":"400","checked_out":"400","checked_out_time":"2014-09-16 17:55:58","publish_up":"2014-07-28 13:20:56","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/the-Breathing-Commercial.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/the-Breathing-Commercial.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":7,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"53","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"1","language":"*","xreference":""}', 0),
(138, 35, 1, '', '2014-09-16 17:57:30', 651, 2891, '8c759126fd328c5660dbb3d6d3a238127defe4c8', '{"id":35,"asset_id":224,"title":"City Photography and Direction (2)","alias":"city-photography-and-direction-2","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":"1","catid":9,"created":"2014-07-28 13:21:47","created_by":"400","created_by_alias":"","modified":"2014-09-16 17:54:50","modified_by":"400","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-07-28 13:21:47","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/City-Photography-and-Direction.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/City-Photography-and-Direction.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"6","ordering":"0","metakey":"","metadesc":"","access":"1","hits":"1","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(139, 36, 1, '', '2014-09-16 17:57:30', 651, 2839, 'b8ab1241b14e2eb5accd43dd4110d81e034862c0', '{"id":36,"asset_id":225,"title":"Eastern Reverence (2)","alias":"eastern-reverence-2","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":"1","catid":9,"created":"2014-07-28 13:21:34","created_by":"400","created_by_alias":"","modified":"2014-09-16 17:55:22","modified_by":"400","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-07-28 13:21:34","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/Eastern-Reverence.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/Eastern-Reverence.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"7","ordering":"1","metakey":"","metadesc":"","access":"1","hits":"4","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(140, 36, 1, '', '2014-09-16 17:57:55', 651, 2839, '16bdc063fae5489f4ee1549064d91fc90ebaf881', '{"id":36,"asset_id":"225","title":"University Luggage","alias":"university-luggage","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:21:34","created_by":"400","created_by_alias":"","modified":"2014-09-16 17:57:55","modified_by":"400","checked_out":"400","checked_out_time":"2014-09-16 17:57:34","publish_up":"2014-07-28 13:21:34","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/University-Luggage.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/University-Luggage.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":8,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"4","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(141, 35, 1, '', '2014-09-16 17:58:21', 651, 2927, 'ce895bd77c24b455da792715ad7e5a11ea523f66', '{"id":35,"asset_id":"224","title":"Why This Commercial Became so Successful","alias":"why-this-commercial-became-so-successful","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:21:47","created_by":"400","created_by_alias":"","modified":"2014-09-16 17:58:21","modified_by":"400","checked_out":"400","checked_out_time":"2014-09-16 17:58:00","publish_up":"2014-07-28 13:21:47","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/Why-This-Commercial-Became-so-Successful.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/Why-This-Commercial-Became-so-Successful.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":7,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"1","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(142, 37, 1, '', '2014-09-16 17:59:47', 651, 2853, '7928283d3c74e16eb6c4f82471ca6c0773539a40', '{"id":37,"asset_id":226,"title":"the Mysterious Man","alias":"the-mysterious-man","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":"1","catid":18,"created":"2014-07-28 13:21:13","created_by":"400","created_by_alias":"","modified":"2014-09-14 19:10:08","modified_by":"400","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-07-28 13:21:13","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/magazine\\\\\\/audio_solution\\\\\\/the-Mysterious-Man.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/magazine\\\\\\/audio_solution\\\\\\/the-Mysterious-Man.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"9","ordering":"0","metakey":"","metadesc":"","access":"1","hits":"12","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(143, 38, 1, '', '2014-09-16 17:59:47', 651, 2845, '57f176620349bb5f300710e03dc39fedba4cac55', '{"id":38,"asset_id":227,"title":"Old School Audio","alias":"old-school-audio","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":"1","catid":18,"created":"2014-07-28 13:20:56","created_by":"400","created_by_alias":"","modified":"2014-09-14 19:09:29","modified_by":"400","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-07-28 13:20:56","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/magazine\\\\\\/audio_solution\\\\\\/Old-School-Audio.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/magazine\\\\\\/audio_solution\\\\\\/Old-School-Audio.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"9","ordering":"1","metakey":"","metadesc":"","access":"1","hits":"18","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0);
INSERT INTO `#__ucm_history` (`version_id`, `ucm_item_id`, `ucm_type_id`, `version_note`, `save_date`, `editor_user_id`, `character_count`, `sha1_hash`, `version_data`, `keep_forever`) VALUES
(144, 39, 1, '', '2014-09-16 17:59:47', 651, 2873, 'd3c67d651bb4ca7895602e0fa350d5ec54d9f540', '{"id":39,"asset_id":228,"title":"A Modern Sound Approach","alias":"a-modern-sound-approach","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":"1","catid":18,"created":"2014-07-28 13:20:56","created_by":"400","created_by_alias":"","modified":"2014-09-14 19:07:23","modified_by":"400","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-07-28 13:20:56","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/magazine\\\\\\/audio_solution\\\\\\/A-Modern-Sound-Approach.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/magazine\\\\\\/audio_solution\\\\\\/A-Modern-Sound-Approach.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"7","ordering":"1","metakey":"","metadesc":"","access":"1","hits":"19","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(145, 40, 1, '', '2014-09-16 17:59:47', 651, 2857, '78b8465440a3ac14f72c72d21c874ea855bab9c3', '{"id":40,"asset_id":229,"title":"Colors and Melodies","alias":"colors-and-melodies","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":"1","catid":18,"created":"2014-07-28 13:21:13","created_by":"400","created_by_alias":"","modified":"2014-09-14 19:08:15","modified_by":"400","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-07-28 13:21:13","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/magazine\\\\\\/audio_solution\\\\\\/Colors-and-Melodies.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/magazine\\\\\\/audio_solution\\\\\\/Colors-and-Melodies.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"7","ordering":"0","metakey":"","metadesc":"","access":"1","hits":"13","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(146, 40, 1, '', '2014-09-16 18:03:52', 651, 2877, '0d95f14328ad172f6a0d6dd6eb9b79fbd3ba9711', '{"id":40,"asset_id":"229","title":"Communication is Always Important","alias":"colors-and-melodies","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"18","created":"2014-07-28 13:21:13","created_by":"400","created_by_alias":"","modified":"2014-09-16 18:03:52","modified_by":"400","checked_out":"400","checked_out_time":"2014-09-16 18:01:27","publish_up":"2014-07-28 13:21:13","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/eventmanagment\\\\\\/Communication-is-Always-Important.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/eventmanagment\\\\\\/Communication-is-Always-Important.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":8,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"13","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(147, 39, 1, '', '2014-09-16 18:04:24', 651, 2875, '22bd151041405a882779807e2db63609e01fff38', '{"id":39,"asset_id":"228","title":"Creating an Even t Experience","alias":"creating-an-even-t-experience","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"18","created":"2014-07-28 13:20:56","created_by":"400","created_by_alias":"","modified":"2014-09-16 18:04:24","modified_by":"400","checked_out":"400","checked_out_time":"2014-09-16 18:03:58","publish_up":"2014-07-28 13:20:56","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/eventmanagment\\\\\\/Creating-an-Even-t-Experience.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/eventmanagment\\\\\\/Creating-an-Even-t-Experience.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":8,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"19","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(148, 38, 1, '', '2014-09-16 18:04:54', 651, 2860, 'e34265a7cfb8b9a99fb56c1a1392c2d4a9f974e8', '{"id":38,"asset_id":"227","title":"Managing the Next Success","alias":"managing-the-next-success","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"18","created":"2014-07-28 13:20:56","created_by":"400","created_by_alias":"","modified":"2014-09-16 18:04:54","modified_by":"400","checked_out":"400","checked_out_time":"2014-09-16 18:04:32","publish_up":"2014-07-28 13:20:56","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/eventmanagment\\\\\\/Managing-the-Next-Success.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/eventmanagment\\\\\\/Managing-the-Next-Success.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":10,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"18","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(149, 37, 1, '', '2014-09-16 18:05:27', 651, 2864, '466c6554a20cdb38e16e27283a297253f24c3cd4', '{"id":37,"asset_id":"226","title":"the Amazing Balloons Event","alias":"the-amazing-balloons-event","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"18","created":"2014-07-28 13:21:13","created_by":"400","created_by_alias":"","modified":"2014-09-16 18:05:27","modified_by":"400","checked_out":"400","checked_out_time":"2014-09-16 18:05:06","publish_up":"2014-07-28 13:21:13","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/eventmanagment\\\\\\/the-Amazing-Balloons-Event.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/eventmanagment\\\\\\/the-Amazing-Balloons-Event.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":10,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"12","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(150, 41, 1, '', '2014-09-16 18:10:34', 651, 2838, 'decfca6cbb2af10da1a3b0e463bc27324677eb8c', '{"id":41,"asset_id":230,"title":"University Luggage","alias":"university-luggage","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":"1","catid":19,"created":"2014-07-28 13:21:34","created_by":"400","created_by_alias":"","modified":"2014-09-16 17:57:58","modified_by":"400","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-07-28 13:21:34","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/University-Luggage.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/University-Luggage.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"9","ordering":"1","metakey":"","metadesc":"","access":"1","hits":"4","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(151, 42, 1, '', '2014-09-16 18:10:34', 651, 2926, '379b9d0080738f570daa1aaa5eaaa9bc68c95755', '{"id":42,"asset_id":231,"title":"Why This Commercial Became so Successful","alias":"why-this-commercial-became-so-successful","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":"1","catid":19,"created":"2014-07-28 13:21:47","created_by":"400","created_by_alias":"","modified":"2014-09-16 17:58:24","modified_by":"400","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-07-28 13:21:47","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/Why-This-Commercial-Became-so-Successful.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/Why-This-Commercial-Became-so-Successful.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"8","ordering":"0","metakey":"","metadesc":"","access":"1","hits":"1","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(152, 43, 1, '', '2014-09-16 18:10:34', 651, 2886, '21f4045146a8a022407d67a44064d2f7e818d91d', '{"id":43,"asset_id":232,"title":"City Photography and Direction","alias":"city-photography-and-direction","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":"1","catid":19,"created":"2014-07-28 13:21:47","created_by":"400","created_by_alias":"","modified":"2014-09-16 17:54:50","modified_by":"400","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-07-28 13:21:47","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/City-Photography-and-Direction.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/City-Photography-and-Direction.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"6","ordering":"0","metakey":"","metadesc":"","access":"1","hits":"1","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(153, 44, 1, '', '2014-09-16 18:10:34', 651, 2834, 'd77d9efcf5cac0295839aeee48fec52579d9057a', '{"id":44,"asset_id":233,"title":"Eastern Reverence","alias":"eastern-reverence","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":"1","catid":19,"created":"2014-07-28 13:21:34","created_by":"400","created_by_alias":"","modified":"2014-09-16 17:55:22","modified_by":"400","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-07-28 13:21:34","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/Eastern-Reverence.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/Eastern-Reverence.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"7","ordering":"1","metakey":"","metadesc":"","access":"1","hits":"4","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(154, 45, 1, '', '2014-09-16 18:10:34', 651, 2907, '21d0f6da9e6318c2e4a5c0ec4f4c549222111e07', '{"id":45,"asset_id":234,"title":"Make Your Red Backround Work Better","alias":"make-your-red-backround-work-better","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":"1","catid":19,"created":"2014-07-28 13:21:13","created_by":"400","created_by_alias":"","modified":"2014-09-16 17:55:55","modified_by":"400","checked_out":"0","checked_out_time":"0000-00-00 00:00:00","publish_up":"2014-07-28 13:21:13","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/Make-Your-Red-Backround-Work-Better.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/Make-Your-Red-Backround-Work-Better.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":"9","ordering":"0","metakey":"","metadesc":"","access":"1","hits":"20","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"1","language":"*","xreference":""}', 0),
(157, 45, 1, '', '2014-09-16 18:11:35', 651, 2874, '26873ca2a01924d965d0c9ce64653125a7762448', '{"id":45,"asset_id":"234","title":"Flying On Cloudy Weather","alias":"flying-on-cloudy-weather","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"19","created":"2014-07-28 13:21:13","created_by":"400","created_by_alias":"","modified":"2014-09-16 18:11:35","modified_by":"400","checked_out":"400","checked_out_time":"2014-09-16 18:11:07","publish_up":"2014-07-28 13:21:13","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/videoandmusicproduction\\\\\\/Flying-On-Cloudy-Weather.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/videoandmusicproduction\\\\\\/Flying-On-Cloudy-Weather.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":10,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"20","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"1","language":"*","xreference":""}', 0),
(158, 44, 1, '', '2014-09-16 18:12:06', 651, 2848, '25c511cc04fd8b63fbe4c46c2ead23f704b7e2e5', '{"id":44,"asset_id":"233","title":"Lost in Music Land","alias":"lost-in-music-land","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"19","created":"2014-07-28 13:21:34","created_by":"400","created_by_alias":"","modified":"2014-09-16 18:12:06","modified_by":"400","checked_out":"400","checked_out_time":"2014-09-16 18:11:38","publish_up":"2014-07-28 13:21:34","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/videoandmusicproduction\\\\\\/Lost-in-Music-Land.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/videoandmusicproduction\\\\\\/Lost-in-Music-Land.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":8,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"4","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(159, 43, 1, '', '2014-09-16 18:12:39', 651, 2848, '00cec4bbb07bfae0e4e1648680065de0bb8a5a22', '{"id":43,"asset_id":"232","title":"The City in Motion","alias":"the-city-in-motion","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"19","created":"2014-07-28 13:21:47","created_by":"400","created_by_alias":"","modified":"2014-09-16 18:12:39","modified_by":"400","checked_out":"400","checked_out_time":"2014-09-16 18:12:15","publish_up":"2014-07-28 13:21:47","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/videoandmusicproduction\\\\\\/the-City-in-Motion.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/videoandmusicproduction\\\\\\/the-City-in-Motion.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":7,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"1","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(160, 42, 1, '', '2014-09-16 18:13:09', 651, 2876, '9461217c876edffd277877522584cbfddd60d140', '{"id":42,"asset_id":"231","title":"The Shipwreck Documentary","alias":"the-shipwreck-documentary","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"19","created":"2014-07-28 13:21:47","created_by":"400","created_by_alias":"","modified":"2014-09-16 18:13:09","modified_by":"400","checked_out":"400","checked_out_time":"2014-09-16 18:12:44","publish_up":"2014-07-28 13:21:47","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/videoandmusicproduction\\\\\\/the-Shipwreck-Documentary.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/videoandmusicproduction\\\\\\/the-Shipwreck-Documentary.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":9,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"1","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0);
INSERT INTO `#__ucm_history` (`version_id`, `ucm_item_id`, `ucm_type_id`, `version_note`, `save_date`, `editor_user_id`, `character_count`, `sha1_hash`, `version_data`, `keep_forever`) VALUES
(161, 41, 1, '', '2014-09-16 18:13:39', 651, 2909, '8da857d523c2f425cd4d4449dbee34d8ec18f7a3', '{"id":41,"asset_id":"230","title":"The Strange Formations Music Clip","alias":"the-strange-formations-music-clip","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"19","created":"2014-07-28 13:21:34","created_by":"400","created_by_alias":"","modified":"2014-09-16 18:13:39","modified_by":"400","checked_out":"400","checked_out_time":"2014-09-16 18:13:14","publish_up":"2014-07-28 13:21:34","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/videoandmusicproduction\\\\\\/the-Strange-Formations-Music-Clip.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/videoandmusicproduction\\\\\\/the-Strange-Formations-Music-Clip.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":10,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"4","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(163, 18, 6, '', '2014-09-17 13:41:16', 651, 903, '9190bba25a069774b1b979a67ac206c2752f465b', '{"id":18,"asset_id":"198","parent_id":"8","lft":"22","rgt":"23","level":"2","path":"articles\\/event-managment","extension":"com_content","title":"Event Management","alias":"event-management","note":"","description":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.<\\/p>","published":"1","checked_out":"400","checked_out_time":"2014-09-17 13:41:08","access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/categories\\\\\\/music production.jpg\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"400","created_time":"2014-09-12 12:39:43","modified_user_id":"400","modified_time":"2014-09-17 13:41:16","hits":"0","language":"*","version":"1"}', 0),
(164, 19, 6, '', '2014-09-17 13:41:24', 651, 868, '7d23d3dc21a963da448c7587da89f1a013fd0f36', '{"id":19,"asset_id":"200","parent_id":"8","lft":"24","rgt":"25","level":"2","path":"articles\\/video-andmusic-production","extension":"com_content","title":"Video And Music Production","alias":"video-andmusic-production","note":"","description":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.<\\/p>","published":"1","checked_out":"400","checked_out_time":"2014-09-17 13:41:19","access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"400","created_time":"2014-09-14 19:01:40","modified_user_id":"400","modified_time":"2014-09-17 13:41:24","hits":"0","language":"*","version":"1"}', 0),
(165, 19, 6, '', '2014-09-17 13:41:34', 651, 869, '03b73d6d5977dcb35926cdb7c2de7ac2f1835097', '{"id":19,"asset_id":"200","parent_id":"8","lft":"24","rgt":"25","level":"2","path":"articles\\/video-andmusic-production","extension":"com_content","title":"Video And Music Production","alias":"video-and-music-production","note":"","description":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.<\\/p>","published":"1","checked_out":"400","checked_out_time":"2014-09-17 13:41:27","access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"400","created_time":"2014-09-14 19:01:40","modified_user_id":"400","modified_time":"2014-09-17 13:41:34","hits":"0","language":"*","version":"1"}', 0),
(166, 39, 1, '', '2014-09-17 13:56:12', 651, 2874, '6b1f43727181a6ed2277fb8df257709484e9957c', '{"id":39,"asset_id":"228","title":"Creating an Event Experience","alias":"creating-an-event-experience","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"18","created":"2014-07-28 13:20:56","created_by":"400","created_by_alias":"","modified":"2014-09-17 13:56:12","modified_by":"400","checked_out":"400","checked_out_time":"2014-09-17 13:56:04","publish_up":"2014-07-28 13:20:56","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/eventmanagment\\\\\\/Creating-an-Even-t-Experience.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/eventmanagment\\\\\\/Creating-an-Even-t-Experience.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":10,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"19","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(167, 37, 1, '', '2014-09-17 13:56:28', 651, 2864, '7badb836a7664eff39477b622b5cd31bfc22c932', '{"id":37,"asset_id":"226","title":"The Amazing Balloons Event","alias":"the-amazing-balloons-event","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"18","created":"2014-07-28 13:21:13","created_by":"400","created_by_alias":"","modified":"2014-09-17 13:56:28","modified_by":"400","checked_out":"400","checked_out_time":"2014-09-17 13:56:21","publish_up":"2014-07-28 13:21:13","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/eventmanagment\\\\\\/the-Amazing-Balloons-Event.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/eventmanagment\\\\\\/the-Amazing-Balloons-Event.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":11,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"12","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(168, 34, 1, '', '2014-09-17 13:56:45', 651, 2856, '4f806c0752f3f684adb7197a2340ee0086189f52', '{"id":34,"asset_id":"204","title":"The Mysterious Man","alias":"the-mysterious-man","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"10","created":"2014-07-28 13:21:13","created_by":"400","created_by_alias":"","modified":"2014-09-17 13:56:45","modified_by":"400","checked_out":"400","checked_out_time":"2014-09-17 13:56:38","publish_up":"2014-07-28 13:21:13","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/magazine\\\\\\/audio_solution\\\\\\/the-Mysterious-Man.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/magazine\\\\\\/audio_solution\\\\\\/the-Mysterious-Man.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":10,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"12","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(170, 2, 1, '', '2014-09-17 14:03:52', 651, 2909, 'a646f476cce73760609e02e021a2c9b67707190b', '{"id":2,"asset_id":"67","title":"Make Your Red Background Work Better","alias":"make-your-red-background-work-better","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:21:13","created_by":"400","created_by_alias":"","modified":"2014-09-17 14:03:52","modified_by":"400","checked_out":"400","checked_out_time":"2014-09-17 14:03:45","publish_up":"2014-07-28 13:21:13","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/Make-Your-Red-Backround-Work-Better.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/Make-Your-Red-Backround-Work-Better.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":10,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"20","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"1","language":"*","xreference":""}', 0),
(173, 34, 1, '', '2014-09-17 15:44:09', 651, 2832, '3ecb62248b100e2a44c01c8dbbb47f92fe690387', '{"id":34,"asset_id":"204","title":"The Mysterious Man","alias":"the-mysterious-man","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"10","created":"2014-07-28 13:21:13","created_by":"400","created_by_alias":"","modified":"2014-09-17 15:44:09","modified_by":"400","checked_out":"400","checked_out_time":"2014-09-17 15:43:43","publish_up":"2014-07-28 13:21:13","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/audio_solution\\\\\\/the-Mysterious-Man.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/audio_solution\\\\\\/the-Mysterious-Man.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":11,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"12","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(174, 33, 1, '', '2014-09-17 15:44:33', 651, 2824, 'a912f49122d71352637ea8e979b254c0afdfbc19', '{"id":33,"asset_id":"203","title":"Old School Audio","alias":"old-school-audio","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"10","created":"2014-07-28 13:20:56","created_by":"400","created_by_alias":"","modified":"2014-09-17 15:44:33","modified_by":"400","checked_out":"400","checked_out_time":"2014-09-17 15:44:12","publish_up":"2014-07-28 13:20:56","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/audio_solution\\\\\\/Old-School-Audio.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/audio_solution\\\\\\/Old-School-Audio.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":10,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"18","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(175, 21, 1, '', '2014-09-17 15:45:00', 651, 2850, 'e0738795b8aa51f1f66543862a3fe10909e9fa0c', '{"id":21,"asset_id":"90","title":"A Modern Sound Approach","alias":"a-modern-sound-approach","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"10","created":"2014-07-28 13:20:56","created_by":"400","created_by_alias":"","modified":"2014-09-17 15:45:00","modified_by":"400","checked_out":"400","checked_out_time":"2014-09-17 15:44:35","publish_up":"2014-07-28 13:20:56","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/audio_solution\\\\\\/A-Modern-Sound-Approach.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/audio_solution\\\\\\/A-Modern-Sound-Approach.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":8,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"20","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(176, 20, 1, '', '2014-09-17 15:45:26', 651, 2834, '0d06b3042e78aab54e659b4e6be507acda001869', '{"id":20,"asset_id":"89","title":"Colors and Melodies","alias":"colors-and-melodies","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"10","created":"2014-07-28 13:21:13","created_by":"400","created_by_alias":"","modified":"2014-09-17 15:45:26","modified_by":"400","checked_out":"400","checked_out_time":"2014-09-17 15:45:03","publish_up":"2014-07-28 13:21:13","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/audio_solution\\\\\\/Colors-and-Melodies.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/audio_solution\\\\\\/Colors-and-Melodies.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":8,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"13","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(186, 18, 6, '', '2014-09-21 20:00:05', 651, 898, 'f6b1144d781f3f112428bd8dc169640954ba41e4', '{"id":18,"asset_id":"198","parent_id":"8","lft":"18","rgt":"19","level":"2","path":"articles\\/event-management","extension":"com_content","title":"Event Management","alias":"event-management","note":"","description":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.<\\/p>","published":"1","checked_out":"445","checked_out_time":"2014-09-21 19:59:58","access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/categories\\\\\\/categories.jpg\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"400","created_time":"2014-09-12 12:39:43","modified_user_id":"445","modified_time":"2014-09-21 20:00:05","hits":"0","language":"*","version":"1"}', 0),
(187, 19, 6, '', '2014-09-21 20:00:22', 651, 928, 'c0f3a0d229b1c645ad8961a1081303cab5f3f6de', '{"id":19,"asset_id":"200","parent_id":"8","lft":"20","rgt":"21","level":"2","path":"articles\\/video-and-music-production","extension":"com_content","title":"Video And Music Production","alias":"video-and-music-production","note":"","description":"<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.<\\/p>","published":"1","checked_out":"445","checked_out_time":"2014-09-21 20:00:08","access":"1","params":"{\\"category_layout\\":\\"\\",\\"image\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/categories\\\\\\/categories.jpg\\"}","metadesc":"","metakey":"","metadata":"{\\"author\\":\\"\\",\\"robots\\":\\"\\"}","created_user_id":"400","created_time":"2014-09-14 19:01:40","modified_user_id":"445","modified_time":"2014-09-21 20:00:22","hits":"0","language":"*","version":"1"}', 0),
(188, 34, 1, '', '2014-09-21 20:01:29', 651, 2824, 'c1fe88ce6b99aa12778f0e1e16aa8e1b456662e2', '{"id":34,"asset_id":"204","title":"The Mysterious Man","alias":"the-mysterious-man","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"10","created":"2014-07-28 13:21:13","created_by":"400","created_by_alias":"","modified":"2014-09-21 20:01:29","modified_by":"445","checked_out":"445","checked_out_time":"2014-09-21 20:01:15","publish_up":"2014-07-28 13:21:13","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/audio_solution\\\\\\/audio_solution.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/audio_solution\\\\\\/audio_solution.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":12,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"13","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(189, 33, 1, '', '2014-09-21 20:01:39', 651, 2820, '36ede37d950b9a1e191a5be3f285921e5c5dbbfd', '{"id":33,"asset_id":"203","title":"Old School Audio","alias":"old-school-audio","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"10","created":"2014-07-28 13:20:56","created_by":"400","created_by_alias":"","modified":"2014-09-21 20:01:39","modified_by":"445","checked_out":"445","checked_out_time":"2014-09-21 20:01:16","publish_up":"2014-07-28 13:20:56","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/audio_solution\\\\\\/audio_solution.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/audio_solution\\\\\\/audio_solution.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":11,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"19","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(190, 21, 1, '', '2014-09-21 20:01:49', 651, 2832, '830ecb07fadfd1e58a5281975537d3501780d3e1', '{"id":21,"asset_id":"90","title":"A Modern Sound Approach","alias":"a-modern-sound-approach","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"10","created":"2014-07-28 13:20:56","created_by":"400","created_by_alias":"","modified":"2014-09-21 20:01:49","modified_by":"445","checked_out":"445","checked_out_time":"2014-09-21 20:01:16","publish_up":"2014-07-28 13:20:56","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/audio_solution\\\\\\/audio_solution.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/audio_solution\\\\\\/audio_solution.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":9,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"21","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(191, 20, 1, '', '2014-09-21 20:01:58', 651, 2824, 'd124d727ca0f5e00f6b8272c5c083cbc04a43c30', '{"id":20,"asset_id":"89","title":"Colors and Melodies","alias":"colors-and-melodies","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"10","created":"2014-07-28 13:21:13","created_by":"400","created_by_alias":"","modified":"2014-09-21 20:01:58","modified_by":"445","checked_out":"445","checked_out_time":"2014-09-21 20:01:17","publish_up":"2014-07-28 13:21:13","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/audio_solution\\\\\\/audio_solution.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/audio_solution\\\\\\/audio_solution.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":9,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"14","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(192, 36, 1, '', '2014-09-21 20:03:29', 651, 2842, '5126ffde7b93bfb21ecabc9cdc8db14847946df8', '{"id":36,"asset_id":"225","title":"University Luggage","alias":"university-luggage","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:21:34","created_by":"400","created_by_alias":"","modified":"2014-09-21 20:03:29","modified_by":"445","checked_out":"445","checked_out_time":"2014-09-21 20:03:14","publish_up":"2014-07-28 13:21:34","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/commercial_services.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/commercial_services.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":10,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"5","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0);
INSERT INTO `#__ucm_history` (`version_id`, `ucm_item_id`, `ucm_type_id`, `version_note`, `save_date`, `editor_user_id`, `character_count`, `sha1_hash`, `version_data`, `keep_forever`) VALUES
(193, 35, 1, '', '2014-09-21 20:03:43', 651, 2885, 'bdd040e7585035dd7e5725e21ca68a6f937e6ff8', '{"id":35,"asset_id":"224","title":"Why This Commercial Became so Successful","alias":"why-this-commercial-became-so-successful","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:21:47","created_by":"400","created_by_alias":"","modified":"2014-09-21 20:03:43","modified_by":"445","checked_out":"445","checked_out_time":"2014-09-21 20:03:15","publish_up":"2014-07-28 13:21:47","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/commercial_services.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/commercial_services.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":9,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"2","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(194, 4, 1, '', '2014-09-21 20:03:51', 651, 2863, '2d1335332650878b886952eb2a54797300c5eb49', '{"id":4,"asset_id":"69","title":"City Photography and Direction","alias":"city-photography-and-direction","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:21:47","created_by":"400","created_by_alias":"","modified":"2014-09-21 20:03:51","modified_by":"445","checked_out":"445","checked_out_time":"2014-09-21 20:03:16","publish_up":"2014-07-28 13:21:47","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/commercial_services.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/commercial_services.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":7,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"2","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(195, 3, 1, '', '2014-09-21 20:04:12', 651, 2837, 'ad2ecd6b5c680fe7e817c9c701f4ad5e0789ce7b', '{"id":3,"asset_id":"68","title":"Eastern Reverence","alias":"eastern-reverence","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:21:34","created_by":"400","created_by_alias":"","modified":"2014-09-21 20:04:12","modified_by":"445","checked_out":"445","checked_out_time":"2014-09-21 20:04:01","publish_up":"2014-07-28 13:21:34","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/commercial_services.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/commercial_services.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":8,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"5","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(196, 2, 1, '', '2014-09-21 20:04:30', 651, 2877, 'f8cdee73ec759784d87225dddb8591e815f7c281', '{"id":2,"asset_id":"67","title":"Make Your Red Background Work Better","alias":"make-your-red-background-work-better","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:21:13","created_by":"400","created_by_alias":"","modified":"2014-09-21 20:04:30","modified_by":"445","checked_out":"445","checked_out_time":"2014-09-21 20:03:18","publish_up":"2014-07-28 13:21:13","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/commercial_services.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/commercial_services.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":11,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"21","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"1","language":"*","xreference":""}', 0),
(197, 1, 1, '', '2014-09-21 20:05:05', 651, 2853, '34ee86b0b30934b1b1fc5f3ee90ea7aa93aa67ab', '{"id":1,"asset_id":"66","title":"The Breathing Commercial","alias":"the-breathing-commercial","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"9","created":"2014-07-28 13:20:56","created_by":"400","created_by_alias":"","modified":"2014-09-21 20:05:05","modified_by":"445","checked_out":"445","checked_out_time":"2014-09-21 20:04:54","publish_up":"2014-07-28 13:20:56","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/commercial_services.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/commercial_services\\\\\\/commercial_services.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":10,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"54","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"1","language":"*","xreference":""}', 0),
(198, 40, 1, '', '2014-09-21 20:05:52', 651, 2840, '82fcf015751d56f1c060a9fb542fabddd3280aff', '{"id":40,"asset_id":"229","title":"Communication is Always Important","alias":"colors-and-melodies","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"18","created":"2014-07-28 13:21:13","created_by":"400","created_by_alias":"","modified":"2014-09-21 20:05:52","modified_by":"445","checked_out":"445","checked_out_time":"2014-09-21 20:05:37","publish_up":"2014-07-28 13:21:13","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/eventmanagment\\\\\\/eventmanagment.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/eventmanagment\\\\\\/eventmanagment.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":10,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"14","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(199, 39, 1, '', '2014-09-21 20:06:02', 651, 2844, '2bb1f98772b5167fbdd0b27a1c38400d64e73a44', '{"id":39,"asset_id":"228","title":"Creating an Event Experience","alias":"creating-an-event-experience","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"18","created":"2014-07-28 13:20:56","created_by":"400","created_by_alias":"","modified":"2014-09-21 20:06:02","modified_by":"445","checked_out":"445","checked_out_time":"2014-09-21 20:05:38","publish_up":"2014-07-28 13:20:56","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/eventmanagment\\\\\\/eventmanagment.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/eventmanagment\\\\\\/eventmanagment.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":12,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"20","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(200, 38, 1, '', '2014-09-21 20:06:13', 651, 2838, 'bbac5523ccc2525853616906d57053744b29059f', '{"id":38,"asset_id":"227","title":"Managing the Next Success","alias":"managing-the-next-success","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"18","created":"2014-07-28 13:20:56","created_by":"400","created_by_alias":"","modified":"2014-09-21 20:06:13","modified_by":"445","checked_out":"445","checked_out_time":"2014-09-21 20:05:40","publish_up":"2014-07-28 13:20:56","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/eventmanagment\\\\\\/eventmanagment.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/eventmanagment\\\\\\/eventmanagment.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":13,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"19","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(201, 37, 1, '', '2014-09-21 20:06:21', 651, 2840, '22965d3648a3e7a673077d5f961f0a893bb09110', '{"id":37,"asset_id":"226","title":"The Amazing Balloons Event","alias":"the-amazing-balloons-event","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"18","created":"2014-07-28 13:21:13","created_by":"400","created_by_alias":"","modified":"2014-09-21 20:06:21","modified_by":"445","checked_out":"445","checked_out_time":"2014-09-21 20:05:42","publish_up":"2014-07-28 13:21:13","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/eventmanagment\\\\\\/eventmanagment.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/eventmanagment\\\\\\/eventmanagment.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":12,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"12","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(203, 45, 1, '', '2014-09-21 20:07:50', 651, 2872, 'dd2e434af3db3d7230064dc5a59e8d444a10d0b5', '{"id":45,"asset_id":"234","title":"Flying On Cloudy Weather","alias":"flying-on-cloudy-weather","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"19","created":"2014-07-28 13:21:13","created_by":"400","created_by_alias":"","modified":"2014-09-21 20:07:50","modified_by":"445","checked_out":"445","checked_out_time":"2014-09-21 20:07:22","publish_up":"2014-07-28 13:21:13","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/videoandmusicproduction\\\\\\/videoandmusicproduction.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/videoandmusicproduction\\\\\\/videoandmusicproduction.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":11,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"21","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"1","language":"*","xreference":""}', 0),
(204, 44, 1, '', '2014-09-21 20:08:02', 651, 2859, '087c714d44f7ee345a53b1ee553beb548472e975', '{"id":44,"asset_id":"233","title":"Lost in Music Land","alias":"lost-in-music-land","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"19","created":"2014-07-28 13:21:34","created_by":"400","created_by_alias":"","modified":"2014-09-21 20:08:02","modified_by":"445","checked_out":"445","checked_out_time":"2014-09-21 20:06:58","publish_up":"2014-07-28 13:21:34","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/videoandmusicproduction\\\\\\/videoandmusicproduction.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/videoandmusicproduction\\\\\\/videoandmusicproduction.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":10,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"5","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(205, 43, 1, '', '2014-09-21 20:08:14', 651, 2858, 'd0b1d65a92810d58a18fb0380b311eec300247d9', '{"id":43,"asset_id":"232","title":"The City in Motion","alias":"the-city-in-motion","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"19","created":"2014-07-28 13:21:47","created_by":"400","created_by_alias":"","modified":"2014-09-21 20:08:14","modified_by":"445","checked_out":"445","checked_out_time":"2014-09-21 20:07:00","publish_up":"2014-07-28 13:21:47","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/videoandmusicproduction\\\\\\/videoandmusicproduction.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/videoandmusicproduction\\\\\\/videoandmusicproduction.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":9,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"1","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(206, 42, 1, '', '2014-09-21 20:08:25', 651, 2873, '413cafb64931997250d883ff1f2cf54fede4a81a', '{"id":42,"asset_id":"231","title":"The Shipwreck Documentary","alias":"the-shipwreck-documentary","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"19","created":"2014-07-28 13:21:47","created_by":"400","created_by_alias":"","modified":"2014-09-21 20:08:25","modified_by":"445","checked_out":"445","checked_out_time":"2014-09-21 20:07:01","publish_up":"2014-07-28 13:21:47","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/videoandmusicproduction\\\\\\/videoandmusicproduction.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/videoandmusicproduction\\\\\\/videoandmusicproduction.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":11,"ordering":"0","metakey":"","metadesc":"","access":"1","hits":"1","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(207, 41, 1, '', '2014-09-21 20:08:35', 651, 2889, '23e6a8361ded72c000a446bdb3dc913e84a7bafd', '{"id":41,"asset_id":"230","title":"The Strange Formations Music Clip","alias":"the-strange-formations-music-clip","introtext":"<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent rutrum consequat turpis, quis malesuada urna porta nec. Suspendisse ipsum odio, auctor sit amet lectus sed, pellentesque pulvinar magna. Cras tincidunt arcu lectus, nec iaculis orci hendrerit bibendum. Nullam et dui ut erat aliquet mattis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.<\\/p>\\r\\n","fulltext":"\\r\\n<p>Donec dui risus, auctor ut libero in, vestibulum dignissim lacus. Proin imperdiet nulla sit amet nunc rhoncus euismod. Duis at neque vel ligula adipiscing congue. Nullam lectus ligula, dapibus at risus sed, egestas vehicula neque. Quisque dapibus eros in nunc pharetra dapibus. In mattis odio enim, vel vulputate augue sagittis sit amet. Aenean dictum mi ante, quis tristique dui varius a. Morbi scelerisque sodales nibh. Phasellus convallis sem et purus ornare pellentesque. Donec tempor lacus sed massa tempus auctor. Morbi at eros tempus, mattis ante lacinia, dapibus felis.<\\/p>","state":1,"catid":"19","created":"2014-07-28 13:21:34","created_by":"400","created_by_alias":"","modified":"2014-09-21 20:08:35","modified_by":"445","checked_out":"445","checked_out_time":"2014-09-21 20:07:02","publish_up":"2014-07-28 13:21:34","publish_down":"0000-00-00 00:00:00","images":"{\\"image_intro\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/videoandmusicproduction\\\\\\/videoandmusicproduction.jpg\\",\\"float_intro\\":\\"\\",\\"image_intro_alt\\":\\"\\",\\"image_intro_caption\\":\\"\\",\\"image_fulltext\\":\\"images\\\\\\/echo\\\\\\/articles\\\\\\/videoandmusicproduction\\\\\\/videoandmusicproduction.jpg\\",\\"float_fulltext\\":\\"\\",\\"image_fulltext_alt\\":\\"\\",\\"image_fulltext_caption\\":\\"\\"}","urls":"{\\"urla\\":false,\\"urlatext\\":\\"\\",\\"targeta\\":\\"\\",\\"urlb\\":false,\\"urlbtext\\":\\"\\",\\"targetb\\":\\"\\",\\"urlc\\":false,\\"urlctext\\":\\"\\",\\"targetc\\":\\"\\"}","attribs":"{\\"show_title\\":\\"\\",\\"link_titles\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_intro\\":\\"\\",\\"info_block_position\\":\\"\\",\\"show_category\\":\\"\\",\\"link_category\\":\\"\\",\\"show_parent_category\\":\\"\\",\\"link_parent_category\\":\\"\\",\\"show_author\\":\\"\\",\\"link_author\\":\\"\\",\\"show_create_date\\":\\"\\",\\"show_modify_date\\":\\"\\",\\"show_publish_date\\":\\"\\",\\"show_item_navigation\\":\\"\\",\\"show_icons\\":\\"\\",\\"show_print_icon\\":\\"\\",\\"show_email_icon\\":\\"\\",\\"show_vote\\":\\"\\",\\"show_hits\\":\\"\\",\\"show_noauth\\":\\"\\",\\"urls_position\\":\\"\\",\\"alternative_readmore\\":\\"\\",\\"article_layout\\":\\"\\",\\"show_publishing_options\\":\\"\\",\\"show_article_options\\":\\"\\",\\"show_urls_images_backend\\":\\"\\",\\"show_urls_images_frontend\\":\\"\\"}","version":11,"ordering":"1","metakey":"","metadesc":"","access":"1","hits":"4","metadata":"{\\"robots\\":\\"\\",\\"author\\":\\"\\",\\"rights\\":\\"\\",\\"xreference\\":\\"\\"}","featured":"0","language":"*","xreference":""}', 0),
(219, 1, 3, '', '2014-11-13 17:35:57', 651, 1873, 'cc2164be8da8e499d7b6c5587a9947e2b82dd7af', '{"id":1,"name":"John Doe","alias":"john-doe","con_position":"","address":"2411 Any Street","suburb":"Any Town","state":"","country":"United Kingdom","postcode":"","telephone":"Q+123 456 7890","fax":"fax","misc":"If you have any enquiry then you may simply get in touch<br>\\r\\nand we will get back to you as soon as possible ","image":"images\\/ziggy\\/contact\\/contact.jpg","email_to":"info@youremail.you","default_con":0,"published":"1","checked_out":"216","checked_out_time":"2014-11-13 17:35:35","ordering":"1","params":"{\\"show_contact_category\\":\\"\\",\\"show_contact_list\\":\\"\\",\\"presentation_style\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_name\\":\\"\\",\\"show_position\\":\\"\\",\\"show_email\\":\\"\\",\\"show_street_address\\":\\"\\",\\"show_suburb\\":\\"\\",\\"show_state\\":\\"\\",\\"show_postcode\\":\\"\\",\\"show_country\\":\\"\\",\\"show_telephone\\":\\"\\",\\"show_mobile\\":\\"\\",\\"show_fax\\":\\"\\",\\"show_webpage\\":\\"\\",\\"show_misc\\":\\"\\",\\"show_image\\":\\"\\",\\"allow_vcard\\":\\"\\",\\"show_articles\\":\\"\\",\\"show_profile\\":\\"\\",\\"show_links\\":\\"\\",\\"linka_name\\":\\"\\",\\"linka\\":false,\\"linkb_name\\":\\"\\",\\"linkb\\":false,\\"linkc_name\\":\\"\\",\\"linkc\\":false,\\"linkd_name\\":\\"\\",\\"linkd\\":false,\\"linke_name\\":\\"\\",\\"linke\\":\\"\\",\\"contact_layout\\":\\"\\",\\"show_email_form\\":\\"\\",\\"show_email_copy\\":\\"\\",\\"banned_email\\":\\"\\",\\"banned_subject\\":\\"\\",\\"banned_text\\":\\"\\",\\"validate_session\\":\\"\\",\\"custom_reply\\":\\"\\",\\"redirect\\":\\"\\"}","user_id":"445","catid":"14","access":"1","mobile":"Q+999 456 7890","webpage":"","sortname1":"","sortname2":"","sortname3":"","language":"*","created":"2014-07-28 13:30:42","created_by":"216","created_by_alias":"","modified":"2014-11-13 17:35:57","modified_by":"216","metakey":"","metadesc":"","metadata":"{\\"robots\\":\\"\\",\\"rights\\":\\"\\"}","featured":"1","xreference":"","publish_up":"0000-00-00 00:00:00","publish_down":"0000-00-00 00:00:00","version":11,"hits":"115"}', 0),
(225, 1, 3, '', '2014-11-18 13:33:09', 651, 1869, 'e430b9284081d7b054db34e6a3dd62c36ff397c3', '{"id":1,"name":"John Doe","alias":"john-doe","con_position":"","address":"2411 Any Street","suburb":"Any Town","state":"","country":"United Kingdom","postcode":"","telephone":"Q+123 456 7890","fax":"fax","misc":"If you have any enquiry then you may simply get in touch<br>\\r\\nand we will get back to you as soon as possible ","image":"images\\/ziggy\\/contact\\/map.jpg","email_to":"info@youremail.you","default_con":0,"published":"1","checked_out":"216","checked_out_time":"2014-11-18 13:32:50","ordering":"1","params":"{\\"show_contact_category\\":\\"\\",\\"show_contact_list\\":\\"\\",\\"presentation_style\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_name\\":\\"\\",\\"show_position\\":\\"\\",\\"show_email\\":\\"\\",\\"show_street_address\\":\\"\\",\\"show_suburb\\":\\"\\",\\"show_state\\":\\"\\",\\"show_postcode\\":\\"\\",\\"show_country\\":\\"\\",\\"show_telephone\\":\\"\\",\\"show_mobile\\":\\"\\",\\"show_fax\\":\\"\\",\\"show_webpage\\":\\"\\",\\"show_misc\\":\\"\\",\\"show_image\\":\\"\\",\\"allow_vcard\\":\\"\\",\\"show_articles\\":\\"\\",\\"show_profile\\":\\"\\",\\"show_links\\":\\"\\",\\"linka_name\\":\\"\\",\\"linka\\":false,\\"linkb_name\\":\\"\\",\\"linkb\\":false,\\"linkc_name\\":\\"\\",\\"linkc\\":false,\\"linkd_name\\":\\"\\",\\"linkd\\":false,\\"linke_name\\":\\"\\",\\"linke\\":\\"\\",\\"contact_layout\\":\\"\\",\\"show_email_form\\":\\"\\",\\"show_email_copy\\":\\"\\",\\"banned_email\\":\\"\\",\\"banned_subject\\":\\"\\",\\"banned_text\\":\\"\\",\\"validate_session\\":\\"\\",\\"custom_reply\\":\\"\\",\\"redirect\\":\\"\\"}","user_id":"445","catid":"14","access":"1","mobile":"Q+999 456 7890","webpage":"","sortname1":"","sortname2":"","sortname3":"","language":"*","created":"2014-07-28 13:30:42","created_by":"216","created_by_alias":"","modified":"2014-11-18 13:33:09","modified_by":"216","metakey":"","metadesc":"","metadata":"{\\"robots\\":\\"\\",\\"rights\\":\\"\\"}","featured":"1","xreference":"","publish_up":"0000-00-00 00:00:00","publish_down":"0000-00-00 00:00:00","version":12,"hits":"123"}', 0);
INSERT INTO `#__ucm_history` (`version_id`, `ucm_item_id`, `ucm_type_id`, `version_note`, `save_date`, `editor_user_id`, `character_count`, `sha1_hash`, `version_data`, `keep_forever`) VALUES
(226, 1, 3, '', '2014-12-18 16:07:47', 651, 1803, 'f333cb37bcfaf231a88d18881bb244644d0fff78', '{"id":1,"name":"John Doe","alias":"john-doe","con_position":"","address":"2411 Any Street","suburb":"Any Town","state":"","country":"United Kingdom","postcode":"","telephone":"Q+123 456 7890","fax":"fax","misc":"We are Always Excited about New Projects. Say Hello!","image":"images\\/ziggy\\/contact\\/map.jpg","email_to":"info@youremail.you","default_con":0,"published":"1","checked_out":"4","checked_out_time":"2014-12-18 16:07:23","ordering":"1","params":"{\\"show_contact_category\\":\\"\\",\\"show_contact_list\\":\\"\\",\\"presentation_style\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_name\\":\\"\\",\\"show_position\\":\\"\\",\\"show_email\\":\\"\\",\\"show_street_address\\":\\"\\",\\"show_suburb\\":\\"\\",\\"show_state\\":\\"\\",\\"show_postcode\\":\\"\\",\\"show_country\\":\\"\\",\\"show_telephone\\":\\"\\",\\"show_mobile\\":\\"\\",\\"show_fax\\":\\"\\",\\"show_webpage\\":\\"\\",\\"show_misc\\":\\"\\",\\"show_image\\":\\"\\",\\"allow_vcard\\":\\"\\",\\"show_articles\\":\\"\\",\\"show_profile\\":\\"\\",\\"show_links\\":\\"\\",\\"linka_name\\":\\"\\",\\"linka\\":false,\\"linkb_name\\":\\"\\",\\"linkb\\":false,\\"linkc_name\\":\\"\\",\\"linkc\\":false,\\"linkd_name\\":\\"\\",\\"linkd\\":false,\\"linke_name\\":\\"\\",\\"linke\\":\\"\\",\\"contact_layout\\":\\"\\",\\"show_email_form\\":\\"\\",\\"show_email_copy\\":\\"\\",\\"banned_email\\":\\"\\",\\"banned_subject\\":\\"\\",\\"banned_text\\":\\"\\",\\"validate_session\\":\\"\\",\\"custom_reply\\":\\"\\",\\"redirect\\":\\"\\"}","user_id":"445","catid":"14","access":"1","mobile":"Q+999 456 7890","webpage":"","sortname1":"","sortname2":"","sortname3":"","language":"*","created":"2014-07-28 13:30:42","created_by":"4","created_by_alias":"","modified":"2014-12-18 16:07:47","modified_by":"4","metakey":"","metadesc":"","metadata":"{\\"robots\\":\\"\\",\\"rights\\":\\"\\"}","featured":"1","xreference":"","publish_up":"0000-00-00 00:00:00","publish_down":"0000-00-00 00:00:00","version":13,"hits":"207"}', 0),
(227, 1, 3, '', '2014-12-18 16:09:08', 651, 1751, '4b024d30dbe6873713b7cee96de3a49a8dffd9a9', '{"id":1,"name":"John Doe","alias":"john-doe","con_position":"","address":"2411 Any Street","suburb":"Any Town","state":"","country":"United Kingdom","postcode":"","telephone":"Q+123 456 7890","fax":"fax","misc":"","image":"images\\/ziggy\\/contact\\/map.jpg","email_to":"info@youremail.you","default_con":0,"published":"1","checked_out":"4","checked_out_time":"2014-12-18 16:09:01","ordering":"1","params":"{\\"show_contact_category\\":\\"\\",\\"show_contact_list\\":\\"\\",\\"presentation_style\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_name\\":\\"\\",\\"show_position\\":\\"\\",\\"show_email\\":\\"\\",\\"show_street_address\\":\\"\\",\\"show_suburb\\":\\"\\",\\"show_state\\":\\"\\",\\"show_postcode\\":\\"\\",\\"show_country\\":\\"\\",\\"show_telephone\\":\\"\\",\\"show_mobile\\":\\"\\",\\"show_fax\\":\\"\\",\\"show_webpage\\":\\"\\",\\"show_misc\\":\\"\\",\\"show_image\\":\\"\\",\\"allow_vcard\\":\\"\\",\\"show_articles\\":\\"\\",\\"show_profile\\":\\"\\",\\"show_links\\":\\"\\",\\"linka_name\\":\\"\\",\\"linka\\":false,\\"linkb_name\\":\\"\\",\\"linkb\\":false,\\"linkc_name\\":\\"\\",\\"linkc\\":false,\\"linkd_name\\":\\"\\",\\"linkd\\":false,\\"linke_name\\":\\"\\",\\"linke\\":\\"\\",\\"contact_layout\\":\\"\\",\\"show_email_form\\":\\"\\",\\"show_email_copy\\":\\"\\",\\"banned_email\\":\\"\\",\\"banned_subject\\":\\"\\",\\"banned_text\\":\\"\\",\\"validate_session\\":\\"\\",\\"custom_reply\\":\\"\\",\\"redirect\\":\\"\\"}","user_id":"445","catid":"14","access":"1","mobile":"Q+999 456 7890","webpage":"","sortname1":"","sortname2":"","sortname3":"","language":"*","created":"2014-07-28 13:30:42","created_by":"4","created_by_alias":"","modified":"2014-12-18 16:09:08","modified_by":"4","metakey":"","metadesc":"","metadata":"{\\"robots\\":\\"\\",\\"rights\\":\\"\\"}","featured":"1","xreference":"","publish_up":"0000-00-00 00:00:00","publish_down":"0000-00-00 00:00:00","version":14,"hits":"210"}', 0),
(228, 1, 3, '', '2014-12-18 16:24:25', 651, 1851, '08d2d6ae8da2f8bd5048e3a4f659c2acae99d0f5', '{"id":1,"name":"John Doe","alias":"john-doe","con_position":"","address":"2411 Any Street","suburb":"Any Town","state":"","country":"United Kingdom","postcode":"","telephone":"Q+123 456 7890","fax":"fax","misc":"<a href=\\"index.php?option=com_content&view=article&id=56&catid=10&Itemid=306\\">Look of the day<\\/a>","image":"images\\/ziggy\\/contact\\/map.jpg","email_to":"info@youremail.you","default_con":0,"published":"1","checked_out":"4","checked_out_time":"2014-12-18 16:24:12","ordering":"1","params":"{\\"show_contact_category\\":\\"\\",\\"show_contact_list\\":\\"\\",\\"presentation_style\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_name\\":\\"\\",\\"show_position\\":\\"\\",\\"show_email\\":\\"\\",\\"show_street_address\\":\\"\\",\\"show_suburb\\":\\"\\",\\"show_state\\":\\"\\",\\"show_postcode\\":\\"\\",\\"show_country\\":\\"\\",\\"show_telephone\\":\\"\\",\\"show_mobile\\":\\"\\",\\"show_fax\\":\\"\\",\\"show_webpage\\":\\"\\",\\"show_misc\\":\\"\\",\\"show_image\\":\\"\\",\\"allow_vcard\\":\\"\\",\\"show_articles\\":\\"\\",\\"show_profile\\":\\"\\",\\"show_links\\":\\"\\",\\"linka_name\\":\\"\\",\\"linka\\":false,\\"linkb_name\\":\\"\\",\\"linkb\\":false,\\"linkc_name\\":\\"\\",\\"linkc\\":false,\\"linkd_name\\":\\"\\",\\"linkd\\":false,\\"linke_name\\":\\"\\",\\"linke\\":\\"\\",\\"contact_layout\\":\\"\\",\\"show_email_form\\":\\"\\",\\"show_email_copy\\":\\"\\",\\"banned_email\\":\\"\\",\\"banned_subject\\":\\"\\",\\"banned_text\\":\\"\\",\\"validate_session\\":\\"\\",\\"custom_reply\\":\\"\\",\\"redirect\\":\\"\\"}","user_id":"445","catid":"14","access":"1","mobile":"Q+999 456 7890","webpage":"","sortname1":"","sortname2":"","sortname3":"","language":"*","created":"2014-07-28 13:30:42","created_by":"4","created_by_alias":"","modified":"2014-12-18 16:24:25","modified_by":"4","metakey":"","metadesc":"","metadata":"{\\"robots\\":\\"\\",\\"rights\\":\\"\\"}","featured":"1","xreference":"","publish_up":"0000-00-00 00:00:00","publish_down":"0000-00-00 00:00:00","version":15,"hits":"218"}', 0),
(229, 1, 3, '', '2014-12-18 16:32:31', 651, 1720, '21bc8e84a7d596aea0250fd9deea83eaea614ebd', '{"id":1,"name":"John Doe","alias":"john-doe","con_position":"","address":"2411 Any Street","suburb":"Any Town","state":"","country":"United Kingdom","postcode":"","telephone":"Q+123 456 7890","fax":"fax","misc":"","image":"","email_to":"info@youremail.you","default_con":0,"published":"1","checked_out":"4","checked_out_time":"2014-12-18 16:24:45","ordering":"1","params":"{\\"show_contact_category\\":\\"\\",\\"show_contact_list\\":\\"\\",\\"presentation_style\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_name\\":\\"\\",\\"show_position\\":\\"\\",\\"show_email\\":\\"\\",\\"show_street_address\\":\\"\\",\\"show_suburb\\":\\"\\",\\"show_state\\":\\"\\",\\"show_postcode\\":\\"\\",\\"show_country\\":\\"\\",\\"show_telephone\\":\\"\\",\\"show_mobile\\":\\"\\",\\"show_fax\\":\\"\\",\\"show_webpage\\":\\"\\",\\"show_misc\\":\\"\\",\\"show_image\\":\\"\\",\\"allow_vcard\\":\\"\\",\\"show_articles\\":\\"\\",\\"show_profile\\":\\"\\",\\"show_links\\":\\"\\",\\"linka_name\\":\\"\\",\\"linka\\":false,\\"linkb_name\\":\\"\\",\\"linkb\\":false,\\"linkc_name\\":\\"\\",\\"linkc\\":false,\\"linkd_name\\":\\"\\",\\"linkd\\":false,\\"linke_name\\":\\"\\",\\"linke\\":\\"\\",\\"contact_layout\\":\\"\\",\\"show_email_form\\":\\"\\",\\"show_email_copy\\":\\"\\",\\"banned_email\\":\\"\\",\\"banned_subject\\":\\"\\",\\"banned_text\\":\\"\\",\\"validate_session\\":\\"\\",\\"custom_reply\\":\\"\\",\\"redirect\\":\\"\\"}","user_id":"445","catid":"14","access":"1","mobile":"Q+999 456 7890","webpage":"","sortname1":"","sortname2":"","sortname3":"","language":"*","created":"2014-07-28 13:30:42","created_by":"4","created_by_alias":"","modified":"2014-12-18 16:32:31","modified_by":"4","metakey":"","metadesc":"","metadata":"{\\"robots\\":\\"\\",\\"rights\\":\\"\\"}","featured":"1","xreference":"","publish_up":"0000-00-00 00:00:00","publish_down":"0000-00-00 00:00:00","version":17,"hits":"228"}', 0),
(230, 1, 3, '', '2014-12-18 16:43:26', 651, 1758, 'bcd8a550bb3c93388e12c5e7a6ae3fb475a6ffc9', '{"id":1,"name":"John Doe","alias":"john-doe","con_position":"","address":"2411 Any Street","suburb":"Any Town","state":"asda","country":"United Kingdom","postcode":"dasd","telephone":"Q+123 456 7890","fax":"fax","misc":"","image":"","email_to":"info@youremail.you","default_con":0,"published":"1","checked_out":"4","checked_out_time":"2014-12-18 16:32:31","ordering":"1","params":"{\\"show_contact_category\\":\\"\\",\\"show_contact_list\\":\\"\\",\\"presentation_style\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_name\\":\\"\\",\\"show_position\\":\\"\\",\\"show_email\\":\\"\\",\\"show_street_address\\":\\"\\",\\"show_suburb\\":\\"\\",\\"show_state\\":\\"\\",\\"show_postcode\\":\\"\\",\\"show_country\\":\\"\\",\\"show_telephone\\":\\"\\",\\"show_mobile\\":\\"\\",\\"show_fax\\":\\"\\",\\"show_webpage\\":\\"\\",\\"show_misc\\":\\"\\",\\"show_image\\":\\"\\",\\"allow_vcard\\":\\"\\",\\"show_articles\\":\\"\\",\\"show_profile\\":\\"\\",\\"show_links\\":\\"\\",\\"linka_name\\":\\"\\",\\"linka\\":false,\\"linkb_name\\":\\"\\",\\"linkb\\":false,\\"linkc_name\\":\\"\\",\\"linkc\\":false,\\"linkd_name\\":\\"\\",\\"linkd\\":false,\\"linke_name\\":\\"\\",\\"linke\\":\\"\\",\\"contact_layout\\":\\"\\",\\"show_email_form\\":\\"\\",\\"show_email_copy\\":\\"\\",\\"banned_email\\":\\"\\",\\"banned_subject\\":\\"\\",\\"banned_text\\":\\"\\",\\"validate_session\\":\\"\\",\\"custom_reply\\":\\"\\",\\"redirect\\":\\"\\"}","user_id":"445","catid":"14","access":"1","mobile":"Q+999 456 7890","webpage":"http:\\/\\/adsad","sortname1":"asda","sortname2":"asdasd","sortname3":"asdasd","language":"*","created":"2014-07-28 13:30:42","created_by":"4","created_by_alias":"","modified":"2014-12-18 16:43:26","modified_by":"4","metakey":"","metadesc":"","metadata":"{\\"robots\\":\\"\\",\\"rights\\":\\"\\"}","featured":"1","xreference":"","publish_up":"0000-00-00 00:00:00","publish_down":"0000-00-00 00:00:00","version":18,"hits":"245"}', 0),
(231, 1, 3, '', '2015-03-11 14:19:07', 651, 1730, 'bee863ce58f0c3a4956f8a6594a3d039cd89052c', '{"id":1,"name":"John Doe","alias":"john-doe","con_position":"","address":"2411 Any Street","suburb":"Any Town","state":"","country":"United Kingdom","postcode":"","telephone":"Q+123 456 7890","fax":"fax","misc":"","image":"","email_to":"info@youremail.you","default_con":0,"published":"1","checked_out":"737","checked_out_time":"2015-03-11 14:18:58","ordering":"1","params":"{\\"show_contact_category\\":\\"\\",\\"show_contact_list\\":\\"\\",\\"presentation_style\\":\\"\\",\\"show_tags\\":\\"\\",\\"show_name\\":\\"\\",\\"show_position\\":\\"\\",\\"show_email\\":\\"\\",\\"show_street_address\\":\\"\\",\\"show_suburb\\":\\"\\",\\"show_state\\":\\"\\",\\"show_postcode\\":\\"\\",\\"show_country\\":\\"\\",\\"show_telephone\\":\\"\\",\\"show_mobile\\":\\"\\",\\"show_fax\\":\\"\\",\\"show_webpage\\":\\"\\",\\"show_misc\\":\\"\\",\\"show_image\\":\\"\\",\\"allow_vcard\\":\\"\\",\\"show_articles\\":\\"\\",\\"show_profile\\":\\"\\",\\"show_links\\":\\"\\",\\"linka_name\\":\\"\\",\\"linka\\":false,\\"linkb_name\\":\\"\\",\\"linkb\\":false,\\"linkc_name\\":\\"\\",\\"linkc\\":false,\\"linkd_name\\":\\"\\",\\"linkd\\":false,\\"linke_name\\":\\"\\",\\"linke\\":false,\\"contact_layout\\":\\"\\",\\"show_email_form\\":\\"\\",\\"show_email_copy\\":\\"\\",\\"banned_email\\":\\"\\",\\"banned_subject\\":\\"\\",\\"banned_text\\":\\"\\",\\"validate_session\\":\\"\\",\\"custom_reply\\":\\"\\",\\"redirect\\":\\"\\"}","user_id":"445","catid":"14","access":"1","mobile":"Q+999 456 7890","webpage":false,"sortname1":"","sortname2":"","sortname3":"","language":"*","created":"2014-07-28 13:30:42","created_by":"737","created_by_alias":"","modified":"2015-03-11 14:19:07","modified_by":"737","metakey":"","metadesc":"","metadata":"{\\"robots\\":\\"\\",\\"rights\\":\\"\\"}","featured":"1","xreference":"","publish_up":"0000-00-00 00:00:00","publish_down":"0000-00-00 00:00:00","version":20,"hits":"531"}', 0);

DROP TABLE IF EXISTS `#__updates`;
CREATE TABLE IF NOT EXISTS `#__updates` (
`update_id` int(11) NOT NULL,
  `update_site_id` int(11) DEFAULT '0',
  `extension_id` int(11) DEFAULT '0',
  `name` varchar(100) DEFAULT '',
  `description` text NOT NULL,
  `element` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `folder` varchar(20) DEFAULT '',
  `client_id` tinyint(3) DEFAULT '0',
  `version` varchar(32) DEFAULT '',
  `data` text NOT NULL,
  `detailsurl` text NOT NULL,
  `infourl` text NOT NULL,
  `extra_query` varchar(1000) DEFAULT ''
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8 COMMENT='Available Updates';

INSERT INTO `#__updates` (`update_id`, `update_site_id`, `extension_id`, `name`, `description`, `element`, `type`, `folder`, `client_id`, `version`, `data`, `detailsurl`, `infourl`, `extra_query`) VALUES
(1, 4, 0, 'Sample package for Uber Medicare', '', 'uber_medicare', 'sample_package', '', 0, '2.1.0', '', 'http://update.joomlart.com/service/tracking/j31/uber_medicare.xml', '', ''),
(2, 4, 0, 'Sample package for Uber Music', '', 'uber_music', 'sample_package', '', 0, '2.0.2', '', 'http://update.joomlart.com/service/tracking/j31/uber_music.xml', '', ''),
(3, 4, 0, 'Sample package for Uber Restaurant', '', 'uber_restaurant', 'sample_package', '', 0, '2.0.2', '', 'http://update.joomlart.com/service/tracking/j31/uber_restaurant.xml', '', ''),
(4, 4, 0, 'Sample package for Uber Spa', '', 'uber_spa', 'sample_package', '', 0, '2.0.2', '', 'http://update.joomlart.com/service/tracking/j31/uber_spa.xml', '', ''),
(5, 4, 0, 'Sample package for Uber University', '', 'uber_university', 'sample_package', '', 0, '2.0.2', '', 'http://update.joomlart.com/service/tracking/j31/uber_university.xml', '', ''),
(6, 4, 0, 'Sample package for Uber Wedding', '', 'uber_wedding', 'sample_package', '', 0, '2.0.2', '', 'http://update.joomlart.com/service/tracking/j31/uber_wedding.xml', '', '');

DROP TABLE IF EXISTS `#__update_sites`;
CREATE TABLE IF NOT EXISTS `#__update_sites` (
`update_site_id` int(11) NOT NULL,
  `name` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `location` text NOT NULL,
  `enabled` int(11) DEFAULT '0',
  `last_check_timestamp` bigint(20) DEFAULT '0',
  `extra_query` varchar(1000) DEFAULT ''
) ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=utf8 COMMENT='Update Sites';

INSERT INTO `#__update_sites` (`update_site_id`, `name`, `type`, `location`, `enabled`, `last_check_timestamp`, `extra_query`) VALUES
(1, 'Joomla! Core', 'collection', 'http://update.joomla.org/core/list.xml', 1, 1438373647, ''),
(2, 'Joomla! Extension Directory', 'collection', 'http://update.joomla.org/jed/list.xml', 0, 0, ''),
(3, 'Accredited Joomla! Translations', 'collection', 'http://update.joomla.org/language/translationlist_3.xml', 1, 0, ''),
(4, '', 'collection', 'http://update.joomlart.com/service/tracking/list.xml', 1, 1438373645, ''),
(5, 'K2 Updates', 'extension', 'http://getk2.org/update.xml', 0, 0, ''),
(6, 'Joomla! Update Component Update Site', 'extension', 'http://update.joomla.org/core/extensions/com_joomlaupdate.xml', 1, 1438373645, ''),
(8, 'AllVideos', 'extension', 'http://www.joomlaworks.net/updates/jw_allvideos.xml', 1, 1438373645, ''),
(9, 'Weblinks Update Site', 'extension', 'https://raw.githubusercontent.com/joomla-extensions/weblinks/master/manifest.xml', 1, 1438373645, ''),
(10, 'AllVideos', 'extension', 'http://cdn.joomlaworks.org/updates/allvideos.xml', 1, 1438373645, '');

DROP TABLE IF EXISTS `#__update_sites_extensions`;
CREATE TABLE IF NOT EXISTS `#__update_sites_extensions` (
  `update_site_id` int(11) NOT NULL DEFAULT '0',
  `extension_id` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Links extensions to update sites';

INSERT INTO `#__update_sites_extensions` (`update_site_id`, `extension_id`) VALUES
(1, 700),
(2, 700),
(3, 600),
(4, 10000),
(5, 10002),
(6, 28),
(8, 10049),
(9, 801),
(10, 10049);

DROP TABLE IF EXISTS `#__usergroups`;
CREATE TABLE IF NOT EXISTS `#__usergroups` (
`id` int(10) unsigned NOT NULL COMMENT 'Primary Key',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Adjacency List Reference Id',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `title` varchar(100) NOT NULL DEFAULT ''
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;

INSERT INTO `#__usergroups` (`id`, `parent_id`, `lft`, `rgt`, `title`) VALUES
(1, 0, 1, 18, 'Public'),
(2, 1, 8, 15, 'Registered'),
(3, 2, 9, 14, 'Author'),
(4, 3, 10, 13, 'Editor'),
(5, 4, 11, 12, 'Publisher'),
(6, 1, 4, 7, 'Manager'),
(7, 6, 5, 6, 'Administrator'),
(8, 1, 16, 17, 'Super Users'),
(9, 1, 2, 3, 'Guest');

DROP TABLE IF EXISTS `#__users`;
CREATE TABLE IF NOT EXISTS `#__users` (
`id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL DEFAULT '',
  `username` varchar(150) NOT NULL DEFAULT '',
  `email` varchar(100) NOT NULL DEFAULT '',
  `password` varchar(100) NOT NULL DEFAULT '',
  `block` tinyint(4) NOT NULL DEFAULT '0',
  `sendEmail` tinyint(4) DEFAULT '0',
  `registerDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `lastvisitDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `activation` varchar(100) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  `lastResetTime` datetime NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Date of last password reset',
  `resetCount` int(11) NOT NULL DEFAULT '0' COMMENT 'Count of password resets since lastResetTime',
  `otpKey` varchar(1000) NOT NULL DEFAULT '' COMMENT 'Two factor authentication encrypted keys',
  `otep` varchar(1000) NOT NULL DEFAULT '' COMMENT 'One time emergency passwords',
  `requireReset` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Require user to reset password on next login'
) ENGINE=InnoDB AUTO_INCREMENT=652 DEFAULT CHARSET=utf8;

INSERT INTO `#__users` (`id`, `name`, `username`, `email`, `password`, `block`, `sendEmail`, `registerDate`, `lastvisitDate`, `activation`, `params`, `lastResetTime`, `resetCount`, `otpKey`, `otep`, `requireReset`) VALUES
(445, 'John Doe', 'john', 'JohnDoe@anymail.com', '$2y$10$JCFYxABytyAw3C.ecWktPudNhXmS0Qk5l7RH7VmUg8CmHNOopkepm', 0, 0, '2014-07-28 13:15:28', '2015-07-29 18:44:57', '', '{"admin_style":"","admin_language":"","language":"","editor":"","helpsite":"","timezone":""}', '0000-00-00 00:00:00', 0, '', '', 0),
(446, 'Samantha Doe', 'samantha', 'SamanthaVerdi@anymail.com', '$2y$10$kAenMwQMlBJ8o6xMUEQhXe4HO2hNTfMwLwaSzYi8f498OMsX606v.', 0, 0, '2014-07-28 13:16:31', '2015-05-28 12:54:16', '', '{"admin_style":"","admin_language":"","language":"","editor":"","helpsite":"","timezone":""}', '0000-00-00 00:00:00', 0, '', '', 0);

DROP TABLE IF EXISTS `#__user_keys`;
CREATE TABLE IF NOT EXISTS `#__user_keys` (
`id` int(10) unsigned NOT NULL,
  `user_id` varchar(255) NOT NULL,
  `token` varchar(255) NOT NULL,
  `series` varchar(255) NOT NULL,
  `invalid` tinyint(4) NOT NULL,
  `time` varchar(200) NOT NULL,
  `uastring` varchar(255) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__user_notes`;
CREATE TABLE IF NOT EXISTS `#__user_notes` (
`id` int(10) unsigned NOT NULL,
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(100) NOT NULL DEFAULT '',
  `body` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL,
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `review_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__user_profiles`;
CREATE TABLE IF NOT EXISTS `#__user_profiles` (
  `user_id` int(11) NOT NULL,
  `profile_key` varchar(100) NOT NULL,
  `profile_value` text NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Simple user profile storage table';

DROP TABLE IF EXISTS `#__user_usergroup_map`;
CREATE TABLE IF NOT EXISTS `#__user_usergroup_map` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Foreign Key to #___users.id',
  `group_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Foreign Key to #___usergroups.id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `#__user_usergroup_map` (`user_id`, `group_id`) VALUES
(445, 7),
(446, 7);

DROP TABLE IF EXISTS `#__viewlevels`;
CREATE TABLE IF NOT EXISTS `#__viewlevels` (
`id` int(10) unsigned NOT NULL COMMENT 'Primary Key',
  `title` varchar(100) NOT NULL DEFAULT '',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.'
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8;

INSERT INTO `#__viewlevels` (`id`, `title`, `ordering`, `rules`) VALUES
(1, 'Public', 0, '[1]'),
(2, 'Registered', 1, '[6,2,8]'),
(3, 'Special', 2, '[6,3,8]'),
(5, 'Guest', 0, '[9]'),
(6, 'Super Users', 0, '[8]');

DROP TABLE IF EXISTS `#__weblinks`;
CREATE TABLE IF NOT EXISTS `#__weblinks` (
`id` int(10) unsigned NOT NULL,
  `catid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `url` varchar(250) NOT NULL DEFAULT '',
  `description` text NOT NULL,
  `hits` int(11) NOT NULL DEFAULT '0',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if link is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `images` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


ALTER TABLE `#__assets`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `idx_asset_name` (`name`), ADD KEY `idx_lft_rgt` (`lft`,`rgt`), ADD KEY `idx_parent_id` (`parent_id`);

ALTER TABLE `#__associations`
 ADD PRIMARY KEY (`context`,`id`), ADD KEY `idx_key` (`key`);

ALTER TABLE `#__banners`
 ADD PRIMARY KEY (`id`), ADD KEY `idx_state` (`state`), ADD KEY `idx_own_prefix` (`own_prefix`), ADD KEY `idx_metakey_prefix` (`metakey_prefix`), ADD KEY `idx_banner_catid` (`catid`), ADD KEY `idx_language` (`language`);

ALTER TABLE `#__banner_clients`
 ADD PRIMARY KEY (`id`), ADD KEY `idx_own_prefix` (`own_prefix`), ADD KEY `idx_metakey_prefix` (`metakey_prefix`);

ALTER TABLE `#__banner_tracks`
 ADD PRIMARY KEY (`track_date`,`track_type`,`banner_id`), ADD KEY `idx_track_date` (`track_date`), ADD KEY `idx_track_type` (`track_type`), ADD KEY `idx_banner_id` (`banner_id`);

ALTER TABLE `#__categories`
 ADD PRIMARY KEY (`id`), ADD KEY `cat_idx` (`extension`,`published`,`access`), ADD KEY `idx_access` (`access`), ADD KEY `idx_checkout` (`checked_out`), ADD KEY `idx_path` (`path`), ADD KEY `idx_left_right` (`lft`,`rgt`), ADD KEY `idx_alias` (`alias`), ADD KEY `idx_language` (`language`);

ALTER TABLE `#__contact_details`
 ADD PRIMARY KEY (`id`), ADD KEY `idx_access` (`access`), ADD KEY `idx_checkout` (`checked_out`), ADD KEY `idx_state` (`published`), ADD KEY `idx_catid` (`catid`), ADD KEY `idx_createdby` (`created_by`), ADD KEY `idx_featured_catid` (`featured`,`catid`), ADD KEY `idx_language` (`language`), ADD KEY `idx_xreference` (`xreference`);

ALTER TABLE `#__content`
 ADD PRIMARY KEY (`id`), ADD KEY `idx_access` (`access`), ADD KEY `idx_checkout` (`checked_out`), ADD KEY `idx_state` (`state`), ADD KEY `idx_catid` (`catid`), ADD KEY `idx_createdby` (`created_by`), ADD KEY `idx_featured_catid` (`featured`,`catid`), ADD KEY `idx_language` (`language`), ADD KEY `idx_xreference` (`xreference`);

ALTER TABLE `#__contentitem_tag_map`
 ADD UNIQUE KEY `uc_ItemnameTagid` (`type_id`,`content_item_id`,`tag_id`), ADD KEY `idx_tag_type` (`tag_id`,`type_id`), ADD KEY `idx_date_id` (`tag_date`,`tag_id`), ADD KEY `idx_tag` (`tag_id`), ADD KEY `idx_type` (`type_id`), ADD KEY `idx_core_content_id` (`core_content_id`);

ALTER TABLE `#__content_frontpage`
 ADD PRIMARY KEY (`content_id`);

ALTER TABLE `#__content_rating`
 ADD PRIMARY KEY (`content_id`);

ALTER TABLE `#__content_types`
 ADD PRIMARY KEY (`type_id`), ADD KEY `idx_alias` (`type_alias`);

ALTER TABLE `#__extensions`
 ADD PRIMARY KEY (`extension_id`), ADD KEY `element_clientid` (`element`,`client_id`), ADD KEY `element_folder_clientid` (`element`,`folder`,`client_id`), ADD KEY `extension` (`type`,`element`,`folder`,`client_id`);

ALTER TABLE `#__finder_filters`
 ADD PRIMARY KEY (`filter_id`);

ALTER TABLE `#__finder_links`
 ADD PRIMARY KEY (`link_id`), ADD KEY `idx_type` (`type_id`), ADD KEY `idx_title` (`title`), ADD KEY `idx_md5` (`md5sum`), ADD KEY `idx_url` (`url`(75)), ADD KEY `idx_published_list` (`published`,`state`,`access`,`publish_start_date`,`publish_end_date`,`list_price`), ADD KEY `idx_published_sale` (`published`,`state`,`access`,`publish_start_date`,`publish_end_date`,`sale_price`);

ALTER TABLE `#__finder_links_terms0`
 ADD PRIMARY KEY (`link_id`,`term_id`), ADD KEY `idx_term_weight` (`term_id`,`weight`), ADD KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`);

ALTER TABLE `#__finder_links_terms1`
 ADD PRIMARY KEY (`link_id`,`term_id`), ADD KEY `idx_term_weight` (`term_id`,`weight`), ADD KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`);

ALTER TABLE `#__finder_links_terms2`
 ADD PRIMARY KEY (`link_id`,`term_id`), ADD KEY `idx_term_weight` (`term_id`,`weight`), ADD KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`);

ALTER TABLE `#__finder_links_terms3`
 ADD PRIMARY KEY (`link_id`,`term_id`), ADD KEY `idx_term_weight` (`term_id`,`weight`), ADD KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`);

ALTER TABLE `#__finder_links_terms4`
 ADD PRIMARY KEY (`link_id`,`term_id`), ADD KEY `idx_term_weight` (`term_id`,`weight`), ADD KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`);

ALTER TABLE `#__finder_links_terms5`
 ADD PRIMARY KEY (`link_id`,`term_id`), ADD KEY `idx_term_weight` (`term_id`,`weight`), ADD KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`);

ALTER TABLE `#__finder_links_terms6`
 ADD PRIMARY KEY (`link_id`,`term_id`), ADD KEY `idx_term_weight` (`term_id`,`weight`), ADD KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`);

ALTER TABLE `#__finder_links_terms7`
 ADD PRIMARY KEY (`link_id`,`term_id`), ADD KEY `idx_term_weight` (`term_id`,`weight`), ADD KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`);

ALTER TABLE `#__finder_links_terms8`
 ADD PRIMARY KEY (`link_id`,`term_id`), ADD KEY `idx_term_weight` (`term_id`,`weight`), ADD KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`);

ALTER TABLE `#__finder_links_terms9`
 ADD PRIMARY KEY (`link_id`,`term_id`), ADD KEY `idx_term_weight` (`term_id`,`weight`), ADD KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`);

ALTER TABLE `#__finder_links_termsa`
 ADD PRIMARY KEY (`link_id`,`term_id`), ADD KEY `idx_term_weight` (`term_id`,`weight`), ADD KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`);

ALTER TABLE `#__finder_links_termsb`
 ADD PRIMARY KEY (`link_id`,`term_id`), ADD KEY `idx_term_weight` (`term_id`,`weight`), ADD KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`);

ALTER TABLE `#__finder_links_termsc`
 ADD PRIMARY KEY (`link_id`,`term_id`), ADD KEY `idx_term_weight` (`term_id`,`weight`), ADD KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`);

ALTER TABLE `#__finder_links_termsd`
 ADD PRIMARY KEY (`link_id`,`term_id`), ADD KEY `idx_term_weight` (`term_id`,`weight`), ADD KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`);

ALTER TABLE `#__finder_links_termse`
 ADD PRIMARY KEY (`link_id`,`term_id`), ADD KEY `idx_term_weight` (`term_id`,`weight`), ADD KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`);

ALTER TABLE `#__finder_links_termsf`
 ADD PRIMARY KEY (`link_id`,`term_id`), ADD KEY `idx_term_weight` (`term_id`,`weight`), ADD KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`);

ALTER TABLE `#__finder_taxonomy`
 ADD PRIMARY KEY (`id`), ADD KEY `parent_id` (`parent_id`), ADD KEY `state` (`state`), ADD KEY `ordering` (`ordering`), ADD KEY `access` (`access`), ADD KEY `idx_parent_published` (`parent_id`,`state`,`access`);

ALTER TABLE `#__finder_taxonomy_map`
 ADD PRIMARY KEY (`link_id`,`node_id`), ADD KEY `link_id` (`link_id`), ADD KEY `node_id` (`node_id`);

ALTER TABLE `#__finder_terms`
 ADD PRIMARY KEY (`term_id`), ADD UNIQUE KEY `idx_term` (`term`), ADD KEY `idx_term_phrase` (`term`,`phrase`), ADD KEY `idx_stem_phrase` (`stem`,`phrase`), ADD KEY `idx_soundex_phrase` (`soundex`,`phrase`);

ALTER TABLE `#__finder_terms_common`
 ADD KEY `idx_word_lang` (`term`,`language`), ADD KEY `idx_lang` (`language`);

ALTER TABLE `#__finder_tokens`
 ADD KEY `idx_word` (`term`), ADD KEY `idx_context` (`context`);

ALTER TABLE `#__finder_tokens_aggregate`
 ADD KEY `token` (`term`), ADD KEY `keyword_id` (`term_id`);

ALTER TABLE `#__finder_types`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `title` (`title`);

ALTER TABLE `#__k2_attachments`
 ADD PRIMARY KEY (`id`), ADD KEY `itemID` (`itemID`);

ALTER TABLE `#__k2_categories`
 ADD PRIMARY KEY (`id`), ADD KEY `category` (`published`,`access`,`trash`), ADD KEY `parent` (`parent`), ADD KEY `ordering` (`ordering`), ADD KEY `published` (`published`), ADD KEY `access` (`access`), ADD KEY `trash` (`trash`), ADD KEY `language` (`language`);

ALTER TABLE `#__k2_comments`
 ADD PRIMARY KEY (`id`), ADD KEY `itemID` (`itemID`), ADD KEY `userID` (`userID`), ADD KEY `published` (`published`), ADD KEY `latestComments` (`published`,`commentDate`);

ALTER TABLE `#__k2_extra_fields`
 ADD PRIMARY KEY (`id`), ADD KEY `group` (`group`), ADD KEY `published` (`published`), ADD KEY `ordering` (`ordering`);

ALTER TABLE `#__k2_extra_fields_groups`
 ADD PRIMARY KEY (`id`);

ALTER TABLE `#__k2_items`
 ADD PRIMARY KEY (`id`), ADD KEY `item` (`published`,`publish_up`,`publish_down`,`trash`,`access`), ADD KEY `catid` (`catid`), ADD KEY `created_by` (`created_by`), ADD KEY `ordering` (`ordering`), ADD KEY `featured` (`featured`), ADD KEY `featured_ordering` (`featured_ordering`), ADD KEY `hits` (`hits`), ADD KEY `created` (`created`), ADD KEY `language` (`language`);

ALTER TABLE `#__k2_rating`
 ADD PRIMARY KEY (`itemID`);

ALTER TABLE `#__k2_tags`
 ADD PRIMARY KEY (`id`), ADD KEY `published` (`published`);

ALTER TABLE `#__k2_tags_xref`
 ADD PRIMARY KEY (`id`), ADD KEY `tagID` (`tagID`), ADD KEY `itemID` (`itemID`);

ALTER TABLE `#__k2_users`
 ADD PRIMARY KEY (`id`), ADD KEY `userID` (`userID`), ADD KEY `group` (`group`);

ALTER TABLE `#__k2_user_groups`
 ADD PRIMARY KEY (`id`);

ALTER TABLE `#__languages`
 ADD PRIMARY KEY (`lang_id`), ADD UNIQUE KEY `idx_sef` (`sef`), ADD UNIQUE KEY `idx_image` (`image`), ADD UNIQUE KEY `idx_langcode` (`lang_code`), ADD KEY `idx_access` (`access`), ADD KEY `idx_ordering` (`ordering`);

ALTER TABLE `#__menu`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `idx_client_id_parent_id_alias_language` (`client_id`,`parent_id`,`alias`,`language`), ADD KEY `idx_componentid` (`component_id`,`menutype`,`published`,`access`), ADD KEY `idx_menutype` (`menutype`), ADD KEY `idx_left_right` (`lft`,`rgt`), ADD KEY `idx_alias` (`alias`), ADD KEY `idx_path` (`path`(255)), ADD KEY `idx_language` (`language`);

ALTER TABLE `#__menu_types`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `idx_menutype` (`menutype`);

ALTER TABLE `#__messages`
 ADD PRIMARY KEY (`message_id`), ADD KEY `useridto_state` (`user_id_to`,`state`);

ALTER TABLE `#__messages_cfg`
 ADD UNIQUE KEY `idx_user_var_name` (`user_id`,`cfg_name`);

ALTER TABLE `#__minitek_wall_instances`
 ADD PRIMARY KEY (`id`);

ALTER TABLE `#__minitek_wall_modules`
 ADD PRIMARY KEY (`id`);

ALTER TABLE `#__modules`
 ADD PRIMARY KEY (`id`), ADD KEY `published` (`published`,`access`), ADD KEY `newsfeeds` (`module`,`published`), ADD KEY `idx_language` (`language`);

ALTER TABLE `#__modules_menu`
 ADD PRIMARY KEY (`moduleid`,`menuid`);

ALTER TABLE `#__newsfeeds`
 ADD PRIMARY KEY (`id`), ADD KEY `idx_access` (`access`), ADD KEY `idx_checkout` (`checked_out`), ADD KEY `idx_state` (`published`), ADD KEY `idx_catid` (`catid`), ADD KEY `idx_createdby` (`created_by`), ADD KEY `idx_language` (`language`), ADD KEY `idx_xreference` (`xreference`);

ALTER TABLE `#__overrider`
 ADD PRIMARY KEY (`id`);

ALTER TABLE `#__postinstall_messages`
 ADD PRIMARY KEY (`postinstall_message_id`);

ALTER TABLE `#__redirect_links`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `idx_link_old` (`old_url`), ADD KEY `idx_link_modifed` (`modified_date`);

ALTER TABLE `#__schemas`
 ADD PRIMARY KEY (`extension_id`,`version_id`);

ALTER TABLE `#__session`
 ADD PRIMARY KEY (`session_id`), ADD KEY `userid` (`userid`), ADD KEY `time` (`time`);

ALTER TABLE `#__tags`
 ADD PRIMARY KEY (`id`), ADD KEY `tag_idx` (`published`,`access`), ADD KEY `idx_access` (`access`), ADD KEY `idx_checkout` (`checked_out`), ADD KEY `idx_path` (`path`), ADD KEY `idx_left_right` (`lft`,`rgt`), ADD KEY `idx_alias` (`alias`), ADD KEY `idx_language` (`language`);

ALTER TABLE `#__template_styles`
 ADD PRIMARY KEY (`id`), ADD KEY `idx_template` (`template`), ADD KEY `idx_home` (`home`);

ALTER TABLE `#__ucm_base`
 ADD PRIMARY KEY (`ucm_id`), ADD KEY `idx_ucm_item_id` (`ucm_item_id`), ADD KEY `idx_ucm_type_id` (`ucm_type_id`), ADD KEY `idx_ucm_language_id` (`ucm_language_id`);

ALTER TABLE `#__ucm_content`
 ADD PRIMARY KEY (`core_content_id`), ADD KEY `tag_idx` (`core_state`,`core_access`), ADD KEY `idx_access` (`core_access`), ADD KEY `idx_alias` (`core_alias`), ADD KEY `idx_language` (`core_language`), ADD KEY `idx_title` (`core_title`), ADD KEY `idx_modified_time` (`core_modified_time`), ADD KEY `idx_created_time` (`core_created_time`), ADD KEY `idx_content_type` (`core_type_alias`), ADD KEY `idx_core_modified_user_id` (`core_modified_user_id`), ADD KEY `idx_core_checked_out_user_id` (`core_checked_out_user_id`), ADD KEY `idx_core_created_user_id` (`core_created_user_id`), ADD KEY `idx_core_type_id` (`core_type_id`);

ALTER TABLE `#__ucm_history`
 ADD PRIMARY KEY (`version_id`), ADD KEY `idx_ucm_item_id` (`ucm_type_id`,`ucm_item_id`), ADD KEY `idx_save_date` (`save_date`);

ALTER TABLE `#__updates`
 ADD PRIMARY KEY (`update_id`);

ALTER TABLE `#__update_sites`
 ADD PRIMARY KEY (`update_site_id`);

ALTER TABLE `#__update_sites_extensions`
 ADD PRIMARY KEY (`update_site_id`,`extension_id`);

ALTER TABLE `#__usergroups`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `idx_usergroup_parent_title_lookup` (`parent_id`,`title`), ADD KEY `idx_usergroup_title_lookup` (`title`), ADD KEY `idx_usergroup_adjacency_lookup` (`parent_id`), ADD KEY `idx_usergroup_nested_set_lookup` (`lft`,`rgt`);

ALTER TABLE `#__users`
 ADD PRIMARY KEY (`id`), ADD KEY `idx_name` (`name`), ADD KEY `idx_block` (`block`), ADD KEY `username` (`username`), ADD KEY `email` (`email`);

ALTER TABLE `#__user_keys`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `series` (`series`), ADD UNIQUE KEY `series_2` (`series`), ADD UNIQUE KEY `series_3` (`series`), ADD KEY `user_id` (`user_id`);

ALTER TABLE `#__user_notes`
 ADD PRIMARY KEY (`id`), ADD KEY `idx_user_id` (`user_id`), ADD KEY `idx_category_id` (`catid`);

ALTER TABLE `#__user_profiles`
 ADD UNIQUE KEY `idx_user_id_profile_key` (`user_id`,`profile_key`);

ALTER TABLE `#__user_usergroup_map`
 ADD PRIMARY KEY (`user_id`,`group_id`);

ALTER TABLE `#__viewlevels`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `idx_assetgroup_title_lookup` (`title`);

ALTER TABLE `#__weblinks`
 ADD PRIMARY KEY (`id`), ADD KEY `idx_access` (`access`), ADD KEY `idx_checkout` (`checked_out`), ADD KEY `idx_state` (`state`), ADD KEY `idx_catid` (`catid`), ADD KEY `idx_createdby` (`created_by`), ADD KEY `idx_featured_catid` (`featured`,`catid`), ADD KEY `idx_language` (`language`), ADD KEY `idx_xreference` (`xreference`);


ALTER TABLE `#__assets`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',AUTO_INCREMENT=528;
ALTER TABLE `#__banners`
MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
ALTER TABLE `#__banner_clients`
MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
ALTER TABLE `#__categories`
MODIFY `id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=16;
ALTER TABLE `#__contact_details`
MODIFY `id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=2;
ALTER TABLE `#__content`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=63;
ALTER TABLE `#__content_types`
MODIFY `type_id` int(10) unsigned NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=16;
ALTER TABLE `#__extensions`
MODIFY `extension_id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=10074;
ALTER TABLE `#__finder_filters`
MODIFY `filter_id` int(10) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `#__finder_links`
MODIFY `link_id` int(10) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `#__finder_taxonomy`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `#__finder_terms`
MODIFY `term_id` int(10) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `#__finder_types`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=7;
ALTER TABLE `#__k2_attachments`
MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
ALTER TABLE `#__k2_categories`
MODIFY `id` int(11) unsigned NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=6;
ALTER TABLE `#__k2_comments`
MODIFY `id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=3;
ALTER TABLE `#__k2_extra_fields`
MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
ALTER TABLE `#__k2_extra_fields_groups`
MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
ALTER TABLE `#__k2_items`
MODIFY `id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=75;
ALTER TABLE `#__k2_tags`
MODIFY `id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=411;
ALTER TABLE `#__k2_tags_xref`
MODIFY `id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=159;
ALTER TABLE `#__k2_users`
MODIFY `id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=4;
ALTER TABLE `#__k2_user_groups`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=3;
ALTER TABLE `#__languages`
MODIFY `lang_id` int(11) unsigned NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=2;
ALTER TABLE `#__menu`
MODIFY `id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=454;
ALTER TABLE `#__menu_types`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=5;
ALTER TABLE `#__messages`
MODIFY `message_id` int(10) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `#__minitek_wall_instances`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=2;
ALTER TABLE `#__minitek_wall_modules`
MODIFY `id` int(11) unsigned NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=3;
ALTER TABLE `#__modules`
MODIFY `id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=360;
ALTER TABLE `#__newsfeeds`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `#__overrider`
MODIFY `id` int(10) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key';
ALTER TABLE `#__postinstall_messages`
MODIFY `postinstall_message_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=47;
ALTER TABLE `#__redirect_links`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `#__tags`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=2;
ALTER TABLE `#__template_styles`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=102;
ALTER TABLE `#__ucm_content`
MODIFY `core_content_id` int(10) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `#__ucm_history`
MODIFY `version_id` int(10) unsigned NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=232;
ALTER TABLE `#__updates`
MODIFY `update_id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=7;
ALTER TABLE `#__update_sites`
MODIFY `update_site_id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=12;
ALTER TABLE `#__usergroups`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',AUTO_INCREMENT=10;
ALTER TABLE `#__users`
MODIFY `id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=652;
ALTER TABLE `#__user_keys`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `#__user_notes`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `#__viewlevels`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',AUTO_INCREMENT=7;
ALTER TABLE `#__weblinks`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
